package com.ruoyi.common.constant;

/**
 * 岗检问题状态枚举
 */
public enum PostCheckedProblemEnum {
//	  1-待指定整改人（问题录入完成时）；2-待填写方案（部门管理员指定整改人后）；
//    10-待部门审核；11-部门审核驳回；
//    20-待专业部门人审核（非必填）；21-专业部门人审核驳回（非必填）；
//    30-待整改人待上传实施（整改人上传实施图片）；
//    40-待复查部门人审核；41-复查部门人审核通过；42-复查部门人审核驳回

    ADD("待指定整改人（问题录入完成时）", 1),
    EDIT_WAIT_ONR("待填写方案（部门管理员指定整改人后）", 2),
//    EDIT_ONE_OVER("方案填写完成", 2),

    DEPT_WAIT("待部门审核", 10),
    //TODO 前台传过来的审核状态，数据库并不保存，部门审核通过后，单据流转到专业部门待审核或者方案待填写
    DEPT_PASS("部门审核通过", 11),
    DEPT_BACK("部门审核驳回", 12),

    ZHUAN_ZY_WAIT("待专业部门人审核（非必填）", 20),
    //TODO 前台传过来的审核状态，数据库并不保存，专业部门审核通过后，单据流转到待整改人待上传实施
    ZHUAN_ZY_PASS("专业部门人审核通过（非必填）", 21),
    ZHUAN_ZY_BACK("专业部门人审核驳回（非必填）；", 22),

    EDIT_WAIT_TWO("待整改人待上传实施（整改人上传实施图片）", 30),
    EDIT_TWO_OVER("上传实施照片完成", 31),

    FU_CHA_WAIT("待复查部门人审核；", 40),
    FU_CHA_PASS("复查部门人审核通过；", 41),
    FU_CHA_BACK("复查部门人审核驳回", 42);

    private String name;
    private Integer value;

    PostCheckedProblemEnum(String name, Integer value) {
        this.name = name;
        this.value = value;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getValue() {
        return value;
    }

    public void setValue(Integer value) {
        this.value = value;
    }
}
