package com.ruoyi.postCheck.controller;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.postCheck.domain.homePage.AssessmentRatingView;
import com.ruoyi.postCheck.domain.homePage.DeptProblemRectificationView;
import com.ruoyi.postCheck.domain.homePage.PostCheckedProblemView;
import com.ruoyi.postCheck.domain.homePage.PostCheckedUnCheckedView;
import com.ruoyi.postCheck.domain.problemStatistics.*;
import com.ruoyi.postCheck.service.IPostCheckedProblemService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.math.BigDecimal;
import java.util.*;

/**
 * 岗检问题表Controller
 *
 * @author csg
 * @date 2023-12-23
 */
@Api(tags = "5.1.1-统计分析-检查统计-问题统计（职能管理）")
@RestController
@RequestMapping("/postCheck/functionProblemStatistics")
public class PostCheckedFunctionProblemStatisticsController extends BaseController {
    @Autowired
    private IPostCheckedProblemService postCheckedProblemService;


    @ApiOperation("1-职能部各部门问题数量对比")
    @GetMapping("/functionDeptProblemContrast")
//    @ApiImplicitParam(name = "notParam", value = "V2方便接口联调-这是返回信息", dataType = "FunctionDeptProblemContrastView", dataTypeClass = FunctionDeptProblemContrastView.class)
    public AjaxResult functionDeptProblemContrast(FunctionDeptProblemContrastView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）
//        GROUP BY problem_category -- 问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）
        List<FunctionDeptProblemContrastView> list = new ArrayList<>();

        Integer type = 1;
        List<Map<String, Object>> deptIdListByType = postCheckedProblemService.getDeptIdListByType(type);
        if (deptIdListByType!=null && deptIdListByType.size()>0){
            for (Map<String, Object> map : deptIdListByType) {
                FunctionDeptProblemContrastView data = new FunctionDeptProblemContrastView();
                data.setDeptId(Long.parseLong(map.get("deptId").toString()));
                data.setDeptName(String.valueOf(map.get("deptName")));
                postCheckedProblemService.functionDeptProblemContrast(data);
                list.add(data);
            }
        }

        return success(list);
    }


    @ApiOperation("2-岗检覆盖率")
    @GetMapping("/coverageRateView")
    public AjaxResult coverageRateView(CoverageRateView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        status = 40    状态：1-待指定整改人（问题录入完成时）；2-待填写方案（部门管理员指定整改人后）；3-方案填写完成；10-部门审核通过；11-部门审核驳回；20-专业部门人审核（非必填）通过；21-专业部门人审核驳回（非必填）；30-整改人待上传实施（整改人上传实施图片）；31-上传实施照片完成；40-复查部门人审核通过；41-复查部门人审核驳回
//        is_rectification_completed = 1 整改情况-是否完成(1-Yes；2-No；)


        Integer type = 1;
        return success(postCheckedProblemService.coverageRateView(type));
    }

    @ApiOperation("3-岗检问题职责类别占比")
    @GetMapping("/dutyTypeProblemStatisticsView")
    public AjaxResult dutyTypeProblemStatisticsView(DutyTypeProblemStatisticsView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        group by duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；


        Integer type = 1;
        return success(postCheckedProblemService.dutyTypeProblemStatisticsView(type));
    }

    @ApiOperation("4-岗检问题级别占比")
    @GetMapping("/problemLevelView")
    public AjaxResult problemLevelView(ProblemLevelView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        group by problem_level   问题等级（一般、重要）

        Integer type = 1;
        return success(postCheckedProblemService.problemLevelView(type));
    }


    @ApiOperation("5-岗检问题属性及类别整改占比")
    @GetMapping("/problemAttributeCategoryView")
    public AjaxResult problemAttributeCategoryView(ProblemAttributeCategoryView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）
//        GROUP BY problem_category -- 问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）


        List<ProblemAttributeCategoryView> list = new ArrayList<>();
        /*
        [
        {
            problemCategoryType: 1
            problemCategoryType: 职责权限问题
            problemComplete: 完整性数量
            problemSuitable: 适宜性数量
            problemEffective: 有效性数量
        },
        {
            problemCategoryType: 2
            problemCategoryType: 工作内容问题
            problemComplete: 完整性数量
            problemSuitable: 适宜性数量
            problemEffective: 有效性数量
        },
        {
            problemCategoryType: 3
            problemCategoryType: 工作标准问题
            problemComplete: 完整性数量
            problemSuitable: 适宜性数量
            problemEffective: 有效性数量
        }
        ……
        ……
        ……
    ]
         */
        ProblemAttributeCategoryView data1 = new ProblemAttributeCategoryView();
        data1.setProblemCategoryType(1);
        data1.setProblemCategoryTypeView("职责权限问题");
        data1.setProblemComplete(1);// 完整性数量
        data1.setProblemSuitable(2);// 适宜性数量
        data1.setProblemEffective(3);// 有效性数量
        list.add(data1);

        ProblemAttributeCategoryView data2 = new ProblemAttributeCategoryView();
        data2.setProblemCategoryType(2);
        data2.setProblemCategoryTypeView("工作内容问题");
        data2.setProblemComplete(2);// 完整性数量
        data2.setProblemSuitable(2);// 适宜性数量
        data2.setProblemEffective(3);// 有效性数量
        list.add(data2);

        ProblemAttributeCategoryView data3 = new ProblemAttributeCategoryView();
        data3.setProblemCategoryType(3);
        data3.setProblemCategoryTypeView("工作标准问题");
        data3.setProblemComplete(3);// 完整性数量
        data3.setProblemSuitable(2);// 适宜性数量
        data3.setProblemEffective(3);// 有效性数量
        list.add(data3);

        ProblemAttributeCategoryView data4 = new ProblemAttributeCategoryView();
        data4.setProblemCategoryType(4);
        data4.setProblemCategoryTypeView("考核奖励问题");
        data4.setProblemComplete(4);// 完整性数量
        data4.setProblemSuitable(2);// 适宜性数量
        data4.setProblemEffective(3);// 有效性数量
        list.add(data4);

        ProblemAttributeCategoryView data5 = new ProblemAttributeCategoryView();
        data5.setProblemCategoryType(5);
        data5.setProblemCategoryTypeView("任职资格问题");
        data5.setProblemComplete(5);// 完整性数量
        data5.setProblemSuitable(2);// 适宜性数量
        data5.setProblemEffective(3);// 有效性数量
        list.add(data5);

        ProblemAttributeCategoryView data6 = new ProblemAttributeCategoryView();
        data6.setProblemCategoryType(6);
        data6.setProblemCategoryTypeView("其他");
        data6.setProblemComplete(6);// 完整性数量
        data6.setProblemSuitable(2);// 适宜性数量
        data6.setProblemEffective(3);// 有效性数量
        list.add(data6);
//=======================以上是模拟数据供参考=================

        Integer type = 1;
        return success(postCheckedProblemService.problemAttributeCategoryView(type));
    }


    @ApiOperation("6-历年岗检问题数量")
    @GetMapping("/historyProblemNumberView")
    public AjaxResult historyProblemNumberView(HistoryProblemNumberView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）
//        GROUP BY problem_category -- 问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）


        Integer type = 1;
        return success(postCheckedProblemService.historyProblemNumberView(type));
    }

    @ApiOperation("7-部门详情")
    @GetMapping("/deptDetaailView")
    public AjaxResult deptDetaailView(CheckedProblemDeptDetaailView notParam) { //notParam不是参数-是返回信息-方便接口联调
//         查询问题表
//        select * from "public"."post_checked_problem";
//        group by duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；
//        GROUP BY problem_attribute -- 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）


        List<CheckedProblemDeptDetaailView> list = new ArrayList<>();

        //TODO 第一步：得到各个部门ID、部门名称、问题总数量、重要问题数量、一般问题数量、统计时间
        //TODO 第二步：得到4个职责类别的问题数量及整改完成数量(1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；)
        //TODO 第三步：设置部门的整改率：遍历职责类别计算整改率


        CheckedProblemDeptDetaailView data1 = new CheckedProblemDeptDetaailView();
        data1.setDeptId(1l); //部门ID
        data1.setDeptName("测试部门名称1");// 部门名称
        data1.setProblemTotal(10); //问题数量
        data1.setProblemLeveTwo(2); //重要问题
        data1.setProblemLeveOne(8); //一般问题
        data1.setStatisticsTime(new Date());// 统计时间

//        List<CheckedProblemDeptDetaailView.ProblemAttributeInner> children1 = new ArrayList<>();
        CheckedProblemDeptDetaailView.ProblemAttributeInner child1 = new CheckedProblemDeptDetaailView.ProblemAttributeInner();
        child1.setProblemComplete(1); //child1.set完整性数量
        child1.setProblemSuitable(2); //child1.set适宜性数量
        child1.setProblemEffective(3);//child1.set有效性数量
        //children1.add(child1);
        //data1.setChildren(children1);
        data1.getChildren().add(child1);
        list.add(data1);

        CheckedProblemDeptDetaailView data2 = new CheckedProblemDeptDetaailView();
        data2.setDeptId(2l); //部门ID
        data2.setDeptName("测试部门名称2");// 部门名称
        data2.setProblemTotal(9); //问题数量
        data2.setProblemLeveTwo(2); //重要问题
        data2.setProblemLeveOne(7); //一般问题
        data2.setStatisticsTime(new Date());// 统计时间
        CheckedProblemDeptDetaailView.ProblemAttributeInner child2 = new CheckedProblemDeptDetaailView.ProblemAttributeInner();
        data2.getChildren().add(child2);
        list.add(data2);

        CheckedProblemDeptDetaailView data3 = new CheckedProblemDeptDetaailView();
        data3.setDeptId(3l); //部门ID
        data3.setDeptName("测试部门名称3");// 部门名称
        data3.setProblemTotal(8); //问题数量
        data3.setProblemLeveTwo(3); //重要问题
        data3.setProblemLeveOne(5); //一般问题
        data3.setStatisticsTime(new Date());// 统计时间
        CheckedProblemDeptDetaailView.ProblemAttributeInner child3 = new CheckedProblemDeptDetaailView.ProblemAttributeInner();
        data3.getChildren().add(child3);
        list.add(data3);

        CheckedProblemDeptDetaailView data4 = new CheckedProblemDeptDetaailView();
        data4.setDeptId(4l); //部门ID
        data4.setDeptName("测试部门名称4");// 部门名称
        data4.setProblemTotal(6); //问题数量
        data4.setProblemLeveTwo(1); //重要问题
        data4.setProblemLeveOne(5); //一般问题
        data4.setStatisticsTime(new Date());// 统计时间
        CheckedProblemDeptDetaailView.ProblemAttributeInner child4 = new CheckedProblemDeptDetaailView.ProblemAttributeInner();
        data4.getChildren().add(child4);
        list.add(data4);
        Integer type = 1;
        return success(postCheckedProblemService.deptDetaailView(type));
    }
}
