package com.ruoyi.postCheck.domain;

import java.math.BigDecimal;
import java.util.Date;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 考核规则对象 post_assessment_rules
 *
 * @author csg
 * @date 2023-12-28
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "考核规则对象")
@TableName("post_assessment_rules") // 数据库表名
public class PostAssessmentRules extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；")
    @TableField(value = "type")
    @Excel(name = "评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；")
    private Integer type;

    @ApiModelProperty("职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规与保密职责；5-任职资格与能力素质要求；6-岗位责任制文件完整性与适宜性；")
    @TableField(value = "duty_type")
    @Excel(name = "职责类别")
    private Integer dutyType;

    @ApiModelProperty("满分/权重")
    @TableField(value = "full_score")
    @Excel(name = "满分/权重")
    private Integer fullScore;

    @ApiModelProperty("考核规则/评分标准")
    @TableField(value = "rule")
    @Excel(name = "考核规则/评分标准")
    private String rule;

    @ApiModelProperty("type=1-岗检考核规则：一般分数")
    @TableField(value = "problem_level_one")
    @Excel(name = "type=1-岗检考核规则：一般分数")
    private BigDecimal problemLevelOne;

    @ApiModelProperty("type=1-岗检考核规则：重要分数")
    @TableField(value = "problem_level_two")
    @Excel(name = "type=1-岗检考核规则：重要分数")
    private BigDecimal problemLevelTwo;

    @ApiModelProperty("状态：1-待审核；3-通过；4-驳回；")
    @TableField(value = "status")
    @Excel(name = "状态：1-待审核；3-通过；4-驳回；")
    private Integer status;

    @ApiModelProperty("审核人ID")
    @TableField(value = "status_by_user_id")
    @Excel(name = "审核人ID")
    private Long statusByUserId;

    @ApiModelProperty("审核人姓名")
    @TableField(value = "status_by_user_name")
    @Excel(name = "审核人姓名")
    private String statusByUserName;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;

    @ApiModelProperty("审核不通过原因")
    @TableField(value = "status_reason")
    @Excel(name = "审核不通过原因")
    private String statusReason;

    @ApiModelProperty("审核不通过时间")
    @TableField(value = "status_approve_time")
    @Excel(name = "审核不通过时间")
    private Date statusApproveTime;

}
