package com.ruoyi.postCheck.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 岗检表管理明细对象 post_checked_items
 *
 * @author csg
 * @date 2024-01-05
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检表管理明细对象")
@TableName("post_checked_items") // 数据库表名
public class PostCheckedItems extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("岗位责任制检查表ID")
    @TableField(value = "post_checked_id")
    @Excel(name = "岗位责任制检查表ID")
    private Long postCheckedId;

    @ApiModelProperty("检查项目：参考post_list_info表；类型")
    @TableField(value = "type")
    @Excel(name = "检查项目：参考post_list_info表；类型", readConverterExp = "1=-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求")
    private Integer type;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;

    @ApiModelProperty("检查内容")
    @TableField(value = "post_checked_content")
    @Excel(name = "检查内容")
    private String postCheckedContent;

    @ApiModelProperty("检查标准")
    @TableField(value = "post_checked_standard")
    @Excel(name = "检查标准")
    private String postCheckedStandard;

    @ApiModelProperty("检查方法")
    @TableField(value = "post_checked_method")
    @Excel(name = "检查方法")
    private String postCheckedMethod;

    @ApiModelProperty("检查结果")
    @TableField(value = "post_checked_result")
    @Excel(name = "检查结果")
    private String postCheckedResult;

}
