package com.ruoyi.postCheck.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 岗检亮点对象 post_highlights
 *
 * @author csg
 * @date 2023-12-26
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检亮点对象")
@TableName("post_highlights") // 数据库表名
public class PostHighlights extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；")
    @TableField(value = "highlights_type")
    @Excel(name = "职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；")
    private Integer highlightsType;

    @ApiModelProperty("问题属性")
    @TableField(value = "problem_attribute")
    @Excel(name = "问题属性", readConverterExp = "完整问题、有效性问题、适宜性问题")
    private String problemAttribute;

    @ApiModelProperty("管理亮点")
    @TableField(value = "highlights")
    @Excel(name = "管理亮点")
    private String highlights;

    private Integer delFlag;

    @ApiModelProperty("创建人ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建人ID")
    private Long createUserId;

}
