package com.ruoyi.postCheck.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 岗检方案模板对象 post_programme_template
 *
 * @author csg
 * @date 2023-12-19
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检方案模板对象")
@TableName("post_programme_template") // 数据库表名
public class PostProgrammeTemplate extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("方案名称")
    @TableField(value = "plan_name")
    @Excel(name = "方案名称")
    private String planName;

    @ApiModelProperty("模板名称")
    @TableField(value = "template_name")
    @Excel(name = "模板名称")
    private String templateName;

    @ApiModelProperty("模板磁盘路径")
    @TableField(value = "disk_path")
    @Excel(name = "模板磁盘路径")
    private String diskPath;

    @ApiModelProperty("状态")
    @TableField(value = "status")
    @Excel(name = "状态", readConverterExp = "1=-启动；2-作废")
    private Integer status;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;

}
