package com.ruoyi.postCheck.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.baomidou.mybatisplus.annotation.TableField;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 岗检工作组关联部门对象 post_team_dept
 *
 * @author csg
 * @date 2023-12-19
 */
@EqualsAndHashCode(callSuper = true)
@Data
@ApiModel(value = "岗检工作组关联部门对象")
@TableName("post_team_dept") // 数据库表名
public class PostTeamDept extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @ApiModelProperty("岗检工作组ID")
    @TableField(value = "post_team_id")
    @Excel(name = "岗检工作组ID")
    private String postTeamId;

    @ApiModelProperty("岗检工作组名称（与部门不相关，自定义的名称，例如：综合岗检工作组、生产岗检工作组）")
    @TableField(value = "group_team_name")
    @Excel(name = "岗检工作组名称")
    private String groupTeamName;

    @ApiModelProperty("类型")
    @TableField(value = "type")
    @Excel(name = "类型", readConverterExp = "1-牵头；2-成员")
    private Long type;

    @ApiModelProperty("创建者用户ID")
    @TableField(value = "create_user_id")
    @Excel(name = "创建者用户ID")
    private Long createUserId;

}
