package com.ruoyi.postCheck.domain.problemStatistics;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@EqualsAndHashCode
@Data
@ApiModel(value = "统计分析-检查统计-问题统计（生产运用）-部门详情")
//extends DutyTypeProblemStatisticsView
public class DeptDetaailView implements Serializable {

    private static final long serialVersionUID = 5666890687691604123L;
    @ApiModelProperty("部门ID")
    private Long deptId;
    @ApiModelProperty("部门名称")
    private String deptName;

    @ApiModelProperty("整改率")
    private BigDecimal problemRectificationRate;
    @ApiModelProperty("统计时间")
    private Date statisticsTime;

    @ApiModelProperty("duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；")
    private List<ProblemAttributeInner> children = new ArrayList<>();


    /**
     * 按业务职责归类存放问题整改的情况
     */
//            extends ProblemNumberBase {
    @Data
    public static class ProblemAttributeInner implements Serializable {

        private static final long serialVersionUID = 3140695152506065277L;

        @ApiModelProperty("业务职责字典值-前端自己显示中文名称：duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；")
        private Integer dutyType;


        @ApiModelProperty("完整性数量")
        private Integer problemComplete;
        @ApiModelProperty("适宜性数量")
        private Integer problemSuitable;
        @ApiModelProperty("有效性数量")
        private Integer problemEffective;

        @ApiModelProperty("已完成完整性数量")
        private Integer problemCompleteChecked;
        @ApiModelProperty("已完成适宜性数量")
        private Integer problemSuitableChecked;
        @ApiModelProperty("已完成有效性数量")
        private Integer problemEffectiveChecked;

    }


/**
 * 业务职责类型
 */
//    public static class ProblemDutyType {
//        @ApiModelProperty("业务职责字典值：duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；")
//        private Integer dutyType;
//
//        @ApiModelProperty("业务职责字典值显示名称（后台可以不设置值，让前端做）：duty_type 职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；")
//        private Integer dutyView;
//
//
//        /**
//         * @ApiModelProperty("完整性数量") private Integer problemComplete;
//         * @ApiModelProperty("适宜性数量") private Integer problemSuitable;
//         * @ApiModelProperty("有效性数量") private Integer problemEffective;
//         * @ApiModelProperty("已完成完整性数量") private Integer problemCompleteChecked;
//         * @ApiModelProperty("已完成适宜性数量") private Integer problemSuitableChecked;
//         * @ApiModelProperty("已完成有效性数量") private Integer problemEffectiveChecked;
//         */
//        @ApiModelProperty("problem_attribute 问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）")
//        private List<DutyTypeProblemStatisticsView.ProblemAttributeInner> children = new ArrayList<>();
//
//
//    }


}
