package com.ruoyi.postCheck.mapper;

import java.util.List;
import com.ruoyi.postCheck.domain.PostHighlights;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * 岗检亮点Mapper接口
 *
 * @author csg
 * @date 2023-12-26
 */
public interface PostHighlightsMapper extends BaseMapper<PostHighlights>
{
    /**
     * 查询岗检亮点
     *
     * @param id 岗检亮点主键
     * @return 岗检亮点
     */
    public PostHighlights selectPostHighlightsById(Long id);

    /**
     * 查询岗检亮点列表
     *
     * @param postHighlights 岗检亮点
     * @return 岗检亮点集合
     */
    public List<PostHighlights> selectPostHighlightsList(PostHighlights postHighlights);

    /**
     * 新增岗检亮点
     *
     * @param postHighlights 岗检亮点
     * @return 结果
     */
    public int insertPostHighlights(PostHighlights postHighlights);

    /**
     * 修改岗检亮点
     *
     * @param postHighlights 岗检亮点
     * @return 结果
     */
    public int updatePostHighlights(PostHighlights postHighlights);

    /**
     * 删除岗检亮点
     *
     * @param id 岗检亮点主键
     * @return 结果
     */
    public int deletePostHighlightsById(Long id);

    /**
     * 批量删除岗检亮点
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePostHighlightsByIds(Long[] ids);
}
