package com.ruoyi.postCheck.mapper;

import java.util.List;
import com.ruoyi.postCheck.domain.PostPlanInfo;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;

/**
 * 岗检计划明细表Mapper接口
 *
 * @author csg
 * @date 2023-12-19
 */
public interface PostPlanInfoMapper extends BaseMapper<PostPlanInfo>
{
    /**
     * 查询岗检计划明细表
     *
     * @param id 岗检计划明细表主键
     * @return 岗检计划明细表
     */
    public PostPlanInfo selectPostPlanInfoById(Long id);

    /**
     * 查询岗检计划明细表列表
     *
     * @param postPlanInfo 岗检计划明细表
     * @return 岗检计划明细表集合
     */
    public List<PostPlanInfo> selectPostPlanInfoList(PostPlanInfo postPlanInfo);

    /**
     * 新增岗检计划明细表
     *
     * @param postPlanInfo 岗检计划明细表
     * @return 结果
     */
    public int insertPostPlanInfo(PostPlanInfo postPlanInfo);

    /**
     * 修改岗检计划明细表
     *
     * @param postPlanInfo 岗检计划明细表
     * @return 结果
     */
    public int updatePostPlanInfo(PostPlanInfo postPlanInfo);

    /**
     * 删除岗检计划明细表
     *
     * @param id 岗检计划明细表主键
     * @return 结果
     */
    public int deletePostPlanInfoById(Long id);

    /**
     * 批量删除岗检计划明细表
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deletePostPlanInfoByIds(Long[] ids);
}
