package com.ruoyi.postCheck.service;

import java.util.List;
import com.ruoyi.postCheck.domain.PostAssessmentRatingOther;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 打分表(职能互评生产日常)Service接口
 *
 * @author csg
 * @date 2024-01-01
 */
public interface IPostAssessmentRatingOtherService extends IService<PostAssessmentRatingOther>
{
    /**
     * 查询打分表(职能互评生产日常)
     *
     * @param id 打分表(职能互评生产日常)主键
     * @return 打分表(职能互评生产日常)
     */
    public PostAssessmentRatingOther selectPostAssessmentRatingOtherById(Long id);

    /**
     * 查询打分表(职能互评生产日常)列表
     *
     * @param postAssessmentRatingOther 打分表(职能互评生产日常)
     * @return 打分表(职能互评生产日常)集合
     */
    public List<PostAssessmentRatingOther> selectPostAssessmentRatingOtherList(PostAssessmentRatingOther postAssessmentRatingOther);

    /**
     * 新增打分表(职能互评生产日常)
     *
     * @param postAssessmentRatingOther 打分表(职能互评生产日常)
     * @return 结果
     */
    public int insertPostAssessmentRatingOther(PostAssessmentRatingOther postAssessmentRatingOther);

    /**
     * 修改打分表(职能互评生产日常)
     *
     * @param postAssessmentRatingOther 打分表(职能互评生产日常)
     * @return 结果
     */
    public int updatePostAssessmentRatingOther(PostAssessmentRatingOther postAssessmentRatingOther);

    /**
     * 批量删除打分表(职能互评生产日常)
     *
     * @param ids 需要删除的打分表(职能互评生产日常)主键集合
     * @return 结果
     */
    public int deletePostAssessmentRatingOtherByIds(Long[] ids);

    /**
     * 删除打分表(职能互评生产日常)信息
     *
     * @param id 打分表(职能互评生产日常)主键
     * @return 结果
     */
    public int deletePostAssessmentRatingOtherById(Long id);

    /**
     * 管理员创建互评计划：(职能部门互评、生产部门日常)
     * 互评批次：管理员启动互评任务，初始化13个部门互相打分的记录
     * @param postAssessmentRatingOther
     * @return
     */
    int batchAddRatingOther(PostAssessmentRatingOther postAssessmentRatingOther);

    int batchAddRatingOtherUpdate(PostAssessmentRatingOther postAssessmentRatingOther);

    int productionDepartmentSub(List<PostAssessmentRatingOther> postAssessmentRatingOther);
}
