package com.ruoyi.postCheck.service;

import java.util.List;
import com.ruoyi.postCheck.domain.PostAssessmentRules;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 考核规则Service接口
 *
 * @author csg
 * @date 2023-12-28
 */
public interface IPostAssessmentRulesService extends IService<PostAssessmentRules>
{
    /**
     * 查询考核规则
     *
     * @param id 考核规则主键
     * @return 考核规则
     */
    public PostAssessmentRules selectPostAssessmentRulesById(Long id);

    /**
     * 查询考核规则列表
     *
     * @param postAssessmentRules 考核规则
     * @return 考核规则集合
     */
    public List<PostAssessmentRules> selectPostAssessmentRulesList(PostAssessmentRules postAssessmentRules);

    /**
     * 新增考核规则
     *
     * @param postAssessmentRules 考核规则
     * @return 结果
     */
    public int insertPostAssessmentRules(PostAssessmentRules postAssessmentRules);

    /**
     * 修改考核规则
     *
     * @param postAssessmentRules 考核规则
     * @return 结果
     */
    public int updatePostAssessmentRules(PostAssessmentRules postAssessmentRules);

    /**
     * 批量删除考核规则
     *
     * @param ids 需要删除的考核规则主键集合
     * @return 结果
     */
    public int deletePostAssessmentRulesByIds(Long[] ids);

    /**
     * 删除考核规则信息
     *
     * @param id 考核规则主键
     * @return 结果
     */
    public int deletePostAssessmentRulesById(Long id);

    /**
     * 考核规则审核
     * @param id 主键
     * @param status 状态：3-通过；4-驳回；
     * @param statusReason 未通过理由
     * @return
     */
    int statusApprove(Long id, Integer status, String statusReason);
}
