package com.ruoyi.postCheck.service;

import java.util.List;
import com.ruoyi.postCheck.domain.PostCheckedReport;
import com.baomidou.mybatisplus.extension.service.IService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

/**
 * 岗检报告管理Service接口
 *
 * @author csg
 * @date 2023-12-28
 */
public interface IPostCheckedReportService extends IService<PostCheckedReport>
{
    /**
     * 查询岗检报告管理
     *
     * @param id 岗检报告管理主键
     * @return 岗检报告管理
     */
    public PostCheckedReport selectPostCheckedReportById(Long id);

    /**
     * 查询岗检报告管理列表
     *
     * @param postCheckedReport 岗检报告管理
     * @return 岗检报告管理集合
     */
    public List<PostCheckedReport> selectPostCheckedReportList(PostCheckedReport postCheckedReport);

    /**
     * 新增岗检报告管理
     *
     * @param postCheckedReport 岗检报告管理
     * @return 结果
     */
    public int insertPostCheckedReport(PostCheckedReport postCheckedReport);

    /**
     * 修改岗检报告管理
     *
     * @param postCheckedReport 岗检报告管理
     * @return 结果
     */
    public int updatePostCheckedReport(PostCheckedReport postCheckedReport);

    /**
     * 批量删除岗检报告管理
     *
     * @param ids 需要删除的岗检报告管理主键集合
     * @return 结果
     */
    public int deletePostCheckedReportByIds(Long[] ids);

    /**
     * 删除岗检报告管理信息
     *
     * @param id 岗检报告管理主键
     * @return 结果
     */
    public int deletePostCheckedReportById(Long id);


    /**
     * 岗检报告审核
     * @param id 主键
     * @param status 状态：3-通过；4-驳回；
     * @param statusReason 未通过理由
     * @return
     */
    int statusApprove(Long id, Integer status, String statusReason);
}
