package com.ruoyi.postCheck.service;

import java.util.List;

import com.ruoyi.postCheck.domain.PostCheckedItems;
import com.ruoyi.postCheck.domain.PostList;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 岗检责任制清单Service接口
 *
 * @author csg
 * @date 2023-12-20
 */
public interface IPostListService extends IService<PostList>
{
    /**
     * 查询岗检责任制清单
     *
     * @param id 岗检责任制清单主键
     * @return 岗检责任制清单
     */
    public PostList selectPostListById(Long id);

    /**
     * 查询岗检责任制清单列表
     *
     * @param postList 岗检责任制清单
     * @return 岗检责任制清单集合
     */
    public List<PostList> selectPostListList(PostList postList);

    /**
     * 新增岗检责任制清单
     *
     * @param postList 岗检责任制清单
     * @return 结果
     */
    public int insertPostList(PostList postList);

    /**
     * 修改岗检责任制清单
     *
     * @param postList 岗检责任制清单
     * @return 结果
     */
    public int updatePostList(PostList postList);

    /**
     * 批量删除岗检责任制清单
     *
     * @param ids 需要删除的岗检责任制清单主键集合
     * @return 结果
     */
    public int deletePostListByIds(Long[] ids);

    /**
     * 删除岗检责任制清单信息
     *
     * @param id 岗检责任制清单主键
     * @return 结果
     */
    public int deletePostListById(Long id);

    /**
     *
     * @param deptId 部门ID
     * @param postId 岗位ID
     * @param type 检查项目（业务职责、党建党风、安全环保……）
     * @return
     */
    List<PostCheckedItems> contentListByType(Long deptId, Long postId, Integer type);
}
