package com.ruoyi.postCheck.service;

import java.util.List;
import com.ruoyi.postCheck.domain.PostPlanInfo;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 岗检计划明细表Service接口
 *
 * @author csg
 * @date 2023-12-19
 */
public interface IPostPlanInfoService extends IService<PostPlanInfo>
{
    /**
     * 查询岗检计划明细表
     *
     * @param id 岗检计划明细表主键
     * @return 岗检计划明细表
     */
    public PostPlanInfo selectPostPlanInfoById(Long id);

    /**
     * 查询岗检计划明细表列表
     *
     * @param postPlanInfo 岗检计划明细表
     * @return 岗检计划明细表集合
     */
    public List<PostPlanInfo> selectPostPlanInfoList(PostPlanInfo postPlanInfo);

    /**
     * 新增岗检计划明细表：涉及部门和岗位是必选参数
     *
     * @param postPlanInfo 岗检计划明细表
     * @return 结果
     */
    public int insertPostPlanInfo(PostPlanInfo postPlanInfo);

    /**
     * 修改岗检计划明细表
     *
     * @param postPlanInfo 岗检计划明细表
     * @return 结果
     */
    public int updatePostPlanInfo(PostPlanInfo postPlanInfo);

    /**
     * 批量删除岗检计划明细表
     *
     * @param ids 需要删除的岗检计划明细表主键集合
     * @return 结果
     */
    public int deletePostPlanInfoByIds(Long[] ids);

    /**
     * 删除岗检计划明细表信息
     *
     * @param id 岗检计划明细表主键
     * @return 结果
     */
    public int deletePostPlanInfoById(Long id);
}
