package com.ruoyi.postCheck.service;

import java.util.List;
import com.ruoyi.postCheck.domain.PostTeamUser;
import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 岗检小组关联成员Service接口
 *
 * @author csg
 * @date 2023-12-19
 */
public interface IPostTeamUserService extends IService<PostTeamUser>
{
    /**
     * 查询岗检小组关联成员
     *
     * @param id 岗检小组关联成员主键
     * @return 岗检小组关联成员
     */
    public PostTeamUser selectPostTeamUserById(Long id);

    /**
     * 查询岗检小组关联成员列表
     *
     * @param postTeamUser 岗检小组关联成员
     * @return 岗检小组关联成员集合
     */
    public List<PostTeamUser> selectPostTeamUserList(PostTeamUser postTeamUser);

    /**
     * 新增岗检小组关联成员
     *
     * @param postTeamUserList 岗检小组关联成员数组
     * @return 结果
     */
    public int insertPostTeamUser(List<PostTeamUser> postTeamUserList);

    /**
     * 修改岗检小组关联成员
     *
     * @param postTeamUserList 岗检小组关联成员数组
     * @return 结果
    public int updatePostTeamUser(List<PostTeamUser> postTeamUserList);
     */

    /**
     * 批量删除岗检小组关联成员
     *
     * @param ids 需要删除的岗检小组关联成员主键集合
     * @return 结果
     */
    public int deletePostTeamUserByIds(Long[] ids);

    /**
     * 删除岗检小组关联成员信息
     *
     * @param id 岗检小组关联成员主键
     * @return 结果
     */
    public int deletePostTeamUserById(Long id);
}
