--
-- Kingbase database dump
--

-- Dumped from database version 12.1
-- Dumped by sys_dump version 12.1

-- Started on 2024-01-03 17:30:05

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', 'public', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;
SET default_with_oids = off;

--
-- TOC entry 23 (class 2615 OID 2200)
-- Name: public; Type: SCHEMA; Schema: -; Owner: system
--

CREATE SCHEMA public;


ALTER SCHEMA public OWNER TO system;

--
-- TOC entry 8570 (class 0 OID 0)
-- Dependencies: 23
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: system
--

COMMENT ON SCHEMA public IS 'standard public schema';


SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- TOC entry 615 (class 1259 OID 17947)
-- Name: $post_PostPlanJoinChecked; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public."$post_PostPlanJoinChecked" (
    id integer,
    name integer
);


ALTER TABLE public."$post_PostPlanJoinChecked" OWNER TO postcheckuser;

--
-- TOC entry 8572 (class 0 OID 0)
-- Dependencies: 615
-- Name: TABLE "$post_PostPlanJoinChecked"; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public."$post_PostPlanJoinChecked" IS '岗检记录上传列表-辅助表';


--
-- TOC entry 614 (class 1259 OID 17944)
-- Name: $post_PostPlanJoinProblem; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public."$post_PostPlanJoinProblem" (
    id integer,
    name integer
);


ALTER TABLE public."$post_PostPlanJoinProblem" OWNER TO postcheckuser;

--
-- TOC entry 8573 (class 0 OID 0)
-- Dependencies: 614
-- Name: TABLE "$post_PostPlanJoinProblem"; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public."$post_PostPlanJoinProblem" IS '岗检问题录入列表辅助表';


--
-- TOC entry 589 (class 1259 OID 17051)
-- Name: gen_table; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.gen_table (
    table_id bigint NOT NULL,
    table_name character varying(200 char) DEFAULT ''::varchar,
    table_comment character varying(500 char) DEFAULT ''::varchar,
    sub_table_name character varying(64 char),
    sub_table_fk_name character varying(64 char),
    class_name character varying(100 char) DEFAULT ''::varchar,
    tpl_category character varying(200 char) DEFAULT 'crud'::varchar,
    tpl_web_type character varying(30 char) DEFAULT ''::varchar,
    package_name character varying(100 char),
    module_name character varying(30 char),
    business_name character varying(30 char),
    function_name character varying(50 char),
    function_author character varying(50 char),
    gen_type character(1 char) DEFAULT '0'::bpchar,
    gen_path character varying(200 char) DEFAULT '/'::varchar,
    options character varying(1000 char),
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.gen_table OWNER TO postcheckuser;

--
-- TOC entry 8574 (class 0 OID 0)
-- Dependencies: 589
-- Name: TABLE gen_table; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.gen_table IS '代码生成业务表';


--
-- TOC entry 8575 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.table_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.table_id IS '编号';


--
-- TOC entry 8576 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.table_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.table_name IS '表名称';


--
-- TOC entry 8577 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.table_comment; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.table_comment IS '表描述';


--
-- TOC entry 8578 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.sub_table_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.sub_table_name IS '关联子表的表名';


--
-- TOC entry 8579 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.sub_table_fk_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.sub_table_fk_name IS '子表关联的外键名';


--
-- TOC entry 8580 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.class_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.class_name IS '实体类名称';


--
-- TOC entry 8581 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.tpl_category; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.tpl_category IS '使用的模板（crud单表操作 tree树表操作）';


--
-- TOC entry 8582 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.tpl_web_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.tpl_web_type IS '前端模板类型（element-ui模版 element-plus模版）';


--
-- TOC entry 8583 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.package_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.package_name IS '生成包路径';


--
-- TOC entry 8584 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.module_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.module_name IS '生成模块名';


--
-- TOC entry 8585 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.business_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.business_name IS '生成业务名';


--
-- TOC entry 8586 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.function_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.function_name IS '生成功能名';


--
-- TOC entry 8587 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.function_author; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.function_author IS '生成功能作者';


--
-- TOC entry 8588 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.gen_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.gen_type IS '生成代码方式（0zip压缩包 1自定义路径）';


--
-- TOC entry 8589 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.gen_path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.gen_path IS '生成路径（不填默认项目路径）';


--
-- TOC entry 8590 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.options; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.options IS '其它生成选项';


--
-- TOC entry 8591 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.create_by IS '创建者';


--
-- TOC entry 8592 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.create_time IS '创建时间';


--
-- TOC entry 8593 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.update_by IS '更新者';


--
-- TOC entry 8594 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.update_time IS '更新时间';


--
-- TOC entry 8595 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN gen_table.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.remark IS '备注';


--
-- TOC entry 607 (class 1259 OID 17223)
-- Name: gen_table_column; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.gen_table_column (
    column_id bigint NOT NULL,
    table_id bigint,
    column_name character varying(200 char),
    column_comment character varying(500 char),
    column_type character varying(100 char),
    java_type character varying(500 char),
    java_field character varying(200 char),
    is_pk character(1 char),
    is_increment character(1 char),
    is_required character(1 char),
    is_insert character(1 char),
    is_edit character(1 char),
    is_list character(1 char),
    is_query character(1 char),
    query_type character varying(200 char) DEFAULT 'EQ'::varchar,
    html_type character varying(200 char),
    dict_type character varying(200 char) DEFAULT ''::varchar,
    sort integer,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone
);


ALTER TABLE public.gen_table_column OWNER TO postcheckuser;

--
-- TOC entry 8596 (class 0 OID 0)
-- Dependencies: 607
-- Name: TABLE gen_table_column; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.gen_table_column IS '代码生成业务表字段';


--
-- TOC entry 8597 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.column_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_id IS '编号';


--
-- TOC entry 8598 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.table_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.table_id IS '归属表编号';


--
-- TOC entry 8599 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.column_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_name IS '列名称';


--
-- TOC entry 8600 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.column_comment; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_comment IS '列描述';


--
-- TOC entry 8601 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.column_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_type IS '列类型';


--
-- TOC entry 8602 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.java_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.java_type IS 'JAVA类型';


--
-- TOC entry 8603 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.java_field; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.java_field IS 'JAVA字段名';


--
-- TOC entry 8604 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_pk; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_pk IS '是否主键（1是）';


--
-- TOC entry 8605 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_increment; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_increment IS '是否自增（1是）';


--
-- TOC entry 8606 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_required; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_required IS '是否必填（1是）';


--
-- TOC entry 8607 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_insert; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_insert IS '是否为插入字段（1是）';


--
-- TOC entry 8608 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_edit; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_edit IS '是否编辑字段（1是）';


--
-- TOC entry 8609 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_list; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_list IS '是否列表字段（1是）';


--
-- TOC entry 8610 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.is_query; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_query IS '是否查询字段（1是）';


--
-- TOC entry 8611 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.query_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.query_type IS '查询方式（等于、不等于、大于、小于、范围）';


--
-- TOC entry 8612 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.html_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.html_type IS '显示类型（文本框、文本域、下拉框、复选框、单选框、日期控件）';


--
-- TOC entry 8613 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.dict_type IS '字典类型';


--
-- TOC entry 8614 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.sort IS '排序';


--
-- TOC entry 8615 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.create_by IS '创建者';


--
-- TOC entry 8616 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.create_time IS '创建时间';


--
-- TOC entry 8617 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.update_by IS '更新者';


--
-- TOC entry 8618 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN gen_table_column.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.update_time IS '更新时间';


--
-- TOC entry 613 (class 1259 OID 17897)
-- Name: post_assessment_rating; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_assessment_rating (
    id tinyint NOT NULL,
    type integer NOT NULL,
    dept_id bigint NOT NULL,
    post_id bigint NOT NULL,
    head_user_id bigint NOT NULL,
    integrity_issues_total integer DEFAULT 0 NOT NULL,
    integrity_issues_resolved integer DEFAULT 0 NOT NULL,
    effectiveness_issues_total integer DEFAULT 0 NOT NULL,
    effectiveness_issues_resolved integer DEFAULT 0 NOT NULL,
    suitability_issues_total integer DEFAULT 0 NOT NULL,
    suitability_issues_resolved integer DEFAULT 0 NOT NULL,
    peer_evaluation_score numeric(5,2) DEFAULT 0.00 NOT NULL,
    daily_score numeric(5,2) DEFAULT 0.00 NOT NULL,
    department_score numeric(5,2) DEFAULT 0.00 NOT NULL,
    position_score numeric(5,2) DEFAULT 0.00 NOT NULL,
    rating_time datetime DEFAULT CURRENT_TIMESTAMP NOT NULL,
    remark character varying(500 char) DEFAULT NULL::varchar,
    del_flag integer DEFAULT 0 NOT NULL,
    create_time datetime NOT NULL,
    create_by character varying(64 char) NOT NULL,
    update_time datetime NOT NULL,
    update_by character varying(64 char) NOT NULL
);


ALTER TABLE public.post_assessment_rating OWNER TO postcheckuser;

--
-- TOC entry 8619 (class 0 OID 0)
-- Dependencies: 613
-- Name: TABLE post_assessment_rating; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_assessment_rating IS '考核评比表';


--
-- TOC entry 8620 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.id IS '主键';


--
-- TOC entry 8621 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.type IS '类型：1-职能；2-生产；';


--
-- TOC entry 8622 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.dept_id IS '部门ID';


--
-- TOC entry 8623 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.post_id IS '岗位名称';


--
-- TOC entry 8624 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.head_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.head_user_id IS '负责人ID';


--
-- TOC entry 8625 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.integrity_issues_total; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.integrity_issues_total IS '完整性问题数量-总数';


--
-- TOC entry 8626 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.integrity_issues_resolved; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.integrity_issues_resolved IS '完整性问题数量-已整改';


--
-- TOC entry 8627 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.effectiveness_issues_total; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.effectiveness_issues_total IS '有效性问题数量-总数';


--
-- TOC entry 8628 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.effectiveness_issues_resolved; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.effectiveness_issues_resolved IS '有效性问题数量-已整改';


--
-- TOC entry 8629 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.suitability_issues_total; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.suitability_issues_total IS '适宜性问题数量-总数';


--
-- TOC entry 8630 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.suitability_issues_resolved; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.suitability_issues_resolved IS '适宜性问题数量-已整改';


--
-- TOC entry 8631 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.peer_evaluation_score; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.peer_evaluation_score IS '互评得分';


--
-- TOC entry 8632 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.daily_score; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.daily_score IS '日常得分';


--
-- TOC entry 8633 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.department_score; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.department_score IS '部门得分';


--
-- TOC entry 8634 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.position_score; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.position_score IS '岗位得分';


--
-- TOC entry 8635 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.rating_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.rating_time IS '评分时间';


--
-- TOC entry 8636 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.remark IS '备注';


--
-- TOC entry 8637 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8638 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.create_time IS '创建时间';


--
-- TOC entry 8639 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.create_by IS '创建者';


--
-- TOC entry 8640 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.update_time IS '更新时间';


--
-- TOC entry 8641 (class 0 OID 0)
-- Dependencies: 613
-- Name: COLUMN post_assessment_rating.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating.update_by IS '更新者';


--
-- TOC entry 617 (class 1259 OID 18088)
-- Name: post_assessment_rating_other; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_assessment_rating_other (
    id bigint NOT NULL,
    type integer NOT NULL,
    batch_id varchar NOT NULL,
    start_time datetime NOT NULL,
    status integer NOT NULL,
    dept_id bigint NOT NULL,
    complete_time datetime,
    score_user_id bigint,
    score_user_name varchar,
    create_user_id bigint NOT NULL,
    remark character varying(255 char),
    del_flag integer NOT NULL,
    create_time datetime NOT NULL,
    create_by character varying(64 char) NOT NULL,
    update_time datetime NOT NULL,
    update_by character varying(64 char) NOT NULL
);


ALTER TABLE public.post_assessment_rating_other OWNER TO postcheckuser;

--
-- TOC entry 8642 (class 0 OID 0)
-- Dependencies: 617
-- Name: TABLE post_assessment_rating_other; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_assessment_rating_other IS '打分表(职能互评生产日常)';


--
-- TOC entry 8643 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.id IS '主键';


--
-- TOC entry 8644 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.type IS '类型：1-职能互评；2-生产日常；';


--
-- TOC entry 8645 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.batch_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.batch_id IS '批次号（管理员创建的）';


--
-- TOC entry 8646 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.start_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.start_time IS '评分开始时间（管理员创建的）';


--
-- TOC entry 8647 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.status IS '状态：1-进行中；2-已完成';


--
-- TOC entry 8648 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.dept_id IS '评分部门ID：打分部门，自己给其他12个部门打分；';


--
-- TOC entry 8649 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.complete_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.complete_time IS '评分完成时间';


--
-- TOC entry 8650 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.score_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.score_user_id IS '评分人ID';


--
-- TOC entry 8651 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.score_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.score_user_name IS '评分人姓名';


--
-- TOC entry 8652 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.create_user_id IS '创建者用户ID';


--
-- TOC entry 8653 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.remark IS '备注';


--
-- TOC entry 8654 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8655 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.create_time IS '创建时间/提交时间';


--
-- TOC entry 8656 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.create_by IS '创建者';


--
-- TOC entry 8657 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.update_time IS '更新时间';


--
-- TOC entry 8658 (class 0 OID 0)
-- Dependencies: 617
-- Name: COLUMN post_assessment_rating_other.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other.update_by IS '更新者';


--
-- TOC entry 618 (class 1259 OID 18107)
-- Name: post_assessment_rating_other_info; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_assessment_rating_other_info (
    id bigint NOT NULL,
    rating_other_id bigint NOT NULL,
    duty_type integer NOT NULL,
    score_weight numeric(10,0) NOT NULL,
    rule character varying(512 char),
    by_dept_id bigint NOT NULL,
    by_dept_score numeric(5,2),
    improvement_suggestions character varying(512 char),
    create_user_id bigint,
    remark character varying(255 char),
    del_flag integer,
    create_time datetime,
    create_by character varying(64 char),
    update_time datetime,
    update_by character varying(64 char)
);


ALTER TABLE public.post_assessment_rating_other_info OWNER TO postcheckuser;

--
-- TOC entry 8659 (class 0 OID 0)
-- Dependencies: 618
-- Name: TABLE post_assessment_rating_other_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_assessment_rating_other_info IS '打分表明细(职能互评生产日常)';


--
-- TOC entry 8660 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.id IS '主键';


--
-- TOC entry 8661 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.rating_other_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.rating_other_id IS '打分表ID';


--
-- TOC entry 8662 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.duty_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.duty_type IS '评分分类/项目/专业：职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规与保密职责；5-任职资格与能力素质要求；6-岗位责任制文件完整性与适宜性；10-工作态度；11-部门协作；12-廉洁从业；13-主要工作完成情况；20-HSE；21-生产；22-设备；';


--
-- TOC entry 8663 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.score_weight; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.score_weight IS '分值/权重；（当前考核规则的分和权重镜像到这里）';


--
-- TOC entry 8664 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.rule; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.rule IS '考核规则/评分标准（岗检和职能部门时有值）';


--
-- TOC entry 8665 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.by_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.by_dept_id IS '被评分部门ID';


--
-- TOC entry 8666 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.by_dept_score; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.by_dept_score IS '被评分部门得分';


--
-- TOC entry 8667 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.improvement_suggestions; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.improvement_suggestions IS '改进建议';


--
-- TOC entry 8668 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.create_user_id IS '创建者用户ID';


--
-- TOC entry 8669 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.remark IS '备注';


--
-- TOC entry 8670 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8671 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.create_time IS '创建时间/提交时间';


--
-- TOC entry 8672 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.create_by IS '创建者';


--
-- TOC entry 8673 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.update_time IS '更新时间';


--
-- TOC entry 8674 (class 0 OID 0)
-- Dependencies: 618
-- Name: COLUMN post_assessment_rating_other_info.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rating_other_info.update_by IS '更新者';


--
-- TOC entry 616 (class 1259 OID 18041)
-- Name: post_assessment_rules; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_assessment_rules (
    id bigint NOT NULL,
    type integer,
    full_score integer,
    rule character varying(500 char),
    problem_level_one numeric(10,0),
    problem_level_two numeric(10,0),
    status integer,
    status_by_user_id bigint,
    status_by_user_name character varying(255 char),
    remark character varying(500 char) DEFAULT NULL::varchar,
    del_flag integer DEFAULT 0 NOT NULL,
    create_time datetime NOT NULL,
    create_by character varying(64 char) NOT NULL,
    update_time datetime NOT NULL,
    update_by character varying(64 char) NOT NULL,
    create_user_id bigint,
    status_reason character varying(255 char),
    status_approve_time datetime,
    duty_type integer
);


ALTER TABLE public.post_assessment_rules OWNER TO postcheckuser;

--
-- TOC entry 8675 (class 0 OID 0)
-- Dependencies: 616
-- Name: TABLE post_assessment_rules; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_assessment_rules IS '考核规则表';


--
-- TOC entry 8676 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.id IS '主键';


--
-- TOC entry 8677 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.type IS '评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；';


--
-- TOC entry 8678 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.full_score; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.full_score IS '满分/权重';


--
-- TOC entry 8679 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.rule; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.rule IS '考核规则/评分标准';


--
-- TOC entry 8680 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.problem_level_one; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.problem_level_one IS 'type=1-岗检考核规则：一般扣分数';


--
-- TOC entry 8681 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.problem_level_two; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.problem_level_two IS 'type=1-岗检考核规则：重要扣分数';


--
-- TOC entry 8682 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.status IS '状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8683 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.status_by_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.status_by_user_id IS '审核人ID';


--
-- TOC entry 8684 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.status_by_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.status_by_user_name IS '审核人姓名';


--
-- TOC entry 8685 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.remark IS '备注';


--
-- TOC entry 8686 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8687 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.create_time IS '创建时间/提交时间';


--
-- TOC entry 8688 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.create_by IS '创建者';


--
-- TOC entry 8689 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.update_time IS '更新时间';


--
-- TOC entry 8690 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.update_by IS '更新者';


--
-- TOC entry 8691 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.create_user_id IS '创建者用户ID';


--
-- TOC entry 8692 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.status_reason; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.status_reason IS '审核不通过原因';


--
-- TOC entry 8693 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.status_approve_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.status_approve_time IS '审核时间';


--
-- TOC entry 8694 (class 0 OID 0)
-- Dependencies: 616
-- Name: COLUMN post_assessment_rules.duty_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_assessment_rules.duty_type IS '职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规与保密职责；5-任职资格与能力素质要求；6-岗位责任制文件完整性与适宜性；10-工作态度；11-部门协作；13-廉洁从业；14-主要工作完成情况；20-HSE；21-生产；22-设备；';


--
-- TOC entry 594 (class 1259 OID 17101)
-- Name: post_checked; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked (
    id bigint NOT NULL,
    check_workgroup_id bigint,
    check_group_id bigint,
    checked_dept_id bigint,
    checked_post_id bigint,
    print_user_id bigint,
    print_time timestamp(0) with time zone,
    checked_img character varying(255 char),
    checked_user_id bigint,
    checked_time timestamp(0) with time zone,
    upload_user_id bigint,
    upload_time timestamp(0) with time zone,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_checked OWNER TO postcheckuser;

--
-- TOC entry 8695 (class 0 OID 0)
-- Dependencies: 594
-- Name: TABLE post_checked; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked IS '岗位责任制检查表';


--
-- TOC entry 8696 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.id IS '主键ID';


--
-- TOC entry 8697 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.check_workgroup_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.check_workgroup_id IS '检查工作组ID';


--
-- TOC entry 8698 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.check_group_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.check_group_id IS '检查小组ID';


--
-- TOC entry 8699 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.checked_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_dept_id IS '被检查部门ID';


--
-- TOC entry 8700 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.checked_post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_post_id IS '被检查岗位ID';


--
-- TOC entry 8701 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.print_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.print_user_id IS '打印人ID';


--
-- TOC entry 8702 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.print_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.print_time IS '打印时间';


--
-- TOC entry 8703 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.checked_img; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_img IS '上传：检查后的检查表照片或PDF，磁盘相对路径';


--
-- TOC entry 8704 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.checked_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_user_id IS '上传：检查人ID';


--
-- TOC entry 8705 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.checked_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_time IS '上传：检查时间';


--
-- TOC entry 8706 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.upload_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.upload_user_id IS '上传：检查后的检查表操作人';


--
-- TOC entry 8707 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.upload_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.upload_time IS '上传：检查后的检查表上传时间';


--
-- TOC entry 8708 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.remark IS '备注';


--
-- TOC entry 8709 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8710 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.create_time IS '创建时间';


--
-- TOC entry 8711 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.create_by IS '创建者';


--
-- TOC entry 8712 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.update_time IS '更新时间';


--
-- TOC entry 8713 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.update_by IS '更新者';


--
-- TOC entry 8714 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN post_checked.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.create_user_id IS '创建者用户ID';


--
-- TOC entry 586 (class 1259 OID 17034)
-- Name: post_checked_items; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_items (
    id bigint NOT NULL,
    post_checked_id bigint,
    type integer,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_checked_items OWNER TO postcheckuser;

--
-- TOC entry 8715 (class 0 OID 0)
-- Dependencies: 586
-- Name: TABLE post_checked_items; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked_items IS '岗位责任制检查表配置检查项';


--
-- TOC entry 8716 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.id IS '主键ID';


--
-- TOC entry 8717 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.post_checked_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.post_checked_id IS '岗位责任制检查表ID';


--
-- TOC entry 8718 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.type IS '参考post_list_info表；类型（1-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求）';


--
-- TOC entry 8719 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.remark IS '备注';


--
-- TOC entry 8720 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8721 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.create_time IS '创建时间';


--
-- TOC entry 8722 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.create_by IS '创建者';


--
-- TOC entry 8723 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.update_time IS '更新时间';


--
-- TOC entry 8724 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.update_by IS '更新者';


--
-- TOC entry 8725 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN post_checked_items.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.create_user_id IS '创建者用户ID';


--
-- TOC entry 611 (class 1259 OID 17791)
-- Name: post_checked_problem; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_problem (
    id bigint NOT NULL,
    status integer DEFAULT 1 NOT NULL,
    problem_no character varying(255 char) NOT NULL,
    check_workgroup_id bigint NOT NULL,
    check_group_id bigint NOT NULL,
    check_user_id bigint,
    dept_approve_user_id bigint,
    dept_approve_time timestamp(0) with time zone,
    speciality_department_reviewer_id bigint,
    speciality_department_review_time timestamp with time zone,
    problem_level integer NOT NULL,
    problem_attribute integer NOT NULL,
    problem_category integer NOT NULL,
    description character varying(512 char),
    problem_cause character varying(512 char),
    is_immediately_corrected integer,
    rectification_measure character varying(512 char),
    checked_dept_id bigint,
    checked_post_id bigint,
    rectification_responsible_user_id bigint,
    rectification_period timestamp(0) with time zone,
    is_rectification_completed integer,
    rectification_completion_time timestamp(0) with time zone,
    rectification_completion_img character varying(255 char),
    review_department_reviewer_id bigint,
    review_department_reviewer_time datetime,
    review_conclusion character varying(255 char),
    reason character varying(255 char),
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    check_time datetime,
    duty_type integer,
    check_user_name character varying(64 char)
);


ALTER TABLE public.post_checked_problem OWNER TO postcheckuser;

--
-- TOC entry 8726 (class 0 OID 0)
-- Dependencies: 611
-- Name: TABLE post_checked_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked_problem IS '岗检问题录入表对应的操作记录表';


--
-- TOC entry 8727 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.id IS '主键ID';


--
-- TOC entry 8728 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.status IS '状态：1-待指定整改人（问题录入完成时）；2-待填写方案（部门管理员指定整改人后）；3-方案填写完成；10-部门审核通过；11-部门审核驳回；20-专业部门人审核（非必填）通过；21-专业部门人审核驳回（非必填）；30-整改人待上传实施（整改人上传实施图片）；31-上传实施照片完成；40-复查部门人审核通过；41-复查部门人审核驳回';


--
-- TOC entry 8729 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.problem_no; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_no IS '问题编号（需要甲方提供规则规则）';


--
-- TOC entry 8730 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.check_workgroup_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_workgroup_id IS '检查工作组ID';


--
-- TOC entry 8731 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.check_group_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_group_id IS '检查小组ID';


--
-- TOC entry 8732 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.check_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_user_id IS '废弃：检查人员ID';


--
-- TOC entry 8733 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.dept_approve_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.dept_approve_user_id IS '审核1：整改部门经理ID';


--
-- TOC entry 8734 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.dept_approve_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.dept_approve_time IS '审核1：整改部门经理审核时间';


--
-- TOC entry 8735 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.speciality_department_reviewer_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.speciality_department_reviewer_id IS '审核2：专业部门的审核人ID（非必选，方案填写人选择）';


--
-- TOC entry 8736 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.speciality_department_review_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.speciality_department_review_time IS '审核2：专业部门审核人审核时间';


--
-- TOC entry 8737 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.problem_level; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_level IS '问题等级（一般、重要）';


--
-- TOC entry 8738 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.problem_attribute; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_attribute IS '问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）';


--
-- TOC entry 8739 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.problem_category; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_category IS '问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）';


--
-- TOC entry 8740 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.description; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.description IS '问题描述';


--
-- TOC entry 8741 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.problem_cause; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_cause IS '问题原因';


--
-- TOC entry 8742 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.is_immediately_corrected; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.is_immediately_corrected IS '是否立行立改(1-Yes；2-No；)';


--
-- TOC entry 8743 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.rectification_measure; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_measure IS '整改措施';


--
-- TOC entry 8744 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.checked_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.checked_dept_id IS '整改责任部门ID（被检查部门ID）';


--
-- TOC entry 8745 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.checked_post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.checked_post_id IS '整改责任岗位ID（被检查岗位ID）';


--
-- TOC entry 8746 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.rectification_responsible_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_responsible_user_id IS '整改责任人ID';


--
-- TOC entry 8747 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.rectification_period; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_period IS '整改期限';


--
-- TOC entry 8748 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.is_rectification_completed; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.is_rectification_completed IS '整改情况-是否完成(1-Yes；2-No；)';


--
-- TOC entry 8749 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.rectification_completion_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_completion_time IS '整改完成时间';


--
-- TOC entry 8750 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.rectification_completion_img; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_completion_img IS '整改完成图片磁盘路径';


--
-- TOC entry 8751 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.review_department_reviewer_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.review_department_reviewer_id IS '审核3：复查部门的审核人ID（措施上传时必选，实施人选择）';


--
-- TOC entry 8752 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.review_department_reviewer_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.review_department_reviewer_time IS '审核3：复查部门的审核人复查时间';


--
-- TOC entry 8753 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.review_conclusion; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.review_conclusion IS '复查结论';


--
-- TOC entry 8754 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.reason; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.reason IS '未通过理由';


--
-- TOC entry 8755 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.remark IS '备注';


--
-- TOC entry 8756 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8757 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.create_time IS '创建时间';


--
-- TOC entry 8758 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.create_by IS '创建者';


--
-- TOC entry 8759 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.update_time IS '更新时间';


--
-- TOC entry 8760 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.update_by IS '更新者';


--
-- TOC entry 8761 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.create_user_id IS '创建者用户ID';


--
-- TOC entry 8762 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.check_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_time IS '检查时间';


--
-- TOC entry 8763 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.duty_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.duty_type IS '职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；';


--
-- TOC entry 8764 (class 0 OID 0)
-- Dependencies: 611
-- Name: COLUMN post_checked_problem.check_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_user_name IS '检查人员姓名';


--
-- TOC entry 612 (class 1259 OID 17803)
-- Name: post_checked_problem_record; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_problem_record (
    id bigint NOT NULL,
    problem_id bigint NOT NULL,
    user_by varchar NOT NULL,
    content varchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL
);


ALTER TABLE public.post_checked_problem_record OWNER TO postcheckuser;

--
-- TOC entry 8765 (class 0 OID 0)
-- Dependencies: 612
-- Name: COLUMN post_checked_problem_record.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem_record.id IS '主键ID';


--
-- TOC entry 8766 (class 0 OID 0)
-- Dependencies: 612
-- Name: COLUMN post_checked_problem_record.problem_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem_record.problem_id IS '问题ID（多）';


--
-- TOC entry 8767 (class 0 OID 0)
-- Dependencies: 612
-- Name: COLUMN post_checked_problem_record.user_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem_record.user_by IS '操作者姓名';


--
-- TOC entry 8768 (class 0 OID 0)
-- Dependencies: 612
-- Name: COLUMN post_checked_problem_record.content; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem_record.content IS '操作内容';


--
-- TOC entry 8769 (class 0 OID 0)
-- Dependencies: 612
-- Name: COLUMN post_checked_problem_record.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem_record.create_time IS '创建时间';


--
-- TOC entry 575 (class 1259 OID 16953)
-- Name: post_checked_report; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_report (
    id bigint NOT NULL,
    report_no character varying(36 char) NOT NULL,
    report_name character varying(255 char) NOT NULL,
    report_preface character varying(255 char) NOT NULL,
    consummation_problem integer,
    suitability_problem integer,
    effectiveness_problem integer,
    li_xing_li_gai_question_number integer,
    li_xing_li_gai_question_has_rectified_number integer,
    rich_text text,
    generate_time timestamp(0) with time zone,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    html_one text,
    html_two text,
    html_three text,
    html_four text,
    html_five text,
    html_six text,
    html_seven text,
    html_eight text,
    html_nine text,
    status integer NOT NULL,
    status_by_user_id bigint,
    status_by_user_name character varying(64 char),
    status_reason character varying(255 char),
    status_approve_time datetime
);


ALTER TABLE public.post_checked_report OWNER TO postcheckuser;

--
-- TOC entry 8770 (class 0 OID 0)
-- Dependencies: 575
-- Name: TABLE post_checked_report; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked_report IS '岗检报告表';


--
-- TOC entry 8771 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.id IS '主键ID';


--
-- TOC entry 8772 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.report_no; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.report_no IS '编码';


--
-- TOC entry 8773 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.report_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.report_name IS '岗检报告名称';


--
-- TOC entry 8774 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.report_preface; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.report_preface IS '前言';


--
-- TOC entry 8775 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.consummation_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.consummation_problem IS '废弃：完善性问题';


--
-- TOC entry 8776 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.suitability_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.suitability_problem IS '废弃：适宜性问题';


--
-- TOC entry 8777 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.effectiveness_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.effectiveness_problem IS '废弃：有效性问题';


--
-- TOC entry 8778 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.li_xing_li_gai_question_number; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.li_xing_li_gai_question_number IS '废弃：立行立改问题数量';


--
-- TOC entry 8779 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.li_xing_li_gai_question_has_rectified_number; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.li_xing_li_gai_question_has_rectified_number IS '废弃：立行立改问题已整改数量';


--
-- TOC entry 8780 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.rich_text; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.rich_text IS '废弃：富文本';


--
-- TOC entry 8781 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.generate_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.generate_time IS '生成时间';


--
-- TOC entry 8782 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.remark IS '备注';


--
-- TOC entry 8783 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8784 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.create_time IS '创建时间';


--
-- TOC entry 8785 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.create_by IS '创建者';


--
-- TOC entry 8786 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.update_time IS '更新时间';


--
-- TOC entry 8787 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.update_by IS '更新者';


--
-- TOC entry 8788 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.create_user_id IS '创建者用户ID';


--
-- TOC entry 8789 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_one; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_one IS '1、（一）组织情况';


--
-- TOC entry 8790 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_two; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_two IS '2、（二）岗检的时间、范围和开展形式';


--
-- TOC entry 8791 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_three; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_three IS '3、（三）岗检发现的主要问题';


--
-- TOC entry 8792 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_four; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_four IS '4、（四）原因分析';


--
-- TOC entry 8793 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_five; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_five IS '5、（五）取得成绩';


--
-- TOC entry 8794 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_six; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_six IS '6、（一）“立行立改”问题整改情况';


--
-- TOC entry 8795 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_seven; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_seven IS '7、（二）“非立行立改”问题整改情况';


--
-- TOC entry 8796 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_eight; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_eight IS '8、三、下一步岗位责任提升计划';


--
-- TOC entry 8797 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.html_nine; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.html_nine IS '9、四、总结结论';


--
-- TOC entry 8798 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.status IS '状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8799 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.status_by_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.status_by_user_id IS '审核人ID';


--
-- TOC entry 8800 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.status_by_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.status_by_user_name IS '审核人姓名';


--
-- TOC entry 8801 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.status_reason; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.status_reason IS '审核不通过原因';


--
-- TOC entry 8802 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.status_approve_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.status_approve_time IS '审核时间';


--
-- TOC entry 580 (class 1259 OID 16987)
-- Name: post_highlights; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_highlights (
    id bigint NOT NULL,
    highlights_type integer NOT NULL,
    highlights character varying(512 char) NOT NULL,
    remark character varying(500 char) DEFAULT NULL::varchar,
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    problem_attribute integer
);


ALTER TABLE public.post_highlights OWNER TO postcheckuser;

--
-- TOC entry 8803 (class 0 OID 0)
-- Dependencies: 580
-- Name: TABLE post_highlights; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_highlights IS '岗检亮点表';


--
-- TOC entry 8804 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.id IS '主键';


--
-- TOC entry 8805 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.highlights_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.highlights_type IS '职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；';


--
-- TOC entry 8806 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.highlights; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.highlights IS '管理亮点';


--
-- TOC entry 8807 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.remark IS '备注';


--
-- TOC entry 8808 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8809 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.create_time IS '创建时间';


--
-- TOC entry 8810 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.create_by IS '创建者';


--
-- TOC entry 8811 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.update_time IS '更新时间';


--
-- TOC entry 8812 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.update_by IS '更新者';


--
-- TOC entry 8813 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.create_user_id IS '创建者用户ID';


--
-- TOC entry 8814 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.problem_attribute; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.problem_attribute IS '问题属性（1-完整问题；2-有效性问题；3-适宜性问题；）';


--
-- TOC entry 605 (class 1259 OID 17210)
-- Name: post_list; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_list (
    id bigint NOT NULL,
    status integer,
    status_by_user_id bigint,
    status_by_user_name character varying(64 char),
    unit_id character varying(255 char),
    post_id bigint,
    position_level character varying(255 char),
    direct_superior character varying(255 char),
    subordinate_count integer,
    dept_id bigint,
    position_code character varying(255 char),
    is_confidential character varying(10 char),
    direct_subordinate character varying(255 char),
    creation_date date,
    revision_date date,
    job_summary text,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_list OWNER TO postcheckuser;

--
-- TOC entry 8815 (class 0 OID 0)
-- Dependencies: 605
-- Name: TABLE post_list; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_list IS '岗位责任制清单';


--
-- TOC entry 8816 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.id IS '主键，自增长ID';


--
-- TOC entry 8817 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.status IS '状态：1-待审核；2-审核中；3-通过；4-驳回；';


--
-- TOC entry 8818 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.status_by_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.status_by_user_id IS '审核人ID';


--
-- TOC entry 8819 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.status_by_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.status_by_user_name IS '审核人姓名';


--
-- TOC entry 8820 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.unit_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.unit_id IS '所在单位';


--
-- TOC entry 8821 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.post_id IS '岗位名称：岗位ID';


--
-- TOC entry 8822 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.position_level; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.position_level IS '岗位级别';


--
-- TOC entry 8823 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.direct_superior; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.direct_superior IS '直接上级';


--
-- TOC entry 8824 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.subordinate_count; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.subordinate_count IS '辖员人数';


--
-- TOC entry 8825 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.dept_id IS '所在部门：部门ID';


--
-- TOC entry 8826 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.position_code; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.position_code IS '岗位编码';


--
-- TOC entry 8827 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.is_confidential; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.is_confidential IS '是否涉密';


--
-- TOC entry 8828 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.direct_subordinate; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.direct_subordinate IS '直接下级';


--
-- TOC entry 8829 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.creation_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.creation_date IS '编制日期';


--
-- TOC entry 8830 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.revision_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.revision_date IS '修订日期';


--
-- TOC entry 8831 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.job_summary; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.job_summary IS '工作摘要';


--
-- TOC entry 8832 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.remark IS '备注';


--
-- TOC entry 8833 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8834 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.create_time IS '创建时间';


--
-- TOC entry 8835 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.create_by IS '创建者';


--
-- TOC entry 8836 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.update_time IS '更新时间';


--
-- TOC entry 8837 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.update_by IS '更新者';


--
-- TOC entry 8838 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN post_list.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.create_user_id IS '创建者用户ID';


--
-- TOC entry 583 (class 1259 OID 17015)
-- Name: post_list_info; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_list_info (
    id bigint NOT NULL,
    status integer,
    status_by_user_id bigint,
    status_by_user_name character varying(64 char),
    post_list_id bigint,
    type integer,
    sequence_project varchar,
    level_one varchar,
    level_two varchar,
    level_three varchar,
    level_four varchar,
    level_five varchar,
    work_standard character varying(255 char),
    requirement text,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_list_info OWNER TO postcheckuser;

--
-- TOC entry 8839 (class 0 OID 0)
-- Dependencies: 583
-- Name: TABLE post_list_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_list_info IS '表创建注释';


--
-- TOC entry 8840 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.id IS '主键ID';


--
-- TOC entry 8841 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.status IS '分区域审核-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8842 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.status_by_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.status_by_user_id IS '审核人ID';


--
-- TOC entry 8843 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.status_by_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.status_by_user_name IS '审核人姓名';


--
-- TOC entry 8844 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.post_list_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.post_list_id IS '岗位责任制清单表ID（多）';


--
-- TOC entry 8845 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.type IS '类型（1-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求）';


--
-- TOC entry 8846 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.sequence_project; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.sequence_project IS '序号/项目（1、2）';


--
-- TOC entry 8847 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.level_one; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_one IS '一级事项（1）';


--
-- TOC entry 8848 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.level_two; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_two IS '二级事项（1）';


--
-- TOC entry 8849 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.level_three; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_three IS '三级事项（1）';


--
-- TOC entry 8850 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.level_four; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_four IS '四级事项（1）';


--
-- TOC entry 8851 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.level_five; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_five IS '五级事项（1）';


--
-- TOC entry 8852 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.work_standard; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.work_standard IS '工作标准（1）';


--
-- TOC entry 8853 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.requirement; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.requirement IS '要求（2）';


--
-- TOC entry 8854 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.remark IS '备注';


--
-- TOC entry 8855 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8856 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.create_time IS '创建时间';


--
-- TOC entry 8857 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.create_by IS '创建者';


--
-- TOC entry 8858 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.update_time IS '更新时间';


--
-- TOC entry 8859 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.update_by IS '更新者';


--
-- TOC entry 8860 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN post_list_info.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.create_user_id IS '创建者用户ID';


--
-- TOC entry 579 (class 1259 OID 16983)
-- Name: post_plan; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_plan (
    id bigint NOT NULL,
    name character varying(255 char),
    content character varying(255 char),
    start_time timestamp(0) with time zone,
    end_time timestamp(0) with time zone,
    status integer NOT NULL,
    remark character varying(255 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    check_group_id bigint NOT NULL,
    check_team_id bigint NOT NULL,
    status_icfa integer,
    date_icfa datetime,
    reason_icfa character varying(255 char),
    status_hr integer,
    date_hr datetime,
    reason_hr character varying(255 char),
    status_time datetime,
    status_user_id bigint,
    status_icfa_user_id integer,
    status_hr_user_id integer
);


ALTER TABLE public.post_plan OWNER TO postcheckuser;

--
-- TOC entry 8861 (class 0 OID 0)
-- Dependencies: 579
-- Name: TABLE post_plan; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_plan IS '岗检计划';


--
-- TOC entry 8862 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.id IS '主键ID';


--
-- TOC entry 8863 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.name IS '名称';


--
-- TOC entry 8864 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.content; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.content IS '内容';


--
-- TOC entry 8865 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.start_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.start_time IS '开始时间';


--
-- TOC entry 8866 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.end_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.end_time IS '结束时间';


--
-- TOC entry 8867 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status IS '状态：1-待审核；2-审核中；3-通过；4-驳回；';


--
-- TOC entry 8868 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.remark IS '备注';


--
-- TOC entry 8869 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8870 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.create_time IS '创建时间';


--
-- TOC entry 8871 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.create_by IS '创建者';


--
-- TOC entry 8872 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.update_time IS '更新时间';


--
-- TOC entry 8873 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.update_by IS '更新者';


--
-- TOC entry 8874 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.create_user_id IS '创建者用户ID';


--
-- TOC entry 8875 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.check_group_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.check_group_id IS '检查工作组ID';


--
-- TOC entry 8876 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.check_team_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.check_team_id IS '检查小组';


--
-- TOC entry 8877 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status_icfa IS '1-内控法务部审批-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8878 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.date_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.date_icfa IS '1-内控法务部审批-通过日期';


--
-- TOC entry 8879 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.reason_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.reason_icfa IS '1-内控法务部审批-未通过理由';


--
-- TOC entry 8880 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status_hr IS '2-人力资源审批-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8881 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.date_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.date_hr IS '2-人力资源审批-通过日期';


--
-- TOC entry 8882 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.reason_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.reason_hr IS '2-人力资源审批-未通过理由';


--
-- TOC entry 8883 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status_time IS '审核时间';


--
-- TOC entry 8884 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status_user_id IS '审核时人ID';


--
-- TOC entry 8885 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status_icfa_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status_icfa_user_id IS '1-内控法务部审批人ID';


--
-- TOC entry 8886 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status_hr_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status_hr_user_id IS '2-人力资源审批人ID';


--
-- TOC entry 568 (class 1259 OID 16924)
-- Name: post_plan_info; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_plan_info (
    id bigint NOT NULL,
    post_plan_id bigint,
    checked_dept_id bigint,
    check_time timestamp(0) with time zone,
    checked_post_id bigint,
    remark character varying(255 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    status integer,
    print_user_id bigint,
    print_time datetime,
    checked_img varchar,
    checked_user_id bigint,
    checked_time datetime
);


ALTER TABLE public.post_plan_info OWNER TO postcheckuser;

--
-- TOC entry 8887 (class 0 OID 0)
-- Dependencies: 568
-- Name: TABLE post_plan_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_plan_info IS '岗检计划明细表';


--
-- TOC entry 8888 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.id IS '主键ID';


--
-- TOC entry 8889 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.post_plan_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.post_plan_id IS '计划ID';


--
-- TOC entry 8890 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.checked_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.checked_dept_id IS '被检查部门ID';


--
-- TOC entry 8891 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.check_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.check_time IS '检查时间';


--
-- TOC entry 8892 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.checked_post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.checked_post_id IS '被检查岗位ID';


--
-- TOC entry 8893 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.remark IS '备注';


--
-- TOC entry 8894 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8895 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.create_time IS '创建时间';


--
-- TOC entry 8896 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.create_by IS '创建者';


--
-- TOC entry 8897 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.update_time IS '更新时间';


--
-- TOC entry 8898 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.update_by IS '更新者';


--
-- TOC entry 8899 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.create_user_id IS '创建者用户ID';


--
-- TOC entry 8900 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.status IS '岗检状态：1-未检；2-已检；';


--
-- TOC entry 8901 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.print_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.print_user_id IS '打印人ID';


--
-- TOC entry 8902 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.print_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.print_time IS '打印时间';


--
-- TOC entry 8903 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.checked_img; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.checked_img IS '上传：检查后的检查表照片或PDF，磁盘相对路径';


--
-- TOC entry 8904 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.checked_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.checked_user_id IS '上传：检查人ID';


--
-- TOC entry 8905 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.checked_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.checked_time IS '上传：检查时间';


--
-- TOC entry 578 (class 1259 OID 16979)
-- Name: post_plan_info_user; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_plan_info_user (
    id bigint NOT NULL,
    post_plan_info_id bigint,
    checked_user_id bigint,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    type bigint NOT NULL
);


ALTER TABLE public.post_plan_info_user OWNER TO postcheckuser;

--
-- TOC entry 8906 (class 0 OID 0)
-- Dependencies: 578
-- Name: TABLE post_plan_info_user; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_plan_info_user IS '岗检计划明细检查人表';


--
-- TOC entry 8907 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.id IS '主键ID';


--
-- TOC entry 8908 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.post_plan_info_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.post_plan_info_id IS '计划明细ID';


--
-- TOC entry 8909 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.checked_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.checked_user_id IS '检查人员ID';


--
-- TOC entry 8910 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.remark IS '备注';


--
-- TOC entry 8911 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8912 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.create_time IS '创建时间';


--
-- TOC entry 8913 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.create_by IS '创建者';


--
-- TOC entry 8914 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.update_time IS '更新时间';


--
-- TOC entry 8915 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.update_by IS '更新者';


--
-- TOC entry 8916 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.create_user_id IS '创建者用户ID';


--
-- TOC entry 8917 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.type IS '检查人员ID：1-组长；2-组员；';


--
-- TOC entry 577 (class 1259 OID 16975)
-- Name: post_programme; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_programme (
    id bigint NOT NULL,
    name character varying(255 char),
    submit_date timestamp(0) with time zone,
    status_hr integer,
    date_hr timestamp with time zone,
    reason_hr varchar,
    status_icfa integer,
    date_icfa timestamp with time zone,
    reason_icfa varchar,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    disk_path character varying(255 char) NOT NULL,
    dept_id bigint,
    dept_name character varying(64 char),
    status integer,
    status_time datetime,
    status_user_id bigint,
    status_icfa_user_id integer,
    status_hr_user_id integer
);


ALTER TABLE public.post_programme OWNER TO postcheckuser;

--
-- TOC entry 8918 (class 0 OID 0)
-- Dependencies: 577
-- Name: TABLE post_programme; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_programme IS '岗检方案';


--
-- TOC entry 8919 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.id IS '主键ID';


--
-- TOC entry 8920 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.name IS '名称';


--
-- TOC entry 8921 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.submit_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.submit_date IS '提交日期';


--
-- TOC entry 8922 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_hr IS '1-人力资源审批-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8923 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.date_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.date_hr IS '1-人力资源审批-通过日期';


--
-- TOC entry 8924 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.reason_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.reason_hr IS '1-人力资源审批-未通过理由';


--
-- TOC entry 8925 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_icfa IS '2-内控法务部审批-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8926 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.date_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.date_icfa IS '2-内控法务部审批-通过日期';


--
-- TOC entry 8927 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.reason_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.reason_icfa IS '2-内控法务部审批-未通过理由';


--
-- TOC entry 8928 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.remark IS '备注';


--
-- TOC entry 8929 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8930 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.create_time IS '创建时间';


--
-- TOC entry 8931 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.create_by IS '创建者';


--
-- TOC entry 8932 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.update_time IS '更新时间';


--
-- TOC entry 8933 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.update_by IS '更新者';


--
-- TOC entry 8934 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.create_user_id IS '创建者用户ID';


--
-- TOC entry 8935 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.disk_path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.disk_path IS '岗检方案文件地址';


--
-- TOC entry 8936 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.dept_id IS '提交部门ID';


--
-- TOC entry 8937 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.dept_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.dept_name IS '提交部门名称';


--
-- TOC entry 8938 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status IS '状态：1-待审核；2-审核中；3-通过；4-驳回；';


--
-- TOC entry 8939 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_time IS '审核时间';


--
-- TOC entry 8940 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_user_id IS '审核时人ID';


--
-- TOC entry 8941 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_icfa_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_icfa_user_id IS '2-内控法务部审批人ID';


--
-- TOC entry 8942 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_hr_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_hr_user_id IS '1-人力资源审批人ID';


--
-- TOC entry 571 (class 1259 OID 16935)
-- Name: post_programme_template; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_programme_template (
    id bigint NOT NULL,
    plan_name character varying(255 char) NOT NULL,
    template_name character varying(255 char) NOT NULL,
    disk_path character varying(255 char) NOT NULL,
    status integer NOT NULL,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_programme_template OWNER TO postcheckuser;

--
-- TOC entry 8943 (class 0 OID 0)
-- Dependencies: 571
-- Name: TABLE post_programme_template; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_programme_template IS '岗检方案模板';


--
-- TOC entry 8944 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.id IS '主键ID';


--
-- TOC entry 8945 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.plan_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.plan_name IS '方案名称';


--
-- TOC entry 8946 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.template_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.template_name IS '模板名称';


--
-- TOC entry 8947 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.disk_path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.disk_path IS '模板磁盘路径';


--
-- TOC entry 8948 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.status IS '状态（1-启动；2-作废）';


--
-- TOC entry 8949 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.remark IS '备注';


--
-- TOC entry 8950 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8951 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.create_time IS '创建时间';


--
-- TOC entry 8952 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.create_by IS '创建者';


--
-- TOC entry 8953 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.update_time IS '更新时间';


--
-- TOC entry 8954 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.update_by IS '更新者';


--
-- TOC entry 8955 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.create_user_id IS '创建者用户ID';


--
-- TOC entry 591 (class 1259 OID 17087)
-- Name: post_team; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_team (
    id bigint NOT NULL,
    name character varying(255 char),
    parent_id bigint,
    status integer,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint,
    type integer,
    team_type integer DEFAULT 2 NOT NULL
);


ALTER TABLE public.post_team OWNER TO postcheckuser;

--
-- TOC entry 8956 (class 0 OID 0)
-- Dependencies: 591
-- Name: TABLE post_team; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_team IS '岗检小组';


--
-- TOC entry 8957 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.id IS '主键ID';


--
-- TOC entry 8958 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.name IS '名称';


--
-- TOC entry 8959 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.parent_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.parent_id IS '父ID（0代表根节点）';


--
-- TOC entry 8960 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.status IS '状态（1-启用；2-未启用）';


--
-- TOC entry 8961 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.remark IS '备注';


--
-- TOC entry 8962 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8963 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.create_time IS '创建时间';


--
-- TOC entry 8964 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.create_by IS '创建者';


--
-- TOC entry 8965 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.update_time IS '更新时间';


--
-- TOC entry 8966 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.update_by IS '更新者';


--
-- TOC entry 8967 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.create_user_id IS '创建者用户ID';


--
-- TOC entry 8968 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.type IS '类型：1-联合办公室；2-岗检工作组；3-工作小组；';


--
-- TOC entry 8969 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN post_team.team_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.team_type IS 'type=3时，工作小组权限（1-牵头；2-成员）';


--
-- TOC entry 610 (class 1259 OID 17781)
-- Name: post_team_dept; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_team_dept (
    id bigint NOT NULL,
    post_team_id varchar,
    group_team_name varchar NOT NULL,
    type integer DEFAULT 1 NOT NULL,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_team_dept OWNER TO postcheckuser;

--
-- TOC entry 8970 (class 0 OID 0)
-- Dependencies: 610
-- Name: TABLE post_team_dept; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_team_dept IS '(废弃)岗检工作组关联部门';


--
-- TOC entry 8971 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.id IS '主键ID';


--
-- TOC entry 8972 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.post_team_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.post_team_id IS '岗检工作组ID';


--
-- TOC entry 8973 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.group_team_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.group_team_name IS '岗检工作组名称（与部门不相关，自定义的名称，例如：综合岗检工作组、生产岗检工作组）';


--
-- TOC entry 8974 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.type IS '类型（1-牵头；2-成员）';


--
-- TOC entry 8975 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.remark IS '备注';


--
-- TOC entry 8976 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8977 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.create_time IS '创建时间';


--
-- TOC entry 8978 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.create_by IS '创建者';


--
-- TOC entry 8979 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.update_time IS '更新时间';


--
-- TOC entry 8980 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.update_by IS '更新者';


--
-- TOC entry 8981 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN post_team_dept.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_dept.create_user_id IS '创建者用户ID';


--
-- TOC entry 570 (class 1259 OID 16931)
-- Name: post_team_user; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_team_user (
    id bigint NOT NULL,
    post_team_id bigint,
    user_id bigint,
    type integer,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by character varying(64 char) DEFAULT ''::varchar NOT NULL,
    create_user_id bigint
);


ALTER TABLE public.post_team_user OWNER TO postcheckuser;

--
-- TOC entry 8982 (class 0 OID 0)
-- Dependencies: 570
-- Name: TABLE post_team_user; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_team_user IS '岗检小组关联成员';


--
-- TOC entry 8983 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.id IS '主键ID';


--
-- TOC entry 8984 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.post_team_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.post_team_id IS '岗检小组ID';


--
-- TOC entry 8985 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.user_id IS '用户ID';


--
-- TOC entry 8986 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.type IS '类型（1-组长；2-成员；）';


--
-- TOC entry 8987 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.remark IS '备注';


--
-- TOC entry 8988 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8989 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.create_time IS '创建时间';


--
-- TOC entry 8990 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.create_by IS '创建者';


--
-- TOC entry 8991 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.update_time IS '更新时间';


--
-- TOC entry 8992 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.update_by IS '更新者';


--
-- TOC entry 8993 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.create_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.create_user_id IS '创建者用户ID';


--
-- TOC entry 572 (class 1259 OID 16939)
-- Name: qrtz_blob_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_blob_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    blob_data blob
);


ALTER TABLE public.qrtz_blob_triggers OWNER TO postcheckuser;

--
-- TOC entry 8994 (class 0 OID 0)
-- Dependencies: 572
-- Name: TABLE qrtz_blob_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_blob_triggers IS 'Blob类型的触发器表';


--
-- TOC entry 8995 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.sched_name IS '调度名称';


--
-- TOC entry 8996 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 8997 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 8998 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.blob_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.blob_data IS '存放持久化Trigger对象';


--
-- TOC entry 588 (class 1259 OID 17044)
-- Name: qrtz_calendars; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_calendars (
    sched_name character varying(120 char) NOT NULL,
    calendar_name character varying(200 char) NOT NULL,
    calendar blob NOT NULL
);


ALTER TABLE public.qrtz_calendars OWNER TO postcheckuser;

--
-- TOC entry 8999 (class 0 OID 0)
-- Dependencies: 588
-- Name: TABLE qrtz_calendars; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_calendars IS '日历信息表';


--
-- TOC entry 9000 (class 0 OID 0)
-- Dependencies: 588
-- Name: COLUMN qrtz_calendars.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_calendars.sched_name IS '调度名称';


--
-- TOC entry 9001 (class 0 OID 0)
-- Dependencies: 588
-- Name: COLUMN qrtz_calendars.calendar_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_calendars.calendar_name IS '日历名称';


--
-- TOC entry 9002 (class 0 OID 0)
-- Dependencies: 588
-- Name: COLUMN qrtz_calendars.calendar; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_calendars.calendar IS '存放持久化calendar对象';


--
-- TOC entry 574 (class 1259 OID 16950)
-- Name: qrtz_cron_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_cron_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    cron_expression character varying(200 char) NOT NULL,
    time_zone_id character varying(80 char)
);


ALTER TABLE public.qrtz_cron_triggers OWNER TO postcheckuser;

--
-- TOC entry 9003 (class 0 OID 0)
-- Dependencies: 574
-- Name: TABLE qrtz_cron_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_cron_triggers IS 'Cron类型的触发器表';


--
-- TOC entry 9004 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.sched_name IS '调度名称';


--
-- TOC entry 9005 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 9006 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 9007 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.cron_expression; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.cron_expression IS 'cron表达式';


--
-- TOC entry 9008 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.time_zone_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.time_zone_id IS '时区';


--
-- TOC entry 573 (class 1259 OID 16945)
-- Name: qrtz_fired_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_fired_triggers (
    sched_name character varying(120 char) NOT NULL,
    entry_id character varying(95 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    instance_name character varying(200 char) NOT NULL,
    fired_time bigint NOT NULL,
    sched_time bigint NOT NULL,
    priority integer NOT NULL,
    state character varying(16 char) NOT NULL,
    job_name character varying(200 char),
    job_group character varying(200 char),
    is_nonconcurrent character varying(1 char),
    requests_recovery character varying(1 char)
);


ALTER TABLE public.qrtz_fired_triggers OWNER TO postcheckuser;

--
-- TOC entry 9009 (class 0 OID 0)
-- Dependencies: 573
-- Name: TABLE qrtz_fired_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_fired_triggers IS '已触发的触发器表';


--
-- TOC entry 9010 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.sched_name IS '调度名称';


--
-- TOC entry 9011 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.entry_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.entry_id IS '调度器实例id';


--
-- TOC entry 9012 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 9013 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 9014 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.instance_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.instance_name IS '调度器实例名';


--
-- TOC entry 9015 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.fired_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.fired_time IS '触发的时间';


--
-- TOC entry 9016 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.sched_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.sched_time IS '定时器制定的时间';


--
-- TOC entry 9017 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.priority; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.priority IS '优先级';


--
-- TOC entry 9018 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.state; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.state IS '状态';


--
-- TOC entry 9019 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.job_name IS '任务名称';


--
-- TOC entry 9020 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.job_group IS '任务组名';


--
-- TOC entry 9021 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.is_nonconcurrent; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.is_nonconcurrent IS '是否并发';


--
-- TOC entry 9022 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.requests_recovery; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.requests_recovery IS '是否接受恢复执行';


--
-- TOC entry 584 (class 1259 OID 17022)
-- Name: qrtz_job_details; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_job_details (
    sched_name character varying(120 char) NOT NULL,
    job_name character varying(200 char) NOT NULL,
    job_group character varying(200 char) NOT NULL,
    description character varying(250 char),
    job_class_name character varying(250 char) NOT NULL,
    is_durable character varying(1 char) NOT NULL,
    is_nonconcurrent character varying(1 char) NOT NULL,
    is_update_data character varying(1 char) NOT NULL,
    requests_recovery character varying(1 char) NOT NULL,
    job_data blob
);


ALTER TABLE public.qrtz_job_details OWNER TO postcheckuser;

--
-- TOC entry 9023 (class 0 OID 0)
-- Dependencies: 584
-- Name: TABLE qrtz_job_details; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_job_details IS '任务详细信息表';


--
-- TOC entry 9024 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.sched_name IS '调度名称';


--
-- TOC entry 9025 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_name IS '任务名称';


--
-- TOC entry 9026 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_group IS '任务组名';


--
-- TOC entry 9027 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.description; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.description IS '相关介绍';


--
-- TOC entry 9028 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.job_class_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_class_name IS '执行任务类名称';


--
-- TOC entry 9029 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.is_durable; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.is_durable IS '是否持久化';


--
-- TOC entry 9030 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.is_nonconcurrent; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.is_nonconcurrent IS '是否并发';


--
-- TOC entry 9031 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.is_update_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.is_update_data IS '是否更新数据';


--
-- TOC entry 9032 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.requests_recovery; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.requests_recovery IS '是否接受恢复执行';


--
-- TOC entry 9033 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN qrtz_job_details.job_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_data IS '存放持久化job对象';


--
-- TOC entry 569 (class 1259 OID 16928)
-- Name: qrtz_locks; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_locks (
    sched_name character varying(120 char) NOT NULL,
    lock_name character varying(40 char) NOT NULL
);


ALTER TABLE public.qrtz_locks OWNER TO postcheckuser;

--
-- TOC entry 9034 (class 0 OID 0)
-- Dependencies: 569
-- Name: TABLE qrtz_locks; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_locks IS '存储的悲观锁信息表';


--
-- TOC entry 9035 (class 0 OID 0)
-- Dependencies: 569
-- Name: COLUMN qrtz_locks.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_locks.sched_name IS '调度名称';


--
-- TOC entry 9036 (class 0 OID 0)
-- Dependencies: 569
-- Name: COLUMN qrtz_locks.lock_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_locks.lock_name IS '悲观锁名称';


--
-- TOC entry 592 (class 1259 OID 17091)
-- Name: qrtz_paused_trigger_grps; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_paused_trigger_grps (
    sched_name character varying(120 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL
);


ALTER TABLE public.qrtz_paused_trigger_grps OWNER TO postcheckuser;

--
-- TOC entry 9037 (class 0 OID 0)
-- Dependencies: 592
-- Name: TABLE qrtz_paused_trigger_grps; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_paused_trigger_grps IS '暂停的触发器表';


--
-- TOC entry 9038 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN qrtz_paused_trigger_grps.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_paused_trigger_grps.sched_name IS '调度名称';


--
-- TOC entry 9039 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN qrtz_paused_trigger_grps.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_paused_trigger_grps.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 582 (class 1259 OID 17012)
-- Name: qrtz_scheduler_state; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_scheduler_state (
    sched_name character varying(120 char) NOT NULL,
    instance_name character varying(200 char) NOT NULL,
    last_checkin_time bigint NOT NULL,
    checkin_interval bigint NOT NULL
);


ALTER TABLE public.qrtz_scheduler_state OWNER TO postcheckuser;

--
-- TOC entry 9040 (class 0 OID 0)
-- Dependencies: 582
-- Name: TABLE qrtz_scheduler_state; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_scheduler_state IS '调度器状态表';


--
-- TOC entry 9041 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN qrtz_scheduler_state.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.sched_name IS '调度名称';


--
-- TOC entry 9042 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN qrtz_scheduler_state.instance_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.instance_name IS '实例名称';


--
-- TOC entry 9043 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN qrtz_scheduler_state.last_checkin_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.last_checkin_time IS '上次检查时间';


--
-- TOC entry 9044 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN qrtz_scheduler_state.checkin_interval; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.checkin_interval IS '检查间隔时间';


--
-- TOC entry 599 (class 1259 OID 17144)
-- Name: qrtz_simple_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_simple_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    repeat_count bigint NOT NULL,
    repeat_interval bigint NOT NULL,
    times_triggered bigint NOT NULL
);


ALTER TABLE public.qrtz_simple_triggers OWNER TO postcheckuser;

--
-- TOC entry 9045 (class 0 OID 0)
-- Dependencies: 599
-- Name: TABLE qrtz_simple_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_simple_triggers IS '简单触发器的信息表';


--
-- TOC entry 9046 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN qrtz_simple_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.sched_name IS '调度名称';


--
-- TOC entry 9047 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN qrtz_simple_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 9048 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN qrtz_simple_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 9049 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN qrtz_simple_triggers.repeat_count; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.repeat_count IS '重复的次数统计';


--
-- TOC entry 9050 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN qrtz_simple_triggers.repeat_interval; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.repeat_interval IS '重复的间隔时间';


--
-- TOC entry 9051 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN qrtz_simple_triggers.times_triggered; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.times_triggered IS '已经触发的次数';


--
-- TOC entry 585 (class 1259 OID 17030)
-- Name: qrtz_simprop_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_simprop_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    str_prop_1 character varying(512 char),
    str_prop_2 character varying(512 char),
    str_prop_3 character varying(512 char),
    int_prop_1 integer,
    int_prop_2 integer,
    long_prop_1 bigint,
    long_prop_2 bigint,
    dec_prop_1 numeric(13,4),
    dec_prop_2 numeric(13,4),
    bool_prop_1 character varying(1 char),
    bool_prop_2 character varying(1 char)
);


ALTER TABLE public.qrtz_simprop_triggers OWNER TO postcheckuser;

--
-- TOC entry 9052 (class 0 OID 0)
-- Dependencies: 585
-- Name: TABLE qrtz_simprop_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_simprop_triggers IS '同步机制的行锁表';


--
-- TOC entry 9053 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.sched_name IS '调度名称';


--
-- TOC entry 9054 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 9055 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 9056 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.str_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.str_prop_1 IS 'String类型的trigger的第一个参数';


--
-- TOC entry 9057 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.str_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.str_prop_2 IS 'String类型的trigger的第二个参数';


--
-- TOC entry 9058 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.str_prop_3; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.str_prop_3 IS 'String类型的trigger的第三个参数';


--
-- TOC entry 9059 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.int_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.int_prop_1 IS 'int类型的trigger的第一个参数';


--
-- TOC entry 9060 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.int_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.int_prop_2 IS 'int类型的trigger的第二个参数';


--
-- TOC entry 9061 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.long_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.long_prop_1 IS 'long类型的trigger的第一个参数';


--
-- TOC entry 9062 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.long_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.long_prop_2 IS 'long类型的trigger的第二个参数';


--
-- TOC entry 9063 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.dec_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.dec_prop_1 IS 'decimal类型的trigger的第一个参数';


--
-- TOC entry 9064 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.dec_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.dec_prop_2 IS 'decimal类型的trigger的第二个参数';


--
-- TOC entry 9065 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.bool_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.bool_prop_1 IS 'Boolean类型的trigger的第一个参数';


--
-- TOC entry 9066 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_simprop_triggers.bool_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.bool_prop_2 IS 'Boolean类型的trigger的第二个参数';


--
-- TOC entry 602 (class 1259 OID 17168)
-- Name: qrtz_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    job_name character varying(200 char) NOT NULL,
    job_group character varying(200 char) NOT NULL,
    description character varying(250 char),
    next_fire_time bigint,
    prev_fire_time bigint,
    priority integer,
    trigger_state character varying(16 char) NOT NULL,
    trigger_type character varying(8 char) NOT NULL,
    start_time bigint NOT NULL,
    end_time bigint,
    calendar_name character varying(200 char),
    misfire_instr smallint,
    job_data blob
);


ALTER TABLE public.qrtz_triggers OWNER TO postcheckuser;

--
-- TOC entry 9067 (class 0 OID 0)
-- Dependencies: 602
-- Name: TABLE qrtz_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_triggers IS '触发器详细信息表';


--
-- TOC entry 9068 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.sched_name IS '调度名称';


--
-- TOC entry 9069 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_name IS '触发器的名字';


--
-- TOC entry 9070 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_group IS '触发器所属组的名字';


--
-- TOC entry 9071 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.job_name IS 'qrtz_job_details表job_name的外键';


--
-- TOC entry 9072 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.job_group IS 'qrtz_job_details表job_group的外键';


--
-- TOC entry 9073 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.description; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.description IS '相关介绍';


--
-- TOC entry 9074 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.next_fire_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.next_fire_time IS '上一次触发时间（毫秒）';


--
-- TOC entry 9075 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.prev_fire_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.prev_fire_time IS '下一次触发时间（默认为-1表示不触发）';


--
-- TOC entry 9076 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.priority; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.priority IS '优先级';


--
-- TOC entry 9077 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.trigger_state; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_state IS '触发器状态';


--
-- TOC entry 9078 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.trigger_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_type IS '触发器的类型';


--
-- TOC entry 9079 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.start_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.start_time IS '开始时间';


--
-- TOC entry 9080 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.end_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.end_time IS '结束时间';


--
-- TOC entry 9081 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.calendar_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.calendar_name IS '日程表名称';


--
-- TOC entry 9082 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.misfire_instr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.misfire_instr IS '补偿执行的策略';


--
-- TOC entry 9083 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN qrtz_triggers.job_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.job_data IS '存放持久化job对象';


--
-- TOC entry 576 (class 1259 OID 16962)
-- Name: sys_con; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_con (
    config_id integer NOT NULL,
    config_name character varying(100 char) DEFAULT ''::varchar,
    config_key character varying(100 char) DEFAULT ''::varchar,
    config_value character varying(500 char) DEFAULT ''::varchar,
    config_type character(1 char) DEFAULT 'N'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_con OWNER TO postcheckuser;

--
-- TOC entry 9084 (class 0 OID 0)
-- Dependencies: 576
-- Name: TABLE sys_con; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_con IS '参数配置表';


--
-- TOC entry 9085 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_id IS '参数主键';


--
-- TOC entry 9086 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_name IS '参数名称';


--
-- TOC entry 9087 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_key; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_key IS '参数键名';


--
-- TOC entry 9088 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_value; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_value IS '参数键值';


--
-- TOC entry 9089 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_type IS '系统内置（Y是 N否）';


--
-- TOC entry 9090 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.create_by IS '创建者';


--
-- TOC entry 9091 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.create_time IS '创建时间';


--
-- TOC entry 9092 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.update_by IS '更新者';


--
-- TOC entry 9093 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.update_time IS '更新时间';


--
-- TOC entry 9094 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.remark IS '备注';


--
-- TOC entry 581 (class 1259 OID 16990)
-- Name: sys_dept; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_dept (
    dept_id bigint NOT NULL,
    parent_id bigint DEFAULT 0,
    ancestors character varying(50 char) DEFAULT ''::varchar,
    dept_name character varying(30 char) DEFAULT ''::varchar,
    order_num integer DEFAULT 0,
    leader character varying(20 char),
    phone character varying(11 char),
    email character varying(50 char),
    status character(1 char) DEFAULT '0'::bpchar,
    del_flag character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone
);


ALTER TABLE public.sys_dept OWNER TO postcheckuser;

--
-- TOC entry 9095 (class 0 OID 0)
-- Dependencies: 581
-- Name: TABLE sys_dept; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_dept IS '部门表';


--
-- TOC entry 9096 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.dept_id IS '部门id';


--
-- TOC entry 9097 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.parent_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.parent_id IS '父部门id';


--
-- TOC entry 9098 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.ancestors; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.ancestors IS '祖级列表';


--
-- TOC entry 9099 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.dept_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.dept_name IS '部门名称';


--
-- TOC entry 9100 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.order_num; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.order_num IS '显示顺序';


--
-- TOC entry 9101 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.leader; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.leader IS '负责人';


--
-- TOC entry 9102 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.phone; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.phone IS '联系电话';


--
-- TOC entry 9103 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.email; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.email IS '邮箱';


--
-- TOC entry 9104 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.status IS '部门状态（0正常 1停用）';


--
-- TOC entry 9105 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 9106 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.create_by IS '创建者';


--
-- TOC entry 9107 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.create_time IS '创建时间';


--
-- TOC entry 9108 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.update_by IS '更新者';


--
-- TOC entry 9109 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.update_time IS '更新时间';


--
-- TOC entry 603 (class 1259 OID 17180)
-- Name: sys_dict_data; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_dict_data (
    dict_code bigint NOT NULL,
    dict_sort integer DEFAULT 0,
    dict_label character varying(100 char) DEFAULT ''::varchar,
    dict_value character varying(100 char) DEFAULT ''::varchar,
    dict_type character varying(100 char) DEFAULT ''::varchar,
    css_class character varying(100 char),
    list_class character varying(100 char),
    is_default character(1 char) DEFAULT 'N'::bpchar,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_dict_data OWNER TO postcheckuser;

--
-- TOC entry 9110 (class 0 OID 0)
-- Dependencies: 603
-- Name: TABLE sys_dict_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_dict_data IS '字典数据表';


--
-- TOC entry 9111 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.dict_code; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_code IS '字典编码';


--
-- TOC entry 9112 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.dict_sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_sort IS '字典排序';


--
-- TOC entry 9113 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.dict_label; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_label IS '字典标签';


--
-- TOC entry 9114 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.dict_value; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_value IS '字典键值';


--
-- TOC entry 9115 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_type IS '字典类型';


--
-- TOC entry 9116 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.css_class; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.css_class IS '样式属性（其他样式扩展）';


--
-- TOC entry 9117 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.list_class; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.list_class IS '表格回显样式';


--
-- TOC entry 9118 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.is_default; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.is_default IS '是否默认（Y是 N否）';


--
-- TOC entry 9119 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.status IS '状态（0正常 1停用）';


--
-- TOC entry 9120 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.create_by IS '创建者';


--
-- TOC entry 9121 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.create_time IS '创建时间';


--
-- TOC entry 9122 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.update_by IS '更新者';


--
-- TOC entry 9123 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.update_time IS '更新时间';


--
-- TOC entry 9124 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN sys_dict_data.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.remark IS '备注';


--
-- TOC entry 609 (class 1259 OID 17248)
-- Name: sys_dict_type; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_dict_type (
    dict_id bigint NOT NULL,
    dict_name character varying(100 char) DEFAULT ''::varchar,
    dict_type character varying(100 char) DEFAULT ''::varchar,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_dict_type OWNER TO postcheckuser;

--
-- TOC entry 9125 (class 0 OID 0)
-- Dependencies: 609
-- Name: TABLE sys_dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_dict_type IS '字典类型表';


--
-- TOC entry 9126 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.dict_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.dict_id IS '字典主键';


--
-- TOC entry 9127 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.dict_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.dict_name IS '字典名称';


--
-- TOC entry 9128 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.dict_type IS '字典类型';


--
-- TOC entry 9129 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.status IS '状态（0正常 1停用）';


--
-- TOC entry 9130 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.create_by IS '创建者';


--
-- TOC entry 9131 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.create_time IS '创建时间';


--
-- TOC entry 9132 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.update_by IS '更新者';


--
-- TOC entry 9133 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.update_time IS '更新时间';


--
-- TOC entry 9134 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_dict_type.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.remark IS '备注';


--
-- TOC entry 601 (class 1259 OID 17156)
-- Name: sys_job; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_job (
    job_id bigint NOT NULL,
    job_name character varying(64 char) DEFAULT ''::varchar NOT NULL,
    job_group character varying(64 char) DEFAULT 'DEFAULT'::varchar NOT NULL,
    invoke_target character varying(500 char) NOT NULL,
    cron_expression character varying(255 char) DEFAULT ''::varchar,
    misfire_policy character varying(20 char) DEFAULT '3'::varchar,
    concurrent character(1 char) DEFAULT '1'::bpchar,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char) DEFAULT ''::varchar
);


ALTER TABLE public.sys_job OWNER TO postcheckuser;

--
-- TOC entry 9135 (class 0 OID 0)
-- Dependencies: 601
-- Name: TABLE sys_job; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_job IS '定时任务调度表';


--
-- TOC entry 9136 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.job_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.job_id IS '任务ID';


--
-- TOC entry 9137 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.job_name IS '任务名称';


--
-- TOC entry 9138 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.job_group IS '任务组名';


--
-- TOC entry 9139 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.invoke_target; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.invoke_target IS '调用目标字符串';


--
-- TOC entry 9140 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.cron_expression; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.cron_expression IS 'cron执行表达式';


--
-- TOC entry 9141 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.misfire_policy; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.misfire_policy IS '计划执行错误策略（1立即执行 2执行一次 3放弃执行）';


--
-- TOC entry 9142 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.concurrent; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.concurrent IS '是否并发执行（0允许 1禁止）';


--
-- TOC entry 9143 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.status IS '状态（0正常 1暂停）';


--
-- TOC entry 9144 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.create_by IS '创建者';


--
-- TOC entry 9145 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.create_time IS '创建时间';


--
-- TOC entry 9146 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.update_by IS '更新者';


--
-- TOC entry 9147 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.update_time IS '更新时间';


--
-- TOC entry 9148 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_job.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.remark IS '备注信息';


--
-- TOC entry 567 (class 1259 OID 16916)
-- Name: sys_job_log; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_job_log (
    job_log_id bigint NOT NULL,
    job_name character varying(64 char) NOT NULL,
    job_group character varying(64 char) NOT NULL,
    invoke_target character varying(500 char) NOT NULL,
    job_message character varying(500 char),
    status character(1 char) DEFAULT '0'::bpchar,
    exception_info character varying(2000 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone
);


ALTER TABLE public.sys_job_log OWNER TO postcheckuser;

--
-- TOC entry 9149 (class 0 OID 0)
-- Dependencies: 567
-- Name: TABLE sys_job_log; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_job_log IS '定时任务调度日志表';


--
-- TOC entry 9150 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_log_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_log_id IS '任务日志ID';


--
-- TOC entry 9151 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_name IS '任务名称';


--
-- TOC entry 9152 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_group IS '任务组名';


--
-- TOC entry 9153 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.invoke_target; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.invoke_target IS '调用目标字符串';


--
-- TOC entry 9154 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_message; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_message IS '日志信息';


--
-- TOC entry 9155 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.status IS '执行状态（0正常 1失败）';


--
-- TOC entry 9156 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.exception_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.exception_info IS '异常信息';


--
-- TOC entry 9157 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.create_time IS '创建时间';


--
-- TOC entry 608 (class 1259 OID 17234)
-- Name: sys_logininfor; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_logininfor (
    info_id bigint NOT NULL,
    user_name character varying(50 char) DEFAULT ''::varchar,
    ipaddr character varying(128 char) DEFAULT ''::varchar,
    login_location character varying(255 char) DEFAULT ''::varchar,
    browser character varying(50 char) DEFAULT ''::varchar,
    os character varying(50 char) DEFAULT ''::varchar,
    status character(1 char) DEFAULT '0'::bpchar,
    msg character varying(255 char) DEFAULT ''::varchar,
    login_time timestamp(0) with time zone
);


ALTER TABLE public.sys_logininfor OWNER TO postcheckuser;

--
-- TOC entry 9158 (class 0 OID 0)
-- Dependencies: 608
-- Name: TABLE sys_logininfor; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_logininfor IS '系统访问记录';


--
-- TOC entry 9159 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.info_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.info_id IS '访问ID';


--
-- TOC entry 9160 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.user_name IS '用户账号';


--
-- TOC entry 9161 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.ipaddr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.ipaddr IS '登录IP地址';


--
-- TOC entry 9162 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.login_location; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.login_location IS '登录地点';


--
-- TOC entry 9163 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.browser; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.browser IS '浏览器类型';


--
-- TOC entry 9164 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.os; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.os IS '操作系统';


--
-- TOC entry 9165 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.status IS '登录状态（0成功 1失败）';


--
-- TOC entry 9166 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.msg; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.msg IS '提示消息';


--
-- TOC entry 9167 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN sys_logininfor.login_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.login_time IS '访问时间';


--
-- TOC entry 604 (class 1259 OID 17191)
-- Name: sys_menu; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_menu (
    menu_id bigint NOT NULL,
    menu_name character varying(50 char) NOT NULL,
    parent_id bigint DEFAULT 0,
    order_num integer DEFAULT 0,
    path character varying(200 char) DEFAULT ''::varchar,
    component character varying(255 char),
    query character varying(255 char),
    is_frame integer DEFAULT 1,
    is_cache integer DEFAULT 0,
    menu_type character(1 char) DEFAULT ''::bpchar,
    visible character(1 char) DEFAULT '0'::bpchar,
    status character(1 char) DEFAULT '0'::bpchar,
    perms character varying(100 char),
    icon character varying(100 char) DEFAULT '#'::varchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char) DEFAULT ''::varchar
);


ALTER TABLE public.sys_menu OWNER TO postcheckuser;

--
-- TOC entry 9168 (class 0 OID 0)
-- Dependencies: 604
-- Name: TABLE sys_menu; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_menu IS '菜单权限表';


--
-- TOC entry 9169 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.menu_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.menu_id IS '菜单ID';


--
-- TOC entry 9170 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.menu_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.menu_name IS '菜单名称';


--
-- TOC entry 9171 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.parent_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.parent_id IS '父菜单ID';


--
-- TOC entry 9172 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.order_num; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.order_num IS '显示顺序';


--
-- TOC entry 9173 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.path IS '路由地址';


--
-- TOC entry 9174 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.component; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.component IS '组件路径';


--
-- TOC entry 9175 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.query; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.query IS '路由参数';


--
-- TOC entry 9176 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.is_frame; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.is_frame IS '是否为外链（0是 1否）';


--
-- TOC entry 9177 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.is_cache; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.is_cache IS '是否缓存（0缓存 1不缓存）';


--
-- TOC entry 9178 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.menu_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.menu_type IS '菜单类型（M目录 C菜单 F按钮）';


--
-- TOC entry 9179 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.visible; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.visible IS '菜单状态（0显示 1隐藏）';


--
-- TOC entry 9180 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.status IS '菜单状态（0正常 1停用）';


--
-- TOC entry 9181 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.perms; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.perms IS '权限标识';


--
-- TOC entry 9182 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.icon; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.icon IS '菜单图标';


--
-- TOC entry 9183 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.create_by IS '创建者';


--
-- TOC entry 9184 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.create_time IS '创建时间';


--
-- TOC entry 9185 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.update_by IS '更新者';


--
-- TOC entry 9186 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.update_time IS '更新时间';


--
-- TOC entry 9187 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_menu.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.remark IS '备注';


--
-- TOC entry 595 (class 1259 OID 17113)
-- Name: sys_notice; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_notice (
    notice_id integer NOT NULL,
    notice_title character varying(50 char) NOT NULL,
    notice_type character(1 char) NOT NULL,
    notice_content blob,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(255 char)
);


ALTER TABLE public.sys_notice OWNER TO postcheckuser;

--
-- TOC entry 9188 (class 0 OID 0)
-- Dependencies: 595
-- Name: TABLE sys_notice; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_notice IS '通知公告表';


--
-- TOC entry 9189 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.notice_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_id IS '公告ID';


--
-- TOC entry 9190 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.notice_title; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_title IS '公告标题';


--
-- TOC entry 9191 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.notice_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_type IS '公告类型（1通知 2公告）';


--
-- TOC entry 9192 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.notice_content; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_content IS '公告内容';


--
-- TOC entry 9193 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.status IS '公告状态（0正常 1关闭）';


--
-- TOC entry 9194 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.create_by IS '创建者';


--
-- TOC entry 9195 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.create_time IS '创建时间';


--
-- TOC entry 9196 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.update_by IS '更新者';


--
-- TOC entry 9197 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.update_time IS '更新时间';


--
-- TOC entry 9198 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN sys_notice.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.remark IS '备注';


--
-- TOC entry 590 (class 1259 OID 17066)
-- Name: sys_oper_log; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_oper_log (
    oper_id bigint NOT NULL,
    title character varying(50 char) DEFAULT ''::varchar,
    business_type integer DEFAULT 0,
    method character varying(100 char) DEFAULT ''::varchar,
    request_method character varying(10 char) DEFAULT ''::varchar,
    operator_type integer DEFAULT 0,
    oper_name character varying(50 char) DEFAULT ''::varchar,
    dept_name character varying(50 char) DEFAULT ''::varchar,
    oper_url character varying(255 char) DEFAULT ''::varchar,
    oper_ip character varying(128 char) DEFAULT ''::varchar,
    oper_location character varying(255 char) DEFAULT ''::varchar,
    oper_param character varying(2000 char) DEFAULT ''::varchar,
    json_result character varying(2000 char) DEFAULT ''::varchar,
    status integer DEFAULT 0,
    error_msg character varying(2000 char) DEFAULT ''::varchar,
    oper_time timestamp(0) with time zone,
    cost_time bigint DEFAULT 0
);


ALTER TABLE public.sys_oper_log OWNER TO postcheckuser;

--
-- TOC entry 9199 (class 0 OID 0)
-- Dependencies: 590
-- Name: TABLE sys_oper_log; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_oper_log IS '操作日志记录';


--
-- TOC entry 9200 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_id IS '日志主键';


--
-- TOC entry 9201 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.title; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.title IS '模块标题';


--
-- TOC entry 9202 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.business_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.business_type IS '业务类型（0其它 1新增 2修改 3删除）';


--
-- TOC entry 9203 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.method; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.method IS '方法名称';


--
-- TOC entry 9204 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.request_method; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.request_method IS '请求方式';


--
-- TOC entry 9205 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.operator_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.operator_type IS '操作类别（0其它 1后台用户 2手机端用户）';


--
-- TOC entry 9206 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_name IS '操作人员';


--
-- TOC entry 9207 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.dept_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.dept_name IS '部门名称';


--
-- TOC entry 9208 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_url; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_url IS '请求URL';


--
-- TOC entry 9209 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_ip; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_ip IS '主机地址';


--
-- TOC entry 9210 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_location; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_location IS '操作地点';


--
-- TOC entry 9211 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_param; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_param IS '请求参数';


--
-- TOC entry 9212 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.json_result; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.json_result IS '返回参数';


--
-- TOC entry 9213 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.status IS '操作状态（0正常 1异常）';


--
-- TOC entry 9214 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.error_msg; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.error_msg IS '错误消息';


--
-- TOC entry 9215 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.oper_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_time IS '操作时间';


--
-- TOC entry 9216 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN sys_oper_log.cost_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.cost_time IS '消耗时间';


--
-- TOC entry 593 (class 1259 OID 17096)
-- Name: sys_post; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_post (
    post_id bigint NOT NULL,
    post_code character varying(64 char) NOT NULL,
    post_name character varying(50 char) NOT NULL,
    post_sort integer NOT NULL,
    status character(1 char) NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_post OWNER TO postcheckuser;

--
-- TOC entry 9217 (class 0 OID 0)
-- Dependencies: 593
-- Name: TABLE sys_post; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_post IS '岗位信息表';


--
-- TOC entry 9218 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_id IS '岗位ID';


--
-- TOC entry 9219 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.post_code; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_code IS '岗位编码';


--
-- TOC entry 9220 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.post_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_name IS '岗位名称';


--
-- TOC entry 9221 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.post_sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_sort IS '显示顺序';


--
-- TOC entry 9222 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.status IS '状态（0正常 1停用）';


--
-- TOC entry 9223 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.create_by IS '创建者';


--
-- TOC entry 9224 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.create_time IS '创建时间';


--
-- TOC entry 9225 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.update_by IS '更新者';


--
-- TOC entry 9226 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.update_time IS '更新时间';


--
-- TOC entry 9227 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN sys_post.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.remark IS '备注';


--
-- TOC entry 598 (class 1259 OID 17141)
-- Name: sys_role; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_role (
    role_id bigint NOT NULL,
    role_name character varying(30 char) NOT NULL,
    role_key character varying(100 char) NOT NULL,
    role_sort integer NOT NULL,
    data_scope character(1 char) DEFAULT '1'::bpchar,
    menu_check_strictly tinyint DEFAULT 1,
    dept_check_strictly tinyint DEFAULT 1,
    status character(1 char) NOT NULL,
    del_flag character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_role OWNER TO postcheckuser;

--
-- TOC entry 9228 (class 0 OID 0)
-- Dependencies: 598
-- Name: TABLE sys_role; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_role IS '角色信息表';


--
-- TOC entry 9229 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_id IS '角色ID';


--
-- TOC entry 9230 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.role_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_name IS '角色名称';


--
-- TOC entry 9231 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.role_key; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_key IS '角色权限字符串';


--
-- TOC entry 9232 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.role_sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_sort IS '显示顺序';


--
-- TOC entry 9233 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.data_scope; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.data_scope IS '数据范围（1：全部数据权限 2：自定数据权限 3：本部门数据权限 4：本部门及以下数据权限）';


--
-- TOC entry 9234 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.menu_check_strictly; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.menu_check_strictly IS '菜单树选择项是否关联显示';


--
-- TOC entry 9235 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.dept_check_strictly; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.dept_check_strictly IS '部门树选择项是否关联显示';


--
-- TOC entry 9236 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.status IS '角色状态（0正常 1停用）';


--
-- TOC entry 9237 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 9238 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.create_by IS '创建者';


--
-- TOC entry 9239 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.create_time IS '创建时间';


--
-- TOC entry 9240 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.update_by IS '更新者';


--
-- TOC entry 9241 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.update_time IS '更新时间';


--
-- TOC entry 9242 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_role.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.remark IS '备注';


--
-- TOC entry 587 (class 1259 OID 17040)
-- Name: sys_role_dept; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_role_dept (
    role_id bigint NOT NULL,
    dept_id bigint NOT NULL
);


ALTER TABLE public.sys_role_dept OWNER TO postcheckuser;

--
-- TOC entry 9243 (class 0 OID 0)
-- Dependencies: 587
-- Name: TABLE sys_role_dept; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_role_dept IS '角色和部门关联表';


--
-- TOC entry 9244 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN sys_role_dept.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_dept.role_id IS '角色ID';


--
-- TOC entry 9245 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN sys_role_dept.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_dept.dept_id IS '部门ID';


--
-- TOC entry 606 (class 1259 OID 17217)
-- Name: sys_role_menu; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_role_menu (
    role_id bigint NOT NULL,
    menu_id bigint NOT NULL
);


ALTER TABLE public.sys_role_menu OWNER TO postcheckuser;

--
-- TOC entry 9246 (class 0 OID 0)
-- Dependencies: 606
-- Name: TABLE sys_role_menu; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_role_menu IS '角色和菜单关联表';


--
-- TOC entry 9247 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN sys_role_menu.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_menu.role_id IS '角色ID';


--
-- TOC entry 9248 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN sys_role_menu.menu_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_menu.menu_id IS '菜单ID';


--
-- TOC entry 596 (class 1259 OID 17122)
-- Name: sys_user_post; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_user_post (
    user_id bigint NOT NULL,
    post_id bigint NOT NULL
);


ALTER TABLE public.sys_user_post OWNER TO postcheckuser;

--
-- TOC entry 9251 (class 0 OID 0)
-- Dependencies: 596
-- Name: TABLE sys_user_post; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_user_post IS '用户与岗位关联表';


--
-- TOC entry 9252 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_user_post.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_post.user_id IS '用户ID';


--
-- TOC entry 9253 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_user_post.post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_post.post_id IS '岗位ID';


--
-- TOC entry 600 (class 1259 OID 17153)
-- Name: sys_user_role; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_user_role (
    user_id bigint NOT NULL,
    role_id bigint NOT NULL
);


ALTER TABLE public.sys_user_role OWNER TO postcheckuser;

--
-- TOC entry 9254 (class 0 OID 0)
-- Dependencies: 600
-- Name: TABLE sys_user_role; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_user_role IS '用户和角色关联表';


--
-- TOC entry 9255 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN sys_user_role.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_role.user_id IS '用户ID';


--
-- TOC entry 9256 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN sys_user_role.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_role.role_id IS '角色ID';


--
-- TOC entry 597 (class 1259 OID 17125)
-- Name: sys_users; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_users (
    user_id bigint NOT NULL,
    dept_id bigint,
    user_name character varying(30 char) NOT NULL,
    nick_name character varying(30 char) NOT NULL,
    user_type character varying(2 char) DEFAULT '00'::varchar,
    email character varying(50 char) DEFAULT ''::varchar,
    phonenumber character varying(11 char) DEFAULT ''::varchar,
    sex character(1 char) DEFAULT '0'::bpchar,
    avatar character varying(100 char) DEFAULT ''::varchar,
    password character varying(100 char) DEFAULT ''::varchar,
    status character(1 char) DEFAULT '0'::bpchar,
    del_flag character(1 char) DEFAULT '0'::bpchar,
    login_ip character varying(128 char) DEFAULT ''::varchar,
    login_date timestamp(0) with time zone,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_users OWNER TO postcheckuser;

--
-- TOC entry 9257 (class 0 OID 0)
-- Dependencies: 597
-- Name: TABLE sys_users; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_users IS '用户信息表';


--
-- TOC entry 9258 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.user_id IS '用户ID';


--
-- TOC entry 9259 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.dept_id IS '部门ID';


--
-- TOC entry 9260 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.user_name IS '用户账号';


--
-- TOC entry 9261 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.nick_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.nick_name IS '用户昵称';


--
-- TOC entry 9262 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.user_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.user_type IS '用户类型（00系统用户）';


--
-- TOC entry 9263 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.email; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.email IS '用户邮箱';


--
-- TOC entry 9264 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.phonenumber; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.phonenumber IS '手机号码';


--
-- TOC entry 9265 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.sex; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.sex IS '用户性别（0男 1女 2未知）';


--
-- TOC entry 9266 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.avatar; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.avatar IS '头像地址';


--
-- TOC entry 9267 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.password; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.password IS '密码';


--
-- TOC entry 9268 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.status IS '帐号状态（0正常 1停用）';


--
-- TOC entry 9269 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 9270 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.login_ip; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.login_ip IS '最后登录IP';


--
-- TOC entry 9271 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.login_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.login_date IS '最后登录时间';


--
-- TOC entry 9272 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.create_by IS '创建者';


--
-- TOC entry 9273 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.create_time IS '创建时间';


--
-- TOC entry 9274 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.update_by IS '更新者';


--
-- TOC entry 9275 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.update_time IS '更新时间';


--
-- TOC entry 9276 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_users.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.remark IS '备注';


--
-- TOC entry 8561 (class 0 OID 17947)
-- Dependencies: 615
-- Data for Name: $post_PostPlanJoinChecked; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8560 (class 0 OID 17944)
-- Dependencies: 614
-- Data for Name: $post_PostPlanJoinProblem; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8535 (class 0 OID 17051)
-- Dependencies: 589
-- Data for Name: gen_table; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (11903831101442, 'post_programme_template', '2.1.2-岗检方案模板', NULL, NULL, 'PostProgrammeTemplate', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'programmeTemplate', '岗检方案模板', 'csg', '1', 'C:\test\gnhz\createCode', '{"parentMenuId":"28684398350338"}', 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (20782669361153, 'post_team', '2.2.1-岗检小组', NULL, NULL, 'PostTeam', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'team', '岗检小组', 'csg', '1', 'C:\test\gnhz\createCode', '{"parentMenuId":"17355455216040"}', 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (21778212581378, 'post_plan_info', '2.3.2-岗检计划明细表', NULL, NULL, 'PostPlanInfo', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postPlanInfo', '岗检计划明细表', 'csg', '1', 'C:\test\gnhz\createCode', '{}', 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (21782784372738, 'post_plan_info_user', '2.3.3-岗检计划明细检查人表', NULL, NULL, 'PostPlanInfoUser', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'planInfoUser', '岗检计划明细检查人表', 'csg', '1', 'C:\test\gnhz\createCode', '{}', 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (302836200067074, 'post_list_info', '1.1.1.1-岗检责任制清单明细', NULL, NULL, 'PostListInfo', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postCheckListInfo', '岗检责任制清单明细', 'csg', '1', 'C:\test\gnhz\createCode', '{}', 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (302827794681858, 'post_list', '1.1.1-岗检责任制清单', 'post_list_info', 'post_list_id', 'PostList', 'sub', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postCheckList', '岗检责任制清单', 'csg', '1', 'C:\test\gnhz\createCode', '{"parentMenuId":"307951506116609"}', 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (17353168139831, 'post_plan', '2.3.1-岗检计划', NULL, NULL, 'PostPlan', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postPlan', '岗检计划', 'csg', '1', 'C:\test\gnhz\createCode', '{"parentMenuId":"17355455216040"}', 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32', '岗检计划');
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (11896495263745, 'post_programme', '2.1.1-岗检方案', NULL, NULL, 'PostProgramme', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'programme', '岗检方案', 'csg', '1', 'C:\test\gnhz\createCode', '{"parentMenuId":"17355455216040"}', 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (729723724357633, 'post_assessment_rating', '4.1.1-考核评比表', NULL, NULL, 'PostAssessmentRating', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'assessmentRating', '考核评比', 'csg', '0', '/', '{"parentMenuId":"689680272056322"}', 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (20787706720257, 'post_team_dept', '2.2.2-岗检工作组添加岗检小组', NULL, NULL, 'PostTeamDept', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'teamDept', '岗检工作组添加岗检小组', 'csg', '1', 'C:\test\gnhz\createCode', '{}', 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (168596933804034, '$post_PostPlanJoinChecked', '3.1.1-岗检记录上传列表-辅助表', NULL, NULL, 'PostPlanJoinChecked', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postPlanJoinChecked', '岗检记录上传列表', 'csg', '0', '/', '{"parentMenuId":"690381161226242"}', 'admin', '2023-12-22 20:04:27', '', '2023-12-22 20:19:38', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (166467322085378, '$post_PostPlanJoinProblem', '3.2.1-岗检问题录入列表-辅助表', NULL, NULL, 'PostPlanJoinProblem', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postPlanJoinProblem', '岗检问题录入列表', 'csg', '0', '/', '{"parentMenuId":"690381161226242"}', 'admin', '2023-12-22 19:56:00', '', '2023-12-22 20:20:16', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (185312766177282, 'post_checked', 'post_checked', NULL, NULL, 'PostChecked', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'checked', 'post_checked', 'csg', '0', '/', '{}', 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (558757534334978, 'post_checked_problem', '3.2.2-岗检问题表', NULL, NULL, 'PostCheckedProblem', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postCheckedProblem', '岗检问题表', 'csg', '0', '/', '{"parentMenuId":175400996667394}', 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (558765130219522, 'post_checked_problem_record', '3.2.2.1-岗检问题操作记录表', NULL, NULL, 'PostCheckedProblemRecord', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postCheckedProblemRecord', '岗检问题操作记录表', 'csg', '0', '/', '{"parentMenuId":175400996667394}', 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (20792089767937, 'post_team_user', '2.2.3-岗检小组关联成员', NULL, NULL, 'PostTeamUser', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'teamUser', '岗检小组关联成员', 'csg', '1', 'C:\test\gnhz\createCode', '{}', 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (640454493450241, 'post_highlights', '6.2.1-岗检亮点', NULL, NULL, 'PostHighlights', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postHighlights', '岗检亮点', 'csg', '0', '/', '{"parentMenuId":"690873270525953"}', 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (288681240596481, 'post_assessment_rules', '4.3.1-考核规则', NULL, NULL, 'PostAssessmentRules', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postAssessmentRules', '考核规则', 'csg', '0', '/', '{"parentMenuId":689680272056322}', 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (288614819598338, 'post_checked_report', '3.4.1-岗检报告管理', NULL, NULL, 'PostCheckedReport', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postCheckedReport', '岗检报告管理', 'csg', '0', '/', '{"parentMenuId":690381161226242}', 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (823219565473793, 'post_assessment_rating_other', '4.2.1-打分表(职能互评生产日常)', NULL, NULL, 'PostAssessmentRatingOther', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postAssessmentRatingOther', '打分表(职能互评生产日常)', 'csg', '0', '/', '{"parentMenuId":"689680272056322"}', 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39', NULL);
INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (823223722029058, 'post_assessment_rating_other_info', '4.2.1.1-打分表明细(职能互评生产日常)', NULL, NULL, 'PostAssessmentRatingOtherInfo', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postCheck', 'postAssessmentRatingOtherInfo', '打分表明细(职能互评生产日常)', 'csg', '0', '/', '{"parentMenuId":689680272056322}', 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29', NULL);


--
-- TOC entry 8553 (class 0 OID 17223)
-- Dependencies: 607
-- Data for Name: gen_table_column; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (732659993010178, 729723724357633, 'dept_id', '部门ID', 'bigint', 'Long', 'deptId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 3, '', '2023-12-21 15:12:11', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (732660261445634, 729723724357633, 'post_id', '岗位名称', 'bigint', 'Long', 'postId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 4, '', '2023-12-21 15:12:11', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (732660462772226, 729723724357633, 'head_user_id', '负责人ID', 'bigint', 'Long', 'headUserId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 5, '', '2023-12-21 15:12:11', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20788428140545, 20787706720257, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20788755296258, 20787706720257, 'post_team_id', '岗检工作组ID', 'varchar', 'String', 'postTeamId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20789086646273, 20787706720257, 'dept_id', '部门ID', 'bigint', 'Long', 'deptId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20789413801986, 20787706720257, 'type', '类型（1-牵头部门；2-成员部门）', 'integer', 'Long', 'type', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'select', '', 4, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20789736763393, 20787706720257, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 5, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11897749360641, 11896495263745, 'id', 'id', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11904565104642, 11903831101442, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11904955174914, 11903831101442, 'plan_name', '方案名称', 'varchar', 'String', 'planName', '0', '0', '1', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11905349439490, 11903831101442, 'template_name', '模板名称', 'varchar', 'String', 'templateName', '0', '0', '1', '1', '1', '1', '1', 'LIKE', 'input', '', 3, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11905676595201, 11903831101442, 'disk_path', '模板磁盘路径', 'varchar', 'String', 'diskPath', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 4, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11905945030657, 11903831101442, 'status', '状态（1-启动；2-作废）', 'integer', 'Integer', 'status', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'radio', '', 5, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11906339295234, 11903831101442, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 6, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11906729365506, 11903831101442, 'del_flag', 'del_flag', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 7, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11907056521218, 11903831101442, 'create_time', 'create_time', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 8, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11907375288321, 11903831101442, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 9, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11907694055425, 11903831101442, 'update_time', 'update_time', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 10, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11908088320001, 11903831101442, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 11, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11908411281410, 11903831101442, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 12, 'admin', '2023-12-19 15:28:07', '', '2023-12-19 17:19:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20783457890306, 20782669361153, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20783847960578, 20782669361153, 'name', '名称', 'varchar', 'String', 'name', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20784372248578, 20782669361153, 'parent_id', '父ID（0代表根节点）', 'bigint', 'Long', 'parentId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20784699404289, 20782669361153, 'status', '状态（1-启用；2-未启用）', 'integer', 'Long', 'status', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'radio', '', 4, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20785026560002, 20782669361153, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 5, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20785353715714, 20782669361153, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 6, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20785613762561, 20782669361153, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 7, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302836854378497, 302836200067074, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302837189922817, 302836200067074, 'status', '分区域审核-状态：1-待审核；3-通过；4-驳回；', 'integer', 'Integer', 'status', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'radio', '', 2, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302837521272833, 302836200067074, 'status_by_user_id', '审核人ID', 'bigint', 'Long', 'statusByUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302837856817154, 302836200067074, 'status_by_user_name', '审核人姓名', 'varchar', 'String', 'statusByUserName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 4, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302838121058306, 302836200067074, 'post_list_id', '岗位责任制清单表ID（多）', 'bigint', 'Long', 'postListId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302838452408322, 302836200067074, 'type', '类型（1-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求）', 'integer', 'Integer', 'type', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'select', '', 6, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302838716649474, 302836200067074, 'sequence_project', '序号/项目（1、2）', 'integer', 'Integer', 'sequenceProject', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 7, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302839110914050, 302836200067074, 'level_one', '一级事项（1）', 'integer', 'Integer', 'levelOne', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302839375155202, 302836200067074, 'level_two', '二级事项（1）', 'integer', 'Integer', 'levelTwo', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302839702310913, 302836200067074, 'level_three', '三级事项（1）', 'integer', 'Integer', 'levelThree', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 10, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302840037855233, 302836200067074, 'level_four', '四级事项（1）', 'integer', 'Integer', 'levelFour', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302840302096386, 302836200067074, 'level_five', '五级事项（1）', 'integer', 'Integer', 'levelFive', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 12, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640455734964225, 640454493450241, 'id', '主键id', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20792811188225, 20792089767937, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20793138343938, 20792089767937, 'post_team_id', '岗检小组ID', 'varchar', 'String', 'postTeamId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20793461305346, 20792089767937, 'user_id', '用户ID', 'bigint', 'Long', 'userId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20793792655361, 20792089767937, 'type', '类型（1-负责人；2-小组成员；）', 'integer', 'Long', 'type', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'select', '', 4, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20794119811074, 20792089767937, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 5, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20794446966785, 20792089767937, 'del_flag', 'del_flag', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 6, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20794769928194, 20792089767937, 'create_time', 'create_time', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 7, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20795159998465, 20792089767937, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 8, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20795684286466, 20792089767937, 'update_time', 'update_time', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 9, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20796015636481, 20792089767937, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 10, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20796342792193, 20792089767937, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:18:10');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20786003832834, 20782669361153, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 8, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20786335182849, 20782669361153, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 9, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20790063919105, 20787706720257, 'del_flag', 'del_flag', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 6, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20790391074817, 20787706720257, 'create_time', 'create_time', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 7, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20790785339394, 20787706720257, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 8, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20791108300802, 20787706720257, 'update_time', 'update_time', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 9, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20791439650818, 20787706720257, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 10, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20791762612226, 20787706720257, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-19 16:03:26', '', '2023-12-21 15:58:17');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20786662338562, 20782669361153, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 10, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20786993688577, 20782669361153, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (20787312455681, 20782669361153, 'type', '类型：1-联合办公室；2-岗检工作组；3-工作小组；', 'integer', 'Integer', 'type', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'select', '', 12, 'admin', '2023-12-19 16:03:26', '', '2023-12-19 17:20:09');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21778929807362, 21778212581378, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21779256963073, 21778212581378, 'post_plan_id', '计划ID', 'bigint', 'Long', 'postPlanId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21779588313089, 21778212581378, 'checked_dept_id', '被检查部门ID', 'bigint', 'Long', 'checkedDeptId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21779915468801, 21778212581378, 'check_time', '检查时间', 'timestamp with time zone', 'Date', 'checkTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 4, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21780234235905, 21778212581378, 'post_id', '被检查岗位ID', 'bigint', 'Long', 'postId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21780557197314, 21778212581378, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 7, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21780884353025, 21778212581378, 'del_flag', 'del_flag', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 8, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21781211508738, 21778212581378, 'create_time', 'create_time', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 9, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21781471555586, 21778212581378, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 10, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21781865820162, 21778212581378, 'update_time', 'update_time', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 11, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21782130061313, 21778212581378, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 12, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21782461411329, 21778212581378, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 13, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:34');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21783438684162, 21782784372738, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21783828754433, 21782784372738, 'post_plan_info_id', '计划明细ID', 'bigint', 'Long', 'postPlanInfoId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21784155910145, 21782784372738, 'checked_user_id', '检查人员ID', 'bigint', 'Long', 'checkedUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21784491454465, 21782784372738, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 4, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21784785055745, 21782784372738, 'del_flag', 'del_flag', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 5, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21785087045633, 21782784372738, 'create_time', 'create_time', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 6, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21785414201345, 21782784372738, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 7, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21785745551361, 21782784372738, 'update_time', 'update_time', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 8, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21786009792514, 21782784372738, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 9, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21786278227969, 21782784372738, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 10, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (21786601189377, 21782784372738, 'type', '检查人员ID：1-组长；2-组员；', 'bigint', 'Integer', 'type', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'select', '', 11, 'admin', '2023-12-19 16:07:23', '', '2023-12-19 17:21:56');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640456255057922, 640454493450241, 'highlights_type', '职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；', 'integer', 'Integer', 'highlightsType', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'select', '', 2, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302828855840769, 302827794681858, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302829187190785, 302827794681858, 'status', '状态：1-待审核；2-审核中；3-通过；4-驳回；', 'integer', 'Long', 'status', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'radio', '', 2, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302829510152194, 302827794681858, 'status_by_user_id', '审核人ID', 'bigint', 'Long', 'statusByUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302829833113602, 302827794681858, 'status_by_user_name', '审核人姓名', 'varchar', 'String', 'statusByUserName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 4, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302830101549058, 302827794681858, 'unit_id', '所在单位', 'varchar', 'String', 'unitId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302830500007938, 302827794681858, 'position_name', '岗位名称', 'varchar', 'String', 'positionName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 6, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11898265260034, 11896495263745, 'name', 'name', 'varchar', 'String', 'name', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302830831357954, 302827794681858, 'position_level', '岗位级别', 'varchar', 'String', 'positionLevel', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 7, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302831166902273, 302827794681858, 'direct_superior', '直接上级', 'varchar', 'String', 'directSuperior', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302831431143426, 302827794681858, 'subordinate_count', '辖员人数', 'integer', 'Integer', 'subordinateCount', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302831833796609, 302827794681858, 'department_name', '所在部门', 'varchar', 'String', 'departmentName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 10, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302832102232065, 302827794681858, 'position_code', '岗位编码', 'varchar', 'String', 'positionCode', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302832500690945, 302827794681858, 'is_confidential', '是否涉密', 'tinyint', 'Integer', 'isConfidential', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 12, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302832781709313, 302827794681858, 'direct_subordinate', '直接下级', 'varchar', 'String', 'directSubordinate', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 13, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302833092087810, 302827794681858, 'creation_date', '编制日期', 'USER-DEFINED', 'Date', 'creationDate', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 14, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302833360523265, 302827794681858, 'revision_date', '修订日期', 'USER-DEFINED', 'Date', 'revisionDate', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 15, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302833691873282, 302827794681858, 'job_summary', '工作摘要', 'text', 'String', 'jobSummary', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 16, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302834019028993, 302827794681858, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 17, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302834346184706, 302827794681858, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 18, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11898596610049, 11896495263745, 'submit_date', 'submit_date', 'timestamp with time zone', 'String', 'submitDate', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 3, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11898923765761, 11896495263745, 'status_hr', 'status_hr', 'integer', 'Long', 'statusHr', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11899246727169, 11896495263745, 'date_hr', 'date_hr', 'timestamp with time zone', 'String', 'dateHr', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 6, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11899640991745, 11896495263745, 'reason_hr', 'reason_hr', 'varchar', 'String', 'reasonHr', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 7, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11900098170881, 11896495263745, 'status_icfa', 'status_icfa', 'integer', 'Long', 'statusIcfa', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11900425326594, 11896495263745, 'date_icfa', 'date_icfa', 'timestamp with time zone', 'String', 'dateIcfa', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 9, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11900748288001, 11896495263745, 'reason_icfa', 'reason_icfa', 'varchar', 'String', 'reasonIcfa', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 10, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11901201272834, 11896495263745, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 11, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11901532622850, 11896495263745, 'del_flag', 'del_flag', 'bpchar', 'String', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 12, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11901863972866, 11896495263745, 'create_time', 'create_time', 'timestamp with time zone', 'String', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 13, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11902191128578, 11896495263745, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 14, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11902522478593, 11896495263745, 'update_time', 'update_time', 'timestamp with time zone', 'String', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 15, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11902849634305, 11896495263745, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 16, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11903180984322, 11896495263745, 'create_user_id', 'create_user_id', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 17, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (11903503945729, 11896495263745, 'disk_path', 'disk_path', 'varchar', 'String', 'diskPath', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 18, 'admin', '2023-12-19 15:28:07', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640456452190210, 640454493450241, 'highlights', '管理亮点', 'varchar', 'String', 'highlights', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302834610425857, 302827794681858, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 19, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302834941775874, 302827794681858, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 20, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302835277320194, 302827794681858, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 21, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302835604475906, 302827794681858, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 22, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302835868717057, 302827794681858, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 23, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:21');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640456649322498, 640454493450241, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 4, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640456846454786, 640454493450241, 'del_flag', 'del_flag', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 5, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (168597722333186, 168596933804034, 'id', 'id', 'integer', 'Long', 'id', '1', '0', '0', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-22 20:04:27', '', '2023-12-22 20:19:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (168598104014849, 168596933804034, 'name', 'name', 'integer', 'Long', 'name', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-22 20:04:27', '', '2023-12-22 20:19:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (166468689428481, 166467322085378, 'id', 'id', 'integer', 'Long', 'id', '1', '0', '0', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-22 19:56:00', '', '2023-12-22 20:20:16');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (166469352128514, 166467322085378, 'name', 'name', 'integer', 'Long', 'name', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-22 19:56:00', '', '2023-12-22 20:20:16');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640457047781378, 640454493450241, 'create_time', 'create_time', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'datetime', '', 6, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640457307828225, 640454493450241, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 7, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678901, 17353168139831, 'id', 'id', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678902, 17353168139831, 'name', 'name', 'varchar', 'String', 'name', '0', '0', '1', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678903, 17353168139831, 'content', 'content', 'varchar', 'String', 'content', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'editor', '', 3, 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678913, 17353168139831, 'start_time', 'start_time', 'timestamp with time zone', 'String', 'startTime', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 4, 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678905, 17353168139831, 'end_time', 'end_time', 'timestamp with time zone', 'String', 'endTime', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 5, 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678906, 17353168139831, 'status', 'status', 'integer', 'Long', 'status', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'radio', '', 6, 'admin', '2023-12-15 06:48:30', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709879378259970, 17353168139831, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 7, '', '2023-12-16 01:14:20', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709879596363777, 17353168139831, 'del_flag', 'del_flag', 'bpchar', 'String', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 8, '', '2023-12-16 01:14:20', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709879848022017, 17353168139831, 'create_time', 'create_time', 'timestamp with time zone', 'String', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 9, '', '2023-12-16 01:14:20', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709880045154305, 17353168139831, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 10, '', '2023-12-16 01:14:20', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709880242286594, 17353168139831, 'update_time', 'update_time', 'timestamp with time zone', 'String', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 11, '', '2023-12-16 01:14:20', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709880439418882, 17353168139831, 'update_by', 'update_by', 'bigint', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 12, '', '2023-12-16 01:14:20', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640457509154817, 640454493450241, 'update_time', 'update_time', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'datetime', '', 8, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640457702092802, 640454493450241, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 9, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (640457903419393, 640454493450241, 'create_user_id', '创建人ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 10, 'admin', '2023-12-26 21:33:02', '', '2023-12-26 21:37:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288683685875714, 288681240596481, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 10, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288683887202305, 288681240596481, 'del_flag', '删除标志（0代表存在 2代表删除）', 'integer', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 11, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288684088528897, 288681240596481, 'create_time', '创建时间/提交时间', 'USER-DEFINED', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 12, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288684348575745, 288681240596481, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 13, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288684549902337, 288681240596481, 'update_time', '更新时间', 'USER-DEFINED', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 14, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288684805754881, 288681240596481, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 15, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288615733956610, 288614819598338, 'id', '主键ID', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288616065306626, 288614819598338, 'report_no', '编码', 'varchar', 'String', 'reportNo', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288616262438913, 288614819598338, 'report_name', '岗检报告名称', 'varchar', 'String', 'reportName', '0', '0', '1', '1', '1', '1', '1', 'LIKE', 'input', '', 3, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288616518291458, 288614819598338, 'report_preface', '前言', 'varchar', 'String', 'reportPreface', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 4, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288616782532609, 288614819598338, 'consummation_problem', '废弃：完善性问题', 'integer', 'Integer', 'consummationProblem', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288616979664898, 288614819598338, 'suitability_problem', '废弃：适宜性问题', 'integer', 'Integer', 'suitabilityProblem', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 6, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288618216984577, 288614819598338, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 13, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558757987319810, 558757534334978, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558758184452097, 558757534334978, 'status', '状态：1-待指定整改人（问题录入完成时）；2-待填写方案（部门管理员指定整改人后）；10-部门审核通过；11-部门审核驳回；20-专业部门人审核（非必填）通过；21-专业部门人审核驳回（非必填）；22-整改人待上传实施（整改人上传实施图片）30-复查部门人审核通过；31-复查部门人审核驳回', 'integer', 'Integer', 'status', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'radio', '', 2, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558758381584385, 558757534334978, 'problem_no', '问题编号（需要甲方提供规则规则）', 'varchar', 'String', 'problemNo', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558758578716673, 558757534334978, 'check_workgroup_id', '检查工作组ID', 'bigint', 'Long', 'checkWorkgroupId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 4, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558758775848962, 558757534334978, 'check_group_id', '检查小组ID', 'bigint', 'Long', 'checkGroupId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558758972981249, 558757534334978, 'check_user_id', '检查人员ID', 'bigint', 'Long', 'checkUserId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 6, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558759174307841, 558757534334978, 'dept_approve_user_id', '审核1：整改部门经理ID', 'bigint', 'Long', 'deptApproveUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 7, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558759371440129, 558757534334978, 'dept_approve_time', '审核1：整改部门经理审核时间', 'timestamp with time zone', 'Date', 'deptApproveTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 8, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558759501463553, 558757534334978, 'speciality_department_reviewer_id', '审核2：专业部门的审核人ID（非必选，方案填写人选择）', 'bigint', 'Long', 'specialityDepartmentReviewerId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558759698595841, 558757534334978, 'speciality_department_review_time', '审核2：专业部门审核人审核时间', 'timestamp with time zone', 'Date', 'specialityDepartmentReviewTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 10, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558759895728129, 558757534334978, 'problem_level', '问题等级（一般、重要）', 'varchar', 'String', 'problemLevel', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823224183402497, 823223722029058, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823224380534786, 823223722029058, 'rating_other_id', '打分表ID', 'bigint', 'Long', 'ratingOtherId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823224581861378, 823223722029058, 'duty_type', '评分分类/项目/专业：职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规与保密职责；5-任职资格与能力素质要求；6-岗位责任制文件完整性与适宜性；10-工作态度；11-部门协作；13-廉洁从业；14-主要工作完成情况；20-HSE；21-生产；22-设备；', 'integer', 'Integer', 'dutyType', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'select', '', 3, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823224711884802, 823223722029058, 'score_weight', '分值/权重；（当前考核规则的分和权重镜像到这里）', 'numeric', 'BigDecimal', 'scoreWeight', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 4, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823224971931650, 823223722029058, 'rule', '考核规则/评分标准（岗检和职能部门时有值）', 'varchar', 'String', 'rule', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823225169063937, 823223722029058, 'by_dept_id', '被评分部门ID', 'bigint', 'Long', 'byDeptId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 6, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823225299087362, 823223722029058, 'by_dept_score', '被评分部门得分', 'numeric', 'BigDecimal', 'byDeptScore', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 7, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302840633446402, 302836200067074, 'work_standard', '工作标准（1）', 'varchar', 'String', 'workStandard', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 13, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302840960602113, 302836200067074, 'requirement', '要求（2）', 'text', 'String', 'requirement', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 14, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302841224843266, 302836200067074, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 15, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302841623302145, 302836200067074, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 16, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302841887543297, 302836200067074, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 17, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302842218893313, 302836200067074, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 18, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302842546049025, 302836200067074, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 19, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302842810290178, 302836200067074, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 20, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (302843145834497, 302836200067074, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 21, 'admin', '2023-12-20 10:44:12', '', '2023-12-20 11:24:00');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424346764013569, 17353168139831, 'create_user_id', 'create_user_id', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 13, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424347363799041, 17353168139831, 'check_workgroup_id', 'check_workgroup_id', 'bigint', 'Long', 'checkWorkgroupId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 14, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424347762257922, 17353168139831, 'check_group_id', 'check_group_id', 'bigint', 'Long', 'checkGroupId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 15, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424348089413633, 17353168139831, 'status_icfa', '1-内控法务部审批-状态：1-待审核；3-通过；4-驳回；', 'integer', 'Long', 'statusIcfa', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 16, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424348546592769, 17353168139831, 'date_icfa', '1-内控法务部审批-通过日期', 'USER-DEFINED', 'String', 'dateIcfa', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 17, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424348932468738, 17353168139831, 'reason_icfa', '1-内控法务部审批-未通过理由', 'varchar', 'String', 'reasonIcfa', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 18, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424349326733313, 17353168139831, 'status_hr', '2-人力资源审批-状态：1-待审核；3-通过；4-驳回；', 'integer', 'Long', 'statusHr', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 19, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424349658083330, 17353168139831, 'date_hr', '2-人力资源审批-通过日期', 'USER-DEFINED', 'String', 'dateHr', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 20, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424350043959298, 17353168139831, 'reason_hr', '2-人力资源审批-未通过理由', 'varchar', 'String', 'reasonHr', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 21, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424350438223874, 17353168139831, 'status_time', '审核时间', 'USER-DEFINED', 'String', 'statusTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 22, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424350765379585, 17353168139831, 'status_user_id', '审核时人ID', 'bigint', 'Long', 'statusUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 23, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424351155449858, 17353168139831, 'status_icfa_user_id', '1-内控法务部审批人ID', 'integer', 'Long', 'statusIcfaUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 24, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (424351478411265, 17353168139831, 'status_hr_user_id', '2-人力资源审批人ID', 'integer', 'Long', 'statusHrUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 25, '', '2023-12-20 18:47:03', '', '2023-12-20 19:29:32');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435921767985153, 11896495263745, 'dept_id', '提交部门ID', 'bigint', 'Long', 'deptId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 19, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435922350993410, 11896495263745, 'dept_name', '提交部门名称', 'varchar', 'String', 'deptName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 20, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435922741063681, 11896495263745, 'status', '状态：1-待审核；2-审核中；3-通过；4-驳回；', 'integer', 'Long', 'status', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'radio', '', 21, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435923068219393, 11896495263745, 'status_time', '审核时间', 'USER-DEFINED', 'Date', 'statusTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 22, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435923462483969, 11896495263745, 'status_user_id', '审核时人ID', 'bigint', 'Long', 'statusUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 23, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435923848359937, 11896495263745, 'status_icfa_user_id', '2-内控法务部审批人ID', 'integer', 'Long', 'statusIcfaUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 24, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (435924175515650, 11896495263745, 'status_hr_user_id', '1-人力资源审批人ID', 'integer', 'Long', 'statusHrUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 25, '', '2023-12-20 19:33:02', '', '2023-12-20 19:35:35');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558765528678402, 558765130219522, 'id', '主键ID', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558765730004994, 558765130219522, 'problem_id', '问题ID（多）', 'bigint', 'Long', 'problemId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558765931331586, 558765130219522, 'user_by', '操作者姓名', 'varchar', 'String', 'userBy', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558766182989825, 558765130219522, 'content', '操作内容', 'varchar', 'String', 'content', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'editor', '', 4, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558766317207553, 558765130219522, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 5, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558766518534146, 558765130219522, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'String', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 6, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558766715666433, 558765130219522, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 7, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558766912798721, 558765130219522, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 8, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729724588384258, 729723724357633, 'id', '主键', 'tinyint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729724923928577, 729723724357633, 'type', '类型：1-职能；2-生产；', 'integer', 'Integer', 'type', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'select', '', 2, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729725787955202, 729723724357633, 'integrity_issues_total', '完整性问题数量-总数', 'integer', 'Integer', 'integrityIssuesTotal', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 6, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729725980893185, 729723724357633, 'integrity_issues_resolved', '完整性问题数量-已整改', 'integer', 'Integer', 'integrityIssuesResolved', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 7, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729726182219778, 729723724357633, 'effectiveness_issues_total', '有效性问题数量-总数', 'integer', 'Integer', 'effectivenessIssuesTotal', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729726383546370, 729723724357633, 'effectiveness_issues_resolved', '有效性问题数量-已整改', 'integer', 'Integer', 'effectivenessIssuesResolved', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729726584872962, 729723724357633, 'suitability_issues_total', '适宜性问题数量-总数', 'integer', 'Integer', 'suitabilityIssuesTotal', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 10, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729726786199553, 729723724357633, 'suitability_issues_resolved', '适宜性问题数量-已整改', 'integer', 'Integer', 'suitabilityIssuesResolved', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729726983331841, 729723724357633, 'peer_evaluation_score', '互评得分', 'numeric', 'BigDecimal', 'peerEvaluationScore', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 12, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729727176269825, 729723724357633, 'daily_score', '日常得分', 'numeric', 'BigDecimal', 'dailyScore', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 13, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729727440510978, 729723724357633, 'department_score', '部门得分', 'numeric', 'BigDecimal', 'departmentScore', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 14, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729727629254658, 729723724357633, 'position_score', '岗位得分', 'numeric', 'BigDecimal', 'positionScore', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 15, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729727830581249, 729723724357633, 'rating_time', '评分时间', 'USER-DEFINED', 'Date', 'ratingTime', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 16, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729728027713538, 729723724357633, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 17, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729728220651522, 729723724357633, 'del_flag', '删除标志（0代表存在 2代表删除）', 'integer', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 18, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729728417783810, 729723724357633, 'create_time', '创建时间', 'USER-DEFINED', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 19, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729728682024962, 729723724357633, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 20, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729728879157249, 729723724357633, 'update_time', '更新时间', 'USER-DEFINED', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 21, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (729729076289538, 729723724357633, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 22, 'admin', '2023-12-21 15:00:31', '', '2023-12-21 15:15:30');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558767109931010, 558765130219522, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 9, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558767311257601, 558765130219522, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 10, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:12:47');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558760097054721, 558757534334978, 'problem_attribute', '问题属性（完整问题、有效性问题、适宜性问题）', 'varchar', 'String', 'problemAttribute', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 12, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185313651175425, 185312766177282, 'id', 'id', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185314104160258, 185312766177282, 'check_workgroup_id', 'check_workgroup_id', 'bigint', 'Long', 'checkWorkgroupId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 2, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185314561339394, 185312766177282, 'check_group_id', 'check_group_id', 'bigint', 'Long', 'checkGroupId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185314947215362, 185312766177282, 'checked_dept_id', 'checked_dept_id', 'bigint', 'Long', 'checkedDeptId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 4, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185315345674242, 185312766177282, 'checked_post_id', 'checked_post_id', 'bigint', 'Long', 'checkedPostId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 5, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185315672829953, 185312766177282, 'print_user_id', '打印人ID', 'bigint', 'Long', 'printUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 6, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185315999985666, 185312766177282, 'print_time', '打印时间', 'timestamp with time zone', 'Date', 'printTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 7, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185316327141378, 185312766177282, 'checked_img', '上传：检查后的检查表照片或PDF，磁盘相对路径', 'varchar', 'String', 'checkedImg', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185316587188225, 185312766177282, 'checked_user_id', '上传：检查人ID', 'bigint', 'Long', 'checkedUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185316851429378, 185312766177282, 'checked_time', '上传：检查时间', 'timestamp with time zone', 'Date', 'checkedTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 10, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185317241499650, 185312766177282, 'upload_user_id', 'upload_user_id', 'bigint', 'Long', 'uploadUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 11, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185317501546497, 185312766177282, 'upload_time', 'upload_time', 'timestamp with time zone', 'String', 'uploadTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 12, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185317900005378, 185312766177282, 'remark', 'remark', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 13, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185318222966785, 185312766177282, 'del_flag', 'del_flag', 'bpchar', 'String', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 14, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185318545928193, 185312766177282, 'create_time', 'create_time', 'timestamp with time zone', 'String', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 15, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185320437559298, 185312766177282, 'create_by', 'create_by', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 16, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185320961847298, 185312766177282, 'update_time', 'update_time', 'timestamp with time zone', 'String', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 17, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185321360306177, 185312766177282, 'update_by', 'update_by', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 18, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (185321687461889, 185312766177282, 'create_user_id', 'create_user_id', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 19, 'admin', '2023-12-22 21:10:53', '', '2023-12-22 21:13:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558760298381314, 558757534334978, 'problem_category', '问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）', 'varchar', 'String', 'problemCategory', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 13, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558760491319297, 558757534334978, 'description', '问题描述', 'varchar', 'String', 'description', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 14, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558760692645889, 558757534334978, 'problem_cause', '问题原因', 'varchar', 'String', 'problemCause', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 15, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558760885583874, 558757534334978, 'is_immediately_corrected', '是否立行立改(1-Yes；2-No；)', 'integer', 'Integer', 'isImmediatelyCorrected', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 16, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558761107881985, 558757534334978, 'rectification_measure', '整改措施', 'varchar', 'String', 'rectificationMeasure', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 17, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558761338568705, 558757534334978, 'checked_dept_id', '整改责任部门ID（被检查部门ID）', 'bigint', 'Long', 'checkedDeptId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 18, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558761531506690, 558757534334978, 'checked_post_id', '整改责任岗位ID（被检查岗位ID）', 'bigint', 'Long', 'checkedPostId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 19, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558761724444673, 558757534334978, 'rectification_responsible_user_id', '整改责任人ID', 'bigint', 'Long', 'rectificationResponsibleUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 20, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558761921576962, 558757534334978, 'rectification_period', '整改期限', 'timestamp with time zone', 'Date', 'rectificationPeriod', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 21, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558762118709249, 558757534334978, 'is_rectification_completed', '整改情况-是否完成(1-Yes；2-No；)', 'integer', 'Long', 'isRectificationCompleted', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 22, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558762244538369, 558757534334978, 'rectification_completion_time', '整改完成时间', 'timestamp with time zone', 'Date', 'rectificationCompletionTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 23, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558762508779522, 558757534334978, 'rectification_completion_img', '整改完成图片磁盘路径', 'varchar', 'String', 'rectificationCompletionImg', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 24, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558762705911809, 558757534334978, 'review_department_reviewer_id', '审核3：复查部门的审核人ID（措施上传时必选，实施人选择）', 'bigint', 'Long', 'reviewDepartmentReviewerId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 25, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558762903044098, 558757534334978, 'review_department_reviewer_time', '审核3：复查部门的审核人复查时间', 'USER-DEFINED', 'Date', 'reviewDepartmentReviewerTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 26, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558763100176386, 558757534334978, 'review_conclusion', '复查结论', 'varchar', 'String', 'reviewConclusion', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 27, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558763297308674, 558757534334978, 'reason', '未通过理由', 'varchar', 'String', 'reason', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 28, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558763427332097, 558757534334978, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 29, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558763620270082, 558757534334978, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 30, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558763817402370, 558757534334978, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 31, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558764014534657, 558757534334978, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 32, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558764211666946, 558757534334978, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 33, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558764404604929, 558757534334978, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 34, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558764597542913, 558757534334978, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 35, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558764798869505, 558757534334978, 'check_time', '检查时间', 'USER-DEFINED', 'Date', 'checkTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 36, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (558764928892929, 558757534334978, 'duty_type', '职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；', 'integer', 'Integer', 'dutyType', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'select', '', 37, 'admin', '2023-12-23 21:54:49', '', '2023-12-23 22:09:45');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288681701969921, 288681240596481, 'id', '主键ID', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288681903296514, 288681240596481, 'type', '评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；', 'integer', 'Integer', 'type', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'select', '', 2, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288682100428801, 288681240596481, 'full_score', '满分/权重', 'integer', 'Integer', 'fullScore', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288682301755393, 288681240596481, 'rule', '考核规则/评分标准', 'varchar', 'String', 'rule', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 4, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288682565996545, 288681240596481, 'problem_level_one', 'type=1-岗检考核规则：一般分数', 'numeric', 'BigDecimal', 'problemLevelOne', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 5, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288682763128834, 288681240596481, 'problem_level_two', 'type=1-岗检考核规则：重要分数', 'numeric', 'BigDecimal', 'problemLevelTwo', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 6, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288682964455425, 288681240596481, 'status', '状态：1-待审核；3-通过；4-驳回；', 'integer', 'Integer', 'status', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'radio', '', 7, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288683157393410, 288681240596481, 'status_by_user_id', '审核人ID', 'bigint', 'Long', 'statusByUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288683379691521, 288681240596481, 'status_by_user_name', '审核人姓名', 'varchar', 'String', 'statusByUserName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 9, 'admin', '2023-12-28 16:28:51', '', '2023-12-28 16:43:27');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288617176797185, 288614819598338, 'effectiveness_problem', '废弃：有效性问题', 'integer', 'Integer', 'effectivenessProblem', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 7, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288617373929473, 288614819598338, 'li_xing_li_gai_question_number', '废弃：立行立改问题数量', 'integer', 'Integer', 'liXingLiGaiQuestionNumber', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288617571061761, 288614819598338, 'li_xing_li_gai_question_has_rectified_number', '废弃：立行立改问题已整改数量', 'integer', 'Integer', 'liXingLiGaiQuestionHasRectifiedNumber', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288617826914306, 288614819598338, 'rich_text', '废弃：富文本', 'text', 'String', 'richText', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 10, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288618024046593, 288614819598338, 'generate_time', '生成时间', 'timestamp with time zone', 'Date', 'generateTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'datetime', '', 12, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288618477031426, 288614819598338, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 14, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288618669969410, 288614819598338, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'datetime', '', 15, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288618938404865, 288614819598338, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 16, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288619127148545, 288614819598338, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'datetime', '', 17, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288619328475138, 288614819598338, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 18, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288619592716290, 288614819598338, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 19, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288619861151746, 288614819598338, 'html_one', '1、（一）组织情况', 'text', 'String', 'htmlOne', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 20, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288620058284034, 288614819598338, 'html_two', '2、（二）岗检的时间、范围和开展形式', 'text', 'String', 'htmlTwo', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 21, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288620255416321, 288614819598338, 'html_three', '3、（三）岗检发现的主要问题', 'text', 'String', 'htmlThree', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 22, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288620452548609, 288614819598338, 'html_four', '4、（四）原因分析', 'text', 'String', 'htmlFour', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 23, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288620653875202, 288614819598338, 'html_five', '5、（五）取得成绩', 'text', 'String', 'htmlFive', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 24, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288620884561922, 288614819598338, 'html_six', '6、（一）“立行立改”问题整改情况', 'text', 'String', 'htmlSix', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 25, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288621509513218, 288614819598338, 'html_seven', '7、（二）“非立行立改”问题整改情况', 'text', 'String', 'htmlSeven', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 26, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288621727617026, 288614819598338, 'html_eight', '8、三、下一步岗位责任提升计划', 'text', 'String', 'htmlEight', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 27, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288622369345538, 288614819598338, 'html_nine', '9、四、总结结论', 'text', 'String', 'htmlNine', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'textarea', '', 28, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288623023656962, 288614819598338, 'status', '状态：1-待审核；3-通过；4-驳回；', 'integer', 'Integer', 'status', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'radio', '', 29, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288623480836098, 288614819598338, 'status_by_user_id', '审核人ID', 'bigint', 'Long', 'statusByUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 30, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288624135147522, 288614819598338, 'status_by_user_name', '审核人姓名', 'varchar', 'String', 'statusByUserName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 31, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (288624328085505, 288614819598338, 'status_reason', '审核不通过原因', 'varchar', 'String', 'statusReason', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 32, 'admin', '2023-12-28 16:28:35', '', '2023-12-28 16:49:44');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823220429500418, 823219565473793, 'id', '主键', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823220752461825, 823219565473793, 'type', '类型：1-职能互评；2-生产日常；', 'integer', 'Integer', 'type', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'select', '', 2, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823220953788417, 823219565473793, 'batch_id', '批次号（管理员创建的）', 'varchar', 'String', 'batchId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 3, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823221155115009, 823219565473793, 'start_time', '评分开始时间（管理员创建的）', 'USER-DEFINED', 'Date', 'startTime', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 4, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823221410967553, 823219565473793, 'status', '状态：1-进行中；2-已完成', 'integer', 'Integer', 'status', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'radio', '', 5, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823221608099842, 823219565473793, 'dept_id', '评分部门ID：打分部门，自己给其他12个部门打分；', 'bigint', 'Long', 'deptId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 6, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823221805232129, 823219565473793, 'complete_time', '评分完成时间', 'USER-DEFINED', 'Date', 'completeTime', '0', '0', '0', '1', '1', '1', '1', 'EQ', NULL, '', 7, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823222006558721, 823219565473793, 'score_user_id', '评分人ID', 'bigint', 'Long', 'scoreUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823222203691010, 823219565473793, 'score_user_name', '评分人姓名', 'varchar', 'String', 'scoreUserName', '0', '0', '0', '1', '1', '1', '1', 'LIKE', 'input', '', 9, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823222337908737, 823219565473793, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'input', '', 10, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823222539235329, 823219565473793, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 11, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823222736367618, 823219565473793, 'del_flag', '删除标志（0代表存在 2代表删除）', 'integer', 'Integer', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 12, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823222929305602, 823219565473793, 'create_time', '创建时间/提交时间', 'USER-DEFINED', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 13, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823223130632193, 823219565473793, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 14, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823223331958785, 823219565473793, 'update_time', '更新时间', 'USER-DEFINED', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 15, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823223529091074, 823219565473793, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 16, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:12:39');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823225496219650, 823223722029058, 'improvement_suggestions', '改进建议', 'varchar', 'String', 'improvementSuggestions', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 8, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823225760460801, 823223722029058, 'create_user_id', '创建者用户ID', 'bigint', 'Long', 'createUserId', '0', '0', '0', '1', '1', '1', '1', 'EQ', 'input', '', 9, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823225953398786, 823223722029058, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 10, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823226142142465, 823223722029058, 'del_flag', '删除标志（0代表存在 2代表删除）', 'integer', 'Long', 'delFlag', '0', '0', '0', '1', NULL, NULL, NULL, 'EQ', 'input', '', 11, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823226335080450, 823223722029058, 'create_time', '创建时间/提交时间', 'USER-DEFINED', 'Date', 'createTime', '0', '0', '0', '1', NULL, NULL, NULL, 'EQ', NULL, '', 12, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823226532212737, 823223722029058, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '0', '1', NULL, NULL, NULL, 'EQ', 'input', '', 13, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823226725150721, 823223722029058, 'update_time', '更新时间', 'USER-DEFINED', 'Date', 'updateTime', '0', '0', '0', '1', '1', NULL, NULL, 'EQ', NULL, '', 14, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (823226922283010, 823223722029058, 'update_by', '更新者', 'varchar', 'String', 'updateBy', '0', '0', '0', '1', '1', NULL, NULL, 'EQ', 'input', '', 15, 'admin', '2024-01-01 22:06:35', '', '2024-01-01 22:16:29');


--
-- TOC entry 8559 (class 0 OID 17897)
-- Dependencies: 613
-- Data for Name: post_assessment_rating; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_assessment_rating (id, type, dept_id, post_id, head_user_id, integrity_issues_total, integrity_issues_resolved, effectiveness_issues_total, effectiveness_issues_resolved, suitability_issues_total, suitability_issues_resolved, peer_evaluation_score, daily_score, department_score, position_score, rating_time, remark, del_flag, create_time, create_by, update_time, update_by) VALUES (1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0.00, 0.00, 0.00, 0.00, '2023-12-21 18:37:36', NULL, 0, '2023-12-21 12:12:12', '1', '2023-12-21 12:12:12', '1');
INSERT INTO public.post_assessment_rating (id, type, dept_id, post_id, head_user_id, integrity_issues_total, integrity_issues_resolved, effectiveness_issues_total, effectiveness_issues_resolved, suitability_issues_total, suitability_issues_resolved, peer_evaluation_score, daily_score, department_score, position_score, rating_time, remark, del_flag, create_time, create_by, update_time, update_by) VALUES (2, 2, 2, 2, 2, 0, 0, 0, 0, 0, 0, 0.00, 0.00, 0.00, 0.00, '2023-12-21 18:37:36', NULL, 0, '2023-12-21 12:12:12', '1', '2023-12-21 12:12:12', '1');


--
-- TOC entry 8563 (class 0 OID 18088)
-- Dependencies: 617
-- Data for Name: post_assessment_rating_other; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8564 (class 0 OID 18107)
-- Dependencies: 618
-- Data for Name: post_assessment_rating_other_info; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8562 (class 0 OID 18041)
-- Dependencies: 616
-- Data for Name: post_assessment_rules; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_assessment_rules (id, type, full_score, rule, problem_level_one, problem_level_two, status, status_by_user_id, status_by_user_name, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status_reason, status_approve_time, duty_type) VALUES (574375479017473, NULL, 100, '11', 10, 10, 1, NULL, NULL, NULL, 0, '2023-12-29 11:24:04', 'admin', '2023-12-29 11:27:35', 'admin', 1, NULL, NULL, 2);


--
-- TOC entry 8540 (class 0 OID 17101)
-- Dependencies: 594
-- Data for Name: post_checked; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8532 (class 0 OID 17034)
-- Dependencies: 586
-- Data for Name: post_checked_items; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8557 (class 0 OID 17791)
-- Dependencies: 611
-- Data for Name: post_checked_problem; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_checked_problem (id, status, problem_no, check_workgroup_id, check_group_id, check_user_id, dept_approve_user_id, dept_approve_time, speciality_department_reviewer_id, speciality_department_review_time, problem_level, problem_attribute, problem_category, description, problem_cause, is_immediately_corrected, rectification_measure, checked_dept_id, checked_post_id, rectification_responsible_user_id, rectification_period, is_rectification_completed, rectification_completion_time, rectification_completion_img, review_department_reviewer_id, review_department_reviewer_time, review_conclusion, reason, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_time, duty_type, check_user_name) VALUES (469559842238466, 1, 'GJ-2024-01-03 16:54:51', 20, 251079386578945, NULL, NULL, NULL, NULL, NULL, 2, 3, 4, '1', NULL, NULL, NULL, 103, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2024-01-03 16:54:51', 'admin', '2024-01-03 16:55:38', 'admin', NULL, NULL, 4, '1');
INSERT INTO public.post_checked_problem (id, status, problem_no, check_workgroup_id, check_group_id, check_user_id, dept_approve_user_id, dept_approve_time, speciality_department_reviewer_id, speciality_department_review_time, problem_level, problem_attribute, problem_category, description, problem_cause, is_immediately_corrected, rectification_measure, checked_dept_id, checked_post_id, rectification_responsible_user_id, rectification_period, is_rectification_completed, rectification_completion_time, rectification_completion_img, review_department_reviewer_id, review_department_reviewer_time, review_conclusion, reason, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_time, duty_type, check_user_name) VALUES (469756232134657, 1, 'GJ-2024-01-03 16:55:38', 20, 251079386578945, NULL, NULL, NULL, NULL, NULL, 2, 2, 4, '2', NULL, NULL, NULL, 103, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2024-01-03 16:55:38', 'admin', '2024-01-03 16:55:38', 'admin', NULL, NULL, 3, '1');
INSERT INTO public.post_checked_problem (id, status, problem_no, check_workgroup_id, check_group_id, check_user_id, dept_approve_user_id, dept_approve_time, speciality_department_reviewer_id, speciality_department_review_time, problem_level, problem_attribute, problem_category, description, problem_cause, is_immediately_corrected, rectification_measure, checked_dept_id, checked_post_id, rectification_responsible_user_id, rectification_period, is_rectification_completed, rectification_completion_time, rectification_completion_img, review_department_reviewer_id, review_department_reviewer_time, review_conclusion, reason, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_time, duty_type, check_user_name) VALUES (172637611319298, 1, 'GJ2024-01-02 21:14:59', 20, 251079386578945, NULL, NULL, NULL, NULL, NULL, 1, 1, 1, '测试PostMan修改问题V2', NULL, NULL, NULL, 103, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2024-01-02 21:15:00', 'admin', '2024-01-03 16:55:38', 'admin', NULL, NULL, 1, '王凯·乔曦');
INSERT INTO public.post_checked_problem (id, status, problem_no, check_workgroup_id, check_group_id, check_user_id, dept_approve_user_id, dept_approve_time, speciality_department_reviewer_id, speciality_department_review_time, problem_level, problem_attribute, problem_category, description, problem_cause, is_immediately_corrected, rectification_measure, checked_dept_id, checked_post_id, rectification_responsible_user_id, rectification_period, is_rectification_completed, rectification_completion_time, rectification_completion_img, review_department_reviewer_id, review_department_reviewer_time, review_conclusion, reason, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_time, duty_type, check_user_name) VALUES (359481336147969, 1, 'GJ-2024-01-03 09:37:26', 20, 251079386578945, NULL, NULL, NULL, NULL, NULL, 1, 2, 2, '1', NULL, NULL, NULL, 103, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2024-01-03 09:37:26', 'admin', '2024-01-03 16:55:38', 'admin', NULL, NULL, 2, '李');
INSERT INTO public.post_checked_problem (id, status, problem_no, check_workgroup_id, check_group_id, check_user_id, dept_approve_user_id, dept_approve_time, speciality_department_reviewer_id, speciality_department_review_time, problem_level, problem_attribute, problem_category, description, problem_cause, is_immediately_corrected, rectification_measure, checked_dept_id, checked_post_id, rectification_responsible_user_id, rectification_period, is_rectification_completed, rectification_completion_time, rectification_completion_img, review_department_reviewer_id, review_department_reviewer_time, review_conclusion, reason, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_time, duty_type, check_user_name) VALUES (1, 2, 'GH-001-问题编号', 1, 1, 1, 1, '2023-12-31 00:00:00', 1, '2023-12-31 00:00:00', 1, 1, 1, '问题描述', '问题原因', 1, '整改措施', 1, 1, 1, '2024-01-05 00:00:00', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2023-12-31 00:00:00', '', '2024-01-03 16:55:38', 'admin', NULL, NULL, NULL, NULL);


--
-- TOC entry 8558 (class 0 OID 17803)
-- Dependencies: 612
-- Data for Name: post_checked_problem_record; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (1, 1, '张三', '录入问题', '2023-12-31 00:00:00');
INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (3, 1, '王五', '填写整改方案', '2023-12-31 02:00:00');
INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (2, 1, '李四', '把问题指派给部门的王五', '2023-12-31 01:00:00');
INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (5, 1, '赵六', '专业部门审核方案', '2023-12-31 04:00:00');
INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (6, 1, '王五', '上传整改证明照片', '2023-12-31 05:00:00');
INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (7, 1, '李拐七', '复查整改记录', '2023-12-31 07:00:00');
INSERT INTO public.post_checked_problem_record (id, problem_id, user_by, content, create_time) VALUES (4, 1, '李四', '部门经理审核方案', '2023-12-31 03:00:00');


--
-- TOC entry 8521 (class 0 OID 16953)
-- Dependencies: 575
-- Data for Name: post_checked_report; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8526 (class 0 OID 16987)
-- Dependencies: 580
-- Data for Name: post_highlights; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_highlights (id, highlights_type, highlights, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, problem_attribute) VALUES (1, 1, '尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，尽职尽责，值得跨奖，', NULL, '0', '2023-12-30 00:00:00', '', '2023-12-30 00:00:00', '', 1, NULL);
INSERT INTO public.post_highlights (id, highlights_type, highlights, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, problem_attribute) VALUES (3, 3, '安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，安全意识很好，', NULL, '0', '2023-12-30 00:00:00', '', '2023-12-30 00:00:00', '', 1, NULL);
INSERT INTO public.post_highlights (id, highlights_type, highlights, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, problem_attribute) VALUES (2, 2, '党风纯正，党风纯正，党风纯正，党风纯正，党风纯正，党风纯正，党风纯正，党风纯正，党风纯正，党风纯正，', NULL, '0', '2023-12-30 00:00:00', '', '2023-12-30 00:00:00', '', 1, NULL);


--
-- TOC entry 8551 (class 0 OID 17210)
-- Dependencies: 605
-- Data for Name: post_list; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_list (id, status, status_by_user_id, status_by_user_name, unit_id, post_id, position_level, direct_superior, subordinate_count, dept_id, position_code, is_confidential, direct_subordinate, creation_date, revision_date, job_summary, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (1, 3, 1, '审核人姓名', '惠州石化', 1, '岗位级别', '上级', 11, 100, 'YX001', '1', '下级', '2023-12-20', '2023-12-20', '摘要内容....', '备注信息', '0', '2023-12-20 00:00:00', '', '2023-12-20 00:00:00', '', NULL);
INSERT INTO public.post_list (id, status, status_by_user_id, status_by_user_name, unit_id, post_id, position_level, direct_superior, subordinate_count, dept_id, position_code, is_confidential, direct_subordinate, creation_date, revision_date, job_summary, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946617862336514, 1, NULL, NULL, '100', NULL, 'M7', '最上级', 88, NULL, '888888', '1', '最下级', '2023-12-20', NULL, '1.工作摘要
', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list (id, status, status_by_user_id, status_by_user_name, unit_id, post_id, position_level, direct_superior, subordinate_count, dept_id, position_code, is_confidential, direct_subordinate, creation_date, revision_date, job_summary, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (21330788122626, 1, 1, 'PostMan审核人姓名', 'PostMan惠州石化', 1, 'PostMan岗位级别', 'PostMan上级', 11, 100, 'YX001PostMan', 'P是涉密的', 'PostMan下级', '2023-12-27', '2023-12-27', 'PostMan摘要内容....', 'PostMan备注信息', '0', '2023-12-27 22:46:28', 'admin', '2023-12-27 22:46:28', 'admin', NULL);
INSERT INTO public.post_list (id, status, status_by_user_id, status_by_user_name, unit_id, post_id, position_level, direct_superior, subordinate_count, dept_id, position_code, is_confidential, direct_subordinate, creation_date, revision_date, job_summary, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (202672903143426, 1, NULL, NULL, '中海油惠州石化', 1, 'M1', '上级', 8, 103, '8888', '是', '下级', '2023-12-28', '2023-12-28', NULL, '100,101,103', '0', '2023-12-28 10:47:03', 'admin', '2023-12-28 14:20:10', 'admin', NULL);


--
-- TOC entry 8529 (class 0 OID 17015)
-- Dependencies: 583
-- Data for Name: post_list_info; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (11, 3, 1, '审核人姓名', 1, 1, '①', '销售管理', '内贸业务管理', '隔墙互供', '合同执行', NULL, '做好隔墙互供产品的销售管理，每月签订销售订单及跟踪执行，并做好产品结算价款的确认，保证合同有效执行、确保资金及时回款。不因合同执行不到位引起法律纠纷。', NULL, NULL, '0', '2023-12-20 00:00:00', '', '2023-12-20 00:00:00', '', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (12, 3, 1, '审核人姓名', 1, 2, '①', '个人廉洁从业情况', '违反相关规章制度', '隔墙互供', '合同执行', NULL, '检查时间范围内未受到处理处分（诫勉以上）（以公司发文为准）。', NULL, NULL, '0', '2023-12-20 00:00:00', '', '2023-12-20 00:00:00', '', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (15, 3, 1, '审核人姓名', 1, 5, '①', '*政治要求', '', '', '', NULL, '', '政治素质好，牢固树立“四个意识”，坚定“四个自信”，坚决做到“两个维护”，严格落实中央八项规定精神，严守政治纪律、政治规矩，忠诚干净担当。', NULL, '0', '2023-12-20 00:00:00', '', '2023-12-20 00:00:00', '', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (21336089722882, 1, 1, 'PostMan审核人姓名', 21330788122626, 1, '①', 'PostMan销售管理', 'PostMan内贸业务管理', 'PostMan隔墙互供', 'PostMan合同执行', 'PostMan第五级', 'PostMan做好隔墙互供产品的销售管理，每月签订销售订单及跟踪执行，并做好产品结算价款的确认，保证合同有效执行、确保资金及时回款。不因合同执行不到位引起法律纠纷。', 'PostMan要求000000', NULL, '0', '2023-12-27 22:46:29', 'admin', '2023-12-27 22:46:29', 'admin', 1);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098561, NULL, NULL, NULL, 946617862336514, 1, NULL, '一级事项', '二级事项', '三级事项', '四级事项', '五级事项', '', NULL, NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098562, NULL, NULL, NULL, 946617862336514, 2, NULL, '', '', '', '', '', '', NULL, NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098563, NULL, NULL, NULL, 946617862336514, 3, NULL, '', '', '', '', '', '', NULL, NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098564, NULL, NULL, NULL, 946617862336514, 4, NULL, '', '', '', '', '', '', NULL, NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098565, NULL, NULL, NULL, 946617862336514, 5, '政治要求', NULL, NULL, NULL, NULL, NULL, NULL, '政治要求', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098566, NULL, NULL, NULL, 946617862336514, 5, '最低学历要求', NULL, NULL, NULL, NULL, NULL, NULL, '最低学历要求', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098567, NULL, NULL, NULL, 946617862336514, 5, '最低学位要求', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098568, NULL, NULL, NULL, 946617862336514, 5, '工作经验', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098569, NULL, NULL, NULL, 946617862336514, 5, '职称要求', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098570, NULL, NULL, NULL, 946617862336514, 5, '专业要求', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098571, NULL, NULL, NULL, 946617862336514, 5, '能力要求', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098572, NULL, NULL, NULL, 946617862336514, 5, '知识要求', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098573, NULL, NULL, NULL, 946617862336514, 5, '在岗时应持有证书必须参加的培训', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);
INSERT INTO public.post_list_info (id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (946618332098574, NULL, NULL, NULL, 946617862336514, 5, '其他要求', NULL, NULL, NULL, NULL, NULL, NULL, '', NULL, '0', '2023-12-27 17:49:35', 'admin', '2023-12-27 17:49:35', 'admin', NULL);


--
-- TOC entry 8525 (class 0 OID 16983)
-- Dependencies: 579
-- Data for Name: post_plan; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_plan (id, name, content, start_time, end_time, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_group_id, check_team_id, status_icfa, date_icfa, reason_icfa, status_hr, date_hr, reason_hr, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (633982612262913, '1', '1', '2023-12-06 00:00:00', '2024-01-26 00:00:00', 1, NULL, '0', '2023-12-29 15:20:56', 'admin', '2023-12-29 17:37:58', 'admin', 1, 20, 251079386578945, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan (id, name, content, start_time, end_time, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_group_id, check_team_id, status_icfa, date_icfa, reason_icfa, status_hr, date_hr, reason_hr, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (658832693252098, '1', '1', '2023-11-29 00:00:00', '2023-12-06 00:00:00', 2, NULL, '0', '2023-12-29 16:59:40', 'admin', '2023-12-29 17:36:01', 'admin', 1, 20, 251079386578945, 4, NULL, 'PostMan测试一下', NULL, NULL, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan (id, name, content, start_time, end_time, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, check_group_id, check_team_id, status_icfa, date_icfa, reason_icfa, status_hr, date_hr, reason_hr, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (630747556487170, '1', '1', '2023-12-05 00:00:00', '2024-01-23 00:00:00', 2, NULL, '0', '2023-12-29 15:08:04', 'admin', '2023-12-29 17:37:17', 'admin', 1, 20, 251079386578945, 3, NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL);


--
-- TOC entry 8514 (class 0 OID 16924)
-- Dependencies: 568
-- Data for Name: post_plan_info; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (3, 1, 102, '2023-12-31 00:00:00', 1, '天剑公司-董事长', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', 1, 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (2, 1, 101, '2023-12-31 00:00:00', 2, '惠州公司-项目经理', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', 1, 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (1, 1, 101, '2023-12-31 00:00:00', 1, '惠州公司-董事长', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', 1, 1, NULL, NULL, NULL, 1, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (667978272448514, 658832693252098, 109, NULL, 3, NULL, '0', '2023-12-29 17:36:01', 'admin', '2023-12-29 17:36:01', 'admin', 1, 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (667978318585857, 658832693252098, 109, NULL, 2, NULL, '0', '2023-12-29 17:36:01', 'admin', '2023-12-29 17:36:01', 'admin', 1, 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (667978180173825, 658832693252098, 103, NULL, 3, NULL, '0', '2023-12-29 17:36:01', 'admin', '2023-12-29 17:36:01', 'admin', 1, 1, NULL, NULL, NULL, NULL, '2024-01-03 00:00:00');
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668299929427969, 630747556487170, 103, NULL, 1, NULL, '0', '2023-12-29 17:37:17', 'admin', '2023-12-29 17:37:17', 'admin', 1, 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668299988148225, 630747556487170, 103, NULL, 2, NULL, '0', '2023-12-29 17:37:17', 'admin', '2023-12-29 17:37:17', 'admin', 1, 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668300080422914, 630747556487170, 103, NULL, 3, NULL, '0', '2023-12-29 17:37:17', 'admin', '2023-12-29 17:37:17', 'admin', 1, 2, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668300130754562, 630747556487170, 108, NULL, 3, NULL, '0', '2023-12-29 17:37:17', 'admin', '2023-12-29 17:37:17', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668300210446338, 630747556487170, 108, NULL, 4, NULL, '0', '2023-12-29 17:37:17', 'admin', '2023-12-29 17:37:17', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668471627456514, 633982612262913, 103, NULL, 1, NULL, '0', '2023-12-29 17:37:58', 'admin', '2023-12-29 17:37:58', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668471803617281, 633982612262913, 103, NULL, 2, NULL, '0', '2023-12-29 17:37:58', 'admin', '2023-12-29 17:37:58', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668471845560321, 633982612262913, 103, NULL, 3, NULL, '0', '2023-12-29 17:37:58', 'admin', '2023-12-29 17:37:58', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668471912669185, 633982612262913, 109, NULL, 1, NULL, '0', '2023-12-29 17:37:58', 'admin', '2023-12-29 17:37:58', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668471912669186, 633982612262913, 109, NULL, 2, NULL, '0', '2023-12-29 17:37:58', 'admin', '2023-12-29 17:37:58', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (668471975583745, 633982612262913, 109, NULL, 3, NULL, '0', '2023-12-29 17:37:58', 'admin', '2023-12-29 17:37:58', 'admin', 1, 1, NULL, NULL, NULL, NULL, NULL);
INSERT INTO public.post_plan_info (id, post_plan_id, checked_dept_id, check_time, checked_post_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, status, print_user_id, print_time, checked_img, checked_user_id, checked_time) VALUES (667978083704834, 658832693252098, 103, NULL, 2, NULL, '0', '2023-12-29 17:36:01', 'admin', '2023-12-29 17:36:01', 'admin', 1, 1, NULL, NULL, NULL, NULL, '2024-01-11 00:00:00');


--
-- TOC entry 8524 (class 0 OID 16979)
-- Dependencies: 578
-- Data for Name: post_plan_info_user; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_plan_info_user (id, post_plan_info_id, checked_user_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type) VALUES (1, 1, 1, '检查董事长的人-组长', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', NULL, 1);
INSERT INTO public.post_plan_info_user (id, post_plan_info_id, checked_user_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type) VALUES (3, 2, 1, '检查项目经理的人-组长', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', NULL, 1);
INSERT INTO public.post_plan_info_user (id, post_plan_info_id, checked_user_id, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type) VALUES (2, 1, 2, '检查董事长的人-成员', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', NULL, 2);


--
-- TOC entry 8523 (class 0 OID 16975)
-- Dependencies: 577
-- Data for Name: post_programme; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_programme (id, name, submit_date, status_hr, date_hr, reason_hr, status_icfa, date_icfa, reason_icfa, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, disk_path, dept_id, dept_name, status, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (493656286097409, 'page2024年方案V2', '2023-12-26 11:49:41', 1, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2023-12-26 11:49:41', 'admin', '2023-12-26 11:49:41', 'admin', NULL, '2024岗检.xlsx', NULL, NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO public.post_programme (id, name, submit_date, status_hr, date_hr, reason_hr, status_icfa, date_icfa, reason_icfa, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, disk_path, dept_id, dept_name, status, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (538179625836546, '2024岗检方案', '2023-12-26 14:46:36', 1, NULL, NULL, NULL, NULL, NULL, NULL, '0', '2023-12-26 14:46:36', 'admin', '2023-12-26 14:46:36', 'admin', NULL, '2024岗检.xlsx', NULL, NULL, 1, NULL, NULL, NULL, NULL);
INSERT INTO public.post_programme (id, name, submit_date, status_hr, date_hr, reason_hr, status_icfa, date_icfa, reason_icfa, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, disk_path, dept_id, dept_name, status, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (1, '测试方案名称', '2023-12-19 19:19:19', 1, '2023-12-19 19:19:19', '人力同意', 1, '2023-12-19 19:19:19', '法务部同意', '备注信息。。', '0', '2023-12-19 19:19:19', '创建者姓名', '2023-12-27 10:12:03', 'admin', 1, '/upload/xxx.docx', NULL, NULL, 3, NULL, NULL, NULL, NULL);
INSERT INTO public.post_programme (id, name, submit_date, status_hr, date_hr, reason_hr, status_icfa, date_icfa, reason_icfa, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, disk_path, dept_id, dept_name, status, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (831574462164993, '2024岗检方案', '2023-12-27 10:12:27', 1, NULL, NULL, NULL, NULL, '不通过', NULL, '0', '2023-12-27 10:12:27', 'admin', '2023-12-27 10:12:27', 'admin', NULL, '2024岗检方案.xlsx', NULL, '人力资源部门', 1, '2024-01-02 12:03:04', NULL, NULL, NULL);
INSERT INTO public.post_programme (id, name, submit_date, status_hr, date_hr, reason_hr, status_icfa, date_icfa, reason_icfa, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, disk_path, dept_id, dept_name, status, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (831810203021314, '2024岗检方案', '2023-12-27 10:13:23', 1, NULL, NULL, NULL, NULL, '不通过', NULL, '0', '2023-12-27 10:13:23', 'admin', '2023-12-27 10:13:23', 'admin', NULL, '2024岗检方案.xlsx', NULL, '人力资源部门', 1, '2024-01-02 12:03:04', NULL, NULL, NULL);
INSERT INTO public.post_programme (id, name, submit_date, status_hr, date_hr, reason_hr, status_icfa, date_icfa, reason_icfa, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, disk_path, dept_id, dept_name, status, status_time, status_user_id, status_icfa_user_id, status_hr_user_id) VALUES (831843405131777, '2024岗检方案', '2023-12-27 10:13:31', 1, NULL, NULL, NULL, NULL, '不通过', NULL, '0', '2023-12-27 10:13:31', 'admin', '2023-12-27 10:13:31', 'admin', NULL, '2024岗检方案.xlsx', NULL, '人力资源部门', 1, '2024-01-02 12:03:04', NULL, NULL, NULL);


--
-- TOC entry 8517 (class 0 OID 16935)
-- Dependencies: 571
-- Data for Name: post_programme_template; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_programme_template (id, plan_name, template_name, disk_path, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (2, '方案名称V2', '模板名称V2-作废', '/upload/temxx.docx', 1, '测试作废模板', '0', '2023-12-19 19:19:19', '', '2023-12-19 19:19:19', '', 1);


--
-- TOC entry 8537 (class 0 OID 17087)
-- Dependencies: 591
-- Data for Name: post_team; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_team (id, name, parent_id, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type, team_type) VALUES (1, '岗检联合办公室', 0, 1, '一级根目录', '0', '2023-12-31 12:12:12', 'csg', '2023-12-31 12:12:12', '', 1, 1, 2);
INSERT INTO public.post_team (id, name, parent_id, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type, team_type) VALUES (20, '综合岗检工作组', 1, 1, '二级目录', '0', '2023-12-31 12:12:12', 'csg', '2023-12-31 12:12:12', '', 1, 2, 2);
INSERT INTO public.post_team (id, name, parent_id, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type, team_type) VALUES (30, '生产岗检工作组', 1, 1, '二级目录', '0', '2023-12-31 12:12:12', 'csg', '2023-12-31 12:12:12', '', 1, 2, 2);
INSERT INTO public.post_team (id, name, parent_id, status, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id, type, team_type) VALUES (251079386578945, '工作组1（综合）', 20, 1, NULL, '0', '2023-12-28 13:59:24', 'admin', '2023-12-28 13:59:24', 'admin', 1, 3, 1);


--
-- TOC entry 8556 (class 0 OID 17781)
-- Dependencies: 610
-- Data for Name: post_team_dept; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8516 (class 0 OID 16931)
-- Dependencies: 570
-- Data for Name: post_team_user; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_team_user (id, post_team_id, user_id, type, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (1, 20, 1, 1, '类型（1-组长；2-成员；）', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', 1);
INSERT INTO public.post_team_user (id, post_team_id, user_id, type, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) VALUES (2, 20, 1, 2, '类型（1-组长；2-成员；）', '0', '2023-12-31 00:00:00', '', '2023-12-31 00:00:00', '', 1);


--
-- TOC entry 8518 (class 0 OID 16939)
-- Dependencies: 572
-- Data for Name: qrtz_blob_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8534 (class 0 OID 17044)
-- Dependencies: 588
-- Data for Name: qrtz_calendars; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8520 (class 0 OID 16950)
-- Dependencies: 574
-- Data for Name: qrtz_cron_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8519 (class 0 OID 16945)
-- Dependencies: 573
-- Data for Name: qrtz_fired_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8530 (class 0 OID 17022)
-- Dependencies: 584
-- Data for Name: qrtz_job_details; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8515 (class 0 OID 16928)
-- Dependencies: 569
-- Data for Name: qrtz_locks; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8538 (class 0 OID 17091)
-- Dependencies: 592
-- Data for Name: qrtz_paused_trigger_grps; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8528 (class 0 OID 17012)
-- Dependencies: 582
-- Data for Name: qrtz_scheduler_state; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8545 (class 0 OID 17144)
-- Dependencies: 599
-- Data for Name: qrtz_simple_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8531 (class 0 OID 17030)
-- Dependencies: 585
-- Data for Name: qrtz_simprop_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8548 (class 0 OID 17168)
-- Dependencies: 602
-- Data for Name: qrtz_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8522 (class 0 OID 16962)
-- Dependencies: 576
-- Data for Name: sys_con; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (1, '主框架页-默认皮肤样式名称', 'sys.index.skinName', 'skin-blue', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '蓝色 skin-blue、绿色 skin-green、紫色 skin-purple、红色 skin-red、黄色 skin-yellow');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (2, '用户管理-账号初始密码', 'sys.user.initPassword', '123456', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '初始化密码 123456');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (3, '主框架页-侧边栏主题', 'sys.index.sideTheme', 'theme-dark', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '深色主题theme-dark，浅色主题theme-light');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (5, '账号自助-是否开启用户注册功能', 'sys.account.registerUser', 'false', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '是否开启注册用户功能（true开启，false关闭）');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (6, '用户登录-黑名单列表', 'sys.login.blackIPList', '', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '设置登录IP黑名单限制，多个匹配项以;分隔，支持匹配（*通配、网段）');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (4, '账号自助-验证码开关', 'sys.account.captchaEnabled', 'false', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '是否开启验证码功能（true开启，false关闭）');


--
-- TOC entry 8527 (class 0 OID 16990)
-- Dependencies: 581
-- Data for Name: sys_dept; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (108, 102, '0,100,102', '市场部门', 1, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (109, 102, '0,100,102', '财务部门', 2, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (102, 100, '0,100', '天津分公司', 2, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (103, 101, '0,100,101', '研发部门', 1, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (104, 101, '0,100,101', '市场部门', 2, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (105, 101, '0,100,101', '测试部门', 3, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (106, 101, '0,100,101', '财务部门', 4, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (107, 101, '0,100,101', '运维部门', 5, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (101, 100, '0,100', '惠州分公司', 1, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', 'admin', '2023-12-27 10:53:08');
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (100, 0, '0', '中海油惠州石化', 0, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);


--
-- TOC entry 8549 (class 0 OID 17180)
-- Dependencies: 603
-- Data for Name: sys_dict_data; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (1, 1, '男', '0', 'sys_user_sex', '', '', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '性别男');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (2, 2, '女', '1', 'sys_user_sex', '', '', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '性别女');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (3, 3, '未知', '2', 'sys_user_sex', '', '', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '性别未知');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (4, 1, '显示', '0', 'sys_show_hide', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '显示菜单');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (5, 2, '隐藏', '1', 'sys_show_hide', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '隐藏菜单');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (6, 1, '正常', '0', 'sys_normal_disable', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (7, 2, '停用', '1', 'sys_normal_disable', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '停用状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (8, 1, '正常', '0', 'sys_job_status', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (9, 2, '暂停', '1', 'sys_job_status', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '停用状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (10, 1, '默认', 'DEFAULT', 'sys_job_group', '', '', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '默认分组');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (11, 2, '系统', 'SYSTEM', 'sys_job_group', '', '', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统分组');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (12, 1, '是', 'Y', 'sys_yes_no', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统默认是');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (13, 2, '否', 'N', 'sys_yes_no', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统默认否');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (14, 1, '通知', '1', 'sys_notice_type', '', 'warning', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '通知');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (15, 2, '公告', '2', 'sys_notice_type', '', 'success', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '公告');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (16, 1, '正常', '0', 'sys_notice_status', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (17, 2, '关闭', '1', 'sys_notice_status', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '关闭状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (18, 99, '其他', '0', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '其他操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (19, 1, '新增', '1', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '新增操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (20, 2, '修改', '2', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '修改操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (21, 3, '删除', '3', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '删除操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (22, 4, '授权', '4', 'sys_oper_type', '', 'primary', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '授权操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (23, 5, '导出', '5', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '导出操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (24, 6, '导入', '6', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '导入操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (25, 7, '强退', '7', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '强退操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (26, 8, '生成代码', '8', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '生成操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (27, 9, '清空数据', '9', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '清空操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (28, 1, '成功', '0', 'sys_common_status', '', 'primary', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (29, 2, '失败', '1', 'sys_common_status', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '停用状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (100, 1, '是-测试', '1', 'post_check_test_v1', NULL, 'default', 'N', '0', 'admin', '2023-12-11 14:10:22', '', NULL, NULL);
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (101, 2, '否-测试', '2', 'post_check_test_v1', NULL, 'default', 'N', '0', 'admin', '2023-12-11 14:10:39', '', NULL, NULL);


--
-- TOC entry 8555 (class 0 OID 17248)
-- Dependencies: 609
-- Data for Name: sys_dict_type; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (1, '用户性别', 'sys_user_sex', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '用户性别列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (2, '菜单状态', 'sys_show_hide', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '菜单状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (3, '系统开关', 'sys_normal_disable', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统开关列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (4, '任务状态', 'sys_job_status', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '任务状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (5, '任务分组', 'sys_job_group', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '任务分组列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (6, '系统是否', 'sys_yes_no', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统是否列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (7, '通知类型', 'sys_notice_type', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '通知类型列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (8, '通知状态', 'sys_notice_status', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '通知状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (9, '操作类型', 'sys_oper_type', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '操作类型列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (10, '系统状态', 'sys_common_status', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '登录状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (100, '岗检测试1', 'post_check_test_v1', '0', 'admin', '2023-12-11 14:09:50', '', NULL, '测试1');


--
-- TOC entry 8547 (class 0 OID 17156)
-- Dependencies: 601
-- Data for Name: sys_job; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_job (job_id, job_name, job_group, invoke_target, cron_expression, misfire_policy, concurrent, status, create_by, create_time, update_by, update_time, remark) VALUES (1, '系统默认（无参）', 'DEFAULT', 'ryTask.ryNoParams', '0/10 * * * * ?', '3', '1', '1', 'admin', '2023-12-11 13:16:59', '', NULL, '');
INSERT INTO public.sys_job (job_id, job_name, job_group, invoke_target, cron_expression, misfire_policy, concurrent, status, create_by, create_time, update_by, update_time, remark) VALUES (2, '系统默认（有参）', 'DEFAULT', 'ryTask.ryParams(''ry'')', '0/15 * * * * ?', '3', '1', '1', 'admin', '2023-12-11 13:16:59', '', NULL, '');
INSERT INTO public.sys_job (job_id, job_name, job_group, invoke_target, cron_expression, misfire_policy, concurrent, status, create_by, create_time, update_by, update_time, remark) VALUES (3, '系统默认（多参）', 'DEFAULT', 'ryTask.ryMultipleParams(''ry'', true, 2000L, 316.50D, 100)', '0/20 * * * * ?', '3', '1', '1', 'admin', '2023-12-11 13:16:59', '', NULL, '');


--
-- TOC entry 8513 (class 0 OID 16916)
-- Dependencies: 567
-- Data for Name: sys_job_log; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8554 (class 0 OID 17234)
-- Dependencies: 608
-- Data for Name: sys_logininfor; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (100, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-11 14:08:38');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (101, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-11 14:24:56');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (102, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-11 14:25:02');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (103, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-12 14:43:20');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1702479387267, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 06:56:27');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1702479795757, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-14 07:03:16');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1702479798165, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 07:03:18');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1734955974273003521, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-14 07:18:33');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1734956098776723458, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 07:19:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1735200293693120514, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 23:29:23');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (17354791172740, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 17:57:20');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (569163985522689, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-15 23:55:09');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (569174408368129, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 23:55:11');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (640495448338434, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 20:38:38');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (642318659358722, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 20:45:50');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (650221913468929, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 21:17:17');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (650251533643778, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 21:17:24');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (654436291407874, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-15 21:34:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (654452779216897, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 21:34:06');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (661500354977793, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 22:02:06');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (661511495049217, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 22:02:09');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (676701624164353, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 23:02:31');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (216743643848706, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-17 10:48:28');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (600736067362817, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-18 12:14:19');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (991968404852737, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 14:08:56');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (20643301027841, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 16:02:53');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (28911314391042, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-19 16:35:44');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (28923805028354, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 16:35:47');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (37496148709378, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-19 17:09:51');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (37508672901122, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 17:09:54');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (50176146276353, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 18:00:14');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (56426373898241, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 18:25:00');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (57177064648705, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-19 18:28:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (57038648422402, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-19 18:28:09');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (283770225250305, 'admin', '125.36.249.248', 'XX XX', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-20 09:28:23');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (297558985494529, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-20 10:23:15');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (381533382340610, 'admin', '125.36.249.248', 'XX XX', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-20 15:56:52');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (638016053374978, 'admin', '125.36.249.104', 'XX XX', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-21 08:56:02');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (684872823726081, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-21 12:02:18');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (689324498608129, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-21 12:20:00');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (691013393833986, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-21 12:26:42');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (691029013422081, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-21 12:27:05');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (729582481170434, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-21 14:59:57');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (742349644738562, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-21 15:50:42');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (742365922832385, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-21 15:50:45');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (743443636662273, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-21 15:55:02');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (743459331747841, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-21 15:55:06');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (991882242514945, 'admin', '125.36.249.104', 'XX XX', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-22 08:22:10');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (11730687287297, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-22 09:41:02');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (28847197315073, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-22 10:49:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (72811915358210, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-22 13:43:50');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (123246811996161, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-22 17:04:10');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (167636580794370, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-22 20:00:38');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (167651109863426, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-22 20:00:42');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (169346204270594, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-22 20:07:26');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (169358900428802, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-22 20:07:48');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (169702590087170, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-22 20:08:51');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (169716997521409, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-22 20:08:54');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (557352044036097, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-23 21:49:14');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (564595896451073, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-23 22:18:01');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (564606709366785, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-23 22:18:23');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (564968140931074, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-23 22:19:29');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (564980149223425, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-23 22:19:32');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (78586701434881, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-25 08:20:21');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (79585314885633, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-25 08:24:18');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (158605033361409, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-25 13:38:18');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (160110679445505, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-25 13:44:17');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (440684971315201, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 08:19:11');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (442241209094145, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 08:25:22');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (454765568610306, 'admin', '127.0.0.1', '内网IP', 'Chrome 11', 'Windows 10', '0', '登录成功', '2023-12-26 09:15:08');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (472755293335553, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-26 10:26:39');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (516677580845058, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '退出成功', '2023-12-26 13:21:09');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (517016845512706, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 13:22:30');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (519010574364673, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-26 13:30:26');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (803847684222978, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-27 08:22:16');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (812750098657281, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-27 08:57:38');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (815614391390209, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-27 09:09:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (898093317632001, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-27 14:36:46');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (18136645271553, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-27 22:33:48');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (164452354076673, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-28 08:15:11');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (176288994541569, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-28 09:02:13');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (176880654028802, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-28 09:04:35');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (177985291096065, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-28 09:08:58');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (178055268864002, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-28 09:09:15');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (255929100910593, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '退出成功', '2023-12-28 14:18:41');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (255945706160129, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-28 14:18:45');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (259099373977602, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-28 14:31:16');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (259763734953985, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-28 14:33:55');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (529678463217665, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-29 08:26:28');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (530378261868546, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2023-12-29 08:29:14');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (562625315135489, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-29 10:37:24');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (984147339018241, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-30 14:32:24');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (794934831853569, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2024-01-01 20:14:11');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (977041920847874, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-02 08:17:46');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (979750782726145, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-02 08:28:32');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (18549435240450, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2024-01-02 11:02:44');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (79404337786881, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-02 15:04:31');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (81803202850818, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-02 15:14:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (342639683104769, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-03 08:30:31');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (353716017885186, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-03 09:14:32');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (368907080716290, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2024-01-03 10:14:57');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (374296400646146, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2024-01-03 10:36:23');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (377341545041921, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2024-01-03 10:48:28');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (377349841375234, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2024-01-03 10:48:30');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (418628945588225, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-03 13:32:29');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (447066740342785, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2024-01-03 15:25:32');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (453791193993217, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-03 15:53:18');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (454591496556545, 'admin', '192.168.3.17', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-03 15:56:29');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (471521895706626, 'admin', '127.0.0.1', '内网IP', 'Chrome 12', 'Windows 10', '0', '登录成功', '2024-01-03 17:02:39');


--
-- TOC entry 8550 (class 0 OID 17191)
-- Dependencies: 604
-- Data for Name: sys_menu; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1000, '用户查询', 100, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:user:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1001, '用户新增', 100, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:user:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1002, '用户修改', 100, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:user:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1003, '用户删除', 100, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:user:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1004, '用户导出', 100, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:user:export', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1005, '用户导入', 100, 6, '', '', '', 1, 0, 'F', '0', '0', 'system:user:import', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1006, '重置密码', 100, 7, '', '', '', 1, 0, 'F', '0', '0', 'system:user:resetPwd', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1007, '角色查询', 101, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:role:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1008, '角色新增', 101, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:role:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1009, '角色修改', 101, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:role:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1010, '角色删除', 101, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:role:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1011, '角色导出', 101, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:role:export', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1012, '菜单查询', 102, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1013, '菜单新增', 102, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1014, '菜单修改', 102, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1015, '菜单删除', 102, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1016, '部门查询', 103, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1017, '部门新增', 103, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1018, '部门修改', 103, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1019, '部门删除', 103, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1020, '岗位查询', 104, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:post:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1021, '岗位新增', 104, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:post:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1022, '岗位修改', 104, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:post:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1023, '岗位删除', 104, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:post:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1024, '岗位导出', 104, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:post:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1025, '字典查询', 105, 1, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1026, '字典新增', 105, 2, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1027, '字典修改', 105, 3, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1028, '字典删除', 105, 4, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1029, '字典导出', 105, 5, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1030, '参数查询', 106, 1, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1031, '参数新增', 106, 2, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1032, '参数修改', 106, 3, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1033, '参数删除', 106, 4, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1034, '参数导出', 106, 5, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1035, '公告查询', 107, 1, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1036, '公告新增', 107, 2, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1037, '公告修改', 107, 3, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1038, '公告删除', 107, 4, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1039, '操作查询', 500, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1040, '操作删除', 500, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1041, '日志导出', 500, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1042, '登录查询', 501, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1043, '登录删除', 501, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1044, '日志导出', 501, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1045, '账户解锁', 501, 4, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:unlock', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1046, '在线查询', 109, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:online:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1047, '批量强退', 109, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:online:batchLogout', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1048, '单条强退', 109, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:online:forceLogout', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1049, '任务查询', 110, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1050, '任务新增', 110, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1051, '任务修改', 110, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1052, '任务删除', 110, 4, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1053, '状态修改', 110, 5, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:changeStatus', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1054, '任务导出', 110, 6, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1055, '生成查询', 116, 1, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1056, '生成修改', 116, 2, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1057, '生成删除', 116, 3, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1058, '导入代码', 116, 4, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:import', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1059, '预览代码', 116, 5, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:preview', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1060, '生成代码', 116, 6, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:code', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (28684398350339, '岗检方案查询', 28684398350338, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:programme:query', '#', 'admin', '2023-12-19 16:35:35', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (28684398350340, '岗检方案新增', 28684398350338, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:programme:add', '#', 'admin', '2023-12-19 16:35:35', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (28684398350341, '岗检方案修改', 28684398350338, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:programme:edit', '#', 'admin', '2023-12-19 16:35:35', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (28684398350342, '岗检方案删除', 28684398350338, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:programme:remove', '#', 'admin', '2023-12-19 16:35:35', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (28684398350343, '岗检方案导出', 28684398350338, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:programme:export', '#', 'admin', '2023-12-19 16:35:35', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (37253508222978, '岗检小组查询', 37253508222977, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:team:query', '#', 'admin', '2023-12-19 17:09:41', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (37253508222979, '岗检小组新增', 37253508222977, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:team:add', '#', 'admin', '2023-12-19 17:09:41', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (37253508222980, '岗检小组修改', 37253508222977, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:team:edit', '#', 'admin', '2023-12-19 17:09:41', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (37253508222981, '岗检小组删除', 37253508222977, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:team:remove', '#', 'admin', '2023-12-19 17:09:41', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (37253508222982, '岗检小组导出', 37253508222977, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:team:export', '#', 'admin', '2023-12-19 17:09:41', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (298192019214338, '岗检计划查询', 298192019214337, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlan:query', '#', 'admin', '2023-12-20 10:26:18', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (298192019214339, '岗检计划新增', 298192019214337, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlan:add', '#', 'admin', '2023-12-20 10:26:18', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (298192019214340, '岗检计划修改', 298192019214337, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlan:edit', '#', 'admin', '2023-12-20 10:26:18', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (298192019214341, '岗检计划删除', 298192019214337, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlan:remove', '#', 'admin', '2023-12-20 10:26:18', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (298192019214342, '岗检计划导出', 298192019214337, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlan:export', '#', 'admin', '2023-12-20 10:26:18', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (309207674998786, '岗检责任制清单查询', 309207674998785, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckList:query', '#', 'admin', '2023-12-20 11:14:22', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (309207674998787, '岗检责任制清单新增', 309207674998785, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckList:add', '#', 'admin', '2023-12-20 11:14:22', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (309207674998788, '岗检责任制清单修改', 309207674998785, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckList:edit', '#', 'admin', '2023-12-20 11:14:22', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (309207674998789, '岗检责任制清单删除', 309207674998785, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckList:remove', '#', 'admin', '2023-12-20 11:14:22', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (309207674998790, '岗检责任制清单导出', 309207674998785, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckList:export', '#', 'admin', '2023-12-20 11:14:22', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (105, '字典管理', 1, 6, 'dict', 'system/dict/index', '', 1, 0, 'C', '0', '0', 'system:dict:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '字典管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (106, '参数设置', 1, 7, 'config', 'system/config/index', '', 1, 0, 'C', '0', '0', 'system:config:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '参数设置菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (107, '通知公告', 1, 8, 'notice', 'system/notice/index', '', 1, 0, 'C', '0', '0', 'system:notice:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '通知公告菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (173097644294145, '岗检记录上传', 690381161226242, 310, 'postPlanJoinChecked', 'postCheck/postPlanJoinChecked/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postPlanJoinChecked:list', '#', 'admin', '2023-12-22 20:33:07', 'admin', '2023-12-23 22:21:50', '岗检记录上传菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (108, '日志管理', 1, 9, 'log', '', '', 1, 0, 'M', '0', '0', '', '', 'admin', '2023-12-11 13:16:57', '', NULL, '日志管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (175400996667394, '岗检问题录入列表', 690381161226242, 320, 'postPlanJoinProblem', 'postCheck/postPlanJoinProblem/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postPlanJoinProblem:list', '#', 'admin', '2023-12-22 20:33:07', 'admin', '2023-12-23 22:22:00', '岗检问题录入列表菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (175400996667395, '岗检问题录入列表查询', 175400996667394, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinProblem:query', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (175400996667396, '岗检问题录入列表新增', 175400996667394, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinProblem:add', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (175400996667397, '岗检问题录入列表修改', 175400996667394, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinProblem:edit', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (175400996667398, '岗检问题录入列表删除', 175400996667394, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinProblem:remove', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (175400996667399, '岗检问题录入列表导出', 175400996667394, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinProblem:export', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (564205528383490, '岗检问题录入查询', 564205528383489, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedProblem:query', '#', 'admin', '2023-12-23 22:27:34', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (309207674998785, '岗检责任制编制', 307951506116609, 110, 'postCheckList', 'postCheck/postCheckList/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postCheckList:list', '#', 'admin', '2023-12-20 11:14:22', 'admin', '2023-12-21 12:29:55', '岗检责任制清单菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (116, '代码生成', 3, 2, 'gen', 'tool/gen/index', '', 1, 0, 'C', '0', '0', 'tool:gen:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '代码生成菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (564205528383491, '岗检问题录入新增', 564205528383489, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedProblem:add', '#', 'admin', '2023-12-23 22:27:34', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (117, '系统接口', 3, 3, 'swagger', 'tool/swagger/index', '', 1, 0, 'C', '1', '1', 'tool:swagger:list', '', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-14 07:03:10', '系统接口菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (564205528383492, '岗检问题录入修改', 564205528383489, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedProblem:edit', '#', 'admin', '2023-12-23 22:27:34', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (115, '表单构建', 3, 1, 'build', 'tool/build/index', '', 1, 0, 'C', '1', '1', 'tool:build:list', '', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-26 21:32:36', '表单构建菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (2, '系统监控', 0, 900, 'monitor', NULL, '', 1, 0, 'M', '0', '1', '', '', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-26 11:35:19', '系统监控目录');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (109, '在线用户', 2, 1, 'online', 'monitor/online/index', '', 1, 0, 'C', '0', '0', 'monitor:online:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '在线用户菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (4, '若依官网', 0, 1000, 'http://ruoyi.vip', NULL, '', 0, 0, 'M', '1', '1', '', 'guide', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-21 12:31:57', '若依官网地址');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (564205528383493, '岗检问题录入删除', 564205528383489, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedProblem:remove', '#', 'admin', '2023-12-23 22:27:34', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (37253508222977, '岗检小组', 17355455216040, 220, 'team', 'postCheck/team/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:team:list', '#', 'admin', '2023-12-19 17:09:41', 'admin', '2023-12-21 12:32:46', '岗检小组菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (298192019214337, '岗检计划', 17355455216040, 230, 'postPlan', 'postCheck/postPlan/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postPlan:list', '#', 'admin', '2023-12-20 10:26:18', 'admin', '2023-12-21 12:32:52', '岗检计划菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (734552664301570, '考核评比', 689680272056322, 1, 'assessmentRating', 'postCheck/assessmentRating/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:assessmentRating:list', '#', 'admin', '2023-12-21 15:21:25', '', NULL, '考核评比菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (734552664301572, '考核评比新增', 734552664301570, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:assessmentRating:add', '#', 'admin', '2023-12-21 15:21:25', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (734552664301573, '考核评比修改', 734552664301570, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:assessmentRating:edit', '#', 'admin', '2023-12-21 15:21:25', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (734552664301574, '考核评比删除', 734552664301570, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:assessmentRating:remove', '#', 'admin', '2023-12-21 15:21:25', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (734552664301575, '考核评比导出', 734552664301570, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:assessmentRating:export', '#', 'admin', '2023-12-21 15:21:25', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (110, '定时任务', 2, 2, 'job', 'monitor/job/index', '', 1, 0, 'C', '0', '0', 'monitor:job:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '定时任务菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (112, '服务监控', 2, 4, 'server', 'monitor/server/index', '', 1, 0, 'C', '0', '0', 'monitor:server:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '服务监控菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (113, '缓存监控', 2, 5, 'cache', 'monitor/cache/index', '', 1, 0, 'C', '0', '0', 'monitor:cache:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '缓存监控菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (564205528383494, '岗检问题录入导出', 564205528383489, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedProblem:export', '#', 'admin', '2023-12-23 22:27:34', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (126872108326913, '(岗位)岗检方案', 28684398350338, 6, 'postInspectionPlanning/projectManagement/index', 'postInspectionPlanning/projectManagement/index', NULL, 1, 1, 'C', '0', '0', '', '#', 'admin', '2023-12-22 17:18:34', 'admin', '2023-12-22 17:18:52', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (114, '缓存列表', 2, 6, 'cacheList', 'monitor/cache/list', '', 1, 0, 'C', '0', '0', 'monitor:cache:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '缓存列表菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (564205528383489, '岗检问题录入', 690381161226242, 321, 'postCheckedProblem', 'postCheck/postCheckedProblem/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postCheckedProblem:list', '#', 'admin', '2023-12-23 22:27:34', 'admin', '2023-12-23 22:30:03', '岗检问题录入菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (28684398350338, '岗检方案管理', 17355455216040, 210, 'ParentView', 'ParentView', NULL, 1, 0, 'M', '0', '0', 'postCheck:programme:list', '#', 'admin', '2023-12-19 16:35:35', 'admin', '2023-12-22 17:23:28', '岗检方案菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (307951506116609, '岗位责任制管理', 0, 100, '/postCheck/postCheckList', NULL, NULL, 1, 0, 'M', '1', '0', '', 'star', 'admin', '2023-12-20 11:04:33', 'admin', '2023-12-26 11:32:35', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (17355455216040, '岗检策划', 0, 200, '/postCheck/programme', NULL, NULL, 1, 0, 'M', '1', '0', '', 'star', 'admin', '2023-12-15 22:21:24', 'admin', '2023-12-26 11:34:23', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (173097644294146, '岗检记录上传查询', 173097644294145, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinChecked:query', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (173097644294147, '岗检记录上传新增', 173097644294145, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinChecked:add', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (173097644294148, '岗检记录上传修改', 173097644294145, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinChecked:edit', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (173097644294149, '岗检记录上传删除', 173097644294145, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinChecked:remove', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (173097644294150, '岗检记录上传导出', 173097644294145, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postPlanJoinChecked:export', '#', 'admin', '2023-12-22 20:33:07', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (690381161226242, '岗检实施', 0, 300, '/xx', NULL, NULL, 1, 0, 'M', '1', '0', '', 'star', 'admin', '2023-12-21 12:24:12', 'admin', '2023-12-26 11:34:30', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (689680272056322, '考核评比', 0, 400, '/postCheck/assessmentRating', NULL, NULL, 1, 0, 'M', '1', '0', '', 'star', 'admin', '2023-12-21 12:21:25', 'admin', '2023-12-26 11:34:37', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (690736334888962, '统计分析', 0, 500, '/xxxxx', NULL, NULL, 1, 0, 'M', '1', '0', '', 'star', 'admin', '2023-12-21 12:25:36', 'admin', '2023-12-26 11:34:44', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (690873270525953, '岗检历史', 0, 600, '/xxxxxx', NULL, NULL, 1, 0, 'M', '1', '0', '', 'star', 'admin', '2023-12-21 12:26:09', 'admin', '2023-12-26 11:34:50', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (111, '数据监控', 2, 3, 'druid', 'monitor/druid/index', '', 1, 0, 'C', '1', '1', 'monitor:druid:list', '', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-14 07:02:50', '数据监控菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (641583692361730, '岗检亮点', 690873270525953, 1, 'postHighlights', 'postCheck/postHighlights/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postHighlights:list', '#', 'admin', '2023-12-26 21:37:52', '', NULL, '岗检亮点菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (641583692361731, '岗检亮点查询', 641583692361730, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postHighlights:query', '#', 'admin', '2023-12-26 21:37:52', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (641583692361732, '岗检亮点新增', 641583692361730, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postHighlights:add', '#', 'admin', '2023-12-26 21:37:52', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (641583692361733, '岗检亮点修改', 641583692361730, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postHighlights:edit', '#', 'admin', '2023-12-26 21:37:52', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (641583692361734, '岗检亮点删除', 641583692361730, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postHighlights:remove', '#', 'admin', '2023-12-26 21:37:52', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (641583692361735, '岗检亮点导出', 641583692361730, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postHighlights:export', '#', 'admin', '2023-12-26 21:37:52', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1, '系统管理', 0, 700, 'system', NULL, '', 1, 0, 'M', '0', '0', '', '', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-21 12:30:55', '系统管理目录');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (100, '用户管理', 1, 1, 'user', 'system/user/index', '', 1, 0, 'C', '0', '0', 'system:user:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '用户管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (101, '角色管理', 1, 2, 'role', 'system/role/index', '', 1, 0, 'C', '0', '0', 'system:role:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '角色管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (102, '菜单管理', 1, 3, 'menu', 'system/menu/index', '', 1, 0, 'C', '0', '0', 'system:menu:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '菜单管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (103, '部门管理', 1, 4, 'dept', 'system/dept/index', '', 1, 0, 'C', '0', '0', 'system:dept:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '部门管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (104, '岗位管理', 1, 5, 'post', 'system/post/index', '', 1, 0, 'C', '0', '0', 'system:post:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '岗位管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (500, '操作日志', 108, 1, 'operlog', 'monitor/operlog/index', '', 1, 0, 'C', '0', '0', 'monitor:operlog:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '操作日志菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (501, '登录日志', 108, 2, 'logininfor', 'monitor/logininfor/index', '', 1, 0, 'C', '0', '0', 'monitor:logininfor:list', '', 'admin', '2023-12-11 13:16:57', '', NULL, '登录日志菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (734552664301571, '考核评比查询', 734552664301570, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:assessmentRating:query', '#', 'admin', '2023-12-21 15:21:25', 'admin', '2023-12-27 10:51:55', '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (3, '系统工具', 0, 800, 'tool', NULL, '', 1, 0, 'M', '0', '0', '', '', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-28 16:27:43', '系统工具目录');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294295035482114, '岗检报告管理', 690381161226242, 1, 'postCheckedReport', 'postCheck/postCheckedReport/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postCheckedReport:list', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '岗检报告管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294295035482115, '岗检报告管理查询', 294295035482114, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedReport:query', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294295035482116, '岗检报告管理新增', 294295035482114, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedReport:add', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294295035482117, '岗检报告管理修改', 294295035482114, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedReport:edit', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294295035482118, '岗检报告管理删除', 294295035482114, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedReport:remove', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294295035482119, '岗检报告管理导出', 294295035482114, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postCheckedReport:export', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294296021143553, '考核规则', 689680272056322, 1, 'postAssessmentRules', 'postCheck/postAssessmentRules/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postAssessmentRules:list', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '考核规则菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294296021143554, '考核规则查询', 294296021143553, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRules:query', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294296021143555, '考核规则新增', 294296021143553, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRules:add', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294296021143556, '考核规则修改', 294296021143553, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRules:edit', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294296021143557, '考核规则删除', 294296021143553, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRules:remove', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (294296021143558, '考核规则导出', 294296021143553, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRules:export', '#', 'admin', '2023-12-28 16:52:17', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (825754321793025, '互评（职能）', 689680272056322, 1, 'postAssessmentRatingOther', 'postCheck/postAssessmentRatingOther/index', NULL, 1, 0, 'C', '0', '0', 'postCheck:postAssessmentRatingOther:list', '#', 'admin', '2024-01-01 22:20:47', '', NULL, '互评（职能）菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (825754321793026, '互评（职能）查询', 825754321793025, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRatingOther:query', '#', 'admin', '2024-01-01 22:20:47', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (825754321793027, '互评（职能）新增', 825754321793025, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRatingOther:add', '#', 'admin', '2024-01-01 22:20:47', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (825754321793028, '互评（职能）修改', 825754321793025, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRatingOther:edit', '#', 'admin', '2024-01-01 22:20:47', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (825754321793029, '互评（职能）删除', 825754321793025, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRatingOther:remove', '#', 'admin', '2024-01-01 22:20:47', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (825754321793030, '互评（职能）导出', 825754321793025, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postCheck:postAssessmentRatingOther:export', '#', 'admin', '2024-01-01 22:20:47', '', NULL, '');


--
-- TOC entry 8541 (class 0 OID 17113)
-- Dependencies: 595
-- Data for Name: sys_notice; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_notice (notice_id, notice_title, notice_type, notice_content, status, create_by, create_time, update_by, update_time, remark) VALUES (1, '温馨提醒：2018-07-01 若依新版本发布啦', '2', '\346\226\260\347\211\210\346\234\254\345\206\205\345\256\271', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '管理员');
INSERT INTO public.sys_notice (notice_id, notice_title, notice_type, notice_content, status, create_by, create_time, update_by, update_time, remark) VALUES (2, '维护通知：2018-07-01 若依系统凌晨维护', '1', '\347\273\264\346\212\244\345\206\205\345\256\271', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '管理员');


--
-- TOC entry 8536 (class 0 OID 17066)
-- Dependencies: 590
-- Data for Name: sys_oper_log; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (100, '字典类型', 1, 'com.ruoyi.web.controller.system.SysDictTypeController.add()', 'POST', 1, 'admin', '研发部门', '/system/dict/type', '127.0.0.1', '内网IP', '{"createBy":"admin","dictName":"岗检测试1","dictType":"post_check_test_v1","params":{},"remark":"测试1","status":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-11 14:09:50', 128);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (101, '字典数据', 1, 'com.ruoyi.web.controller.system.SysDictDataController.add()', 'POST', 1, 'admin', '研发部门', '/system/dict/data', '127.0.0.1', '内网IP', '{"createBy":"admin","default":false,"dictLabel":"是-测试","dictSort":1,"dictType":"post_check_test_v1","dictValue":"1","listClass":"default","params":{},"status":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-11 14:10:22', 86);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (102, '字典数据', 1, 'com.ruoyi.web.controller.system.SysDictDataController.add()', 'POST', 1, 'admin', '研发部门', '/system/dict/data', '127.0.0.1', '内网IP', '{"createBy":"admin","default":false,"dictLabel":"否-测试","dictSort":2,"dictType":"post_check_test_v1","dictValue":"2","listClass":"default","params":{},"status":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-11 14:10:39', 74);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (1734956191860912129, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 05:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":4,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-14 07:19:25', 45);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (1735306895750238210, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_plan"}', NULL, 1, '导入失败：
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-generator\target\classes\mapper\generator\GenTableMapper.xml]
### The error may involve com.ruoyi.generator.mapper.GenTableMapper.insertGenTable-Inline
### The error occurred while setting parameters
### SQL: insert into gen_table (     table_name,      table_comment,      class_name,                package_name,      module_name,      business_name,      function_name,      function_author,                      create_by,     create_time          )values(     ?,      ?,      ?,                ?,      ?,      ?,      ?,      ?,                      ?,       CURRENT_TIMESTAMP          )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).
; 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).', '2023-12-15 06:32:59', 132);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (1735310802555670530, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_plan"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 06:48:31', 188);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354816179600, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isInc', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:07:16', 97);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354820753195, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncr', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:09:05', 35);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354822865069, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isInc', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:09:55', 30);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354823648439, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:10:14', 28);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354825412480, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:10:56', 45);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354850946690, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:21:05', 261354);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354852331397, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:21:38', 9409);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354864071925, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:21:29","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:21:29","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:21:29","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:26:18', 27);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354864995762, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:18","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:18","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:18","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:26:40', 29);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354866648780, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:40","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:40","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:40","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:27:19', 48);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354866747891, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.genCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/genCode/post_plan', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:27:22', 146);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354924314042, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:27:19","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:27:19","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:27:19","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:50:14', 47);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355193393702, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:50:14","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:50:14","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:50:14","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 20:37:10', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (435924888547329, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_programme', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 19:33:05', 2453);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (482704737701890, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 11:06:09","delFlag":0,"diskPath":"2024岗检.xlsx","name":"2024方案","params":{},"updateBy":"admin","updateTime":"2023-12-26 11:06:09"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.insertPostProgramme
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-26 11:06:10', 64);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355195070333, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:09","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:09","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:09","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 20:37:50', 59);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355393657750, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 05:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":4,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"1","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 21:56:44', 62);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355402883751, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-system\target\classes\mapper\system\SysMenuMapper.xml]
### The error may involve com.ruoyi.system.mapper.SysMenuMapper.insertMenu-Inline
### The error occurred while setting parameters
### SQL: insert into sys_menu(            menu_name,     order_num,     path,             is_frame,     is_cache,     menu_type,     visible,     status,         icon,         create_by,    create_time   )values(            ?,     ?,     ?,             ?,     ?,     ?,     ?,     ?,         ?,         ?,       CURRENT_TIMESTAMP   )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).
; 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).', '2023-12-15 22:00:24', 93);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355405781847, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-system\target\classes\mapper\system\SysMenuMapper.xml]
### The error may involve com.ruoyi.system.mapper.SysMenuMapper.insertMenu-Inline
### The error occurred while setting parameters
### SQL: insert into sys_menu(            menu_name,     order_num,     path,             is_frame,     is_cache,     menu_type,     visible,     status,         icon,         create_by,    create_time   )values(            ?,     ?,     ?,             ?,     ?,     ?,     ?,     ?,         ?,         ?,       CURRENT_TIMESTAMP   )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).
; 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).', '2023-12-15 22:01:33', 9975);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355455736218, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":17355455216040,"menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 22:21:24', 14106);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355456010232, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"icon":"star","isCache":"0","isFrame":"1","menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', '{"msg":"新增菜单''岗检策划''失败，菜单名称已存在","code":500}', 0, NULL, '2023-12-15 22:21:31', 4);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355465011837, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:49","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:49","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:49","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 22:25:05', 83);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355584373005, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 14:25:05","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 14:25:05","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 14:25:05","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 23:12:31', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (708974885031937, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_plan', '127.0.0.1', '内网IP', '{}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-generator\target\classes\mapper\generator\GenTableColumnMapper.xml]
### The error may involve com.ruoyi.generator.mapper.GenTableColumnMapper.insertGenTableColumn-Inline
### The error occurred while setting parameters
### SQL: insert into gen_table_column (             column_id,     table_id,      column_name,      column_comment,      column_type,      java_type,      java_field,      is_pk,      is_increment,      is_required,      is_insert,      is_edit,      is_list,           query_type,      html_type,           sort,          create_time          )values(             ?,     ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,           ?,      ?,           ?,                        CURRENT_TIMESTAMP          )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).
; 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).', '2023-12-16 01:10:45', 762);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (709881353777154, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_plan', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:14:21', 944);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (712180167913473, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:23:30', 20974);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (712206239707137, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:23:36', 698);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (712218956836866, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:23:39', 19931);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (11909342416898, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_programme,post_programme_template"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 15:28:11', 3129);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (12024786440193, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programme","className":"PostProgramme","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11897749360641,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11896495263745,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":11898265260034,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":11896495263745,"updateBy":"","usableColumn":false},{"capJavaField":"SubmitDate","columnComment":"submit_date","columnId":11898596610049,"columnName":"submit_date","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"submitDate","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":11896495263745,"updateBy":"","usableColumn":false},{"capJavaField":"StatusHr","columnComment":"status_hr","columnId":11898923765761,"columnName":"status_hr","columnType":"integer","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncreme', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 15:28:38', 1520);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (12079224311810, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"template","className":"PostProgrammeTemplate","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11904565104642,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11903831101442,"updateBy":"","usableColumn":false},{"capJavaField":"PlanName","columnComment":"plan_name","columnId":11904955174914,"columnName":"plan_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"planName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":11903831101442,"updateBy":"","usableColumn":false},{"capJavaField":"TemplateName","columnComment":"template_name","columnId":11905349439490,"columnName":"template_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"templateName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":11903831101442,"updateBy":"","usableColumn":false},{"capJavaField":"DiskPath","columnComment":"disk_path","columnId":11905676595201,"columnName":"disk_path","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"i', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 15:28:51', 1152);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20797127127041, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_team,post_team_user,post_team_dept"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:03:30', 3517);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20992090959873, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","usableColumn":false},{"capJavaField":"ParentId","columnComment":"parent_id","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","usableColumn":true},{"capJavaField":"Status","columnComment":"status","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isLis', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:04:16', 1109);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21086219530241, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"dept","className":"PostTeamDept","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20788428140545,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20787706720257,"updateBy":"","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"post_team_id","columnId":20788755296258,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20787706720257,"updateBy":"","usableColumn":false},{"capJavaField":"DeptId","columnComment":"dept_id","columnId":20789086646273,"columnName":"dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"deptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":20787706720257,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"type","columnId":20789413801986,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","is', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:04:38', 1049);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (127361633935362, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/programme/index","createTime":"2023-12-19 16:35:35","icon":"#","isCache":"0","isFrame":"1","menuId":28684398350338,"menuName":"岗检方案管理","menuType":"C","orderNum":210,"params":{},"parentId":17355455216040,"path":"ParentView","perms":"postCheck:programme:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 17:20:31', 144);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (127831798636546, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"ParentView","createTime":"2023-12-19 16:35:35","icon":"#","isCache":"0","isFrame":"1","menuId":28684398350338,"menuName":"岗检方案管理","menuType":"C","orderNum":210,"params":{},"parentId":17355455216040,"path":"ParentView","perms":"postCheck:programme:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 17:22:23', 29);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (916527472455682, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:50:00","createUserId":1,"delFlag":0,"id":916527342432258,"name":"工作组3(综合)","params":{},"parentId":1,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-27 15:50:00"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:50:01', 19);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21236002320385, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"user","className":"PostTeamUser","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20792811188225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20792089767937,"updateBy":"","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"post_team_id","columnId":20793138343938,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20792089767937,"updateBy":"","usableColumn":false},{"capJavaField":"UserId","columnComment":"user_id","columnId":20793461305346,"columnName":"user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"userId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":20792089767937,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"type","columnId":20793792655361,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","i', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:05:14', 959);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21787326803970, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_plan_info,post_plan_info_user"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:07:26', 2238);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21876954886145, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"info","className":"PostPlanInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":21778929807362,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21778212581378,"updateBy":"","usableColumn":false},{"capJavaField":"PostPlanId","columnComment":"post_plan_id","columnId":21779256963073,"columnName":"post_plan_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21778212581378,"updateBy":"","usableColumn":false},{"capJavaField":"CheckedDeptId","columnComment":"checked_dept_id","columnId":21779588313089,"columnName":"checked_dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedDeptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21778212581378,"updateBy":"","usableColumn":false},{"capJavaField":"CheckTime","columnComment":"check_time","columnId":21779915468801,"columnName":"check_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"increment":false,"inser', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:07:47', 1058);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (22045872091137, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"user","className":"PostPlanInfoUser","columns":[{"capJavaField":"Id","columnComment":"id","columnId":21783438684162,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21782784372738,"updateBy":"","usableColumn":false},{"capJavaField":"PostPlanInfoId","columnComment":"post_plan_info_id","columnId":21783828754433,"columnName":"post_plan_info_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanInfoId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21782784372738,"updateBy":"","usableColumn":false},{"capJavaField":"CheckedUserId","columnComment":"checked_user_id","columnId":21784155910145,"columnName":"checked_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21782784372738,"updateBy":"","usableColumn":false},{"capJavaField":"Remark","columnComment":"remark","columnId":21784491454465,"columnName":"remark","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:08:27', 1042);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (27907202252801, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programme","className":"PostProgramme","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":11897749360641,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 15:28:36","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":11898265260034,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 15:28:36","usableColumn":false},{"capJavaField":"SubmitDate","columnComment":"提交日期","columnId":11898596610049,"columnName":"submit_date","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"submitDate","javaType":"Date","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 15:28:36","usableColumn":false},{"capJavaField":"StatusHr","columnComment":"人力资源审批-状态：1-待审核；3-通过；4-驳回；","columnId":11898923765761,"columnName":"status_hr","columnType":"integer","createBy":"admin","createTime":"2023-12-19', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:31:45', 1620);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (28272052174849, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programme","className":"PostProgramme","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":11897749360641,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 16:31:43","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":11898265260034,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 16:31:43","usableColumn":false},{"capJavaField":"SubmitDate","columnComment":"提交日期","columnId":11898596610049,"columnName":"submit_date","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"submitDate","javaType":"Date","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 16:31:43","usableColumn":false},{"capJavaField":"StatusHr","columnComment":"人力资源审批-状态：1-待审核；3-通过；4-驳回；","columnId":11898923765761,"columnName":"status_hr","columnType":"integer","createBy":"admin","createTime":"2023-12-19', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:33:12', 1526);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (31595421487106, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"template","className":"PostProgrammeTemplate","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11904565104642,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 15:28:50","usableColumn":false},{"capJavaField":"PlanName","columnComment":"方案名称","columnId":11904955174914,"columnName":"plan_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"planName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 15:28:50","usableColumn":false},{"capJavaField":"TemplateName","columnComment":"模板名称","columnId":11905349439490,"columnName":"template_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"templateName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 15:28:50","usableColumn":false},{"capJavaField":"DiskPath","columnComment":"模板磁盘路径","columnId":11905676595201,"columnName":"disk_path","columnType":"varchar","createBy":"admin","createTime"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:46:24', 777);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (31840616304641, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programmeTemplate","className":"PostProgrammeTemplate","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11904565104642,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 16:46:23","usableColumn":false},{"capJavaField":"PlanName","columnComment":"方案名称","columnId":11904955174914,"columnName":"plan_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"planName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 16:46:23","usableColumn":false},{"capJavaField":"TemplateName","columnComment":"模板名称","columnId":11905349439490,"columnName":"template_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"templateName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 16:46:23","usableColumn":false},{"capJavaField":"DiskPath","columnComment":"模板磁盘路径","columnId":11905676595201,"columnName":"disk_path","columnType":"varchar","createBy":"admin","cr', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:47:23', 659);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (34496718032898, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":false},{"capJavaField":"ParentId","columnComment":"parent_id","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":true},{"capJavaField":"Status","columnComment":"status","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":tru', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:57:56', 20884);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (34514610933761, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":false},{"capJavaField":"ParentId","columnComment":"parent_id","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":true},{"capJavaField":"Status","columnComment":"status","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":tru', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:58:00', 669);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (34551692775425, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":false},{"capJavaField":"ParentId","columnComment":"parent_id","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:04:15","usableColumn":true},{"capJavaField":"Status","columnComment":"status","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":tru', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 16:58:09', 19912);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (35119475707906, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:57:59","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:57:59","usableColumn":false},{"capJavaField":"ParentId","columnComment":"父ID（0代表根节点）","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 16:57:59","usableColumn":true},{"capJavaField":"Status","columnComment":"状态（1-启用；2-未启用）","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","e', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:00:24', 745);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (35452616691713, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamDept","className":"PostTeamDept","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20788428140545,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 16:04:37","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"post_team_id","columnId":20788755296258,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 16:04:37","usableColumn":false},{"capJavaField":"DeptId","columnComment":"dept_id","columnId":20789086646273,"columnName":"dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"deptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 16:04:37","usableColumn":false},{"capJavaField":"Type","columnComment":"type","columnId":20789413801986,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","di', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:01:44', 649);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (36467768283138, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamDept","className":"PostTeamDept","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":20788428140545,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:01:43","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"岗检工作组ID","columnId":20788755296258,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:01:43","usableColumn":false},{"capJavaField":"DeptId","columnComment":"部门ID","columnId":20789086646273,"columnName":"dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"deptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:01:43","usableColumn":false},{"capJavaField":"Type","columnComment":"类型（1-牵头部门；2-成员部门）","columnId":20789413801986,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:05:46', 642);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (36899018231809, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamUser","className":"PostTeamUser","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20792811188225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 16:05:13","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"岗检小组ID","columnId":20793138343938,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 16:05:13","usableColumn":false},{"capJavaField":"UserId","columnComment":"用户ID","columnId":20793461305346,"columnName":"user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"userId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 16:05:13","usableColumn":false},{"capJavaField":"Type","columnComment":"类型（1-负责人；2-小组成员；）","columnId":20793792655361,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:07:29', 663);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (128107351826433, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"ParentView","createTime":"2023-12-19 16:35:35","icon":"#","isCache":"0","isFrame":"1","menuId":28684398350338,"menuName":"岗检方案管理","menuType":"M","orderNum":210,"params":{},"parentId":17355455216040,"path":"ParentView","perms":"postCheck:programme:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 17:23:28', 117);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (37998039126018, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamUser","className":"PostTeamUser","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":20792811188225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 17:07:28","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"岗检小组ID","columnId":20793138343938,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 17:07:28","usableColumn":false},{"capJavaField":"UserId","columnComment":"用户ID","columnId":20793461305346,"columnName":"user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"userId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 17:07:28","usableColumn":false},{"capJavaField":"Type","columnComment":"类型（1-负责人；2-小组成员；）","columnId":20793792655361,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:11:51', 596);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (38268190052353, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:23:38","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:23:38","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:23:38","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:12:55', 661);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (38762698493953, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlanInfo","className":"PostPlanInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":21778929807362,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 16:07:46","usableColumn":false},{"capJavaField":"PostPlanId","columnComment":"计划ID","columnId":21779256963073,"columnName":"post_plan_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 16:07:46","usableColumn":false},{"capJavaField":"CheckedDeptId","columnComment":"被检查部门ID","columnId":21779588313089,"columnName":"checked_dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedDeptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 16:07:46","usableColumn":false},{"capJavaField":"CheckTime","columnComment":"检查时间","columnId":21779915468801,"columnName":"check_time","columnType":"timestamp with time zone","createBy":"a', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:14:53', 718);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39164135329794, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"planInfoUser","className":"PostPlanInfoUser","columns":[{"capJavaField":"Id","columnComment":"id","columnId":21783438684162,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 16:08:26","usableColumn":false},{"capJavaField":"PostPlanInfoId","columnComment":"计划明细ID","columnId":21783828754433,"columnName":"post_plan_info_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanInfoId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 16:08:26","usableColumn":false},{"capJavaField":"CheckedUserId","columnComment":"检查人员ID","columnId":21784155910145,"columnName":"checked_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 16:08:26","usableColumn":false},{"capJavaField":"Remark","columnComment":"remark","columnId":21784491454465,"columnName":"remark","columnType":"varchar","createBy":"admin', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:16:29', 658);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39432876969985, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programme","className":"PostProgramme","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":11897749360641,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 16:33:10","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":11898265260034,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 16:33:10","usableColumn":false},{"capJavaField":"SubmitDate","columnComment":"提交日期","columnId":11898596610049,"columnName":"submit_date","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"submitDate","javaType":"Date","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-19 16:33:10","usableColumn":false},{"capJavaField":"StatusHr","columnComment":"人力资源审批-状态：1-待审核；3-通过；4-驳回；","columnId":11898923765761,"columnName":"status_hr","columnType":"integer","createBy":"admin","createTime":"2023-12-19', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:17:33', 880);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39470155943937, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programmeTemplate","className":"PostProgrammeTemplate","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11904565104642,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 16:47:22","usableColumn":false},{"capJavaField":"PlanName","columnComment":"方案名称","columnId":11904955174914,"columnName":"plan_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"planName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 16:47:22","usableColumn":false},{"capJavaField":"TemplateName","columnComment":"模板名称","columnId":11905349439490,"columnName":"template_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"templateName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 16:47:22","usableColumn":false},{"capJavaField":"DiskPath","columnComment":"模板磁盘路径","columnId":11905676595201,"columnName":"disk_path","columnType":"varchar","createBy":"admin","cr', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:17:42', 663);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39510802944001, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"id","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 17:00:24","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 17:00:24","usableColumn":false},{"capJavaField":"ParentId","columnComment":"父ID（0代表根节点）","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 17:00:24","usableColumn":true},{"capJavaField":"Status","columnComment":"状态（1-启用；2-未启用）","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","e', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:17:51', 694);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39554998325249, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamDept","className":"PostTeamDept","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":20788428140545,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:05:45","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"岗检工作组ID","columnId":20788755296258,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:05:45","usableColumn":false},{"capJavaField":"DeptId","columnComment":"部门ID","columnId":20789086646273,"columnName":"dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"deptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:05:45","usableColumn":false},{"capJavaField":"Type","columnComment":"类型（1-牵头部门；2-成员部门）","columnId":20789413801986,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:18:02', 602);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39593669808129, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamUser","className":"PostTeamUser","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":20792811188225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 17:11:50","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"岗检小组ID","columnId":20793138343938,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 17:11:50","usableColumn":false},{"capJavaField":"UserId","columnComment":"用户ID","columnId":20793461305346,"columnName":"user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"userId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":20792089767937,"updateBy":"","updateTime":"2023-12-19 17:11:50","usableColumn":false},{"capJavaField":"Type","columnComment":"类型（1-负责人；2-小组成员；）","columnId":20793792655361,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:18:11', 615);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39667669913601, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlanInfo","className":"PostPlanInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":21778929807362,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 17:14:52","usableColumn":false},{"capJavaField":"PostPlanId","columnComment":"计划ID","columnId":21779256963073,"columnName":"post_plan_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 17:14:52","usableColumn":false},{"capJavaField":"CheckedDeptId","columnComment":"被检查部门ID","columnId":21779588313089,"columnName":"checked_dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedDeptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 17:14:52","usableColumn":false},{"capJavaField":"CheckTime","columnComment":"检查时间","columnId":21779915468801,"columnName":"check_time","columnType":"timestamp with time zone","createBy":"a', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:18:29', 643);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39699848613890, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"planInfoUser","className":"PostPlanInfoUser","columns":[{"capJavaField":"Id","columnComment":"id","columnId":21783438684162,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 17:16:28","usableColumn":false},{"capJavaField":"PostPlanInfoId","columnComment":"计划明细ID","columnId":21783828754433,"columnName":"post_plan_info_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanInfoId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 17:16:28","usableColumn":false},{"capJavaField":"CheckedUserId","columnComment":"检查人员ID","columnId":21784155910145,"columnName":"checked_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 17:16:28","usableColumn":false},{"capJavaField":"Remark","columnComment":"remark","columnId":21784491454465,"columnName":"remark","columnType":"varchar","createBy":"admin', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:18:36', 602);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (39946465300481, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programmeTemplate","className":"PostProgrammeTemplate","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":11904565104642,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 17:17:41","usableColumn":false},{"capJavaField":"PlanName","columnComment":"方案名称","columnId":11904955174914,"columnName":"plan_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"planName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 17:17:41","usableColumn":false},{"capJavaField":"TemplateName","columnComment":"模板名称","columnId":11905349439490,"columnName":"template_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"templateName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":11903831101442,"updateBy":"","updateTime":"2023-12-19 17:17:41","usableColumn":false},{"capJavaField":"DiskPath","columnComment":"模板磁盘路径","columnId":11905676595201,"columnName":"disk_path","columnType":"varchar","createBy":"admin","cr', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:19:35', 660);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (40090191515650, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"team","className":"PostTeam","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":20783457890306,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 17:17:51","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":20783847960578,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 17:17:51","usableColumn":false},{"capJavaField":"ParentId","columnComment":"父ID（0代表根节点）","columnId":20784372248578,"columnName":"parent_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"parentId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":true,"tableId":20782669361153,"updateBy":"","updateTime":"2023-12-19 17:17:51","usableColumn":true},{"capJavaField":"Status","columnComment":"状态（1-启用；2-未启用）","columnId":20784699404289,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","e', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:20:09', 653);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (40448410243074, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlanInfo","className":"PostPlanInfo","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":21778929807362,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 17:18:28","usableColumn":false},{"capJavaField":"PostPlanId","columnComment":"计划ID","columnId":21779256963073,"columnName":"post_plan_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 17:18:28","usableColumn":false},{"capJavaField":"CheckedDeptId","columnComment":"被检查部门ID","columnId":21779588313089,"columnName":"checked_dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedDeptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21778212581378,"updateBy":"","updateTime":"2023-12-19 17:18:28","usableColumn":false},{"capJavaField":"CheckTime","columnComment":"检查时间","columnId":21779915468801,"columnName":"check_time","columnType":"timestamp with time zone","createBy":"a', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:21:35', 682);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (168598758326274, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"$post_PostPlanJoinChecked"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:04:28', 522);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (917045712269313, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/916527342432258', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:52:04', 16);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (40541477654530, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"planInfoUser","className":"PostPlanInfoUser","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":21783438684162,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 17:18:36","usableColumn":false},{"capJavaField":"PostPlanInfoId","columnComment":"计划明细ID","columnId":21783828754433,"columnName":"post_plan_info_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postPlanInfoId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 17:18:36","usableColumn":false},{"capJavaField":"CheckedUserId","columnComment":"检查人员ID","columnId":21784155910145,"columnName":"checked_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:07:23","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkedUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":21782784372738,"updateBy":"","updateTime":"2023-12-19 17:18:36","usableColumn":false},{"capJavaField":"Remark","columnComment":"remark","columnId":21784491454465,"columnName":"remark","columnType":"varchar","createBy":"admin', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:21:57', 612);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (40574570713089, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.batchGenCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/batchGenCode', '127.0.0.1', '内网IP', '{"tables":"post_programme,post_programme_template,post_team,post_team_dept,post_team_user,post_plan,post_plan_info,post_plan_info_user"}', NULL, 0, NULL, '2023-12-19 17:22:05', 1392);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (41048149577729, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-19 17:12:54","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-19 17:12:54","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-19 17:12:54","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-19 17:23:58', 657);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (41252911304705, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.batchGenCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/batchGenCode', '127.0.0.1', '内网IP', '{"tables":"post_programme,post_programme_template,post_team,post_team_dept,post_team_user,post_plan,post_plan_info,post_plan_info_user"}', NULL, 0, NULL, '2023-12-19 17:24:47', 1451);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (297962943107073, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/568950155710471', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:24:52', 367);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (297996271046657, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/568950155710467', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:25:00', 1269);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (298021973741570, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/568950155710468', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:25:06', 959);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (298047588356098, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/568950155710469', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:25:12', 604);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (298071600746498, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/568950155710470', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:25:18', 1665);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (298093998329857, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/568950155710466', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:25:23', 794);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (302843804340225, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_list,post_list_info"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:44:15', 3895);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (303345719922689, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckList","className":"PostList","columns":[{"capJavaField":"Id","columnComment":"id","columnId":302828855840769,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302827794681858,"updateBy":"","usableColumn":false},{"capJavaField":"Status","columnComment":"status","columnId":302829187190785,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302827794681858,"updateBy":"","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"status_by_user_id","columnId":302829510152194,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302827794681858,"updateBy":"","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"status_by_user_name","columnId":302829833113602,"columnName":"status_by_user_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:46:15', 2983);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (303575748136961, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckListInfo","className":"PostListInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":302836854378497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302836200067074,"updateBy":"","usableColumn":false},{"capJavaField":"Status","columnComment":"status","columnId":302837189922817,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302836200067074,"updateBy":"","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"status_by_user_id","columnId":302837521272833,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302836200067074,"updateBy":"","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"status_by_user_name","columnId":302837856817154,"columnName":"status_by_user_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:47:10', 1844);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (303674582716418, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckListInfo","className":"PostListInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":302836854378497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:47:08","usableColumn":false},{"capJavaField":"Status","columnComment":"status","columnId":302837189922817,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:47:08","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"status_by_user_id","columnId":302837521272833,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:47:08","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"status_by_user_name","columnId":302837856817154,"columnName":"status_by_user_name","column', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:47:33', 3935);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (304030788177922, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckList","className":"PostList","columns":[{"capJavaField":"Id","columnComment":"id","columnId":302828855840769,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:46:12","usableColumn":false},{"capJavaField":"Status","columnComment":"status","columnId":302829187190785,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:46:12","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"status_by_user_id","columnId":302829510152194,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:46:12","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"status_by_user_name","columnId":302829833113602,"columnName":"status_by_user_name","columnType":"v', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:48:58', 1918);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (304082642358274, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckListInfo","className":"PostListInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":302836854378497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:47:30","usableColumn":false},{"capJavaField":"Status","columnComment":"status","columnId":302837189922817,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:47:30","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"status_by_user_id","columnId":302837521272833,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:47:30","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"status_by_user_name","columnId":302837856817154,"columnName":"status_by_user_name","column', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:49:11', 1669);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (305866932834306, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckList","className":"PostList","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":302828855840769,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:48:56","usableColumn":false},{"capJavaField":"Status","columnComment":"状态：1-待审核；2-审核中；3-通过；4-驳回；","columnId":302829187190785,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:48:56","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"审核人ID","columnId":302829510152194,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:48:56","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"审核人姓名","columnId":302829833113602,"columnName":"status_by_user_name","columnType":"varchar"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 10:56:16', 1887);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (306926917341186, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckListInfo","className":"PostListInfo","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":302836854378497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:49:09","usableColumn":false},{"capJavaField":"Status","columnComment":"分区域审核-状态：1-待审核；3-通过；4-驳回；","columnId":302837189922817,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:49:09","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"审核人ID","columnId":302837521272833,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 10:49:09","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"审核人姓名","columnId":302837856817154,"columnName":"status_by_user_name","columnType', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 11:00:29', 2001);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (307951967490050, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":307951506116609,"menuName":"岗位责任制管理","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"/xxx","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 11:04:33', 260);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (308107056074753, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckList","className":"PostList","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":302828855840769,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:56:14","usableColumn":false},{"capJavaField":"Status","columnComment":"状态：1-待审核；2-审核中；3-通过；4-驳回；","columnId":302829187190785,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:56:14","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"审核人ID","columnId":302829510152194,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 10:56:14","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"审核人姓名","columnId":302829833113602,"columnName":"status_by_user_name","columnType":"varchar"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 11:05:10', 1839);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (308405438861314, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckList","className":"PostList","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":302828855840769,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 11:05:08","usableColumn":false},{"capJavaField":"Status","columnComment":"状态：1-待审核；2-审核中；3-通过；4-驳回；","columnId":302829187190785,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 11:05:08","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"审核人ID","columnId":302829510152194,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 11:05:08","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"审核人姓名","columnId":302829833113602,"columnName":"status_by_user_name","columnType":"varchar"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 11:06:21', 1725);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (309208593551362, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.batchGenCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/batchGenCode', '127.0.0.1', '内网IP', '{"tables":"post_list"}', NULL, 0, NULL, '2023-12-20 11:09:33', 448);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (312857780527106, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckListInfo","className":"PostListInfo","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":302836854378497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 11:00:27","usableColumn":false},{"capJavaField":"Status","columnComment":"分区域审核-状态：1-待审核；3-通过；4-驳回；","columnId":302837189922817,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 11:00:27","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"审核人ID","columnId":302837521272833,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302836200067074,"updateBy":"","updateTime":"2023-12-20 11:00:27","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"审核人姓名","columnId":302837856817154,"columnName":"status_by_user_name","columnType', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 11:24:03', 3208);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (312947907731458, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckList","className":"PostList","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":302828855840769,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 11:06:20","usableColumn":false},{"capJavaField":"Status","columnComment":"状态：1-待审核；2-审核中；3-通过；4-驳回；","columnId":302829187190785,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"status","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 11:06:20","usableColumn":false},{"capJavaField":"StatusByUserId","columnComment":"审核人ID","columnId":302829510152194,"columnName":"status_by_user_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-20 10:44:12","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"statusByUserId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":302827794681858,"updateBy":"","updateTime":"2023-12-20 11:06:20","usableColumn":false},{"capJavaField":"StatusByUserName","columnComment":"审核人姓名","columnId":302829833113602,"columnName":"status_by_user_name","columnType":"varchar"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 11:24:24', 3727);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (424352464072706, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_plan', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 18:47:06', 2800);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (435041471655937, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-20 18:47:03","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-20 18:47:03","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-20 18:47:03","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictT', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 19:29:34', 3523);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (436535059116034, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programme","className":"PostProgramme","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11897749360641,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-20 19:33:02","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":11898265260034,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-20 19:33:02","usableColumn":false},{"capJavaField":"SubmitDate","columnComment":"submit_date","columnId":11898596610049,"columnName":"submit_date","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"submitDate","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-20 19:33:02","usableColumn":false},{"capJavaField":"StatusHr","columnComment":"status_hr","columnId":11898923765761,"columnName":"status_hr","columnType":"integer","createBy":"admin","createTime":"2023-12-19 15:28', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 19:35:30', 2237);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (436563530051586, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"programme","className":"PostProgramme","columns":[{"capJavaField":"Id","columnComment":"id","columnId":11897749360641,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-20 19:33:02","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":11898265260034,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-20 19:33:02","usableColumn":false},{"capJavaField":"SubmitDate","columnComment":"submit_date","columnId":11898596610049,"columnName":"submit_date","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-19 15:28:07","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"submitDate","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":11896495263745,"updateBy":"","updateTime":"2023-12-20 19:33:02","usableColumn":false},{"capJavaField":"StatusHr","columnComment":"status_hr","columnId":11898923765761,"columnName":"status_hr","columnType":"integer","createBy":"admin","createTime":"2023-12-19 15:28', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-20 19:35:37', 21301);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (641875568029697, '用户管理', 4, 'com.ruoyi.web.controller.system.SysUserController.insertAuthRole()', 'PUT', 1, 'admin', '研发部门', '/system/user/authRole', '125.36.249.104', 'XX XX', '{"roleIds":"2","userId":"2"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 09:11:22', 69);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (659994160197633, '参数管理', 9, 'com.ruoyi.web.controller.system.SysConfigController.refreshCache()', 'DELETE', 1, 'admin', '研发部门', '/system/config/refreshCache', '125.36.249.104', 'XX XX', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 10:23:21', 48);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (660015618256897, '参数管理', 5, 'com.ruoyi.web.controller.system.SysConfigController.export()', 'POST', 1, 'admin', '研发部门', '/system/config/export', '125.36.249.104', 'XX XX', '{"pageSize":"10","pageNum":"1"}', NULL, 0, NULL, '2023-12-21 10:23:27', 1248);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (689680792150017, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":689680272056322,"menuName":"考核评比","menuType":"M","orderNum":4,"params":{},"parentId":0,"path":"/xxx","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:21:25', 211);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (689812883365889, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"system","isCache":"0","isFrame":"1","menuId":1,"menuName":"系统管理","menuType":"M","orderNum":100,"params":{},"parentId":0,"path":"system","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:21:56', 119);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (689909931171841, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":300,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"1","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:22:19', 106);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (689938691514370, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"tool","isCache":"0","isFrame":"1","menuId":3,"menuName":"系统工具","menuType":"M","orderNum":200,"params":{},"parentId":0,"path":"tool","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:22:26', 120);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690038184599553, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"monitor","isCache":"0","isFrame":"1","menuId":2,"menuName":"系统监控","menuType":"M","orderNum":300,"params":{},"parentId":0,"path":"monitor","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:22:50', 106);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690067494395906, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":400,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"1","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:22:57', 105);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690157592240130, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-15 22:21:24","icon":"star","isCache":"0","isFrame":"1","menuId":17355455216040,"menuName":"岗检策划","menuType":"M","orderNum":20,"params":{},"parentId":0,"path":"postPlan","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:23:18', 111);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690184398036993, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-20 11:04:33","icon":"star","isCache":"0","isFrame":"1","menuId":307951506116609,"menuName":"岗位责任制管理","menuType":"M","orderNum":10,"params":{},"parentId":0,"path":"/xxx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:23:25', 132);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690226529820674, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:21:25","icon":"star","isCache":"0","isFrame":"1","menuId":689680272056322,"menuName":"考核评比","menuType":"M","orderNum":40,"params":{},"parentId":0,"path":"/xxx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:23:35', 107);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690381488381953, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":690381161226242,"menuName":"岗检实施","menuType":"M","orderNum":30,"params":{},"parentId":0,"path":"/xx","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:24:12', 122);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690736792068098, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":690736334888962,"menuName":"统计分析","menuType":"M","orderNum":50,"params":{},"parentId":0,"path":"/xxxxx","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:25:36', 164);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (690873593487362, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":690873270525953,"menuName":"岗检历史","menuType":"M","orderNum":60,"params":{},"parentId":0,"path":"/xxxxxx","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:26:09', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691355972001794, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postCheckList/index","createTime":"2023-12-20 11:14:22","icon":"#","isCache":"0","isFrame":"1","menuId":309207674998785,"menuName":"岗检责任制编制","menuType":"C","orderNum":1,"params":{},"parentId":307951506116609,"path":"postCheckList","perms":"postCheck:postCheckList:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:28:04', 124);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691518228652034, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/programme/index","createTime":"2023-12-19 16:35:35","icon":"#","isCache":"0","isFrame":"1","menuId":28684398350338,"menuName":"岗检方案","menuType":"C","orderNum":10,"params":{},"parentId":17355455216040,"path":"programme","perms":"postCheck:programme:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:28:43', 101);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691550596096002, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlan/index","createTime":"2023-12-20 10:26:18","icon":"#","isCache":"0","isFrame":"1","menuId":298192019214337,"menuName":"岗检计划","menuType":"C","orderNum":30,"params":{},"parentId":17355455216040,"path":"postPlan","perms":"postCheck:postPlan:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:28:51', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691578156867586, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/team/index","createTime":"2023-12-19 17:09:41","icon":"#","isCache":"0","isFrame":"1","menuId":37253508222977,"menuName":"岗检小组","menuType":"C","orderNum":20,"params":{},"parentId":17355455216040,"path":"team","perms":"postCheck:team:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:28:57', 108);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691728916930562, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-20 11:04:33","icon":"star","isCache":"0","isFrame":"1","menuId":307951506116609,"menuName":"岗位责任制管理","menuType":"M","orderNum":100,"params":{},"parentId":0,"path":"/xxx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:29:33', 103);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691822051450882, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postCheckList/index","createTime":"2023-12-20 11:14:22","icon":"#","isCache":"0","isFrame":"1","menuId":309207674998785,"menuName":"岗检责任制编制","menuType":"C","orderNum":110,"params":{},"parentId":307951506116609,"path":"postCheckList","perms":"postCheck:postCheckList:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:29:55', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691884559163393, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:26:09","icon":"star","isCache":"0","isFrame":"1","menuId":690873270525953,"menuName":"岗检历史","menuType":"M","orderNum":600,"params":{},"parentId":0,"path":"/xxxxxx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:30:10', 113);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691907816579073, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:25:36","icon":"star","isCache":"0","isFrame":"1","menuId":690736334888962,"menuName":"统计分析","menuType":"M","orderNum":500,"params":{},"parentId":0,"path":"/xxxxx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:30:16', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691932449726465, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:21:25","icon":"star","isCache":"0","isFrame":"1","menuId":689680272056322,"menuName":"考核评比","menuType":"M","orderNum":400,"params":{},"parentId":0,"path":"/xxx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:30:22', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (691968092921858, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:24:12","icon":"star","isCache":"0","isFrame":"1","menuId":690381161226242,"menuName":"岗检实施","menuType":"M","orderNum":300,"params":{},"parentId":0,"path":"/xx","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:30:30', 98);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692006089121793, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-15 22:21:24","icon":"star","isCache":"0","isFrame":"1","menuId":17355455216040,"menuName":"岗检策划","menuType":"M","orderNum":200,"params":{},"parentId":0,"path":"postPlan","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:30:39', 111);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692073567084546, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"system","isCache":"0","isFrame":"1","menuId":1,"menuName":"系统管理","menuType":"M","orderNum":700,"params":{},"parentId":0,"path":"system","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:30:55', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692181884985346, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"tool","isCache":"0","isFrame":"1","menuId":3,"menuName":"系统工具","menuType":"M","orderNum":800,"params":{},"parentId":0,"path":"tool","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:31:21', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692293692547074, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"monitor","isCache":"0","isFrame":"1","menuId":2,"menuName":"系统监控","menuType":"M","orderNum":900,"params":{},"parentId":0,"path":"monitor","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:31:48', 99);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692334620565505, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":1000,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"1","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:31:57', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692499385409538, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/programme/index","createTime":"2023-12-19 16:35:35","icon":"#","isCache":"0","isFrame":"1","menuId":28684398350338,"menuName":"岗检方案","menuType":"C","orderNum":210,"params":{},"parentId":17355455216040,"path":"programme","perms":"postCheck:programme:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:32:37', 98);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692539789139970, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/team/index","createTime":"2023-12-19 17:09:41","icon":"#","isCache":"0","isFrame":"1","menuId":37253508222977,"menuName":"岗检小组","menuType":"C","orderNum":220,"params":{},"parentId":17355455216040,"path":"team","perms":"postCheck:team:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:32:46', 97);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (692564288069634, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlan/index","createTime":"2023-12-20 10:26:18","icon":"#","isCache":"0","isFrame":"1","menuId":298192019214337,"menuName":"岗检计划","menuType":"C","orderNum":230,"params":{},"parentId":17355455216040,"path":"postPlan","perms":"postCheck:postPlan:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 12:32:52', 101);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (729729608966146, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_assessment_rating"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:00:32', 1444);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (730283240316929, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"assessmentRating","className":"PostAssessmentRating","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":729724588384258,"columnName":"id","columnType":"tinyint","createBy":"admin","createTime":"2023-12-21 15:00:31","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":729723724357633,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"类型：1-职能；2-生产；","columnId":729724923928577,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-21 15:00:31","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"type","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":729723724357633,"updateBy":"","usableColumn":false},{"capJavaField":"DepartmentId","columnComment":"department_id","columnId":729725121060866,"columnName":"department_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-21 15:00:31","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"departmentId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":729723724357633,"updateBy":"","usableColumn":false},{"capJavaField":"PositionName","columnComment":"position_name","columnId":729725318193153,"columnName":"position_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-21 15:00:31","dictType":"","edit":true,"htmlType":"input","increm', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:02:44', 1208);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (732664678047746, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_assessment_rating', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:12:12', 1325);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (733502318305281, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"assessmentRating","className":"PostAssessmentRating","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":729724588384258,"columnName":"id","columnType":"tinyint","createBy":"admin","createTime":"2023-12-21 15:00:31","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":729723724357633,"updateBy":"","updateTime":"2023-12-21 15:12:11","usableColumn":false},{"capJavaField":"Type","columnComment":"类型：1-职能；2-生产；","columnId":729724923928577,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-21 15:00:31","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"type","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":729723724357633,"updateBy":"","updateTime":"2023-12-21 15:12:11","usableColumn":false},{"capJavaField":"DeptId","columnComment":"部门ID","columnId":732659993010178,"columnName":"dept_id","columnType":"bigint","createBy":"","createTime":"2023-12-21 15:12:11","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"deptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":729723724357633,"updateBy":"","usableColumn":false},{"capJavaField":"PostId","columnComment":"岗位名称","columnId":732660261445634,"columnName":"post_id","columnType":"bigint","createBy":"","createTime":"2023-12-21 15:12:11","dictType":"","edit":true,"htmlType":"inp', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:15:32', 1213);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (733884582977537, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.batchGenCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/batchGenCode', '127.0.0.1', '内网IP', '{"tables":"post_assessment_rating"}', NULL, 0, NULL, '2023-12-21 15:17:03', 260);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (743206222278657, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:21:25","icon":"star","isCache":"0","isFrame":"1","menuId":689680272056322,"menuName":"考核评比","menuType":"M","orderNum":400,"params":{},"parentId":0,"path":"/postCheck/assessmentRating","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:54:05', 124);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (743285402349569, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-20 11:04:33","icon":"star","isCache":"0","isFrame":"1","menuId":307951506116609,"menuName":"岗位责任制管理","menuType":"M","orderNum":100,"params":{},"parentId":0,"path":"/postCheck/postCheckList","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:54:24', 119);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (743385465860098, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-15 22:21:24","icon":"star","isCache":"0","isFrame":"1","menuId":17355455216040,"menuName":"岗检策划","menuType":"M","orderNum":200,"params":{},"parentId":0,"path":"/postCheck/programme","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:54:48', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (744266752045058, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"teamDept","className":"PostTeamDept","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":20788428140545,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:18:01","usableColumn":false},{"capJavaField":"PostTeamId","columnComment":"岗检工作组ID","columnId":20788755296258,"columnName":"post_team_id","columnType":"varchar","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"postTeamId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:18:01","usableColumn":false},{"capJavaField":"DeptId","columnComment":"部门ID","columnId":20789086646273,"columnName":"dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-19 16:03:26","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"deptId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":20787706720257,"updateBy":"","updateTime":"2023-12-19 17:18:01","usableColumn":false},{"capJavaField":"Type","columnComment":"类型（1-牵头部门；2-成员部门）","columnId":20789413801986,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-19 16:03:26', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-21 15:58:18', 655);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (125776640008194, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/programme/index","createTime":"2023-12-19 16:35:35","icon":"#","isCache":"0","isFrame":"1","menuId":28684398350338,"menuName":"岗检方案管理","menuType":"C","orderNum":210,"params":{},"parentId":17355455216040,"path":"programme","perms":"postCheck:programme:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 17:14:13', 203);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (126872255127554, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postInspectionPlanning/projectManagement/index","createBy":"admin","isCache":"1","isFrame":"1","menuId":126872108326913,"menuName":"(岗位)岗检方案","menuType":"C","orderNum":211,"params":{},"parentId":28684398350338,"path":"postInspectionPlanning/projectManagement/index","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 17:18:34', 37);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (126947207340034, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postInspectionPlanning/projectManagement/index","createTime":"2023-12-22 17:18:34","icon":"#","isCache":"1","isFrame":"1","menuId":126872108326913,"menuName":"(岗位)岗检方案","menuType":"C","orderNum":6,"params":{},"parentId":28684398350338,"path":"postInspectionPlanning/projectManagement/index","perms":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 17:18:52', 24);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (166470270681090, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"$post_PostPlanJoinProblem"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 19:56:00', 784);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (167017073704962, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"planJoinProblem","className":"PostPlanJoinProblem","columns":[{"capJavaField":"Id","columnComment":"id","columnId":166468689428481,"columnName":"id","columnType":"integer","createBy":"admin","createTime":"2023-12-22 19:56:00","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"0","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":false,"sort":1,"superColumn":false,"tableId":166467322085378,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":166469352128514,"columnName":"name","columnType":"integer","createBy":"admin","createTime":"2023-12-22 19:56:00","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":166467322085378,"updateBy":"","usableColumn":false}],"crud":true,"functionAuthor":"csg","functionName":"岗检问题录入列表","genPath":"/","genType":"0","moduleName":"postCheck","options":"{\"parentMenuId\":690381161226242}","packageName":"com.ruoyi.postCheck","params":{"parentMenuId":690381161226242},"parentMenuId":"690381161226242","sub":false,"tableComment":"3.2.1-岗检问题录入列表-辅助表","tableId":166467322085378,"tableName":"$post_PostPlanJoinProblem","tplCategory":"crud","tplWebType":"element-ui","tree":false}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 19:58:11', 445);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (168943345565697, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postplanjoinchecked","className":"Postplanjoinchecked","columns":[{"capJavaField":"Id","columnComment":"id","columnId":168597722333186,"columnName":"id","columnType":"integer","createBy":"admin","createTime":"2023-12-22 20:04:27","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"0","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":false,"sort":1,"superColumn":false,"tableId":168596933804034,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":168598104014849,"columnName":"name","columnType":"integer","createBy":"admin","createTime":"2023-12-22 20:04:27","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":168596933804034,"updateBy":"","usableColumn":false}],"crud":true,"functionAuthor":"csg","functionName":"岗检记录上传列表","genPath":"/","genType":"0","moduleName":"postCheck","options":"{\"parentMenuId\":690381161226242}","packageName":"com.ruoyi.postCheck","params":{"parentMenuId":690381161226242},"parentMenuId":"690381161226242","sub":false,"tableComment":"3.1.1-岗检记录上传列表-辅助表","tableId":168596933804034,"tableName":"$post_PostPlanJoinChecked","tplCategory":"crud","tplWebType":"element-ui","tree":false}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:05:50', 389);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (169484469501954, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postplanjoinchecked/index","createTime":"2023-12-22 20:06:58","icon":"#","isCache":"0","isFrame":"1","menuId":168990275633153,"menuName":"岗检记录上传","menuType":"C","orderNum":10,"params":{},"parentId":690381161226242,"path":"postplanjoinchecked","perms":"postCheck:postplanjoinchecked:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:07:59', 188);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (169513401810945, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/planJoinProblem/index","createTime":"2023-12-22 20:00:31","icon":"#","isCache":"0","isFrame":"1","menuId":167236809097217,"menuName":"岗检问题录入","menuType":"C","orderNum":20,"params":{},"parentId":690381161226242,"path":"planJoinProblem","perms":"postCheck:planJoinProblem:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:08:06', 191);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172417416265729, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlanJoinChecked","className":"PostPlanJoinChecked","columns":[{"capJavaField":"Id","columnComment":"id","columnId":168597722333186,"columnName":"id","columnType":"integer","createBy":"admin","createTime":"2023-12-22 20:04:27","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"0","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":false,"sort":1,"superColumn":false,"tableId":168596933804034,"updateBy":"","updateTime":"2023-12-22 20:05:50","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":168598104014849,"columnName":"name","columnType":"integer","createBy":"admin","createTime":"2023-12-22 20:04:27","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":168596933804034,"updateBy":"","updateTime":"2023-12-22 20:05:50","usableColumn":false}],"crud":true,"functionAuthor":"csg","functionName":"岗检记录上传列表","genPath":"/","genType":"0","moduleName":"postCheck","options":"{\"parentMenuId\":\"690381161226242\"}","packageName":"com.ruoyi.postCheck","params":{"parentMenuId":"690381161226242"},"parentMenuId":"690381161226242","sub":false,"tableComment":"3.1.1-岗检记录上传列表-辅助表","tableId":168596933804034,"tableName":"$post_PostPlanJoinChecked","tplCategory":"crud","tplWebType":"element-ui","tree":false}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:19:38', 315);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172575948374017, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlanJoinProblem","className":"PostPlanJoinProblem","columns":[{"capJavaField":"Id","columnComment":"id","columnId":166468689428481,"columnName":"id","columnType":"integer","createBy":"admin","createTime":"2023-12-22 19:56:00","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"0","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":false,"sort":1,"superColumn":false,"tableId":166467322085378,"updateBy":"","updateTime":"2023-12-22 19:58:10","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":166469352128514,"columnName":"name","columnType":"integer","createBy":"admin","createTime":"2023-12-22 19:56:00","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":166467322085378,"updateBy":"","updateTime":"2023-12-22 19:58:10","usableColumn":false}],"crud":true,"functionAuthor":"csg","functionName":"岗检问题录入列表","genPath":"/","genType":"0","moduleName":"postCheck","options":"{\"parentMenuId\":\"690381161226242\"}","packageName":"com.ruoyi.postCheck","params":{"parentMenuId":"690381161226242"},"parentMenuId":"690381161226242","sub":false,"tableComment":"3.2.1-岗检问题录入列表-辅助表","tableId":166467322085378,"tableName":"$post_PostPlanJoinProblem","tplCategory":"crud","tplWebType":"element-ui","tree":false}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:20:16', 330);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172744571977729, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/168990275633154', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:20:56', 308);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172769263845377, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/168990275633155', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:02', 239);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172786699567105, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/168990275633156', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:06', 232);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172804646993922, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/168990275633157', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:10', 252);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172821759754242, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/168990275633158', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:15', 301);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172856878661633, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/167236809097218', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:23', 258);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172875035803649, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/167236809097221', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:27', 226);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172901455724546, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/167236809097222', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:34', 225);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172919747084290, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/167236809097219', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:38', 265);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172941167394818, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/167236809097220', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:43', 277);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172972180078593, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/168990275633153', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:50', 251);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172995701735426, '菜单管理', 3, 'com.ruoyi.web.controller.system.SysMenuController.remove()', 'DELETE', 1, 'admin', '研发部门', '/system/menu/167236809097217', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 20:21:56', 259);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (185322803146753, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_checked"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 21:10:55', 2801);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (185834181079041, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"checked","className":"PostChecked","columns":[{"capJavaField":"Id","columnComment":"id","columnId":185313651175425,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":185312766177282,"updateBy":"","usableColumn":false},{"capJavaField":"CheckWorkgroupId","columnComment":"check_workgroup_id","columnId":185314104160258,"columnName":"check_workgroup_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkWorkgroupId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":185312766177282,"updateBy":"","usableColumn":false},{"capJavaField":"CheckGroupId","columnComment":"check_group_id","columnId":185314561339394,"columnName":"check_group_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkGroupId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":185312766177282,"updateBy":"","usableColumn":false},{"capJavaField":"CheckedDeptId","columnComment":"checked_dept_id","columnId":185314947215362,"columnName":"checked_dept_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":true', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 21:12:57', 2234);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (186041757184001, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"checked","className":"PostChecked","columns":[{"capJavaField":"Id","columnComment":"id","columnId":185313651175425,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":185312766177282,"updateBy":"","updateTime":"2023-12-22 21:12:55","usableColumn":false},{"capJavaField":"CheckWorkgroupId","columnComment":"check_workgroup_id","columnId":185314104160258,"columnName":"check_workgroup_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkWorkgroupId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":185312766177282,"updateBy":"","updateTime":"2023-12-22 21:12:55","usableColumn":false},{"capJavaField":"CheckGroupId","columnComment":"check_group_id","columnId":185314561339394,"columnName":"check_group_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-22 21:10:53","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"checkGroupId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":185312766177282,"updateBy":"","updateTime":"2023-12-22 21:12:55","usableColumn":false},{"capJavaField":"CheckedDeptId","columnComment":"checked_dept_id","columnId":185314947215362,"columnName":"checked_dept_', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-22 21:13:46', 2359);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (558719777210370, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_checked_problem,post_checked_problem_record"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 21:54:40', 22871);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (558767772631042, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_checked_problem,post_checked_problem_record"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 21:54:51', 21728);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (558913986068482, '代码生成', 3, 'com.ruoyi.generator.controller.GenController.remove()', 'DELETE', 1, 'admin', '研发部门', '/tool/gen/558708649721858,558717038329857', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 21:55:26', 153);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (562493472210946, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckedProblem","className":"PostCheckedProblem","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":558757987319810,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":558757534334978,"updateBy":"","usableColumn":false},{"capJavaField":"Status","columnComment":"状态：1-待指定整改人（问题录入完成时）；2-待填写方案（部门管理员指定整改人后）；10-部门审核通过；11-部门审核驳回；20-专业部门人审核（非必填）通过；21-专业部门人审核驳回（非必填）；22-整改人待上传实施（整改人上传实施图片）30-复查部门人审核通过；31-复查部门人审核驳回","columnId":558758184452097,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"status","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":558757534334978,"updateBy":"","usableColumn":false},{"capJavaField":"ProblemNo","columnComment":"问题编号（需要甲方提供规则规则）","columnId":558758381584385,"columnName":"problem_no","columnType":"varchar","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"problemNo","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":558757534334978,"updateBy":"","usableColumn":false},{"capJavaField":"CheckWorkgroupId","columnComment":"检查工作组ID","columnId":558758578716673,"columnName":"check_workgro', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:09:39', 22030);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (562523893497858, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckedProblem","className":"PostCheckedProblem","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":558757987319810,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":558757534334978,"updateBy":"","usableColumn":false},{"capJavaField":"Status","columnComment":"状态：1-待指定整改人（问题录入完成时）；2-待填写方案（部门管理员指定整改人后）；10-部门审核通过；11-部门审核驳回；20-专业部门人审核（非必填）通过；21-专业部门人审核驳回（非必填）；22-整改人待上传实施（整改人上传实施图片）30-复查部门人审核通过；31-复查部门人审核驳回","columnId":558758184452097,"columnName":"status","columnType":"integer","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"radio","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"status","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":558757534334978,"updateBy":"","usableColumn":false},{"capJavaField":"ProblemNo","columnComment":"问题编号（需要甲方提供规则规则）","columnId":558758381584385,"columnName":"problem_no","columnType":"varchar","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"problemNo","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":558757534334978,"updateBy":"","usableColumn":false},{"capJavaField":"CheckWorkgroupId","columnComment":"检查工作组ID","columnId":558758578716673,"columnName":"check_workgro', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:09:47', 1817);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (563281338662913, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckedProblemRecord","className":"PostCheckedProblemRecord","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":558765528678402,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":558765130219522,"updateBy":"","usableColumn":false},{"capJavaField":"ProblemId","columnComment":"问题ID（多）","columnId":558765730004994,"columnName":"problem_id","columnType":"bigint","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"problemId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":558765130219522,"updateBy":"","usableColumn":false},{"capJavaField":"UserBy","columnComment":"操作者姓名","columnId":558765931331586,"columnName":"user_by","columnType":"varchar","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"userBy","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":558765130219522,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"操作内容","columnId":558766182989825,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-23 21:54:49","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:12:47', 631);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (564830748114946, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlanJoinProblem/index","createTime":"2023-12-22 20:33:07","icon":"#","isCache":"0","isFrame":"1","menuId":175400996667394,"menuName":"岗检问题录入","menuType":"C","orderNum":110,"params":{},"parentId":690381161226242,"path":"postPlanJoinProblem","perms":"postCheck:postPlanJoinProblem:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:18:57', 119);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (564861068738562, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlanJoinChecked/index","createTime":"2023-12-22 20:33:07","icon":"#","isCache":"0","isFrame":"1","menuId":173097644294145,"menuName":"岗检记录上传","menuType":"C","orderNum":100,"params":{},"parentId":690381161226242,"path":"postPlanJoinChecked","perms":"postCheck:postPlanJoinChecked:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:19:04', 95);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (565486468825089, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlanJoinProblem/index","createTime":"2023-12-22 20:33:07","icon":"#","isCache":"0","isFrame":"1","menuId":175400996667394,"menuName":"岗检问题录入","menuType":"C","orderNum":200,"params":{},"parentId":690381161226242,"path":"postPlanJoinProblem","perms":"postCheck:postPlanJoinProblem:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:21:33', 109);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (565558183034882, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlanJoinChecked/index","createTime":"2023-12-22 20:33:07","icon":"#","isCache":"0","isFrame":"1","menuId":173097644294145,"menuName":"岗检记录上传","menuType":"C","orderNum":310,"params":{},"parentId":690381161226242,"path":"postPlanJoinChecked","perms":"postCheck:postPlanJoinChecked:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:21:50', 118);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (565598184112130, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postPlanJoinProblem/index","createTime":"2023-12-22 20:33:07","icon":"#","isCache":"0","isFrame":"1","menuId":175400996667394,"menuName":"岗检问题录入","menuType":"C","orderNum":320,"params":{},"parentId":690381161226242,"path":"postPlanJoinProblem","perms":"postCheck:postPlanJoinProblem:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:22:00', 103);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (567625681305602, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"postCheck/postCheckedProblem/index","createTime":"2023-12-23 22:27:34","icon":"#","isCache":"0","isFrame":"1","menuId":564205528383489,"menuName":"岗检问题录入","menuType":"C","orderNum":321,"params":{},"parentId":690381161226242,"path":"postCheckedProblem","perms":"postCheck:postCheckedProblem:list","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-23 22:30:03', 92);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (457825464356865, '用户管理', 2, 'com.ruoyi.web.controller.system.SysUserController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/user', '125.36.249.104', 'XX XX', '{"admin":true,"avatar":"","createBy":"admin","createTime":"2023-12-11 13:16:57","delFlag":0,"dept":{"ancestors":"0,100,101","children":[],"deptId":103,"deptName":"研发部门","leader":"若依","orderNum":1,"params":{},"parentId":101,"status":"0"},"deptId":103,"email":"ry@163.com","loginDate":"2023-12-26 09:15:08","loginIp":"127.0.0.1","nickName":"管理员","params":{},"phonenumber":"15888888888","postIds":[1],"remark":"管理员","roleIds":[1],"roles":[{"admin":true,"dataScope":"1","deptCheckStrictly":false,"flag":false,"menuCheckStrictly":false,"params":{},"roleId":1,"roleKey":"admin","roleName":"超级管理员","roleSort":1,"status":"0"}],"sex":"1","status":"0","userId":1,"userName":"admin"}', NULL, 1, '不允许操作超级管理员用户', '2023-12-26 09:27:18', 79);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (457845110476801, '用户管理', 2, 'com.ruoyi.web.controller.system.SysUserController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/user', '125.36.249.104', 'XX XX', '{"admin":true,"avatar":"","createBy":"admin","createTime":"2023-12-11 13:16:57","delFlag":0,"dept":{"ancestors":"0,100,101","children":[],"deptId":103,"deptName":"研发部门","leader":"若依","orderNum":1,"params":{},"parentId":101,"status":"0"},"deptId":103,"email":"ry@163.com","loginDate":"2023-12-26 09:15:08","loginIp":"127.0.0.1","nickName":"管理员","params":{},"phonenumber":"15888888888","postIds":[1],"remark":"管理员","roleIds":[1],"roles":[{"admin":true,"dataScope":"1","deptCheckStrictly":false,"flag":false,"menuCheckStrictly":false,"params":{},"roleId":1,"roleKey":"admin","roleName":"超级管理员","roleSort":1,"status":"0"}],"sex":"1","status":"0","userId":1,"userName":"admin"}', NULL, 1, '不允许操作超级管理员用户', '2023-12-26 09:27:23', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (457930091270146, '用户管理', 2, 'com.ruoyi.web.controller.system.SysUserController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/user', '125.36.249.104', 'XX XX', '{"admin":false,"avatar":"","createBy":"admin","createTime":"2023-12-11 13:16:57","delFlag":0,"dept":{"ancestors":"0,100,101","children":[],"deptId":105,"deptName":"测试部门","leader":"若依","orderNum":3,"params":{},"parentId":101,"status":"0"},"deptId":105,"email":"ry@qq.com","loginDate":"2023-12-11 13:16:57","loginIp":"127.0.0.1","nickName":"测试人员","params":{},"phonenumber":"15666666666","postIds":[2],"remark":"测试员","roleIds":[2],"roles":[{"admin":false,"dataScope":"2","deptCheckStrictly":false,"flag":false,"menuCheckStrictly":false,"params":{},"roleId":2,"roleKey":"common","roleName":"普通角色","roleSort":2,"status":"0"}],"sex":"1","status":"0","updateBy":"admin","userId":2,"userName":"ry"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 09:27:43', 177);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (478275087110145, '用户管理', 6, 'com.ruoyi.web.controller.system.SysUserController.importData()', 'POST', 1, 'admin', '研发部门', '/system/user/importData', '127.0.0.1', '内网IP', '{"updateSupport":"0"}', NULL, 1, '', '2023-12-26 10:48:33', 1297);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (480025164648450, '用户管理', 6, 'com.ruoyi.web.controller.system.SysUserController.importData()', 'POST', 1, 'admin', '研发部门', '/system/user/importData', '127.0.0.1', '内网IP', 'false', NULL, 1, '', '2023-12-26 10:55:31', 110);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (917300746924033, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:53:05","createUserId":1,"delFlag":0,"id":917300608512001,"name":"工作组3(综合)","params":{},"parentId":1,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-27 15:53:05"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:53:05', 21);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (487210774958082, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 11:24:03","delFlag":0,"diskPath":"2024岗检.xlsx","name":"2042方案","params":{},"updateBy":"admin","updateTime":"2023-12-26 11:24:03"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.insertPostProgramme
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-26 11:24:04', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (487589493817345, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 11:25:33","delFlag":0,"diskPath":"2024岗检.xlsx","id":1739487588671733761,"name":"2024年","params":{},"updateBy":"admin","updateTime":"2023-12-26 11:25:33"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 2024年, null, null, null, null, null, null, null, null, 0, 2023-12-26 11:25:34, admin, 2023-12-26 11:25:34, admin, null, 2024岗检.xlsx, null, null, null, null, null, null, null).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-postcheck\target\classes\mapper\postCheck\PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.insertPostProgramme-Inline
### The error occurred while setting parameters
### SQL: insert into post_programme          ( name,                                                                                                                                  create_time,             create_by,             update_time,             update_by,                          disk_path )           values ( ?,                                                                                                                                  ?,             ?,             ?,             ?,                          ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 2024年, null, null, null, null, null, null, null, null, 0, 2023-12-26 11:25:34, admin, 2023-12-26 11:25:34, admin, null, 2024岗检.xlsx, null, null, null, null, null, null, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 2024年, null, null, null, null, null, null, null, null, 0, 2023-12-26 11:25:34, admin, 2023-12-26 11:25:34, admin, null, 2024岗检.xlsx, null, null, null, null, null, null, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 2024年, null, null, null, null, null, null, null, null, 0, 2023-12-26 11:25:34, admin, 2023-12-26 11:25:34, admin, null, 2024岗检.xlsx, null, null, null, null, null, null, null).', '2023-12-26 11:25:35', 200);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (489353221246977, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-20 11:04:33","icon":"star","isCache":"0","isFrame":"1","menuId":307951506116609,"menuName":"岗位责任制管理","menuType":"M","orderNum":100,"params":{},"parentId":0,"path":"/postCheck/postCheckList","perms":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:32:35', 161);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (489806256410625, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-15 22:21:24","icon":"star","isCache":"0","isFrame":"1","menuId":17355455216040,"menuName":"岗检策划","menuType":"M","orderNum":200,"params":{},"parentId":0,"path":"/postCheck/programme","perms":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:34:23', 38);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (489838124732417, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:24:12","icon":"star","isCache":"0","isFrame":"1","menuId":690381161226242,"menuName":"岗检实施","menuType":"M","orderNum":300,"params":{},"parentId":0,"path":"/xx","perms":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:34:30', 37);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (489865664532482, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:21:25","icon":"star","isCache":"0","isFrame":"1","menuId":689680272056322,"menuName":"考核评比","menuType":"M","orderNum":400,"params":{},"parentId":0,"path":"/postCheck/assessmentRating","perms":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:34:37', 36);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (489896492666882, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:25:36","icon":"star","isCache":"0","isFrame":"1","menuId":690736334888962,"menuName":"统计分析","menuType":"M","orderNum":500,"params":{},"parentId":0,"path":"/xxxxx","perms":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:34:44', 60);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (489919968186369, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-21 12:26:09","icon":"star","isCache":"0","isFrame":"1","menuId":690873270525953,"menuName":"岗检历史","menuType":"M","orderNum":600,"params":{},"parentId":0,"path":"/xxxxxx","perms":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:34:50', 37);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (490044811644929, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"monitor","isCache":"0","isFrame":"1","menuId":2,"menuName":"系统监控","menuType":"M","orderNum":900,"params":{},"parentId":0,"path":"monitor","perms":"","query":"","status":"1","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:35:20', 46);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (490072376610818, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"tool","isCache":"0","isFrame":"1","menuId":3,"menuName":"系统工具","menuType":"M","orderNum":800,"params":{},"parentId":0,"path":"tool","perms":"","query":"","status":"1","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:35:26', 99);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (490222942179329, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 11:36:01","delFlag":0,"diskPath":"2024岗检.xlsx","id":490222019432449,"name":"page2024年方案","params":{},"updateBy":"admin","updateTime":"2023-12-26 11:36:01"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:36:03', 213);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (493657137541121, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 11:49:40","delFlag":0,"diskPath":"2024岗检.xlsx","id":493656286097409,"name":"page2024年方案V2","params":{},"status":1,"statusHr":1,"submitDate":"2023-12-26 11:49:40","updateBy":"admin","updateTime":"2023-12-26 11:49:40"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 11:49:42', 191);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (538180254982146, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 14:46:35","delFlag":0,"diskPath":"2024岗检.xlsx","id":538179625836546,"name":"2024岗检方案","params":{},"status":1,"statusHr":1,"submitDate":"2023-12-26 14:46:35","updateBy":"admin","updateTime":"2023-12-26 14:46:35"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 14:46:36', 151);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (542813249626113, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"创建者姓名","createTime":"2023-12-19 19:19:19","createUserId":1,"dateHr":"2023-12-19 19:19:19","dateIcfa":"2023-12-19 19:19:19","delFlag":0,"diskPath":"/upload/xxx.docx","id":1,"name":"测试方案名称","params":{},"reasonHr":"人力同意","reasonIcfa":"法务部同意","remark":"备注信息。。","status":3,"statusHr":1,"statusIcfa":1,"submitDate":"2023-12-19 19:19:19","updateBy":"admin","updateTime":"2023-12-26 15:05:00"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.updatePostProgramme
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-26 15:05:01', 5);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (544200700223489, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"diskPath":"2024岗检.xlsx","id":1,"params":{},"updateBy":"admin","updateTime":"2023-12-26 15:10:31"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.updatePostProgramme
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-26 15:10:31', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (544901597782017, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"创建者姓名","createTime":"2023-12-19 19:19:19","createUserId":1,"dateHr":"2023-12-19 19:19:19","dateIcfa":"2023-12-19 19:19:19","delFlag":0,"diskPath":"/upload/xxx.docx","id":1,"name":"测试方案名称","params":{},"reasonHr":"人力同意","reasonIcfa":"法务部同意","remark":"备注信息。。","status":3,"statusHr":1,"statusIcfa":1,"submitDate":"2023-12-19 19:19:19","updateBy":"admin","updateTime":"2023-12-26 15:13:18"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.updatePostProgramme
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-26 15:13:18', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (555632279928833, '岗检方案模板', 1, 'com.ruoyi.postCheck.controller.PostProgrammeTemplateController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programmeTemplate', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-26 15:55:56","delFlag":0,"id":1739555631248130049,"params":{},"updateBy":"admin","updateTime":"2023-12-26 15:55:56"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-26 15:55:57, admin, 2023-12-26 15:55:57, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeTemplateMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeTemplateMapper.insertPostProgrammeTemplate-Inline
### The error occurred while setting parameters
### SQL: insert into post_programme_template          ( del_flag,             create_time,             create_by,             update_time,             update_by )           values ( ?,             ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-26 15:55:57, admin, 2023-12-26 15:55:57, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-26 15:55:57, admin, 2023-12-26 15:55:57, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-26 15:55:57, admin, 2023-12-26 15:55:57, admin, null).', '2023-12-26 15:55:57', 174);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (555878934364162, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"levelFive":"","levelFour":"","levelOne":"1","levelThree":"","levelTwo":"","params":{},"type":1,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"1","levelThree":"","levelTwo":"","params":{},"type":2,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"1","levelThree":"","levelTwo":"","params":{},"type":3,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":4,"workStandard":""},{"params":{},"requirement":"11","sequenceProject":"政治要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学历要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学位要求","type":5},{"params":{},"requirement":"","sequenceProject":"工作经验","type":5},{"params":{},"requirement":"","sequenceProject":"职称要求","type":5},{"params":{},"requirement":"","sequenceProject":"专业要求","type":5},{"params":{},"requirement":"","sequenceProject":"能力要求","type":5},{"params":{},"requirement":"","sequenceProject":"知识要求","type":5},{"params":{},"requirement":"","sequenceProject":"在岗时应持有证书必须参加的培训","type":5},{"params":{},"requirement":"","sequenceProject":"其他要求","type":5}],"createBy":"admin","createTime":"2023-12-26 15:56:55","delFlag":0,"directSubordinate":"1","directSuperior":"1","id":1739555878179389441,"jobSummary":"1","params":{},"positionCode":"1","positionLevel":"M2","subordinateCount":1,"unitId":"0","updateBy":"admin","updateTime":"2023-12-26 15:56:55"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 0, null, M2, 1, 1, null, 1, null, 1, null, null, 1, null, 0, 2023-12-26 15:56:55, admin, 2023-12-26 15:56:55, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( unit_id,                          position_level,             direct_superior,             subordinate_count,                          position_code,                          direct_subordinate,                                       job_summary,                                       create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                          ?,                          ?,                                       ?,                                       ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 0, null, M2, 1, 1, null, 1, null, 1, null, null, 1, null, 0, 2023-12-26 15:56:55, admin, 2023-12-26 15:56:55, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 0, null, M2, 1, 1, null, 1, null, 1, null, null, 1, null, 0, 2023-12-26 15:56:55, admin, 2023-12-26 15:56:55, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 0, null, M2, 1, 1, null, 1, null, 1, null, null, 1, null, 0, 2023-12-26 15:56:55, admin, 2023-12-26 15:56:55, admin, null).', '2023-12-26 15:56:56', 170);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (557544949661698, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"levelFive":"","levelFour":"","levelOne":"234","levelThree":"","levelTwo":"","params":{},"type":1,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":2,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":3,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"234","levelThree":"","levelTwo":"","params":{},"type":4,"workStandard":""},{"params":{},"requirement":"","sequenceProject":"政治要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学历要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学位要求","type":5},{"params":{},"requirement":"","sequenceProject":"工作经验","type":5},{"params":{},"requirement":"","sequenceProject":"职称要求","type":5},{"params":{},"requirement":"","sequenceProject":"专业要求","type":5},{"params":{},"requirement":"","sequenceProject":"能力要求","type":5},{"params":{},"requirement":"","sequenceProject":"知识要求","type":5},{"params":{},"requirement":"","sequenceProject":"在岗时应持有证书必须参加的培训","type":5},{"params":{},"requirement":"","sequenceProject":"其他要求","type":5}],"createBy":"admin","createTime":"2023-12-26 16:03:32","delFlag":0,"directSubordinate":"","directSuperior":"","id":1739557544823832577,"jobSummary":"3423423","params":{},"positionCode":"234","positionLevel":"M2","subordinateCount":2342,"unitId":"100","updateBy":"admin","updateTime":"2023-12-26 16:03:32"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:33, admin, 2023-12-26 16:03:33, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( unit_id,                          position_level,             direct_superior,             subordinate_count,                          position_code,                          direct_subordinate,                                       job_summary,                                       create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                          ?,                          ?,                                       ?,                                       ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:33, admin, 2023-12-26 16:03:33, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:33, admin, 2023-12-26 16:03:33, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:33, admin, 2023-12-26 16:03:33, admin, null).', '2023-12-26 16:03:33', 30);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (557581700153346, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"levelFive":"","levelFour":"","levelOne":"234","levelThree":"","levelTwo":"","params":{},"type":1,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":2,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":3,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"234","levelThree":"","levelTwo":"","params":{},"type":4,"workStandard":""},{"params":{},"requirement":"","sequenceProject":"政治要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学历要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学位要求","type":5},{"params":{},"requirement":"","sequenceProject":"工作经验","type":5},{"params":{},"requirement":"","sequenceProject":"职称要求","type":5},{"params":{},"requirement":"","sequenceProject":"专业要求","type":5},{"params":{},"requirement":"","sequenceProject":"能力要求","type":5},{"params":{},"requirement":"","sequenceProject":"知识要求","type":5},{"params":{},"requirement":"","sequenceProject":"在岗时应持有证书必须参加的培训","type":5},{"params":{},"requirement":"","sequenceProject":"其他要求","type":5}],"createBy":"admin","createTime":"2023-12-26 16:03:41","delFlag":0,"directSubordinate":"","directSuperior":"","id":1739557581582712834,"jobSummary":"3423423","params":{},"positionCode":"234","positionLevel":"M2","subordinateCount":2342,"unitId":"100","updateBy":"admin","updateTime":"2023-12-26 16:03:41"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:42, admin, 2023-12-26 16:03:42, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( unit_id,                          position_level,             direct_superior,             subordinate_count,                          position_code,                          direct_subordinate,                                       job_summary,                                       create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                          ?,                          ?,                                       ?,                                       ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:42, admin, 2023-12-26 16:03:42, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:42, admin, 2023-12-26 16:03:42, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M2, , 2342, null, 234, null, , null, null, 3423423, null, 0, 2023-12-26 16:03:42, admin, 2023-12-26 16:03:42, admin, null).', '2023-12-26 16:03:42', 17);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (557803612389377, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"levelFive":"","levelFour":"","levelOne":"23423","levelThree":"","levelTwo":"","params":{},"type":1,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"2342","levelThree":"","levelTwo":"","params":{},"type":2,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"234","levelThree":"","levelTwo":"","params":{},"type":3,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":4,"workStandard":""},{"params":{},"requirement":"23423","sequenceProject":"政治要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学历要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学位要求","type":5},{"params":{},"requirement":"","sequenceProject":"工作经验","type":5},{"params":{},"requirement":"","sequenceProject":"职称要求","type":5},{"params":{},"requirement":"","sequenceProject":"专业要求","type":5},{"params":{},"requirement":"","sequenceProject":"能力要求","type":5},{"params":{},"requirement":"","sequenceProject":"知识要求","type":5},{"params":{},"requirement":"","sequenceProject":"在岗时应持有证书必须参加的培训","type":5},{"params":{},"requirement":"","sequenceProject":"其他要求","type":5}],"createBy":"admin","createTime":"2023-12-26 16:04:34","delFlag":0,"directSubordinate":"423","directSuperior":"423","id":1739557803532697602,"jobSummary":"234","params":{},"positionCode":"2342","positionLevel":"M1","subordinateCount":3432,"unitId":"100","updateBy":"admin","updateTime":"2023-12-26 16:04:34"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:34, admin, 2023-12-26 16:04:34, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( unit_id,                          position_level,             direct_superior,             subordinate_count,                          position_code,                          direct_subordinate,                                       job_summary,                                       create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                          ?,                          ?,                                       ?,                                       ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:34, admin, 2023-12-26 16:04:34, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:34, admin, 2023-12-26 16:04:34, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:34, admin, 2023-12-26 16:04:34, admin, null).', '2023-12-26 16:04:35', 19);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (917315812864001, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/917300608512001', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:53:09', 61);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (917346225762306, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:53:16","createUserId":1,"delFlag":0,"id":917346104127489,"name":"工作组3(综合)","params":{},"parentId":1,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-27 15:53:16"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:53:16', 19);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (917378077306882, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/917346104127489', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:53:24', 14);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (918150164787202, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:56:27","createUserId":1,"delFlag":0,"id":918150038958081,"name":"1","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 15:56:27"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:56:28', 17);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (918230624120834, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:56:46","createUserId":1,"delFlag":0,"id":918230435377154,"name":"2","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 15:56:46"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:56:47', 33);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (918587169320962, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/918230435377154', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:58:12', 16);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (557823677939713, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"levelFive":"","levelFour":"","levelOne":"23423","levelThree":"","levelTwo":"","params":{},"type":1,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"2342","levelThree":"","levelTwo":"","params":{},"type":2,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"234","levelThree":"","levelTwo":"","params":{},"type":3,"workStandard":""},{"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"type":4,"workStandard":""},{"params":{},"requirement":"23423","sequenceProject":"政治要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学历要求","type":5},{"params":{},"requirement":"","sequenceProject":"最低学位要求","type":5},{"params":{},"requirement":"","sequenceProject":"工作经验","type":5},{"params":{},"requirement":"","sequenceProject":"职称要求","type":5},{"params":{},"requirement":"","sequenceProject":"专业要求","type":5},{"params":{},"requirement":"","sequenceProject":"能力要求","type":5},{"params":{},"requirement":"","sequenceProject":"知识要求","type":5},{"params":{},"requirement":"","sequenceProject":"在岗时应持有证书必须参加的培训","type":5},{"params":{},"requirement":"","sequenceProject":"其他要求","type":5}],"createBy":"admin","createTime":"2023-12-26 16:04:39","delFlag":0,"directSubordinate":"423","directSuperior":"423","id":1739557823346589698,"jobSummary":"234","params":{},"positionCode":"2342","positionLevel":"M1","subordinateCount":3432,"unitId":"100","updateBy":"admin","updateTime":"2023-12-26 16:04:39"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:39, admin, 2023-12-26 16:04:39, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( unit_id,                          position_level,             direct_superior,             subordinate_count,                          position_code,                          direct_subordinate,                                       job_summary,                                       create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                          ?,                          ?,                                       ?,                                       ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:39, admin, 2023-12-26 16:04:39, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:39, admin, 2023-12-26 16:04:39, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, 100, null, M1, 423, 3432, null, 2342, null, 423, null, null, 234, null, 0, 2023-12-26 16:04:39, admin, 2023-12-26 16:04:39, admin, null).', '2023-12-26 16:04:39', 68);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (563839752740866, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067969,"levelFive":"","levelFour":"","levelOne":"3123","levelThree":"","levelTwo":"","params":{},"postListId":563837072580610,"type":1,"updateBy":"admin","updateTime":"2023-12-26 16:28:33","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067970,"levelFive":"","levelFour":"","levelOne":"13212","levelThree":"","levelTwo":"","params":{},"postListId":563837072580610,"type":2,"updateBy":"admin","updateTime":"2023-12-26 16:28:33","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067971,"levelFive":"","levelFour":"","levelOne":"123","levelThree":"","levelTwo":"","params":{},"postListId":563837072580610,"type":3,"updateBy":"admin","updateTime":"2023-12-26 16:28:33","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067972,"levelFive":"","levelFour":"","levelOne":"1231","levelThree":"","levelTwo":"","params":{},"postListId":563837072580610,"type":4,"updateBy":"admin","updateTime":"2023-12-26 16:28:33","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067973,"params":{},"postListId":563837072580610,"requirement":"12312","sequenceProject":"政治要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:28:33"},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067974,"params":{},"postListId":563837072580610,"requirement":"","sequenceProject":"最低学历要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:28:33"},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067975,"params":{},"postListId":563837072580610,"requirement":"","sequenceProject":"最低学位要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:28:33"},{"createBy":"admin","createTime":"2023-12-26 16:28:33","delFlag":0,"id":563837450067976,"params":{},"postListId":5638', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 16:28:34', 635);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (563873101651970, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055746,"levelFive":"","levelFour":"","levelOne":"3123","levelThree":"","levelTwo":"","params":{},"postListId":563872589946881,"type":1,"updateBy":"admin","updateTime":"2023-12-26 16:28:41","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055747,"levelFive":"","levelFour":"","levelOne":"13212","levelThree":"","levelTwo":"","params":{},"postListId":563872589946881,"type":2,"updateBy":"admin","updateTime":"2023-12-26 16:28:41","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055748,"levelFive":"","levelFour":"","levelOne":"123","levelThree":"","levelTwo":"","params":{},"postListId":563872589946881,"type":3,"updateBy":"admin","updateTime":"2023-12-26 16:28:41","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055749,"levelFive":"","levelFour":"","levelOne":"1231","levelThree":"","levelTwo":"","params":{},"postListId":563872589946881,"type":4,"updateBy":"admin","updateTime":"2023-12-26 16:28:41","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055750,"params":{},"postListId":563872589946881,"requirement":"12312","sequenceProject":"政治要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:28:41"},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055751,"params":{},"postListId":563872589946881,"requirement":"","sequenceProject":"最低学历要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:28:41"},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055752,"params":{},"postListId":563872589946881,"requirement":"","sequenceProject":"最低学位要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:28:41"},{"createBy":"admin","createTime":"2023-12-26 16:28:41","delFlag":0,"id":563872657055753,"params":{},"postListId":5638', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 16:28:42', 110);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (564574267645954, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215555,"levelFive":"","levelFour":"","levelOne":"3123","levelThree":"","levelTwo":"","params":{},"postListId":564573848215554,"type":1,"updateBy":"admin","updateTime":"2023-12-26 16:31:28","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215556,"levelFive":"","levelFour":"","levelOne":"1321","levelThree":"","levelTwo":"","params":{},"postListId":564573848215554,"type":2,"updateBy":"admin","updateTime":"2023-12-26 16:31:28","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215557,"levelFive":"","levelFour":"","levelOne":"1231","levelThree":"","levelTwo":"","params":{},"postListId":564573848215554,"type":3,"updateBy":"admin","updateTime":"2023-12-26 16:31:28","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215558,"levelFive":"","levelFour":"","levelOne":"123","levelThree":"","levelTwo":"","params":{},"postListId":564573848215554,"type":4,"updateBy":"admin","updateTime":"2023-12-26 16:31:28","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215559,"params":{},"postListId":564573848215554,"requirement":"123","sequenceProject":"政治要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:31:28"},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215560,"params":{},"postListId":564573848215554,"requirement":"","sequenceProject":"最低学历要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:31:28"},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215561,"params":{},"postListId":564573848215554,"requirement":"","sequenceProject":"最低学位要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:31:28"},{"createBy":"admin","createTime":"2023-12-26 16:31:28","delFlag":0,"id":564573848215562,"params":{},"postListId":5645738', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 16:31:29', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (564770397495298, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790209,"levelFive":"","levelFour":"","levelOne":"213","levelThree":"","levelTwo":"","params":{},"postListId":564769772544001,"type":1,"updateBy":"admin","updateTime":"2023-12-26 16:32:15","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790210,"levelFive":"","levelFour":"","levelOne":"312","levelThree":"","levelTwo":"","params":{},"postListId":564769772544001,"type":2,"updateBy":"admin","updateTime":"2023-12-26 16:32:15","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790211,"levelFive":"","levelFour":"","levelOne":"312","levelThree":"","levelTwo":"","params":{},"postListId":564769772544001,"type":3,"updateBy":"admin","updateTime":"2023-12-26 16:32:15","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790212,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":564769772544001,"type":4,"updateBy":"admin","updateTime":"2023-12-26 16:32:15","workStandard":""},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790213,"params":{},"postListId":564769772544001,"requirement":"123","sequenceProject":"政治要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:32:15"},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790214,"params":{},"postListId":564769772544001,"requirement":"","sequenceProject":"最低学历要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:32:15"},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790215,"params":{},"postListId":564769772544001,"requirement":"","sequenceProject":"最低学位要求","type":5,"updateBy":"admin","updateTime":"2023-12-26 16:32:15"},{"createBy":"admin","createTime":"2023-12-26 16:32:15","delFlag":0,"id":564769885790216,"params":{},"postListId":5647697725440', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 16:32:15', 137);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (640290953342978, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"tool","isCache":"0","isFrame":"1","menuId":3,"menuName":"系统工具","menuType":"M","orderNum":800,"params":{},"parentId":0,"path":"tool","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:32:23', 181);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (640348117512194, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"tool/build/index","createTime":"2023-12-11 13:16:57","icon":"build","isCache":"0","isFrame":"1","menuId":115,"menuName":"表单构建","menuType":"C","orderNum":1,"params":{},"parentId":3,"path":"build","perms":"tool:build:list","query":"","status":"1","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:32:36', 103);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (640458356404225, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_highlights"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:33:03', 973);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (640820274507778, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postHighlights","className":"PostHighlights","columns":[{"capJavaField":"Id","columnComment":"id","columnId":640455734964225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":640454493450241,"updateBy":"","usableColumn":false},{"capJavaField":"HighlightsType","columnComment":"highlights_type","columnId":640456255057922,"columnName":"highlights_type","columnType":"integer","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlightsType","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":640454493450241,"updateBy":"","usableColumn":false},{"capJavaField":"Highlights","columnComment":"highlights","columnId":640456452190210,"columnName":"highlights","columnType":"varchar","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlights","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":640454493450241,"updateBy":"","usableColumn":false},{"capJavaField":"Remark","columnComment":"remark","columnId":640456649322498,"columnName":"remark","columnType":"varchar","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"input","increment":f', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:34:29', 737);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (641201557712897, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postHighlights","className":"PostHighlights","columns":[{"capJavaField":"Id","columnComment":"主键id","columnId":640455734964225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:34:28","usableColumn":false},{"capJavaField":"HighlightsType","columnComment":"职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；","columnId":640456255057922,"columnName":"highlights_type","columnType":"integer","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlightsType","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:34:28","usableColumn":false},{"capJavaField":"Highlights","columnComment":"管理亮点","columnId":640456452190210,"columnName":"highlights","columnType":"varchar","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlights","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:34:28","usableColumn":false},{"capJavaField":"Remark","columnComment":"备注","columnId":640456649322498,"columnName":"remark","colum', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:36:00', 605);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (641454822371329, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postHighlights","className":"PostHighlights","columns":[{"capJavaField":"Id","columnComment":"主键id","columnId":640455734964225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:35:59","usableColumn":false},{"capJavaField":"HighlightsType","columnComment":"职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；","columnId":640456255057922,"columnName":"highlights_type","columnType":"integer","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlightsType","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:35:59","usableColumn":false},{"capJavaField":"Highlights","columnComment":"管理亮点","columnId":640456452190210,"columnName":"highlights","columnType":"varchar","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlights","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:35:59","usableColumn":false},{"capJavaField":"Remark","columnComment":"备注","columnId":640456649322498,"columnName":"remark","colum', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:37:00', 617);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (641570853597185, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postHighlights","className":"PostHighlights","columns":[{"capJavaField":"Id","columnComment":"主键id","columnId":640455734964225,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:37:00","usableColumn":false},{"capJavaField":"HighlightsType","columnComment":"职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规保密职；5-其他；","columnId":640456255057922,"columnName":"highlights_type","columnType":"integer","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlightsType","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:37:00","usableColumn":false},{"capJavaField":"Highlights","columnComment":"管理亮点","columnId":640456452190210,"columnName":"highlights","columnType":"varchar","createBy":"admin","createTime":"2023-12-26 21:33:02","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"highlights","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":640454493450241,"updateBy":"","updateTime":"2023-12-26 21:37:00","usableColumn":false},{"capJavaField":"Remark","columnComment":"备注","columnId":640456649322498,"columnName":"remark","colum', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-26 21:37:28', 581);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (647470272131073, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"diskPath":"2024岗检方案.xlsx","name":"2024岗检方案测试修改V1","params":{},"reasonIcfa":"不通过ss","statusTime":"2024-01-02 12:03:04","updateBy":"admin","updateTime":"2023-12-26 22:00:52"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-postcheck\target\classes\mapper\postCheck\PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.updatePostProgramme
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-26 22:00:54', 50);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (649333763674113, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"diskPath":"2024岗检方案.xlsx","name":"2024岗检方案测试修改V1","params":{},"reasonIcfa":"不通过ss","statusTime":"2024-01-02 12:03:04","updateBy":"admin","updateTime":"2023-12-26 22:08:16"}', '{"msg":"操作失败","code":500}', 0, NULL, '2023-12-26 22:08:19', 111);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (649443973206017, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"diskPath":"2024岗检方案.xlsx","name":"2024岗检方案测试修改V1","params":{},"reasonIcfa":"不通过ss","statusTime":"2024-01-02 12:03:04","updateBy":"admin","updateTime":"2023-12-26 22:08:43"}', '{"msg":"操作失败","code":500}', 0, NULL, '2023-12-26 22:08:45', 49);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (828093215010817, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"","isCache":"0","isFrame":"1","menuId":3,"menuName":"系统工具","menuType":"M","orderNum":800,"params":{},"parentId":0,"path":"tool","perms":"","query":"","status":"1","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 09:58:37', 83);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (831474490929154, '岗检方案', 2, 'com.ruoyi.postCheck.controller.PostProgrammeController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"创建者姓名","createTime":"2023-12-19 19:19:19","createUserId":1,"dateHr":"2023-12-19 19:19:19","dateIcfa":"2023-12-19 19:19:19","delFlag":0,"diskPath":"/upload/xxx.docx","id":1,"name":"测试方案名称","params":{},"reasonHr":"人力同意","reasonIcfa":"法务部同意","remark":"备注信息。。","status":3,"statusHr":1,"statusIcfa":1,"submitDate":"2023-12-19 19:19:19","updateBy":"admin","updateTime":"2023-12-27 10:12:02"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 10:12:03', 49);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (831574667685889, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-27 10:12:26","delFlag":0,"deptName":"人力资源部门","diskPath":"2024岗检方案.xlsx","id":831574462164993,"name":"2024岗检方案","params":{},"reasonIcfa":"不通过","status":1,"statusHr":1,"statusTime":"2024-01-02 12:03:04","submitDate":"2023-12-27 10:12:26","updateBy":"admin","updateTime":"2023-12-27 10:12:26"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 10:12:27', 32);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (831810307878914, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-27 10:13:22","delFlag":0,"deptName":"人力资源部门","diskPath":"2024岗检方案.xlsx","id":831810203021314,"name":"2024岗检方案","params":{},"reasonIcfa":"不通过","status":1,"statusHr":1,"statusTime":"2024-01-02 12:03:04","submitDate":"2023-12-27 10:13:22","updateBy":"admin","updateTime":"2023-12-27 10:13:22"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 10:13:23', 25);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (831843631624194, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-27 10:13:30","delFlag":0,"deptName":"人力资源部门","diskPath":"2024岗检方案.xlsx","id":831843405131777,"name":"2024岗检方案","params":{},"reasonIcfa":"不通过","status":1,"statusHr":1,"statusTime":"2024-01-02 12:03:04","submitDate":"2023-12-27 10:13:30","updateBy":"admin","updateTime":"2023-12-27 10:13:30"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 10:13:31', 41);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (841506787946498, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"component":"","createTime":"2023-12-21 15:21:25","icon":"#","isCache":"0","isFrame":"1","menuId":734552664301571,"menuName":"考核评比查询","menuType":"F","orderNum":1,"params":{},"parentId":734552664301570,"path":"#","perms":"postCheck:assessmentRating:query","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 10:51:55', 63);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (841813571923970, '部门管理', 2, 'com.ruoyi.web.controller.system.SysDeptController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/dept', '127.0.0.1', '内网IP', '{"ancestors":"0,100","children":[],"deptId":101,"deptName":"惠州分公司","email":"ry@qq.com","leader":"若依","orderNum":1,"params":{},"parentId":100,"parentName":"中海油惠州石化","phone":"15888888888","status":"0","updateBy":"admin"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 10:53:08', 119);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (882623109656577, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 13:35:17","delFlag":0,"id":1739882622350487554,"name":"岗检联合办公室","params":{},"parentId":0,"type":1,"updateBy":"admin","updateTime":"2023-12-27 13:35:17"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检联合办公室, 0, null, null, 0, 2023-12-27 13:35:17, admin, 2023-12-27 13:35:17, admin, null, 1, 2).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostTeamMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostTeamMapper.insertPostTeam-Inline
### The error occurred while setting parameters
### SQL: insert into post_team          ( name,             parent_id,                                       del_flag,             create_time,             create_by,             update_time,             update_by,                          type )           values ( ?,             ?,                                       ?,             ?,             ?,             ?,             ?,                          ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检联合办公室, 0, null, null, 0, 2023-12-27 13:35:17, admin, 2023-12-27 13:35:17, admin, null, 1, 2).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检联合办公室, 0, null, null, 0, 2023-12-27 13:35:17, admin, 2023-12-27 13:35:17, admin, null, 1, 2).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检联合办公室, 0, null, null, 0, 2023-12-27 13:35:17, admin, 2023-12-27 13:35:17, admin, null, 1, 2).', '2023-12-27 13:35:18', 170);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (909748877406210, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:23:04","createUserId":1,"delFlag":0,"id":909748499918850,"name":"岗检联合办公室","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 15:23:04"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:23:05', 78);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (916133572784129, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/909748499918850', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:48:27', 26);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (918597143375873, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/918150038958081', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:58:14', 18);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (918818355163137, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:59:07","createUserId":1,"delFlag":0,"id":918818212556802,"name":"1","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 15:59:07"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:59:07', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (918973624102913, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 15:59:44","createUserId":1,"delFlag":0,"id":918973527633921,"name":"2","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 15:59:44"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 15:59:44', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (919297919299586, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:01:01","createUserId":1,"delFlag":0,"id":919297789276161,"name":"11","params":{},"parentId":0,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-27 16:01:01"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:01:01', 18);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (919376986124290, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/918973527633921', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:01:20', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (919388558209026, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/919297789276161', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:01:23', 19);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (919400801382402, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/918818212556802', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:01:26', 12);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (919423576453121, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:01:31","createUserId":1,"delFlag":0,"id":919423484178434,"name":"11","params":{},"parentId":1,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-27 16:01:31"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:01:31', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (919616401190914, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/919423484178434', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:02:17', 49);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (920414870843393, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:05:27","createUserId":1,"delFlag":0,"id":920414761791490,"name":"","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 16:05:27"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:05:28', 14);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (920563462451202, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:06:03","createUserId":1,"delFlag":0,"id":920563349204993,"name":"1","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 16:06:03"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:06:03', 16);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (920579463720961, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/920563349204993', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:06:07', 14);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (930977290137601, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:47:25","createUserId":1,"delFlag":0,"id":930977055256578,"name":"12","params":{},"parentId":1,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-27 16:47:25"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:47:26', 43);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (931167782842369, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/920414761791490', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:48:11', 11);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (931260732813314, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:48:33","createUserId":1,"delFlag":0,"id":931260627955713,"name":"13","params":{},"parentId":1,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-27 16:48:33"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:48:34', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (932016273764354, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/931260627955713', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:51:34', 12);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (932040420372482, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:51:39","createUserId":1,"delFlag":0,"id":932040323903489,"name":"13","params":{},"parentId":20,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-27 16:51:39"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:51:39', 12);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (932068744507393, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 16:51:46","createUserId":1,"delFlag":0,"id":932068627066881,"name":"13","params":{},"parentId":1,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-27 16:51:46"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:51:46', 18);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (932134368587778, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/932068627066881', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:52:02', 18);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (932155562405889, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/932040323903489', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 16:52:07', 12);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (936482691624961, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 17:09:18","createUserId":1,"delFlag":0,"id":936482372857858,"name":"10","params":{},"parentId":1,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 17:09:18"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:09:19', 47);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (936531249082370, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/936482372857858', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:09:30', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (937368750927873, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-27 17:12:49","createUserId":1,"delFlag":0,"id":937368608321538,"name":"1","params":{},"parentId":0,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-27 17:12:49"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:12:50', 21);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (937446848868353, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/937368608321538', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:13:08', 16);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (937687899713537, '岗检小组', 2, 'com.ruoyi.postCheck.controller.PostTeamController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"id":930977055256578,"name":"123","params":{},"updateBy":"admin","updateTime":"2023-12-27 17:14:05"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:14:06', 14);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (940244235726850, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/930977055256578', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:24:15', 29);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (946235710910465, '岗位责任制清单', 3, 'com.ruoyi.postCheck.controller.PostListController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postCheckList/563872589946881', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:48:04', 49);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (946266429992961, '岗位责任制清单', 3, 'com.ruoyi.postCheck.controller.PostListController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postCheckList/563837072580610', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:48:11', 17);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (946285312749570, '岗位责任制清单', 3, 'com.ruoyi.postCheck.controller.PostListController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postCheckList/564573848215554', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:48:16', 16);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (946292656975873, '岗位责任制清单', 3, 'com.ruoyi.postCheck.controller.PostListController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postCheckList/564769772544001', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:48:17', 27);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (946618717974530, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098561,"levelFive":"五级事项","levelFour":"四级事项","levelOne":"一级事项","levelThree":"三级事项","levelTwo":"二级事项","params":{},"postListId":946617862336514,"type":1,"updateBy":"admin","updateTime":"2023-12-27 17:49:35","workStandard":""},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098562,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":946617862336514,"type":2,"updateBy":"admin","updateTime":"2023-12-27 17:49:35","workStandard":""},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098563,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":946617862336514,"type":3,"updateBy":"admin","updateTime":"2023-12-27 17:49:35","workStandard":""},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098564,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":946617862336514,"type":4,"updateBy":"admin","updateTime":"2023-12-27 17:49:35","workStandard":""},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098565,"params":{},"postListId":946617862336514,"requirement":"政治要求","sequenceProject":"政治要求","type":5,"updateBy":"admin","updateTime":"2023-12-27 17:49:35"},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098566,"params":{},"postListId":946617862336514,"requirement":"最低学历要求","sequenceProject":"最低学历要求","type":5,"updateBy":"admin","updateTime":"2023-12-27 17:49:35"},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098567,"params":{},"postListId":946617862336514,"requirement":"","sequenceProject":"最低学位要求","type":5,"updateBy":"admin","updateTime":"2023-12-27 17:49:35"},{"createBy":"admin","createTime":"2023-12-27 17:49:35","delFlag":0,"id":946618332098568,"params":{},"postLis', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 17:49:35', 225);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20318320885762, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"","createTime":"2023-12-20 00:00:00","createUserId":123456,"delFlag":0,"id":11,"levelFive":"PostMan第五级","levelFour":"PostMan合同执行","levelOne":"PostMan销售管理","levelThree":"PostMan隔墙互供","levelTwo":"PostMan内贸业务管理","params":{},"postListId":1,"requirement":"PostMan要求000000","sequenceProject":"①","status":3,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","type":1,"updateBy":"","updateTime":"2023-12-20 00:00:00","workStandard":"PostMan做好隔墙互供产品的销售管理，每月签订销售订单及跟踪执行，并做好产品结算价款的确认，保证合同有效执行、确保资金及时回款。不因合同执行不到位引起法律纠纷。"}],"createBy":"admin","createTime":"2023-12-27 22:42:14","creationDate":"2023-12-27 22:42:15","delFlag":0,"deptId":"100","deptName":"中海油惠州石化","directSubordinate":"PostMan下级","directSuperior":"PostMan上级","id":1,"isConfidential":"PostMan是涉密的","jobSummary":"PostMan摘要内容....","params":{},"positionCode":"YX001PostMan","positionLevel":"PostMan岗位级别","postId":1,"postName":"董事长","remark":"PostMan备注信息","revisionDate":"2023-12-27 22:42:15","status":1,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","subordinateCount":11,"unitId":"PostMan惠州石化","updateBy":"admin","updateTime":"2023-12-27 22:42:14"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 对于可变字符类型来说，值太长了(10)
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-postcheck\target\classes\mapper\postCheck\PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( id,             status,             status_by_user_id,             status_by_user_name,             unit_id,             post_id,             position_level,             direct_superior,             subordinate_count,             dept_id,             position_code,             is_confidential,             direct_subordinate,             creation_date,             revision_date,             job_summary,             remark,                          create_time,             create_by,             update_time,             update_by )           values ( ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,                          ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 对于可变字符类型来说，值太长了(10)
; 错误: 对于可变字符类型来说，值太长了(10); nested exception is com.kingbase8.util.KSQLException: 错误: 对于可变字符类型来说，值太长了(10)', '2023-12-27 22:42:28', 25664);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20754935349250, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"","createTime":"2023-12-20 00:00:00","createUserId":123456,"delFlag":0,"id":11,"levelFive":"PostMan第五级","levelFour":"PostMan合同执行","levelOne":"PostMan销售管理","levelThree":"PostMan隔墙互供","levelTwo":"PostMan内贸业务管理","params":{},"postListId":1,"requirement":"PostMan要求000000","sequenceProject":"①","status":3,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","type":1,"updateBy":"","updateTime":"2023-12-20 00:00:00","workStandard":"PostMan做好隔墙互供产品的销售管理，每月签订销售订单及跟踪执行，并做好产品结算价款的确认，保证合同有效执行、确保资金及时回款。不因合同执行不到位引起法律纠纷。"}],"createBy":"admin","createTime":"2023-12-27 22:43:58","creationDate":"2023-12-27 22:43:58","delFlag":0,"deptId":"100","deptName":"中海油惠州石化","directSubordinate":"PostMan下级","directSuperior":"PostMan上级","id":1,"isConfidential":"P是涉密的","jobSummary":"PostMan摘要内容....","params":{},"positionCode":"YX001PostMan","positionLevel":"PostMan岗位级别","postId":1,"postName":"董事长","remark":"PostMan备注信息","revisionDate":"2023-12-27 22:43:59","status":1,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","subordinateCount":11,"unitId":"PostMan惠州石化","updateBy":"admin","updateTime":"2023-12-27 22:43:58"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_5CD25ED8_D5AE10F7_2330D4DD"
  Detail: 键值"(id)=(1)" 已经存在
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-postcheck\target\classes\mapper\postCheck\PostListMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostListMapper.insertPostList-Inline
### The error occurred while setting parameters
### SQL: insert into post_list          ( id,             status,             status_by_user_id,             status_by_user_name,             unit_id,             post_id,             position_level,             direct_superior,             subordinate_count,             dept_id,             position_code,             is_confidential,             direct_subordinate,             creation_date,             revision_date,             job_summary,             remark,                          create_time,             create_by,             update_time,             update_by )           values ( ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,             ?,                          ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_5CD25ED8_D5AE10F7_2330D4DD"
  Detail: 键值"(id)=(1)" 已经存在
; 错误: 重复键违反唯一约束"PRIMARY_5CD25ED8_D5AE10F7_2330D4DD"
  Detail: 键值"(id)=(1)" 已经存在; nested exception is com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_5CD25ED8_D5AE10F7_2330D4DD"
  Detail: 键值"(id)=(1)" 已经存在', '2023-12-27 22:44:12', 15510);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20971319492609, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-27 22:45:02","createUserId":1,"delFlag":0,"id":11,"levelFive":"PostMan第五级","levelFour":"PostMan合同执行","levelOne":"PostMan销售管理","levelThree":"PostMan隔墙互供","levelTwo":"PostMan内贸业务管理","params":{},"postListId":20957222436866,"requirement":"PostMan要求000000","sequenceProject":"①","status":1,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","type":1,"updateBy":"admin","updateTime":"2023-12-27 22:45:02","workStandard":"PostMan做好隔墙互供产品的销售管理，每月签订销售订单及跟踪执行，并做好产品结算价款的确认，保证合同有效执行、确保资金及时回款。不因合同执行不到位引起法律纠纷。"}],"createBy":"admin","createTime":"2023-12-27 22:44:58","creationDate":"2023-12-27 22:44:58","delFlag":0,"deptId":"100","deptName":"中海油惠州石化","directSubordinate":"PostMan下级","directSuperior":"PostMan上级","id":20957222436866,"isConfidential":"P是涉密的","jobSummary":"PostMan摘要内容....","params":{},"positionCode":"YX001PostMan","positionLevel":"PostMan岗位级别","postId":1,"postName":"董事长","remark":"PostMan备注信息","revisionDate":"2023-12-27 22:44:58","status":1,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","subordinateCount":11,"unitId":"PostMan惠州石化","updateBy":"admin","updateTime":"2023-12-27 22:44:58"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F"
  Detail: 键值"(id)=(11)" 已经存在
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-postcheck\target\classes\mapper\postCheck\PostListMapper.xml]
### The error may involve defaultParameterMap
### The error occurred while setting parameters
### SQL: insert into post_list_info( id, status, status_by_user_id, status_by_user_name, post_list_id, type, sequence_project, level_one, level_two, level_three, level_four, level_five, work_standard, requirement, remark, del_flag, create_time, create_by, update_time, update_by, create_user_id) values                  ( ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)
### Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F"
  Detail: 键值"(id)=(11)" 已经存在
; 错误: 重复键违反唯一约束"PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F"
  Detail: 键值"(id)=(11)" 已经存在; nested exception is com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F"
  Detail: 键值"(id)=(11)" 已经存在', '2023-12-27 22:45:03', 9608);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21336618205185, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-27 22:46:29","createUserId":1,"delFlag":0,"id":21336089722882,"levelFive":"PostMan第五级","levelFour":"PostMan合同执行","levelOne":"PostMan销售管理","levelThree":"PostMan隔墙互供","levelTwo":"PostMan内贸业务管理","params":{},"postListId":21330788122626,"requirement":"PostMan要求000000","sequenceProject":"①","status":1,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","type":1,"updateBy":"admin","updateTime":"2023-12-27 22:46:29","workStandard":"PostMan做好隔墙互供产品的销售管理，每月签订销售订单及跟踪执行，并做好产品结算价款的确认，保证合同有效执行、确保资金及时回款。不因合同执行不到位引起法律纠纷。"}],"createBy":"admin","createTime":"2023-12-27 22:46:27","creationDate":"2023-12-27 22:46:27","delFlag":0,"deptId":"100","deptName":"中海油惠州石化","directSubordinate":"PostMan下级","directSuperior":"PostMan上级","id":21330788122626,"isConfidential":"P是涉密的","jobSummary":"PostMan摘要内容....","params":{},"positionCode":"YX001PostMan","positionLevel":"PostMan岗位级别","postId":1,"postName":"董事长","remark":"PostMan备注信息","revisionDate":"2023-12-27 22:46:27","status":1,"statusByUserId":1,"statusByUserName":"PostMan审核人姓名","subordinateCount":11,"unitId":"PostMan惠州石化","updateBy":"admin","updateTime":"2023-12-27 22:46:27"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-27 22:46:31', 7522);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (181592691949570, '岗检方案', 3, 'com.ruoyi.postCheck.controller.PostProgrammeController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/programme/490222019432449', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 09:23:17', 26);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (181665135968257, '岗检方案模板', 1, 'com.ruoyi.postCheck.controller.PostProgrammeTemplateController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programmeTemplate', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-28 09:23:34","delFlag":0,"id":1740181664406159362,"params":{},"updateBy":"admin","updateTime":"2023-12-28 09:23:34"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-28 09:23:34, admin, 2023-12-28 09:23:34, admin, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeTemplateMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeTemplateMapper.insertPostProgrammeTemplate-Inline
### The error occurred while setting parameters
### SQL: insert into post_programme_template          ( del_flag,             create_time,             create_by,             update_time,             update_by )           values ( ?,             ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-28 09:23:34, admin, 2023-12-28 09:23:34, admin, null).
; 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-28 09:23:34, admin, 2023-12-28 09:23:34, admin, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, null, null, null, null, null, 0, 2023-12-28 09:23:34, admin, 2023-12-28 09:23:34, admin, null).', '2023-12-28 09:23:35', 165);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (181752746590209, '岗检方案模板', 3, 'com.ruoyi.postCheck.controller.PostProgrammeTemplateController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/programmeTemplate/1', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 09:23:56', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (202674253709314, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635842,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":202672903143426,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-28 10:47:03","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635843,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":202672903143426,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-28 10:47:03","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635844,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":202672903143426,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 10:47:03","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635845,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":202672903143426,"status":1,"type":4,"updateBy":"admin","updateTime":"2023-12-28 10:47:03","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635846,"params":{},"postListId":202672903143426,"requirement":"政治要求的要求","sequenceProject":"政治要求","status":1,"type":5,"updateBy":"admin","updateTime":"2023-12-28 10:47:03"},{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635847,"params":{},"postListId":202672903143426,"requirement":"最低学历的要求","sequenceProject":"最低学历要求","status":1,"type":5,"updateBy":"admin","updateTime":"2023-12-28 10:47:03"},{"createBy":"admin","createTime":"2023-12-28 10:47:03","createUserId":1,"delFlag":0,"id":202673129635848,"params":{},"postListId":202672903143426,"requirement":"","sequenceProject":"最低学位要求","st', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 10:47:04', 303);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (250176159989762, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/22', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:55:49', 21);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (250199195107330, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/21', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:55:54', 11);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (250276512907266, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 13:56:12","createUserId":1,"delFlag":0,"id":250276089282562,"name":"工作组1(综合)","params":{},"parentId":20,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 13:56:12"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:56:13', 88);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (250593535180801, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/250276089282562', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:57:28', 11);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (250680864784386, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 13:57:49","createUserId":1,"delFlag":0,"id":250680772509698,"name":"工作组1(综合)","params":{},"parentId":20,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 13:57:49"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:57:49', 12);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (251000751767554, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/250680772509698', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:59:06', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (251079541768193, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 13:59:24","createUserId":1,"delFlag":0,"id":251079386578945,"name":"工作组1（综合）","params":{},"parentId":20,"status":1,"teamType":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 13:59:24"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 13:59:24', 26);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (251296139821058, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 14:00:15","createUserId":1,"delFlag":0,"id":251296001409026,"name":"2","params":{},"parentId":20,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 14:00:15"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 14:00:16', 26);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (251666417172482, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/251296001409026', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 14:01:44', 16);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (251963000602625, '岗位责任制清单', 1, 'com.ruoyi.postCheck.controller.PostListController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006402,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":251962405011457,"status":1,"type":1,"updateBy":"admin","updateTime":"2023-12-28 14:02:54","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006403,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":251962405011457,"status":1,"type":2,"updateBy":"admin","updateTime":"2023-12-28 14:02:54","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006404,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":251962405011457,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 14:02:54","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006405,"levelFive":"","levelFour":"","levelOne":"","levelThree":"","levelTwo":"","params":{},"postListId":251962405011457,"status":1,"type":4,"updateBy":"admin","updateTime":"2023-12-28 14:02:54","workStandard":""},{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006406,"params":{},"postListId":251962405011457,"requirement":"","sequenceProject":"政治要求","status":1,"type":5,"updateBy":"admin","updateTime":"2023-12-28 14:02:54"},{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006407,"params":{},"postListId":251962405011457,"requirement":"","sequenceProject":"最低学历要求","status":1,"type":5,"updateBy":"admin","updateTime":"2023-12-28 14:02:54"},{"createBy":"admin","createTime":"2023-12-28 14:02:54","createUserId":1,"delFlag":0,"id":251962556006408,"params":{},"postListId":251962405011457,"requirement":"","sequenceProject":"最低学位要求","status":1,"type"', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 14:02:55', 130);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (256173490421761, '岗位责任制清单', 3, 'com.ruoyi.postCheck.controller.PostListController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postCheckList/251962405011457', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 14:19:39', 30);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (256305401282561, '岗位责任制清单', 2, 'com.ruoyi.postCheck.controller.PostListController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckList', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 10:47:03","creationDate":"2023-12-28 00:00:00","delFlag":0,"deptId":"103","deptName":"市场部门","directSubordinate":"下级","directSuperior":"上级","id":202672903143426,"isConfidential":"是","params":{},"positionCode":"8888","positionLevel":"M1","postId":1,"postName":"董事长","remark":"100,101,103","revisionDate":"2023-12-28 00:00:00","status":1,"subordinateCount":8,"unitId":"中海油惠州石化","updateBy":"admin","updateTime":"2023-12-28 14:20:10"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 14:20:10', 38);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (270619101229058, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/32', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 15:17:03', 731);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (270638969647106, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/31', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 15:17:08', 10);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (270729306566657, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 15:17:29","createUserId":1,"delFlag":0,"id":270728702586882,"name":"工作组1(生产)","params":{},"parentId":30,"status":1,"teamType":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 15:17:29"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 15:17:29', 135);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (270833480495106, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 15:17:54","createUserId":1,"delFlag":0,"id":270833337888770,"name":"1","params":{},"parentId":30,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 15:17:54"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 15:17:54', 14);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (277245547900929, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/270833337888770', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 15:43:23', 13);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (277334777524226, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 15:43:44","createUserId":1,"delFlag":0,"id":277334676860929,"name":"工作组2(生产)","params":{},"parentId":30,"status":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 15:43:44"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 15:43:44', 14);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (288395927261186, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 13:16:57","icon":"","isCache":"0","isFrame":"1","menuId":3,"menuName":"系统工具","menuType":"M","orderNum":800,"params":{},"parentId":0,"path":"tool","perms":"","query":"","status":"0","updateBy":"admin","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:27:43', 153);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (288624852373505, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_checked_report"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:28:37', 2449);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (288685204213761, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_assessment_rules"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:28:52', 990);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (292316389347329, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRules","className":"PostAssessmentRules","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":288681701969921,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；","columnId":288681903296514,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"type","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"FullScore","columnComment":"满分/权重","columnId":288682100428801,"columnName":"full_score","columnType":"integer","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"fullScore","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"Rule","columnComment":"考核规则/评分标准","columnId":288682301755393,"columnName":"rule","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"input","increm', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:43:17', 21155);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (292329513324545, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRules","className":"PostAssessmentRules","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":288681701969921,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；","columnId":288681903296514,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"type","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"FullScore","columnComment":"满分/权重","columnId":288682100428801,"columnName":"full_score","columnType":"integer","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"fullScore","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"Rule","columnComment":"考核规则/评分标准","columnId":288682301755393,"columnName":"rule","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"input","increm', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:43:20', 865);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (292359238356993, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRules","className":"PostAssessmentRules","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":288681701969921,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"评分分类/项目/专业：1-岗检考核规则；2-职能部门互评表；；3-生产部门日常得分；","columnId":288681903296514,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"type","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":2,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"FullScore","columnComment":"满分/权重","columnId":288682100428801,"columnName":"full_score","columnType":"integer","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"fullScore","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":288681240596481,"updateBy":"","usableColumn":false},{"capJavaField":"Rule","columnComment":"考核规则/评分标准","columnId":288682301755393,"columnName":"rule","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:51","dictType":"","edit":true,"htmlType":"input","increm', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:43:28', 20143);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (293897725841410, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckedReport","className":"PostCheckedReport","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":288615733956610,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportNo","columnComment":"编码","columnId":288616065306626,"columnName":"report_no","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"reportNo","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportName","columnComment":"岗检报告名称","columnId":288616262438913,"columnName":"report_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"reportName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportPreface","columnComment":"前言","columnId":288616518291458,"columnName":"report_preface","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:49:34', 21916);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (293913219600385, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckedReport","className":"PostCheckedReport","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":288615733956610,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportNo","columnComment":"编码","columnId":288616065306626,"columnName":"report_no","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"reportNo","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportName","columnComment":"岗检报告名称","columnId":288616262438913,"columnName":"report_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"reportName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportPreface","columnComment":"前言","columnId":288616518291458,"columnName":"report_preface","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:49:38', 1471);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (293943036907521, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postCheckedReport","className":"PostCheckedReport","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":288615733956610,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportNo","columnComment":"编码","columnId":288616065306626,"columnName":"report_no","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"reportNo","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportName","columnComment":"岗检报告名称","columnId":288616262438913,"columnName":"report_name","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"reportName","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":3,"superColumn":false,"tableId":288614819598338,"updateBy":"","usableColumn":false},{"capJavaField":"ReportPreface","columnComment":"前言","columnId":288616518291458,"columnName":"report_preface","columnType":"varchar","createBy":"admin","createTime":"2023-12-28 16:28:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:49:45', 20741);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (294165198270465, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/270728702586882', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:50:37', 24);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (294180696223745, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/277334676860929', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:50:40', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (294200426229761, '岗检小组', 1, 'com.ruoyi.postCheck.controller.PostTeamController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/team', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","createTime":"2023-12-28 16:50:45","createUserId":1,"delFlag":0,"id":294200241680386,"name":"1","params":{},"parentId":30,"status":1,"teamType":1,"type":3,"updateBy":"admin","updateTime":"2023-12-28 16:50:45"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:50:45', 37);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (294215316008961, '岗检小组', 3, 'com.ruoyi.postCheck.controller.PostTeamController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/team/294200241680386', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-28 16:50:49', 17);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (294296608346113, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.batchGenCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/batchGenCode', '127.0.0.1', '内网IP', '{"tables":"post_checked_report,post_assessment_rules"}', NULL, 0, NULL, '2023-12-28 16:51:09', 436);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (574376200437761, '考核规则', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRulesController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRules', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-29 11:24:04","createUserId":1,"delFlag":0,"dutyType":2,"fullScore":100,"id":574375479017473,"params":{},"problemLevelOne":11,"problemLevelTwo":11,"rule":"11","status":1,"updateBy":"admin","updateTime":"2023-12-29 11:24:04"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 11:24:04', 158);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (575141660917762, '考核规则', 2, 'com.ruoyi.postCheck.controller.PostAssessmentRulesController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postAssessmentRules', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-29 11:24:04","createUserId":1,"delFlag":0,"dutyType":2,"fullScore":100,"id":574375479017473,"params":{},"problemLevelOne":12,"problemLevelTwo":10,"rule":"11","status":1,"updateBy":"admin","updateTime":"2023-12-29 11:27:06"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 11:27:07', 47);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (575262033248258, '考核规则', 2, 'com.ruoyi.postCheck.controller.PostAssessmentRulesController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postAssessmentRules', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2023-12-29 11:24:04","createUserId":1,"delFlag":0,"dutyType":2,"fullScore":100,"id":574375479017473,"params":{},"problemLevelOne":10,"problemLevelTwo":10,"rule":"11","status":1,"updateBy":"admin","updateTime":"2023-12-29 11:27:35"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 11:27:35', 15);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (627255087005697, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedPostId":1,"params":{}},{"checkedPostId":2,"params":{}},{"checkedPostId":4,"params":{}},{"checkedPostId":3,"params":{}},{"checkedPostId":1,"params":{}},{"checkedPostId":2,"params":{}},{"checkedPostId":3,"params":{}},{"checkedPostId":4,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 14:54:11","createUserId":1,"delFlag":0,"endTime":"2024-01-28 00:00:00","id":627254503997442,"name":"1","params":{"beginTime":"2023-12-28 00:00:00","endTime":"2024-01-28 00:00:00"},"startTime":"2023-12-28 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 14:54:11"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostPlanMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostPlanMapper.insertPostPlan
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-29 14:54:12', 127);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (627616707313666, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"children":[{"checkedPostId":3,"params":{}},{"checkedPostId":1,"params":{}},{"checkedPostId":2,"params":{}},{"checkedPostId":3,"params":{}}],"content":"","createBy":"admin","createTime":"2023-12-29 14:55:37","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":627616652787713,"name":"","params":{"beginTime":"2023-12-06 00:00:00","endTime":"2024-01-23 00:00:00"},"startTime":"2023-12-06 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 14:55:37"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostPlanMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostPlanMapper.insertPostPlan
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-29 14:55:38', 3);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (628021507981313, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedPostId":4,"params":{}},{"checkedPostId":2,"params":{}},{"checkedPostId":3,"params":{}},{"checkedPostId":1,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 14:57:14","createUserId":1,"delFlag":0,"endTime":"2024-01-15 00:00:00","id":628021382152194,"name":"1","params":{"beginTime":"2023-12-08 00:00:00","endTime":"2024-01-15 00:00:00"},"startTime":"2023-12-08 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 14:57:14"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostPlanMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostPlanMapper.insertPostPlan
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-29 14:57:14', 3);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (628647533019137, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 14:59:43","createUserId":1,"delFlag":0,"endTime":"2024-01-26 00:00:00","id":628647449133057,"name":"1","params":{"beginTime":"2023-12-06 00:00:00","endTime":"2024-01-26 00:00:00"},"startTime":"2023-12-06 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 14:59:43"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostPlanMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostPlanMapper.insertPostPlan
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-29 14:59:44', 3);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (628882661507073, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedPostId":1,"params":{}},{"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:00:39","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":628882611175425,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 15:00:39"}', NULL, 1, 'nested exception is org.apache.ibatis.exceptions.PersistenceException:
### Error updating database.  Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostPlanMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostPlanMapper.insertPostPlan
### The error occurred while executing an update
### Cause: java.lang.IllegalArgumentException: invalid comparison: java.util.Date and java.lang.String', '2023-12-29 15:00:40', 2);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (630210538774530, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan/', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedPostId":1,"params":{},"postPlanId":630209091739649},{"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:05:55","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":630209091739649,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 15:05:55"}', NULL, 1, '涉及部门和涉及岗位的值为空，请重新选择！', '2023-12-29 15:05:58', 339);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (630880885022722, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan/', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 15:08:33","createUserId":1,"delFlag":0,"id":630866653749250,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 15:08:33"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 15:08:35","createUserId":1,"delFlag":0,"id":630880037773313,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 15:08:35"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":630747556487170,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 15:08:04"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 15:08:38', 31845);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (633983677616129, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 15:20:55","createUserId":1,"delFlag":0,"id":633982901669889,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 15:20:55"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 15:20:55","createUserId":1,"delFlag":0,"id":633983186882561,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 15:20:55"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:20:55","createUserId":1,"delFlag":0,"endTime":"2024-01-26 00:00:00","id":633982612262913,"name":"1","params":{},"startTime":"2023-12-06 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 15:20:55"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 15:20:56', 260);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (654662812684290, '岗检计划', 3, 'com.ruoyi.postCheck.controller.PostPlanController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postPlan/1', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 16:43:06', 94);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (654684425932801, '岗检计划', 3, 'com.ruoyi.postCheck.controller.PostPlanController.remove()', 'DELETE', 1, 'admin', '研发部门', '/postCheck/postPlan/2', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 16:43:11', 38);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (655300581773314, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":30,"children":[{"checkedDeptId":103,"checkedPostId":1,"params":{}},{"checkedDeptId":103,"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"id":630747556487170,"name":"1","params":{},"status":1,"updateBy":"admin","updateTime":"2023-12-29 16:45:38"}', NULL, 1, 'nested exception is org.apache.ibatis.builder.BuilderException: Error evaluating expression ''updateTime != null and''. Cause: org.apache.ibatis.ognl.ExpressionSyntaxException: Malformed OGNL expression: updateTime != null and [org.apache.ibatis.ognl.ParseException: Encountered "<EOF>" at line 1, column 22.
Was expecting one of:
    ":" ...
    "not" ...
    "+" ...
    "-" ...
    "~" ...
    "!" ...
    "(" ...
    "true" ...
    "false" ...
    "null" ...
    "#this" ...
    "#root" ...
    "#" ...
    "[" ...
    "{" ...
    "@" ...
    "new" ...
    <IDENT> ...
    <DYNAMIC_SUBSCRIPT> ...
    "\''" ...
    "`" ...
    "\"" ...
    <INT_LITERAL> ...
    <FLT_LITERAL> ...
    ]', '2023-12-29 16:45:38', 33);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (655839541448705, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"params":{}},{"checkedDeptId":103,"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"id":630747556487170,"name":"1","params":{},"status":1,"updateBy":"admin","updateTime":"2023-12-29 16:47:46"}', NULL, 1, 'nested exception is org.apache.ibatis.builder.BuilderException: Error evaluating expression ''updateTime != null and''. Cause: org.apache.ibatis.ognl.ExpressionSyntaxException: Malformed OGNL expression: updateTime != null and [org.apache.ibatis.ognl.ParseException: Encountered "<EOF>" at line 1, column 22.
Was expecting one of:
    ":" ...
    "not" ...
    "+" ...
    "-" ...
    "~" ...
    "!" ...
    "(" ...
    "true" ...
    "false" ...
    "null" ...
    "#this" ...
    "#root" ...
    "#" ...
    "[" ...
    "{" ...
    "@" ...
    "new" ...
    <IDENT> ...
    <DYNAMIC_SUBSCRIPT> ...
    "\''" ...
    "`" ...
    "\"" ...
    <INT_LITERAL> ...
    <FLT_LITERAL> ...
    ]', '2023-12-29 16:47:47', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (658833129459713, '岗检计划', 1, 'com.ruoyi.postCheck.controller.PostPlanController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 16:59:40","createUserId":1,"delFlag":0,"id":658832802304002,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 16:59:40"},{"checkedDeptId":109,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 16:59:40","createUserId":1,"delFlag":0,"id":658832957493249,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 16:59:40"}],"content":"1","createBy":"admin","createTime":"2023-12-29 16:59:40","createUserId":1,"delFlag":0,"endTime":"2023-12-06 00:00:00","id":658832693252098,"name":"1","params":{},"startTime":"2023-11-29 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 16:59:40"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 16:59:40', 93);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (659386051973121, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"params":{}},{"checkedDeptId":103,"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"id":630747556487170,"name":"1","params":{},"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:01:52"}', NULL, 1, 'nested exception is org.apache.ibatis.builder.BuilderException: Error evaluating expression ''updateTime != null and''. Cause: org.apache.ibatis.ognl.ExpressionSyntaxException: Malformed OGNL expression: updateTime != null and [org.apache.ibatis.ognl.ParseException: Encountered "<EOF>" at line 1, column 22.
Was expecting one of:
    ":" ...
    "not" ...
    "+" ...
    "-" ...
    "~" ...
    "!" ...
    "(" ...
    "true" ...
    "false" ...
    "null" ...
    "#this" ...
    "#root" ...
    "#" ...
    "[" ...
    "{" ...
    "@" ...
    "new" ...
    <IDENT> ...
    <DYNAMIC_SUBSCRIPT> ...
    "\''" ...
    "`" ...
    "\"" ...
    <INT_LITERAL> ...
    <FLT_LITERAL> ...
    ]', '2023-12-29 17:01:52', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (660066779123713, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"params":{}},{"checkedDeptId":103,"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":630747556487170,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:04:34"}', NULL, 1, 'nested exception is org.apache.ibatis.builder.BuilderException: Error evaluating expression ''updateTime != null and''. Cause: org.apache.ibatis.ognl.ExpressionSyntaxException: Malformed OGNL expression: updateTime != null and [org.apache.ibatis.ognl.ParseException: Encountered "<EOF>" at line 1, column 22.
Was expecting one of:
    ":" ...
    "not" ...
    "+" ...
    "-" ...
    "~" ...
    "!" ...
    "(" ...
    "true" ...
    "false" ...
    "null" ...
    "#this" ...
    "#root" ...
    "#" ...
    "[" ...
    "{" ...
    "@" ...
    "new" ...
    <IDENT> ...
    <DYNAMIC_SUBSCRIPT> ...
    "\''" ...
    "`" ...
    "\"" ...
    <INT_LITERAL> ...
    <FLT_LITERAL> ...
    ]', '2023-12-29 17:04:35', 3);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (660306554900481, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"params":{}},{"checkedDeptId":103,"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":630747556487170,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:05:31"}', NULL, 1, 'nested exception is org.apache.ibatis.builder.BuilderException: Error evaluating expression ''updateTime != null and''. Cause: org.apache.ibatis.ognl.ExpressionSyntaxException: Malformed OGNL expression: updateTime != null and [org.apache.ibatis.ognl.ParseException: Encountered "<EOF>" at line 1, column 22.
Was expecting one of:
    ":" ...
    "not" ...
    "+" ...
    "-" ...
    "~" ...
    "!" ...
    "(" ...
    "true" ...
    "false" ...
    "null" ...
    "#this" ...
    "#root" ...
    "#" ...
    "[" ...
    "{" ...
    "@" ...
    "new" ...
    <IDENT> ...
    <DYNAMIC_SUBSCRIPT> ...
    "\''" ...
    "`" ...
    "\"" ...
    <INT_LITERAL> ...
    <FLT_LITERAL> ...
    ]', '2023-12-29 17:05:32', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (660767159123970, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"params":{}},{"checkedDeptId":103,"checkedPostId":2,"params":{}}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"id":630747556487170,"name":"1","params":{},"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:07:17"}', NULL, 1, 'nested exception is org.apache.ibatis.builder.BuilderException: Error evaluating expression ''updateTime != null and''. Cause: org.apache.ibatis.ognl.ExpressionSyntaxException: Malformed OGNL expression: updateTime != null and [org.apache.ibatis.ognl.ParseException: Encountered "<EOF>" at line 1, column 22.
Was expecting one of:
    ":" ...
    "not" ...
    "+" ...
    "-" ...
    "~" ...
    "!" ...
    "(" ...
    "true" ...
    "false" ...
    "null" ...
    "#this" ...
    "#root" ...
    "#" ...
    "[" ...
    "{" ...
    "@" ...
    "new" ...
    <IDENT> ...
    <DYNAMIC_SUBSCRIPT> ...
    "\''" ...
    "`" ...
    "\"" ...
    <INT_LITERAL> ...
    <FLT_LITERAL> ...
    ]', '2023-12-29 17:07:25', 8096);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (664796572442625, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:23:18","createUserId":1,"delFlag":0,"id":664781238067202,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:23:18"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:23:20","createUserId":1,"delFlag":0,"id":664789626675201,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:23:20"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"id":630747556487170,"name":"1","params":{},"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:22:57"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:23:24', 31622);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (667814816227329, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:35:21","createUserId":1,"delFlag":0,"id":667814019309569,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:21"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:35:21","createUserId":1,"delFlag":0,"id":667814203858946,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:21"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:35:21","createUserId":1,"delFlag":0,"id":667814279356417,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:21"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:20:56","createUserId":1,"delFlag":0,"endTime":"2024-01-26 00:00:00","id":633982612262913,"name":"1","params":{},"startTime":"2023-12-06 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:21"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:35:22', 290);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (667852346859521, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":109,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:35:30","createUserId":1,"delFlag":0,"id":667851956789250,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:30"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:35:30","createUserId":1,"delFlag":0,"id":667852049063937,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:30"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:35:30","createUserId":1,"delFlag":0,"id":667852141338625,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:30"}],"content":"1","createBy":"admin","createTime":"2023-12-29 16:59:40","createUserId":1,"delFlag":0,"endTime":"2023-12-06 00:00:00","id":658832693252098,"name":"1","params":{},"startTime":"2023-11-29 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:30"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:35:31', 116);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (667890812821505, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:35:39","createUserId":1,"delFlag":0,"id":667890611494914,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:39"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:35:39","createUserId":1,"delFlag":0,"id":667890611494915,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:39"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:35:39","createUserId":1,"delFlag":0,"id":667890682798082,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:39"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":630747556487170,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:39"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:35:40', 61);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (667949180755969, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:35:53","createUserId":1,"delFlag":0,"id":667948807462914,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:53"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:35:53","createUserId":1,"delFlag":0,"id":667948853600257,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:53"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:35:53","createUserId":1,"delFlag":0,"id":667948903931906,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:53"},{"checkedDeptId":109,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:35:53","createUserId":1,"delFlag":0,"id":667948954263553,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:53"},{"checkedDeptId":109,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:35:53","createUserId":1,"delFlag":0,"id":667949000400898,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:53"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:20:56","createUserId":1,"delFlag":0,"endTime":"2024-01-26 00:00:00","id":633982612262913,"name":"1","params":{},"startTime":"2023-12-06 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:35:53"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:35:54', 98);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (667978465386497, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:36:00","createUserId":1,"delFlag":0,"id":667978083704834,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:36:00"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:36:00","createUserId":1,"delFlag":0,"id":667978180173825,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:36:00"},{"checkedDeptId":109,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:36:00","createUserId":1,"delFlag":0,"id":667978272448514,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:36:00"},{"checkedDeptId":109,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:36:00","createUserId":1,"delFlag":0,"id":667978318585857,"params":{},"postPlanId":658832693252098,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:36:00"}],"content":"1","createBy":"admin","createTime":"2023-12-29 16:59:40","createUserId":1,"delFlag":0,"endTime":"2023-12-06 00:00:00","id":658832693252098,"name":"1","params":{},"startTime":"2023-11-29 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:36:00"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:36:01', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (668300323692545, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:37:17","createUserId":1,"delFlag":0,"id":668299929427969,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:17"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:37:17","createUserId":1,"delFlag":0,"id":668299988148225,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:17"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:37:17","createUserId":1,"delFlag":0,"id":668300080422914,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:17"},{"checkedDeptId":108,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:37:17","createUserId":1,"delFlag":0,"id":668300130754562,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:17"},{"checkedDeptId":108,"checkedPostId":4,"createBy":"admin","createTime":"2023-12-29 17:37:17","createUserId":1,"delFlag":0,"id":668300210446338,"params":{},"postPlanId":630747556487170,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:17"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:08:04","createUserId":1,"delFlag":0,"endTime":"2024-01-23 00:00:00","id":630747556487170,"name":"1","params":{},"startTime":"2023-12-05 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:17"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:37:18', 148);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (668472105607169, '岗检计划', 2, 'com.ruoyi.postCheck.controller.PostPlanController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan', '127.0.0.1', '内网IP', '{"checkGroupId":20,"checkTeamId":251079386578945,"children":[{"checkedDeptId":103,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:37:58","createUserId":1,"delFlag":0,"id":668471627456514,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"},{"checkedDeptId":103,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:37:58","createUserId":1,"delFlag":0,"id":668471803617281,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"},{"checkedDeptId":103,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:37:58","createUserId":1,"delFlag":0,"id":668471845560321,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"},{"checkedDeptId":109,"checkedPostId":1,"createBy":"admin","createTime":"2023-12-29 17:37:58","createUserId":1,"delFlag":0,"id":668471912669185,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"},{"checkedDeptId":109,"checkedPostId":2,"createBy":"admin","createTime":"2023-12-29 17:37:58","createUserId":1,"delFlag":0,"id":668471912669186,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"},{"checkedDeptId":109,"checkedPostId":3,"createBy":"admin","createTime":"2023-12-29 17:37:58","createUserId":1,"delFlag":0,"id":668471975583745,"params":{},"postPlanId":633982612262913,"status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"}],"content":"1","createBy":"admin","createTime":"2023-12-29 15:20:56","createUserId":1,"delFlag":0,"endTime":"2024-01-26 00:00:00","id":633982612262913,"name":"1","params":{},"startTime":"2023-12-06 00:00:00","status":1,"updateBy":"admin","updateTime":"2023-12-29 17:37:58"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-29 17:37:58', 99);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (823227450765313, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_assessment_rating_other_info,post_assessment_rating_other"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-01 22:06:36', 1927);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (824275447951361, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRatingOther","className":"PostAssessmentRatingOther","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":823220429500418,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":823219565473793,"updateBy":"","usableColumn":false},{"capJavaField":"Type","columnComment":"类型：1-职能互评；2-生产日常；","columnId":823220752461825,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"type","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":823219565473793,"updateBy":"","usableColumn":false},{"capJavaField":"BatchId","columnComment":"批次号（管理员创建的）","columnId":823220953788417,"columnName":"batch_id","columnType":"varchar","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"batchId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":823219565473793,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"评分开始时间（管理员创建的）","columnId":823221155115009,"columnName":"start_time","columnType":"USER-DEFINED","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"increment":false,"inse', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-01 22:10:46', 1008);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (824609494904834, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRatingOtherInfo","className":"PostAssessmentRatingOtherInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":823224183402497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":823223722029058,"updateBy":"","usableColumn":false},{"capJavaField":"RatingOtherId","columnComment":"rating_other_id","columnId":823224380534786,"columnName":"rating_other_id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"ratingOtherId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":823223722029058,"updateBy":"","usableColumn":false},{"capJavaField":"DutyType","columnComment":"duty_type","columnId":823224581861378,"columnName":"duty_type","columnType":"integer","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"dutyType","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":823223722029058,"updateBy":"","usableColumn":false},{"capJavaField":"ScoreWeight","columnComment":"score_weight","columnId":823224711884802,"columnName":"score_weight","columnType":"numeric","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":t', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-01 22:12:06', 857);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (824753439223810, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRatingOther","className":"PostAssessmentRatingOther","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":823220429500418,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":823219565473793,"updateBy":"","updateTime":"2024-01-01 22:10:45","usableColumn":false},{"capJavaField":"Type","columnComment":"类型：1-职能互评；2-生产日常；","columnId":823220752461825,"columnName":"type","columnType":"integer","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"type","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":823219565473793,"updateBy":"","updateTime":"2024-01-01 22:10:45","usableColumn":false},{"capJavaField":"BatchId","columnComment":"批次号（管理员创建的）","columnId":823220953788417,"columnName":"batch_id","columnType":"varchar","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"batchId","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":823219565473793,"updateBy":"","updateTime":"2024-01-01 22:10:45","usableColumn":false},{"capJavaField":"StartTime","columnComment":"评分开始时间（管理员创建的）","columnId":823221155115009,"columnName":"start_time","columnType":"USER-DEFINED', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-01 22:12:40', 897);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (824807310864385, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRatingOtherInfo","className":"PostAssessmentRatingOtherInfo","columns":[{"capJavaField":"Id","columnComment":"id","columnId":823224183402497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":823223722029058,"updateBy":"","updateTime":"2024-01-01 22:12:05","usableColumn":false},{"capJavaField":"RatingOtherId","columnComment":"rating_other_id","columnId":823224380534786,"columnName":"rating_other_id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"ratingOtherId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":823223722029058,"updateBy":"","updateTime":"2024-01-01 22:12:05","usableColumn":false},{"capJavaField":"DutyType","columnComment":"duty_type","columnId":823224581861378,"columnName":"duty_type","columnType":"integer","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"dutyType","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":823223722029058,"updateBy":"","updateTime":"2024-01-01 22:12:05","usableColumn":false},{"capJavaField":"ScoreWeight","columnComment":"score_weight","columnId":823224711884802,"columnName":"score_we', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-01 22:12:53', 833);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (825715390263297, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postAssessmentRatingOtherInfo","className":"PostAssessmentRatingOtherInfo","columns":[{"capJavaField":"Id","columnComment":"主键","columnId":823224183402497,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":823223722029058,"updateBy":"","updateTime":"2024-01-01 22:12:52","usableColumn":false},{"capJavaField":"RatingOtherId","columnComment":"打分表ID","columnId":823224380534786,"columnName":"rating_other_id","columnType":"bigint","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"ratingOtherId","javaType":"Long","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":2,"superColumn":false,"tableId":823223722029058,"updateBy":"","updateTime":"2024-01-01 22:12:52","usableColumn":false},{"capJavaField":"DutyType","columnComment":"评分分类/项目/专业：职责类别：1-业务职责；2-党建及党风廉政；3-安全环保职责；4-合规与保密职责；5-任职资格与能力素质要求；6-岗位责任制文件完整性与适宜性；10-工作态度；11-部门协作；13-廉洁从业；14-主要工作完成情况；20-HSE；21-生产；22-设备；","columnId":823224581861378,"columnName":"duty_type","columnType":"integer","createBy":"admin","createTime":"2024-01-01 22:06:35","dictType":"","edit":true,"htmlType":"select","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"dutyType","javaType":"Integer","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":823223722029058,"updateBy":"","updateTime":"2024-01-01 22:12:52","usableCol', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-01 22:16:30', 875);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (825756356030466, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.batchGenCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/batchGenCode', '127.0.0.1', '内网IP', '{"tables":"post_assessment_rating_other,post_assessment_rating_other_info"}', NULL, 0, NULL, '2024-01-01 22:16:39', 813);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (12647027765249, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-01-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 10:39:15', 85);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (12999512879106, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-01-02 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 10:40:39', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (14192184193026, '岗检方案审核-HR', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveHr()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveHr', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 10:45:23', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (14374648999937, '岗检方案审核-HR', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveHr()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveHr', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 10:46:07', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (14780993171458, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 10:47:44', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (14853764345858, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 10:48:01', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (15157385818113, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 10:49:13', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (15419034890241, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 10:50:16', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (18796173561857, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:03:43', 12);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (18928260583426, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:04:15', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (19117901844482, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:05:00', 27683);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20083254464513, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:08:50', 94530);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (20362175680513, '岗检方案审核-HR', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveHr()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveHr', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:09:57', 45383);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21322899451905, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:13:43', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21552074559489, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:14:40', 20684);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (21640110469122, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:14:59', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (22597794238466, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '{"statusIcfa":"4","reasonIcfa":"PostMan测试一下","id":"658832693252098"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 11:18:50', 80514);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (22639395008514, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '60.25.17.197', 'XX XX', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:18:57', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (24394509905921, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:25:56', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (24446867402754, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:26:08', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (25255164309505, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '{"reasonHr":"","statusHr":"3","id":"630747556487170"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 11:29:21', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (25365143154690, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 11:29:47', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (56784749916162, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '{"reasonIcfa":"","statusIcfa":"3"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 13:34:38', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (56820300836866, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '{"reasonIcfa":"","statusIcfa":"3"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 13:34:46', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (56959203602433, '岗检方案审核-Icfa', 2, 'com.ruoyi.postCheck.controller.PostPlanController.approveIcfa()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlan/approveIcfa', '127.0.0.1', '内网IP', '{"reasonIcfa":"","statusIcfa":"3","id":"630747556487170"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 13:35:20', 27);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (58211564056578, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '{"checkedUserId":"1","checkedTime":"2024-01-02 00:00:00","planInfoId":"667978083704834"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 13:40:18', 20);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (58354736623617, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '{"checkedUserId":"1","checkedTime":"2024-01-03 00:00:00","planInfoId":"667978180173825"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 13:40:52', 17);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (58422285889538, '岗检完成确认后重新上传检查表照片', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.imgReUpload()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/imgReUpload', '127.0.0.1', '内网IP', '{"planInfoId":"667978272448514"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 13:41:08', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (58446206005249, '岗检完成确认后重新上传检查表照片', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.imgReUpload()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/imgReUpload', '127.0.0.1', '内网IP', '{"planInfoId":"667978272448514"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 13:41:14', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (60793665679361, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 13:50:34', 4);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (72233768251394, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-01-01 00:00:00"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 14:36:01', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (72584688889857, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 14:37:25', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (72614682357762, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 14:37:32', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (76667495706626, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 14:53:38', 4);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (81932681015298, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 15:14:34', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (86905326202881, '指定方案填写人', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.setRectificationResponsibleUserId()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/setRectificationResponsibleUserId', '127.0.0.1', '内网IP', '{"id":"1"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 15:34:19', 4);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (87165855395841, '指定方案填写人', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.setRectificationResponsibleUserId()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/setRectificationResponsibleUserId', '127.0.0.1', '内网IP', '{"rectificationResponsibleUserId":"1","id":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 15:35:21', 23);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (87712553562113, '打分表(职能互评生产日常)', 1, 'com.ruoyi.postCheck.controller.PostAssessmentRatingOtherController.batchAddRatingOther()', 'POST', 1, 'admin', '研发部门', '/postCheck/postAssessmentRatingOther/batchAddRatingOther', '127.0.0.1', '内网IP', '{"params":{},"startTime":"2024-02-01 00:00:00","type":1}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 15:37:32', 4);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (95770826534914, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-02T16:00:00.000Z","problemCause":"问题原因","id":"1"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 16:09:33', 9);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (96025693417474, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-16T16:00:00.000Z","problemCause":"问题原因","id":"1"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 16:10:34', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (96194568679425, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-02T16:00:00.000Z","problemCause":"问题原因","id":"1"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 16:11:14', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (96420641665025, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-05","problemCause":"问题原因","id":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 16:12:08', 41);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (96910976774146, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-05 00:00:00","problemCause":"问题原因","id":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 16:14:05', 32);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (97070104473602, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-05 00:00:00","problemCause":"问题原因","id":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 16:14:43', 20);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (170246757367810, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯","description":"测试PostMan添加问题","dutyType":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1"}]', NULL, 1, 'Error attempting to get column ''checkGroupName'' from result set.  Cause: com.kingbase8.util.KSQLException: Bad _value for type long : 综合岗检工作组
; Bad _value for type long : 综合岗检工作组; nested exception is com.kingbase8.util.KSQLException: Bad _value for type long : 综合岗检工作组', '2024-01-02 21:05:32', 56266);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172066242256897, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkUserName":"王凯","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-02 21:12:19","delFlag":0,"description":"测试PostMan添加问题","dutyType":1,"id":171963486003202,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","problemNo":"GJ2024-01-02 21:12:20","updateBy":"admin","updateTime":"2024-01-02 21:12:19"}]', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "check_user_id" 中空值违反了非空约束
  Detail: 失败, 行包含(171963486003202, 1, GJ2024-01-02 21:12:20, 20, 251079386578945, null, null, null, null, null, 1, 1, 1, 测试PostMan添加问题, null, null, null, 103, null, null, null, null, null, null, null, null, null, null, null, 0, 2024-01-02 21:12:19, admin, 2024-01-02 21:12:19, admin, null, null, 1, 王凯).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-postcheck\target\classes\mapper\postCheck\PostCheckedProblemMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostCheckedProblemMapper.insertPostCheckedProblem-Inline
### The error occurred while setting parameters
### SQL: insert into post_checked_problem          ( id,                          problem_no,             check_workgroup_id,             check_group_id,                          check_user_name,                                                                 problem_level,             problem_attribute,             problem_category,             description,                                                    checked_dept_id,                                                                                                                                                            del_flag,             create_time,             create_by,             update_time,             update_by,                                       duty_type )           values ( ?,                          ?,             ?,             ?,                          ?,                                                                 ?,             ?,             ?,             ?,                                                    ?,                                                                                                                                                            ?,             ?,             ?,             ?,             ?,                                       ? )
#', '2024-01-02 21:12:46', 165509);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (172821024038914, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkUserName":"王凯","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-02 21:14:59","delFlag":0,"description":"测试PostMan添加问题","dutyType":1,"id":172637611319298,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","problemNo":"GJ2024-01-02 21:14:59","updateBy":"admin","updateTime":"2024-01-02 21:14:59"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 21:15:46', 58268);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (174594312855553, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题","dutyType":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","updateBy":"admin","updateTime":"2024-01-02 21:22:45"}]', NULL, 1, 'nested exception is org.apache.ibatis.reflection.ReflectionException: There is no getter for property named ''checkUserId'' in ''class com.ruoyi.postCheck.domain.PostCheckedProblem''', '2024-01-02 21:22:50', 17);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (175274025029634, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题","dutyType":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","updateBy":"admin","updateTime":"2024-01-02 21:25:27"}]', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 21:25:31', 522);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (175566393184258, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题","dutyType":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","updateBy":"admin","updateTime":"2024-01-02 21:26:33"}]', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 21:26:40', 23137);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (176762738708481, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题","dutyType":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","updateBy":"admin","updateTime":"2024-01-02 21:31:22"}]', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-02 21:31:26', 188);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (177171830132737, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题","dutyType":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1"}]', NULL, 1, 'id为空请检查！', '2024-01-02 21:33:03', 196);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (177295683735554, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题","dutyType":1,"id":172637611319298,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","updateBy":"admin","updateTime":"2024-01-02 21:33:29"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 21:33:33', 141);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (178209656131586, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkUserName":"王凯·乔曦","description":"测试PostMan修改问题V2","dutyType":1,"id":172637611319298,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","updateBy":"admin","updateTime":"2024-01-02 21:37:04"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-02 21:37:11', 14144);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (357248716517378, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 09:28:33","delFlag":0,"id":357246539673602,"params":{},"planInfoId":667978083704834,"problemCategory":"3","problemLevel":"1","problemNo":"GJ-2024-01-03 09:28:33","updateBy":"admin","updateTime":"2024-01-03 09:28:33"}]', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "problem_attribute" 中空值违反了非空约束
  Detail: 失败, 行包含(357246539673602, 1, GJ-2024-01-03 09:28:33, 20, 251079386578945, null, null, null, null, null, 1, null, 3, null, null, null, null, 103, null, null, null, null, null, null, null, null, null, null, null, 0, 2024-01-03 09:28:34, admin, 2024-01-03 09:28:34, admin, null, null, null, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostCheckedProblemMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostCheckedProblemMapper.insertPostCheckedProblem-Inline
### The error occurred while setting parameters
### SQL: insert into post_checked_problem          ( id,                          problem_no,             check_workgroup_id,             check_group_id,                                                                                           problem_level,                          problem_category,                                                                 checked_dept_id,                                                                                                                                                            del_flag,             create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                                                                                           ?,                          ?,                                                                 ?,                                                                                                                                                            ?,             ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "problem_attribute" 中空值违反了非空约束
  Detail: 失败, 行包含(357246539673602, 1,', '2024-01-03 09:28:34', 508);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (359339375734785, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 09:36:52","delFlag":0,"id":359339216351234,"params":{},"planInfoId":667978083704834,"problemCategory":"","problemLevel":"","problemNo":"GJ-2024-01-03 09:36:52","updateBy":"admin","updateTime":"2024-01-03 09:36:52"}]', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "problem_level" 中空值违反了非空约束
  Detail: 失败, 行包含(359339216351234, 1, GJ-2024-01-03 09:36:52, 20, 251079386578945, null, null, null, null, null, null, null, null, null, null, null, null, 103, null, null, null, null, null, null, null, null, null, null, null, 0, 2024-01-03 09:36:53, admin, 2024-01-03 09:36:53, admin, null, null, null, null).
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostCheckedProblemMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostCheckedProblemMapper.insertPostCheckedProblem-Inline
### The error occurred while setting parameters
### SQL: insert into post_checked_problem          ( id,                          problem_no,             check_workgroup_id,             check_group_id,                                                                                                                                                                                      checked_dept_id,                                                                                                                                                            del_flag,             create_time,             create_by,             update_time,             update_by )           values ( ?,                          ?,             ?,             ?,                                                                                                                                                                                      ?,                                                                                                                                                            ?,             ?,             ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "problem_level" 中空值违反了非空约束
  Detail: 失败, 行包含(359339216351234, 1, GJ-2024-01-03 09:36:52, 20, 25107938', '2024-01-03 09:36:53', 51);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (359481545863169, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkUserName":"李","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 09:37:26","delFlag":0,"description":"1","dutyType":2,"id":359481336147969,"params":{},"planInfoId":667978083704834,"problemAttribute":2,"problemCategory":"2","problemLevel":"1","problemNo":"GJ-2024-01-03 09:37:26","updateBy":"admin","updateTime":"2024-01-03 09:37:26"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 09:37:27', 95);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (367960033603586, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":1,"checkWorkgroupId":1,"checkedDeptId":1,"checkedPostId":1,"createBy":"","createTime":"2023-12-31 00:00:00","delFlag":0,"deptApproveTime":"2023-12-31 00:00:00","deptApproveUserId":1,"description":"问题描述","id":1,"isImmediatelyCorrected":1,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemCause":"问题原因","problemLevel":"1","problemNo":"GH-001-问题编号","rectificationMeasure":"整改措施","rectificationPeriod":"2024-01-05 00:00:00","rectificationResponsibleUserId":1,"specialityDepartmentReviewTime":"2023-12-31 00:00:00","specialityDepartmentReviewerId":1,"status":2,"updateBy":"admin","updateTime":"2024-01-03 10:11:07"},{"checkGroupId":251079386578945,"checkUserName":"王凯·乔曦","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-02 21:15:00","delFlag":0,"description":"测试PostMan修改问题V2","dutyType":1,"id":172637611319298,"params":{},"planInfoId":667978083704834,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","problemNo":"GJ2024-01-02 21:14:59","status":1,"updateBy":"admin","updateTime":"2024-01-03 10:11:07"},{"checkGroupId":251079386578945,"checkUserName":"李","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 09:37:26","delFlag":0,"description":"1","dutyType":2,"id":359481336147969,"params":{},"planInfoId":667978083704834,"problemAttribute":2,"problemCategory":"2","problemLevel":"1","problemNo":"GJ-2024-01-03 09:37:26","status":1,"updateBy":"admin","updateTime":"2024-01-03 10:11:07"},{"checkUserName":"呀","description":"1","dutyType":3,"params":{},"planInfoId":667978083704834,"problemAttribute":3,"problemCategory":"4","problemLevel":"1"}]', NULL, 1, 'id为空请检查！', '2024-01-03 10:11:08', 70);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (368384199372802, '岗检完成确认', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.checked()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/checked', '127.0.0.1', '内网IP', '{"checkedUserId":"1","checkedTime":"2024-01-11 00:00:00","planInfoId":"667978083704834"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 10:12:49', 10);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (368406710202369, '岗检完成确认后重新上传检查表照片', 2, 'com.ruoyi.postCheck.controller.PostPlanJoinCheckedController.imgReUpload()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postPlanJoinChecked/imgReUpload', '127.0.0.1', '内网IP', '{"planInfoId":"667978180173825"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-03 10:12:54', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (425097963253761, '审核1：部门经理审核', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.setDeptApproveTime()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/setDeptApproveTime', '127.0.0.1', '内网IP', '{"reason":"","checkUserName":"","status":"10"}', '{"msg":"操作失败","code":500}', 0, NULL, '2024-01-03 13:58:11', 0);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (439533440610306, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2024-01-03 14:55:32","delFlag":0,"diskPath":"2024岗检.xlsx","id":493656286097409,"name":"page2024年方案V2","params":{},"status":1,"statusHr":1,"submitDate":"2024-01-03 14:55:32","updateBy":"admin","updateTime":"2024-01-03 14:55:32"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.insertPostProgramme-Inline
### The error occurred while setting parameters
### SQL: insert into post_programme          ( id,             name,             submit_date,             status_hr,                                                                                                        create_time,             create_by,             update_time,             update_by,                          disk_path,                                       status )           values ( ?,             ?,             ?,             ?,                                                                                                        ?,             ?,             ?,             ?,                          ?,                                       ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在
; 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在; nested exception is com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在', '2024-01-03 14:55:32', 62);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (439572472803329, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2024-01-03 14:55:41","delFlag":0,"diskPath":"2024岗检.xlsx","id":493656286097409,"name":"page2024年方案V2","params":{},"status":1,"statusHr":1,"submitDate":"2024-01-03 14:55:41","updateBy":"admin","updateTime":"2024-01-03 14:55:41"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.insertPostProgramme-Inline
### The error occurred while setting parameters
### SQL: insert into post_programme          ( id,             name,             submit_date,             status_hr,                                                                                                        create_time,             create_by,             update_time,             update_by,                          disk_path,                                       status )           values ( ?,             ?,             ?,             ?,                                                                                                        ?,             ?,             ?,             ?,                          ?,                                       ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在
; 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在; nested exception is com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(493656286097409)" 已经存在', '2024-01-03 14:55:42', 9);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (439602235584513, '岗检方案', 1, 'com.ruoyi.postCheck.controller.PostProgrammeController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/programme', '127.0.0.1', '内网IP', '{"createBy":"admin","createTime":"2024-01-03 14:55:48","delFlag":0,"deptName":"人力资源部门","diskPath":"2024岗检方案.xlsx","id":831574462164993,"name":"2024岗检方案","params":{},"reasonIcfa":"不通过","status":1,"statusHr":1,"statusTime":"2024-01-02 12:03:04","submitDate":"2024-01-03 14:55:48","updateBy":"admin","updateTime":"2024-01-03 14:55:48"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(831574462164993)" 已经存在
### The error may exist in URL [jar:file:/C:/gnhz/postcheck/jar/ruoyi-admin.jar!/BOOT-INF/lib/ruoyi-postcheck-3.8.7.jar!/mapper/postCheck/PostProgrammeMapper.xml]
### The error may involve com.ruoyi.postCheck.mapper.PostProgrammeMapper.insertPostProgramme-Inline
### The error occurred while setting parameters
### SQL: insert into post_programme          ( id,             name,             submit_date,             status_hr,                                                                 reason_icfa,                                       create_time,             create_by,             update_time,             update_by,                          disk_path,                          dept_name,             status,             status_time )           values ( ?,             ?,             ?,             ?,                                                                 ?,                                       ?,             ?,             ?,             ?,                          ?,                          ?,             ?,             ? )
### Cause: com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(831574462164993)" 已经存在
; 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(831574462164993)" 已经存在; nested exception is com.kingbase8.util.KSQLException: 错误: 重复键违反唯一约束"PRIMARY_3B6D5038_61CFC714_59AF6D50"
  Detail: 键值"(id)=(831574462164993)" 已经存在', '2024-01-03 14:55:50', 108);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (469561025032194, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkUserName":"1","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 16:54:51","delFlag":0,"description":"1","dutyType":4,"id":469559842238466,"params":{},"planInfoId":667978180173825,"problemAttribute":3,"problemCategory":"4","problemLevel":"2","problemNo":"GJ-2024-01-03 16:54:51","updateBy":"admin","updateTime":"2024-01-03 16:54:51"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 16:54:52', 318);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (469561553514497, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":1,"checkWorkgroupId":1,"checkedDeptId":1,"checkedPostId":1,"createBy":"","createTime":"2023-12-31 00:00:00","delFlag":0,"deptApproveTime":"2023-12-31 00:00:00","deptApproveUserId":1,"description":"问题描述","id":1,"isImmediatelyCorrected":1,"params":{},"planInfoId":667978180173825,"problemAttribute":1,"problemCategory":"1","problemCause":"问题原因","problemLevel":"1","problemNo":"GH-001-问题编号","rectificationMeasure":"整改措施","rectificationPeriod":"2024-01-05 00:00:00","rectificationResponsibleUserId":1,"specialityDepartmentReviewTime":"2023-12-31 00:00:00","specialityDepartmentReviewerId":1,"status":2,"updateBy":"admin","updateTime":"2024-01-03 16:54:51"},{"checkGroupId":251079386578945,"checkUserName":"王凯·乔曦","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-02 21:15:00","delFlag":0,"description":"测试PostMan修改问题V2","dutyType":1,"id":172637611319298,"params":{},"planInfoId":667978180173825,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","problemNo":"GJ2024-01-02 21:14:59","status":1,"updateBy":"admin","updateTime":"2024-01-03 16:54:51"},{"checkGroupId":251079386578945,"checkUserName":"李","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 09:37:26","delFlag":0,"description":"1","dutyType":2,"id":359481336147969,"params":{},"planInfoId":667978180173825,"problemAttribute":2,"problemCategory":"2","problemLevel":"1","problemNo":"GJ-2024-01-03 09:37:26","status":1,"updateBy":"admin","updateTime":"2024-01-03 16:54:51"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 16:54:52', 429);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (469756626399234, '岗检问题表', 1, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.add()', 'POST', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkUserName":"1","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 16:55:38","delFlag":0,"description":"2","dutyType":3,"id":469756232134657,"params":{},"planInfoId":667978180173825,"problemAttribute":2,"problemCategory":"4","problemLevel":"2","problemNo":"GJ-2024-01-03 16:55:38","updateBy":"admin","updateTime":"2024-01-03 16:55:38"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 16:55:38', 91);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (469756626399235, '岗检问题表', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.edit()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem', '127.0.0.1', '内网IP', '[{"checkGroupId":251079386578945,"checkUserName":"1","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 16:54:51","delFlag":0,"description":"1","dutyType":4,"id":469559842238466,"params":{},"planInfoId":667978180173825,"problemAttribute":3,"problemCategory":"4","problemLevel":"2","problemNo":"GJ-2024-01-03 16:54:51","status":1,"updateBy":"admin","updateTime":"2024-01-03 16:55:38"},{"checkGroupId":1,"checkWorkgroupId":1,"checkedDeptId":1,"checkedPostId":1,"createBy":"","createTime":"2023-12-31 00:00:00","delFlag":0,"deptApproveTime":"2023-12-31 00:00:00","deptApproveUserId":1,"description":"问题描述","id":1,"isImmediatelyCorrected":1,"params":{},"planInfoId":667978180173825,"problemAttribute":1,"problemCategory":"1","problemCause":"问题原因","problemLevel":"1","problemNo":"GH-001-问题编号","rectificationMeasure":"整改措施","rectificationPeriod":"2024-01-05 00:00:00","rectificationResponsibleUserId":1,"specialityDepartmentReviewTime":"2023-12-31 00:00:00","specialityDepartmentReviewerId":1,"status":2,"updateBy":"admin","updateTime":"2024-01-03 16:55:38"},{"checkGroupId":251079386578945,"checkUserName":"王凯·乔曦","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-02 21:15:00","delFlag":0,"description":"测试PostMan修改问题V2","dutyType":1,"id":172637611319298,"params":{},"planInfoId":667978180173825,"problemAttribute":1,"problemCategory":"1","problemLevel":"1","problemNo":"GJ2024-01-02 21:14:59","status":1,"updateBy":"admin","updateTime":"2024-01-03 16:55:38"},{"checkGroupId":251079386578945,"checkUserName":"李","checkWorkgroupId":20,"checkedDeptId":103,"createBy":"admin","createTime":"2024-01-03 09:37:26","delFlag":0,"description":"1","dutyType":2,"id":359481336147969,"params":{},"planInfoId":667978180173825,"problemAttribute":2,"problemCategory":"2","problemLevel":"1","problemNo":"GJ-2024-01-03 09:37:26","status":1,"updateBy":"admin","updateTime":"2024-01-03 16:55:38"}]', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 16:55:38', 78);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (470180578258946, '指定专业部门的审核人', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.setSpecialityDepartmentReviewerId()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/setSpecialityDepartmentReviewerId', '127.0.0.1', '内网IP', '{"specialityDepartmentReviewerId":"1","id":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 16:57:19', 49);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (470182356643841, '方案整改', 2, 'com.ruoyi.postCheck.controller.PostCheckedProblemController.updateRectificationMeasure()', 'PUT', 1, 'admin', '研发部门', '/postCheck/postCheckedProblem/updateRectificationMeasure', '127.0.0.1', '内网IP', '{"isImmediatelyCorrected":"1","rectificationMeasure":"整改措施","rectificationResponsibleUserId":"1","rectificationPeriod":"2024-01-05 00:00:00","problemCause":"问题原因","id":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2024-01-03 16:57:20', 15);


--
-- TOC entry 8539 (class 0 OID 17096)
-- Dependencies: 593
-- Data for Name: sys_post; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (1, 'ceo', '董事长', 1, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (2, 'se', '项目经理', 2, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (3, 'hr', '人力资源', 3, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (4, 'user', '普通员工', 4, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');


--
-- TOC entry 8544 (class 0 OID 17141)
-- Dependencies: 598
-- Data for Name: sys_role; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_role (role_id, role_name, role_key, role_sort, data_scope, menu_check_strictly, dept_check_strictly, status, del_flag, create_by, create_time, update_by, update_time, remark) VALUES (1, '超级管理员', 'admin', 1, '1', 1, 1, '0', '0', 'admin', '2023-12-11 13:16:57', '', NULL, '超级管理员');
INSERT INTO public.sys_role (role_id, role_name, role_key, role_sort, data_scope, menu_check_strictly, dept_check_strictly, status, del_flag, create_by, create_time, update_by, update_time, remark) VALUES (2, '普通角色', 'common', 2, '2', 1, 1, '0', '0', 'admin', '2023-12-11 13:16:57', '', NULL, '普通角色');


--
-- TOC entry 8533 (class 0 OID 17040)
-- Dependencies: 587
-- Data for Name: sys_role_dept; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_role_dept (role_id, dept_id) VALUES (2, 100);
INSERT INTO public.sys_role_dept (role_id, dept_id) VALUES (2, 101);
INSERT INTO public.sys_role_dept (role_id, dept_id) VALUES (2, 105);


--
-- TOC entry 8552 (class 0 OID 17217)
-- Dependencies: 606
-- Data for Name: sys_role_menu; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 2);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 3);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 4);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 100);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 101);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 102);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 103);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 104);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 105);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 106);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 107);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 108);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 109);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 110);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 111);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 112);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 113);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 114);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 115);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 116);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 117);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 500);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 501);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1000);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1001);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1002);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1003);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1004);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1005);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1006);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1007);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1008);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1009);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1010);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1011);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1012);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1013);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1014);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1015);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1016);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1017);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1018);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1019);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1020);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1021);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1022);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1023);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1024);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1025);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1026);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1027);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1028);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1029);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1030);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1031);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1032);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1033);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1034);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1035);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1036);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1037);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1038);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1039);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1040);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1041);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1042);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1043);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1044);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1045);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1046);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1047);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1048);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1049);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1050);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1051);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1052);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1053);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1054);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1055);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1056);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1057);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1058);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1059);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1060);


--
-- TOC entry 8542 (class 0 OID 17122)
-- Dependencies: 596
-- Data for Name: sys_user_post; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_user_post (user_id, post_id) VALUES (1, 1);
INSERT INTO public.sys_user_post (user_id, post_id) VALUES (2, 2);


--
-- TOC entry 8546 (class 0 OID 17153)
-- Dependencies: 600
-- Data for Name: sys_user_role; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_user_role (user_id, role_id) VALUES (1, 1);
INSERT INTO public.sys_user_role (user_id, role_id) VALUES (2, 2);


--
-- TOC entry 8543 (class 0 OID 17125)
-- Dependencies: 597
-- Data for Name: sys_users; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_users (user_id, dept_id, user_name, nick_name, user_type, email, phonenumber, sex, avatar, password, status, del_flag, login_ip, login_date, create_by, create_time, update_by, update_time, remark) VALUES (1, 103, 'admin', '若依', '00', 'ry@163.com', '15888888888', '1', '', '$2a$10$7JB720yubVSZvUI0rEqK/.VqGOZTH.ulu33dHOiBE8ByOhJIrdAu2', '0', '0', '127.0.0.1', '2024-01-03 17:02:39', 'admin', '2023-12-11 13:16:57', '', '2024-01-03 17:02:39', '管理员');
INSERT INTO public.sys_users (user_id, dept_id, user_name, nick_name, user_type, email, phonenumber, sex, avatar, password, status, del_flag, login_ip, login_date, create_by, create_time, update_by, update_time, remark) VALUES (2, 105, 'ry', '测试人员', '00', 'ry@qq.com', '15666666666', '1', '', '$2a$10$7JB720yubVSZvUI0rEqK/.VqGOZTH.ulu33dHOiBE8ByOhJIrdAu2', '0', '0', '127.0.0.1', '2023-12-11 13:16:57', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-26 09:27:43', '测试员');


--
-- TOC entry 8058 (class 2606 OID 17269)
-- Name: qrtz_paused_trigger_grps PRIMARY_2E217F3A_17269606_29EE6398; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_paused_trigger_grps
    ADD CONSTRAINT "PRIMARY_2E217F3A_17269606_29EE6398" PRIMARY KEY (sched_name, trigger_group);


--
-- TOC entry 8037 (class 2606 OID 17175)
-- Name: post_list_info PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_list_info
    ADD CONSTRAINT "PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F" PRIMARY KEY (id);


--
-- TOC entry 8068 (class 2606 OID 17273)
-- Name: sys_users PRIMARY_37A5EAD9_F5A67303_E4D89AFF; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_users
    ADD CONSTRAINT "PRIMARY_37A5EAD9_F5A67303_E4D89AFF" PRIMARY KEY (user_id);


--
-- TOC entry 8025 (class 2606 OID 17095)
-- Name: post_programme PRIMARY_3B6D5038_61CFC714_59AF6D50; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_programme
    ADD CONSTRAINT "PRIMARY_3B6D5038_61CFC714_59AF6D50" PRIMARY KEY (id);


--
-- TOC entry 8009 (class 2606 OID 16972)
-- Name: qrtz_locks PRIMARY_4122D403_EDAB840C_2AF60B02; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_locks
    ADD CONSTRAINT "PRIMARY_4122D403_EDAB840C_2AF60B02" PRIMARY KEY (lock_name, sched_name);


--
-- TOC entry 8066 (class 2606 OID 17277)
-- Name: sys_user_post PRIMARY_43097AA8_212EBDAA_2F33775D; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_user_post
    ADD CONSTRAINT "PRIMARY_43097AA8_212EBDAA_2F33775D" PRIMARY KEY (post_id, user_id);


--
-- TOC entry 8039 (class 2606 OID 17179)
-- Name: qrtz_job_details PRIMARY_43C650FB_DCEB2469_9EB58483; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_job_details
    ADD CONSTRAINT "PRIMARY_43C650FB_DCEB2469_9EB58483" PRIMARY KEY (job_group, job_name, sched_name);


--
-- TOC entry 8017 (class 2606 OID 17045)
-- Name: qrtz_fired_triggers PRIMARY_467C5086_F775F44E_FAF80C9F; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_fired_triggers
    ADD CONSTRAINT "PRIMARY_467C5086_F775F44E_FAF80C9F" PRIMARY KEY (entry_id, sched_name);


--
-- TOC entry 8035 (class 2606 OID 17177)
-- Name: qrtz_scheduler_state PRIMARY_5A1EB912_AE0CA5F9_BDAF3D78; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_scheduler_state
    ADD CONSTRAINT "PRIMARY_5A1EB912_AE0CA5F9_BDAF3D78" PRIMARY KEY (instance_name, sched_name);


--
-- TOC entry 8056 (class 2606 OID 17259)
-- Name: post_team PRIMARY_5C509297_2DA0CC98_7E2B4B57; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_team
    ADD CONSTRAINT "PRIMARY_5C509297_2DA0CC98_7E2B4B57" PRIMARY KEY (id);


--
-- TOC entry 8085 (class 2606 OID 17283)
-- Name: post_list PRIMARY_5CD25ED8_D5AE10F7_2330D4DD; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_list
    ADD CONSTRAINT "PRIMARY_5CD25ED8_D5AE10F7_2330D4DD" PRIMARY KEY (id);


--
-- TOC entry 8074 (class 2606 OID 17287)
-- Name: sys_user_role PRIMARY_5CF660FC_DA0A165E_F7B2E5EE; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_user_role
    ADD CONSTRAINT "PRIMARY_5CF660FC_DA0A165E_F7B2E5EE" PRIMARY KEY (role_id, user_id);


--
-- TOC entry 8005 (class 2606 OID 16961)
-- Name: sys_job_log PRIMARY_65F80228_8FCF5DFA_36EA3E8A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_job_log
    ADD CONSTRAINT "PRIMARY_65F80228_8FCF5DFA_36EA3E8A" PRIMARY KEY (job_log_id);


--
-- TOC entry 8087 (class 2606 OID 17303)
-- Name: sys_role_menu PRIMARY_6B9F418A_E70A6D3E_96DB28E6; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_role_menu
    ADD CONSTRAINT "PRIMARY_6B9F418A_E70A6D3E_96DB28E6" PRIMARY KEY (menu_id, role_id);


--
-- TOC entry 8019 (class 2606 OID 17112)
-- Name: qrtz_cron_triggers PRIMARY_6F7DA771_F8474AF3_23008EF; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_cron_triggers
    ADD CONSTRAINT "PRIMARY_6F7DA771_F8474AF3_23008EF" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8021 (class 2606 OID 17108)
-- Name: post_checked_report PRIMARY_76F0F846_B93E0786_3CAB54F7; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_report
    ADD CONSTRAINT "PRIMARY_76F0F846_B93E0786_3CAB54F7" PRIMARY KEY (id);


--
-- TOC entry 8054 (class 2606 OID 17267)
-- Name: sys_oper_log PRIMARY_7921EFE7_5FBB2EA4_A007EEA4; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_oper_log
    ADD CONSTRAINT "PRIMARY_7921EFE7_5FBB2EA4_A007EEA4" PRIMARY KEY (oper_id);


--
-- TOC entry 8015 (class 2606 OID 17004)
-- Name: qrtz_blob_triggers PRIMARY_7E3C0400_9C121EEF_39306CE2; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_blob_triggers
    ADD CONSTRAINT "PRIMARY_7E3C0400_9C121EEF_39306CE2" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8043 (class 2606 OID 17221)
-- Name: post_checked_items PRIMARY_7EBD25C4_9D07C4F_423FFE73; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_items
    ADD CONSTRAINT "PRIMARY_7EBD25C4_9D07C4F_423FFE73" PRIMARY KEY (id);


--
-- TOC entry 8070 (class 2606 OID 17281)
-- Name: sys_role PRIMARY_7EFFF0FC_946AB27E_6824486D; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_role
    ADD CONSTRAINT "PRIMARY_7EFFF0FC_946AB27E_6824486D" PRIMARY KEY (role_id);


--
-- TOC entry 8033 (class 2606 OID 17257)
-- Name: sys_dept PRIMARY_817FF65E_B3CA0BCB_8150F446; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dept
    ADD CONSTRAINT "PRIMARY_817FF65E_B3CA0BCB_8150F446" PRIMARY KEY (dept_id);


--
-- TOC entry 8011 (class 2606 OID 16974)
-- Name: post_team_user PRIMARY_87E04789_A6707034_24CEE003; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_team_user
    ADD CONSTRAINT "PRIMARY_87E04789_A6707034_24CEE003" PRIMARY KEY (id);


--
-- TOC entry 8076 (class 2606 OID 17285)
-- Name: sys_job PRIMARY_91256962_5694E7E5_C1E146BE; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_job
    ADD CONSTRAINT "PRIMARY_91256962_5694E7E5_C1E146BE" PRIMARY KEY (job_group, job_id, job_name);


--
-- TOC entry 8072 (class 2606 OID 17271)
-- Name: qrtz_simple_triggers PRIMARY_9A335A95_F939BACC_D13130D; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simple_triggers
    ADD CONSTRAINT "PRIMARY_9A335A95_F939BACC_D13130D" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8093 (class 2606 OID 17296)
-- Name: sys_logininfor PRIMARY_A4D1B11F_8F01405C_230B9E0A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_logininfor
    ADD CONSTRAINT "PRIMARY_A4D1B11F_8F01405C_230B9E0A" PRIMARY KEY (info_id);


--
-- TOC entry 8097 (class 2606 OID 17300)
-- Name: sys_dict_type PRIMARY_A6E4B4D3_5E6EA297_AA3A448A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dict_type
    ADD CONSTRAINT "PRIMARY_A6E4B4D3_5E6EA297_AA3A448A" PRIMARY KEY (dict_id);


--
-- TOC entry 8029 (class 2606 OID 17110)
-- Name: post_plan PRIMARY_AE1BC363_582563EE_6E23E224; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_plan
    ADD CONSTRAINT "PRIMARY_AE1BC363_582563EE_6E23E224" PRIMARY KEY (id);


--
-- TOC entry 8089 (class 2606 OID 17294)
-- Name: gen_table_column PRIMARY_BD14958E_FC72F453_184B02D8; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.gen_table_column
    ADD CONSTRAINT "PRIMARY_BD14958E_FC72F453_184B02D8" PRIMARY KEY (column_id);


--
-- TOC entry 8062 (class 2606 OID 17261)
-- Name: post_checked PRIMARY_BDF7E303_17543270_AE60CCDC; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked
    ADD CONSTRAINT "PRIMARY_BDF7E303_17543270_AE60CCDC" PRIMARY KEY (id);


--
-- TOC entry 8078 (class 2606 OID 17279)
-- Name: qrtz_triggers PRIMARY_C52C5CF2_58E0B4C2_3AA840C0; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_triggers
    ADD CONSTRAINT "PRIMARY_C52C5CF2_58E0B4C2_3AA840C0" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8047 (class 2606 OID 17245)
-- Name: qrtz_calendars PRIMARY_D280BAA3_5325D179_B225191C; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_calendars
    ADD CONSTRAINT "PRIMARY_D280BAA3_5325D179_B225191C" PRIMARY KEY (calendar_name, sched_name);


--
-- TOC entry 8007 (class 2606 OID 16949)
-- Name: post_plan_info PRIMARY_D45A0920_20AEC712_42333194; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_plan_info
    ADD CONSTRAINT "PRIMARY_D45A0920_20AEC712_42333194" PRIMARY KEY (id);


--
-- TOC entry 8045 (class 2606 OID 17265)
-- Name: sys_role_dept PRIMARY_D4CC35BE_F0BFC088_E6F3DC38; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_role_dept
    ADD CONSTRAINT "PRIMARY_D4CC35BE_F0BFC088_E6F3DC38" PRIMARY KEY (dept_id, role_id);


--
-- TOC entry 8081 (class 2606 OID 17289)
-- Name: sys_dict_data PRIMARY_DFD26535_85AD8F0D_D03CC464; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dict_data
    ADD CONSTRAINT "PRIMARY_DFD26535_85AD8F0D_D03CC464" PRIMARY KEY (dict_code);


--
-- TOC entry 8049 (class 2606 OID 17247)
-- Name: gen_table PRIMARY_E2A7B70B_3AA9B50_AEC5FEA8; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.gen_table
    ADD CONSTRAINT "PRIMARY_E2A7B70B_3AA9B50_AEC5FEA8" PRIMARY KEY (table_id);


--
-- TOC entry 8013 (class 2606 OID 17029)
-- Name: post_programme_template PRIMARY_E5685837_4A4E5B51_885D79C5; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_programme_template
    ADD CONSTRAINT "PRIMARY_E5685837_4A4E5B51_885D79C5" PRIMARY KEY (id);


--
-- TOC entry 8023 (class 2606 OID 17207)
-- Name: sys_con PRIMARY_EA10AD48_8684CC6D_55402DA2; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_con
    ADD CONSTRAINT "PRIMARY_EA10AD48_8684CC6D_55402DA2" PRIMARY KEY (config_id);


--
-- TOC entry 8064 (class 2606 OID 17275)
-- Name: sys_notice PRIMARY_EFB5DD38_A077CE5A_E0DEBE34; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_notice
    ADD CONSTRAINT "PRIMARY_EFB5DD38_A077CE5A_E0DEBE34" PRIMARY KEY (notice_id);


--
-- TOC entry 8027 (class 2606 OID 17106)
-- Name: post_plan_info_user PRIMARY_F3187EA0_6D33F980_BD60B328; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_plan_info_user
    ADD CONSTRAINT "PRIMARY_F3187EA0_6D33F980_BD60B328" PRIMARY KEY (id);


--
-- TOC entry 8083 (class 2606 OID 17292)
-- Name: sys_menu PRIMARY_F5518E2A_873D814C_8464B39; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_menu
    ADD CONSTRAINT "PRIMARY_F5518E2A_873D814C_8464B39" PRIMARY KEY (menu_id);


--
-- TOC entry 8060 (class 2606 OID 17264)
-- Name: sys_post PRIMARY_F66D76A8_84150B7F_2EA0EABB; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_post
    ADD CONSTRAINT "PRIMARY_F66D76A8_84150B7F_2EA0EABB" PRIMARY KEY (post_id);


--
-- TOC entry 8041 (class 2606 OID 17231)
-- Name: qrtz_simprop_triggers PRIMARY_F8B4E6ED_ABCB7DF0_9F96A52A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simprop_triggers
    ADD CONSTRAINT "PRIMARY_F8B4E6ED_ABCB7DF0_9F96A52A" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8095 (class 2606 OID 17306)
-- Name: sys_dict_type dict_type_2399F8D6_80058C1A_322DFB61; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dict_type
    ADD CONSTRAINT "dict_type_2399F8D6_80058C1A_322DFB61" UNIQUE (dict_type);


--
-- TOC entry 8105 (class 2606 OID 17914)
-- Name: post_assessment_rating post_assessment_rating_pkey; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_assessment_rating
    ADD CONSTRAINT post_assessment_rating_pkey PRIMARY KEY (id);


--
-- TOC entry 8107 (class 2606 OID 18047)
-- Name: post_assessment_rules post_assessment_rules_pkey; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_assessment_rules
    ADD CONSTRAINT post_assessment_rules_pkey PRIMARY KEY (id);


--
-- TOC entry 8101 (class 2606 OID 17801)
-- Name: post_checked_problem post_checked_problem_pkey; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_problem
    ADD CONSTRAINT post_checked_problem_pkey PRIMARY KEY (id);


--
-- TOC entry 8103 (class 2606 OID 17810)
-- Name: post_checked_problem_record post_checked_problem_record_pkey; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_problem_record
    ADD CONSTRAINT post_checked_problem_record_pkey PRIMARY KEY (id);


--
-- TOC entry 8031 (class 2606 OID 17140)
-- Name: post_highlights post_highlights_pkey_C565D409; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_highlights
    ADD CONSTRAINT "post_highlights_pkey_C565D409" PRIMARY KEY (id);


--
-- TOC entry 8099 (class 2606 OID 17788)
-- Name: post_team_dept post_team_dept_pkey; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_team_dept
    ADD CONSTRAINT post_team_dept_pkey PRIMARY KEY (id);


--
-- TOC entry 8090 (class 1259 OID 17304)
-- Name: idx_sys_logininfor_lt_23FF0BED_E71901B0_CED0DA9E; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_logininfor_lt_23FF0BED_E71901B0_CED0DA9E ON public.sys_logininfor USING btree (login_time);


--
-- TOC entry 8091 (class 1259 OID 17307)
-- Name: idx_sys_logininfor_s_DAD31C0B_78012EE1_19B8ECF5; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_logininfor_s_DAD31C0B_78012EE1_19B8ECF5 ON public.sys_logininfor USING btree (status);


--
-- TOC entry 8050 (class 1259 OID 17290)
-- Name: idx_sys_oper_log_bt_5AA8DF25_7F5FE8A4_ED2AE1AD; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_oper_log_bt_5AA8DF25_7F5FE8A4_ED2AE1AD ON public.sys_oper_log USING btree (business_type);


--
-- TOC entry 8051 (class 1259 OID 17297)
-- Name: idx_sys_oper_log_ot_2696A8F7_FE2D1736_B58753C7; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_oper_log_ot_2696A8F7_FE2D1736_B58753C7 ON public.sys_oper_log USING btree (oper_time);


--
-- TOC entry 8052 (class 1259 OID 17301)
-- Name: idx_sys_oper_log_s_94FB440B_C5CB5BC8_411DB57C; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_oper_log_s_94FB440B_C5CB5BC8_411DB57C ON public.sys_oper_log USING btree (status);


--
-- TOC entry 8109 (class 1259 OID 18113)
-- Name: post_assessment_rating_other_info_pkey; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE UNIQUE INDEX post_assessment_rating_other_info_pkey ON public.post_assessment_rating_other_info USING btree (id);


--
-- TOC entry 8108 (class 1259 OID 18094)
-- Name: post_assessment_rating_other_pkey; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE UNIQUE INDEX post_assessment_rating_other_pkey ON public.post_assessment_rating_other USING btree (id);


--
-- TOC entry 8079 (class 1259 OID 17298)
-- Name: sched_name_CFEFF700_DF8C3C86_A6A9A0F6; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX sched_name_CFEFF700_DF8C3C86_A6A9A0F6 ON public.qrtz_triggers USING btree (sched_name, job_name, job_group);


--
-- TOC entry 8110 (class 2606 OID 17313)
-- Name: qrtz_blob_triggers qrtz_blob_triggers_ibfk_1_602016CE_BF4EF810_4A74C7; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_blob_triggers
    ADD CONSTRAINT "qrtz_blob_triggers_ibfk_1_602016CE_BF4EF810_4A74C7" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8111 (class 2606 OID 17318)
-- Name: qrtz_cron_triggers qrtz_cron_triggers_ibfk_1_DCC7CA6E_24F7DA4F_2DFE1CCC; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_cron_triggers
    ADD CONSTRAINT "qrtz_cron_triggers_ibfk_1_DCC7CA6E_24F7DA4F_2DFE1CCC" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8113 (class 2606 OID 17328)
-- Name: qrtz_simple_triggers qrtz_simple_triggers_ibfk_1_BA07CD2E_59F29895_2447A99D; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simple_triggers
    ADD CONSTRAINT "qrtz_simple_triggers_ibfk_1_BA07CD2E_59F29895_2447A99D" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8112 (class 2606 OID 17323)
-- Name: qrtz_simprop_triggers qrtz_simprop_triggers_ibfk_1_FCECB7C0_8EDC5C80_4506780B; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simprop_triggers
    ADD CONSTRAINT "qrtz_simprop_triggers_ibfk_1_FCECB7C0_8EDC5C80_4506780B" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8114 (class 2606 OID 17308)
-- Name: qrtz_triggers qrtz_triggers_ibfk_1_2DEC48B4_582C285F_ED72A16F; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_triggers
    ADD CONSTRAINT "qrtz_triggers_ibfk_1_2DEC48B4_582C285F_ED72A16F" FOREIGN KEY (sched_name, job_name, job_group) REFERENCES public.qrtz_job_details(sched_name, job_name, job_group);


--
-- TOC entry 8571 (class 0 OID 0)
-- Dependencies: 3343
-- Name: FUNCTION sys_stat_statements_reset(userid oid, dbid oid, queryid bigint); Type: ACL; Schema: public; Owner: postcheckuser
--

REVOKE ALL ON FUNCTION public.sys_stat_statements_reset(userid oid, dbid oid, queryid bigint) FROM system;
GRANT IF NOT EXISTS ALL ON FUNCTION public.sys_stat_statements_reset(userid oid, dbid oid, queryid bigint) TO postcheckuser;


--
-- TOC entry 9249 (class 0 OID 0)
-- Dependencies: 550
-- Name: TABLE sys_stat_statements_all; Type: ACL; Schema: public; Owner: postcheckuser
--

REVOKE ALL ON TABLE public.sys_stat_statements_all FROM system;
REVOKE SELECT ON TABLE public.sys_stat_statements_all FROM PUBLIC;
GRANT IF NOT EXISTS ALL ON TABLE public.sys_stat_statements_all TO postcheckuser;
GRANT IF NOT EXISTS SELECT ON TABLE public.sys_stat_statements_all TO PUBLIC;


--
-- TOC entry 9250 (class 0 OID 0)
-- Dependencies: 551
-- Name: TABLE sys_stat_statements; Type: ACL; Schema: public; Owner: postcheckuser
--

REVOKE ALL ON TABLE public.sys_stat_statements FROM system;
REVOKE SELECT ON TABLE public.sys_stat_statements FROM PUBLIC;
GRANT IF NOT EXISTS ALL ON TABLE public.sys_stat_statements TO postcheckuser;
GRANT IF NOT EXISTS SELECT ON TABLE public.sys_stat_statements TO PUBLIC;


-- Completed on 2024-01-03 17:30:54

--
-- Kingbase database dump complete
--

