--
-- Kingbase database dump
--

-- Dumped from database version 12.1
-- Dumped by sys_dump version 12.1

-- Started on 2023-12-16 15:48:18

SET statement_timeout = 0;
SET lock_timeout = 0;
SET idle_in_transaction_session_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SELECT pg_catalog.set_config('search_path', 'public', false);
SET check_function_bodies = false;
SET xmloption = content;
SET client_min_messages = warning;
SET row_security = off;
SET default_with_oids = off;

--
-- TOC entry 23 (class 2615 OID 2200)
-- Name: public; Type: SCHEMA; Schema: -; Owner: system
--

CREATE SCHEMA public;


ALTER SCHEMA public OWNER TO system;

--
-- TOC entry 8504 (class 0 OID 0)
-- Dependencies: 23
-- Name: SCHEMA public; Type: COMMENT; Schema: -; Owner: system
--

COMMENT ON SCHEMA public IS 'standard public schema';


SET default_tablespace = '';

SET default_table_access_method = heap;

--
-- TOC entry 590 (class 1259 OID 17051)
-- Name: gen_table; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.gen_table (
    table_id bigint NOT NULL,
    table_name character varying(200 char) DEFAULT ''::varchar,
    table_comment character varying(500 char) DEFAULT ''::varchar,
    sub_table_name character varying(64 char),
    sub_table_fk_name character varying(64 char),
    class_name character varying(100 char) DEFAULT ''::varchar,
    tpl_category character varying(200 char) DEFAULT 'crud'::varchar,
    tpl_web_type character varying(30 char) DEFAULT ''::varchar,
    package_name character varying(100 char),
    module_name character varying(30 char),
    business_name character varying(30 char),
    function_name character varying(50 char),
    function_author character varying(50 char),
    gen_type character(1 char) DEFAULT '0'::bpchar,
    gen_path character varying(200 char) DEFAULT '/'::varchar,
    options character varying(1000 char),
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.gen_table OWNER TO postcheckuser;

--
-- TOC entry 8506 (class 0 OID 0)
-- Dependencies: 590
-- Name: TABLE gen_table; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.gen_table IS '代码生成业务表';


--
-- TOC entry 8507 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.table_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.table_id IS '编号';


--
-- TOC entry 8508 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.table_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.table_name IS '表名称';


--
-- TOC entry 8509 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.table_comment; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.table_comment IS '表描述';


--
-- TOC entry 8510 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.sub_table_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.sub_table_name IS '关联子表的表名';


--
-- TOC entry 8511 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.sub_table_fk_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.sub_table_fk_name IS '子表关联的外键名';


--
-- TOC entry 8512 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.class_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.class_name IS '实体类名称';


--
-- TOC entry 8513 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.tpl_category; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.tpl_category IS '使用的模板（crud单表操作 tree树表操作）';


--
-- TOC entry 8514 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.tpl_web_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.tpl_web_type IS '前端模板类型（element-ui模版 element-plus模版）';


--
-- TOC entry 8515 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.package_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.package_name IS '生成包路径';


--
-- TOC entry 8516 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.module_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.module_name IS '生成模块名';


--
-- TOC entry 8517 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.business_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.business_name IS '生成业务名';


--
-- TOC entry 8518 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.function_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.function_name IS '生成功能名';


--
-- TOC entry 8519 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.function_author; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.function_author IS '生成功能作者';


--
-- TOC entry 8520 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.gen_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.gen_type IS '生成代码方式（0zip压缩包 1自定义路径）';


--
-- TOC entry 8521 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.gen_path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.gen_path IS '生成路径（不填默认项目路径）';


--
-- TOC entry 8522 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.options; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.options IS '其它生成选项';


--
-- TOC entry 8523 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.create_by IS '创建者';


--
-- TOC entry 8524 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.create_time IS '创建时间';


--
-- TOC entry 8525 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.update_by IS '更新者';


--
-- TOC entry 8526 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.update_time IS '更新时间';


--
-- TOC entry 8527 (class 0 OID 0)
-- Dependencies: 590
-- Name: COLUMN gen_table.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table.remark IS '备注';


--
-- TOC entry 608 (class 1259 OID 17223)
-- Name: gen_table_column; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.gen_table_column (
    column_id bigint NOT NULL,
    table_id bigint,
    column_name character varying(200 char),
    column_comment character varying(500 char),
    column_type character varying(100 char),
    java_type character varying(500 char),
    java_field character varying(200 char),
    is_pk character(1 char),
    is_increment character(1 char),
    is_required character(1 char),
    is_insert character(1 char),
    is_edit character(1 char),
    is_list character(1 char),
    is_query character(1 char),
    query_type character varying(200 char) DEFAULT 'EQ'::varchar,
    html_type character varying(200 char),
    dict_type character varying(200 char) DEFAULT ''::varchar,
    sort integer,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone
);


ALTER TABLE public.gen_table_column OWNER TO postcheckuser;

--
-- TOC entry 8528 (class 0 OID 0)
-- Dependencies: 608
-- Name: TABLE gen_table_column; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.gen_table_column IS '代码生成业务表字段';


--
-- TOC entry 8529 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.column_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_id IS '编号';


--
-- TOC entry 8530 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.table_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.table_id IS '归属表编号';


--
-- TOC entry 8531 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.column_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_name IS '列名称';


--
-- TOC entry 8532 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.column_comment; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_comment IS '列描述';


--
-- TOC entry 8533 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.column_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.column_type IS '列类型';


--
-- TOC entry 8534 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.java_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.java_type IS 'JAVA类型';


--
-- TOC entry 8535 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.java_field; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.java_field IS 'JAVA字段名';


--
-- TOC entry 8536 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_pk; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_pk IS '是否主键（1是）';


--
-- TOC entry 8537 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_increment; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_increment IS '是否自增（1是）';


--
-- TOC entry 8538 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_required; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_required IS '是否必填（1是）';


--
-- TOC entry 8539 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_insert; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_insert IS '是否为插入字段（1是）';


--
-- TOC entry 8540 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_edit; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_edit IS '是否编辑字段（1是）';


--
-- TOC entry 8541 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_list; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_list IS '是否列表字段（1是）';


--
-- TOC entry 8542 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.is_query; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.is_query IS '是否查询字段（1是）';


--
-- TOC entry 8543 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.query_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.query_type IS '查询方式（等于、不等于、大于、小于、范围）';


--
-- TOC entry 8544 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.html_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.html_type IS '显示类型（文本框、文本域、下拉框、复选框、单选框、日期控件）';


--
-- TOC entry 8545 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.dict_type IS '字典类型';


--
-- TOC entry 8546 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.sort IS '排序';


--
-- TOC entry 8547 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.create_by IS '创建者';


--
-- TOC entry 8548 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.create_time IS '创建时间';


--
-- TOC entry 8549 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.update_by IS '更新者';


--
-- TOC entry 8550 (class 0 OID 0)
-- Dependencies: 608
-- Name: COLUMN gen_table_column.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.gen_table_column.update_time IS '更新时间';


--
-- TOC entry 595 (class 1259 OID 17101)
-- Name: post_checked; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked (
    id bigint NOT NULL,
    check_workgroup_id bigint,
    check_group_id bigint,
    checked_dept_id bigint,
    checked_post_id bigint,
    print_user_id bigint,
    print_time timestamp(0) with time zone,
    checked_img character varying(255 char),
    checked_user_id bigint,
    checked_time timestamp(0) with time zone,
    upload_user_id bigint,
    upload_time timestamp(0) with time zone,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_checked OWNER TO postcheckuser;

--
-- TOC entry 8551 (class 0 OID 0)
-- Dependencies: 595
-- Name: TABLE post_checked; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked IS '岗位责任制检查表';


--
-- TOC entry 8552 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.id IS '主键ID';


--
-- TOC entry 8553 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.check_workgroup_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.check_workgroup_id IS '检查工作组ID';


--
-- TOC entry 8554 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.check_group_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.check_group_id IS '检查小组ID';


--
-- TOC entry 8555 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.checked_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_dept_id IS '被检查部门ID';


--
-- TOC entry 8556 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.checked_post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_post_id IS '被检查岗位ID';


--
-- TOC entry 8557 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.print_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.print_user_id IS '打印人ID';


--
-- TOC entry 8558 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.print_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.print_time IS '打印时间';


--
-- TOC entry 8559 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.checked_img; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_img IS '上传：检查后的检查表照片或PDF，磁盘相对路径';


--
-- TOC entry 8560 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.checked_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_user_id IS '上传：检查人ID';


--
-- TOC entry 8561 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.checked_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.checked_time IS '上传：检查时间';


--
-- TOC entry 8562 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.upload_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.upload_user_id IS '上传：检查后的检查表操作人';


--
-- TOC entry 8563 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.upload_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.upload_time IS '上传：检查后的检查表上传时间';


--
-- TOC entry 8564 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.remark IS '备注';


--
-- TOC entry 8565 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8566 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.create_time IS '创建时间';


--
-- TOC entry 8567 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.create_by IS '创建者';


--
-- TOC entry 8568 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.update_time IS '更新时间';


--
-- TOC entry 8569 (class 0 OID 0)
-- Dependencies: 595
-- Name: COLUMN post_checked.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked.update_by IS '更新者';


--
-- TOC entry 587 (class 1259 OID 17034)
-- Name: post_checked_items; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_items (
    id bigint NOT NULL,
    post_checked_id bigint,
    type integer,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_checked_items OWNER TO postcheckuser;

--
-- TOC entry 8570 (class 0 OID 0)
-- Dependencies: 587
-- Name: TABLE post_checked_items; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked_items IS '岗位责任制检查表配置检查项';


--
-- TOC entry 8571 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.id IS '主键ID';


--
-- TOC entry 8572 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.post_checked_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.post_checked_id IS '岗位责任制检查表ID';


--
-- TOC entry 8573 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.type IS '参考post_list_info表；类型（1-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求）';


--
-- TOC entry 8574 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.remark IS '备注';


--
-- TOC entry 8575 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8576 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.create_time IS '创建时间';


--
-- TOC entry 8577 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.create_by IS '创建者';


--
-- TOC entry 8578 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.update_time IS '更新时间';


--
-- TOC entry 8579 (class 0 OID 0)
-- Dependencies: 587
-- Name: COLUMN post_checked_items.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_items.update_by IS '更新者';


--
-- TOC entry 582 (class 1259 OID 17005)
-- Name: post_checked_problem; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_problem (
    id bigint NOT NULL,
    problem_no character varying(255 char) NOT NULL,
    check_workgroup_id bigint NOT NULL,
    check_group_id bigint NOT NULL,
    check_user_id bigint NOT NULL,
    responsibility_type character varying(255 char) NOT NULL,
    status integer NOT NULL,
    dept_admin_user_id bigint,
    dept_admin_setup_time timestamp(0) with time zone,
    dept_approve_user_id bigint,
    dept_approve_time timestamp(0) with time zone,
    responsibility_department_id bigint,
    responsibility_department_reviewer_id bigint,
    responsibility_department_review_time timestamp(0) with time zone,
    problem_attribute character varying(255 char) NOT NULL,
    problem_category character varying(255 char) NOT NULL,
    is_immediately_corrected integer NOT NULL,
    problem_level character varying(255 char) NOT NULL,
    problem_description character varying(512 char),
    problem_cause character varying(512 char),
    rectification_period timestamp(0) with time zone,
    rectification_measure character varying(512 char),
    is_rectification_completed integer,
    checked_dept_id bigint NOT NULL,
    checked_post_id bigint NOT NULL,
    rectification_responsible_user_id bigint,
    rectification_completion_time timestamp(0) with time zone,
    rectification_completion_img character varying(255 char),
    acceptance_conclusion character varying(255 char),
    acceptance_situation character varying(255 char),
    reason character varying(255 char),
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_checked_problem OWNER TO postcheckuser;

--
-- TOC entry 8580 (class 0 OID 0)
-- Dependencies: 582
-- Name: TABLE post_checked_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked_problem IS '岗检问题录入表';


--
-- TOC entry 8581 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.id IS '主键ID';


--
-- TOC entry 8582 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.problem_no; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_no IS '问题编号（需要甲方提供规则规则）';


--
-- TOC entry 8583 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.check_workgroup_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_workgroup_id IS '检查工作组ID';


--
-- TOC entry 8584 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.check_group_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_group_id IS '检查小组ID';


--
-- TOC entry 8585 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.check_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.check_user_id IS '检查人员ID';


--
-- TOC entry 8586 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.responsibility_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.responsibility_type IS '职责类别（参考post_list_info表；类型（1-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求））';


--
-- TOC entry 8587 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.status IS '状态：1-待指定整改人（问题录入完成时）；2-待填写整改措施（部门管理员指定整改人后）；3-待部门审核（整改人填写整改措施，最好需要手动提交待审核，不要自动待审核）；4-待职能部门审核；5-关闭；';


--
-- TOC entry 8588 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.dept_admin_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.dept_admin_user_id IS '管理员指定整改负责人：管理员ID';


--
-- TOC entry 8589 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.dept_admin_setup_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.dept_admin_setup_time IS '管理员指定整改负责人：管理员指定时间';


--
-- TOC entry 8590 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.dept_approve_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.dept_approve_user_id IS '审核1：整改部门经理ID';


--
-- TOC entry 8591 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.dept_approve_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.dept_approve_time IS '审核1：整改部门经理审核时间';


--
-- TOC entry 8592 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.responsibility_department_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.responsibility_department_id IS '审核2：职责部门ID';


--
-- TOC entry 8593 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.responsibility_department_reviewer_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.responsibility_department_reviewer_id IS '审核2：职责部门复查人ID';


--
-- TOC entry 8594 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.responsibility_department_review_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.responsibility_department_review_time IS '审核2：职责部门复查时间';


--
-- TOC entry 8595 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.problem_attribute; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_attribute IS '问题属性（完整问题、有效性问题、适宜性问题）';


--
-- TOC entry 8596 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.problem_category; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_category IS '问题类别（职责权限问题、工作内容问题、工作标准问题、考核奖励问题、任职资格问题、其他）';


--
-- TOC entry 8597 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.is_immediately_corrected; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.is_immediately_corrected IS '是否立行立改(1-Yes；2-No；)';


--
-- TOC entry 8598 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.problem_level; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_level IS '问题等级（一般、重要）';


--
-- TOC entry 8599 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.problem_description; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_description IS '问题描述';


--
-- TOC entry 8600 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.problem_cause; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.problem_cause IS '问题原因';


--
-- TOC entry 8601 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.rectification_period; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_period IS '整改期限';


--
-- TOC entry 8602 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.rectification_measure; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_measure IS '整改措施';


--
-- TOC entry 8603 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.is_rectification_completed; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.is_rectification_completed IS '整改是否完成(1-Yes；2-No；)';


--
-- TOC entry 8604 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.checked_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.checked_dept_id IS '被检查部门ID（整改责任部门ID）';


--
-- TOC entry 8605 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.checked_post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.checked_post_id IS '被检查岗位ID（整改责任岗位ID）';


--
-- TOC entry 8606 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.rectification_responsible_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_responsible_user_id IS '整改责任人ID';


--
-- TOC entry 8607 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.rectification_completion_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_completion_time IS '整改完成时间';


--
-- TOC entry 8608 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.rectification_completion_img; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.rectification_completion_img IS '整改完成图片磁盘路径';


--
-- TOC entry 8609 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.acceptance_conclusion; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.acceptance_conclusion IS '验收结论';


--
-- TOC entry 8610 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.acceptance_situation; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.acceptance_situation IS '验收情况';


--
-- TOC entry 8611 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.reason; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.reason IS '未通过理由';


--
-- TOC entry 8612 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.remark IS '备注';


--
-- TOC entry 8613 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8614 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.create_time IS '创建时间';


--
-- TOC entry 8615 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.create_by IS '创建者';


--
-- TOC entry 8616 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.update_time IS '更新时间';


--
-- TOC entry 8617 (class 0 OID 0)
-- Dependencies: 582
-- Name: COLUMN post_checked_problem.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_problem.update_by IS '更新者';


--
-- TOC entry 575 (class 1259 OID 16953)
-- Name: post_checked_report; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_checked_report (
    id bigint NOT NULL,
    report_no character varying(36 char) NOT NULL,
    report_name character varying(255 char) NOT NULL,
    report_preface character varying(255 char) NOT NULL,
    consummation_problem integer,
    suitability_problem integer,
    effectiveness_problem integer,
    li_xing_li_gai_question_number integer,
    li_xing_li_gai_question_has_rectified_number integer,
    rich_text text,
    status character varying(255 char),
    generate_time timestamp(0) with time zone,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_checked_report OWNER TO postcheckuser;

--
-- TOC entry 8618 (class 0 OID 0)
-- Dependencies: 575
-- Name: TABLE post_checked_report; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_checked_report IS '岗检报告表';


--
-- TOC entry 8619 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.id IS '主键ID';


--
-- TOC entry 8620 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.report_no; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.report_no IS '编码';


--
-- TOC entry 8621 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.report_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.report_name IS '岗检报告名称';


--
-- TOC entry 8622 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.report_preface; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.report_preface IS '前言';


--
-- TOC entry 8623 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.consummation_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.consummation_problem IS '完善性问题';


--
-- TOC entry 8624 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.suitability_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.suitability_problem IS '适宜性问题';


--
-- TOC entry 8625 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.effectiveness_problem; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.effectiveness_problem IS '有效性问题';


--
-- TOC entry 8626 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.li_xing_li_gai_question_number; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.li_xing_li_gai_question_number IS '立行立改问题数量';


--
-- TOC entry 8627 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.li_xing_li_gai_question_has_rectified_number; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.li_xing_li_gai_question_has_rectified_number IS '立行立改问题已整改数量';


--
-- TOC entry 8628 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.rich_text; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.rich_text IS '富文本';


--
-- TOC entry 8629 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.status IS '状态';


--
-- TOC entry 8630 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.generate_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.generate_time IS '生成时间';


--
-- TOC entry 8631 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.remark IS '备注';


--
-- TOC entry 8632 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8633 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.create_time IS '创建时间';


--
-- TOC entry 8634 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.create_by IS '创建者';


--
-- TOC entry 8635 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.update_time IS '更新时间';


--
-- TOC entry 8636 (class 0 OID 0)
-- Dependencies: 575
-- Name: COLUMN post_checked_report.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_checked_report.update_by IS '更新者';


--
-- TOC entry 580 (class 1259 OID 16987)
-- Name: post_highlights; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_highlights (
    id bigint NOT NULL,
    highlights_type integer NOT NULL,
    highlights character varying(512 char) NOT NULL,
    remark character varying(500 char) DEFAULT NULL::varchar,
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_highlights OWNER TO postcheckuser;

--
-- TOC entry 8637 (class 0 OID 0)
-- Dependencies: 580
-- Name: TABLE post_highlights; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_highlights IS '岗检亮点表';


--
-- TOC entry 8638 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.id IS '主键';


--
-- TOC entry 8639 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.highlights_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.highlights_type IS '类型：';


--
-- TOC entry 8640 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.highlights; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.highlights IS '管理亮点';


--
-- TOC entry 8641 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.remark IS '备注';


--
-- TOC entry 8642 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8643 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.create_time IS '创建时间';


--
-- TOC entry 8644 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.create_by IS '创建者';


--
-- TOC entry 8645 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.update_time IS '更新时间';


--
-- TOC entry 8646 (class 0 OID 0)
-- Dependencies: 580
-- Name: COLUMN post_highlights.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_highlights.update_by IS '更新者';


--
-- TOC entry 606 (class 1259 OID 17210)
-- Name: post_list; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_list (
    id bigint NOT NULL,
    status integer,
    status_by_user_id bigint,
    status_by_user_name character varying(64 char),
    unit_id character varying(255 char),
    position_name character varying(255 char),
    position_level character varying(255 char),
    direct_superior character varying(255 char),
    subordinate_count integer,
    department_name character varying(255 char),
    position_code character varying(255 char),
    is_confidential tinyint,
    direct_subordinate character varying(255 char),
    creation_date date,
    revision_date date,
    job_summary text,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_list OWNER TO postcheckuser;

--
-- TOC entry 8647 (class 0 OID 0)
-- Dependencies: 606
-- Name: TABLE post_list; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_list IS '岗位责任制清单';


--
-- TOC entry 8648 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.id IS '主键，自增长ID';


--
-- TOC entry 8649 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.status IS '状态：1-待审核；2-审核中；3-通过；4-驳回；';


--
-- TOC entry 8650 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.status_by_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.status_by_user_id IS '审核人ID';


--
-- TOC entry 8651 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.status_by_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.status_by_user_name IS '审核人姓名';


--
-- TOC entry 8652 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.unit_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.unit_id IS '所在单位';


--
-- TOC entry 8653 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.position_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.position_name IS '岗位名称';


--
-- TOC entry 8654 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.position_level; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.position_level IS '岗位级别';


--
-- TOC entry 8655 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.direct_superior; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.direct_superior IS '直接上级';


--
-- TOC entry 8656 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.subordinate_count; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.subordinate_count IS '辖员人数';


--
-- TOC entry 8657 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.department_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.department_name IS '所在部门';


--
-- TOC entry 8658 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.position_code; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.position_code IS '岗位编码';


--
-- TOC entry 8659 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.is_confidential; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.is_confidential IS '是否涉密';


--
-- TOC entry 8660 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.direct_subordinate; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.direct_subordinate IS '直接下级';


--
-- TOC entry 8661 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.creation_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.creation_date IS '编制日期';


--
-- TOC entry 8662 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.revision_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.revision_date IS '修订日期';


--
-- TOC entry 8663 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.job_summary; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.job_summary IS '工作摘要';


--
-- TOC entry 8664 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.remark IS '备注';


--
-- TOC entry 8665 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8666 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.create_time IS '创建时间';


--
-- TOC entry 8667 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.create_by IS '创建者';


--
-- TOC entry 8668 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.update_time IS '更新时间';


--
-- TOC entry 8669 (class 0 OID 0)
-- Dependencies: 606
-- Name: COLUMN post_list.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list.update_by IS '更新者';


--
-- TOC entry 584 (class 1259 OID 17015)
-- Name: post_list_info; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_list_info (
    id bigint NOT NULL,
    status integer,
    status_by_user_id bigint,
    status_by_user_name character varying(64 char),
    post_list_id bigint,
    type integer,
    sequence_project integer,
    level_one integer,
    level_two integer,
    level_three integer,
    level_four integer,
    level_five integer,
    work_standard character varying(255 char),
    requirement text,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_list_info OWNER TO postcheckuser;

--
-- TOC entry 8670 (class 0 OID 0)
-- Dependencies: 584
-- Name: TABLE post_list_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_list_info IS '表创建注释';


--
-- TOC entry 8671 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.id IS '主键ID';


--
-- TOC entry 8672 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.status IS '状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8673 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.status_by_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.status_by_user_id IS '审核人ID';


--
-- TOC entry 8674 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.status_by_user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.status_by_user_name IS '审核人姓名';


--
-- TOC entry 8675 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.post_list_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.post_list_id IS '岗位责任制清单表ID（多）';


--
-- TOC entry 8676 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.type IS '类型（1-业务职责；2-党建及党风廉政建设职责；3-安全环保职责；4-合规保密职；5-任职资格与能力素质要求）';


--
-- TOC entry 8677 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.sequence_project; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.sequence_project IS '序号/项目（1、2）';


--
-- TOC entry 8678 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.level_one; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_one IS '一级事项（1）';


--
-- TOC entry 8679 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.level_two; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_two IS '二级事项（1）';


--
-- TOC entry 8680 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.level_three; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_three IS '三级事项（1）';


--
-- TOC entry 8681 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.level_four; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_four IS '四级事项（1）';


--
-- TOC entry 8682 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.level_five; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.level_five IS '五级事项（1）';


--
-- TOC entry 8683 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.work_standard; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.work_standard IS '工作标准（1）';


--
-- TOC entry 8684 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.requirement; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.requirement IS '要求（2）';


--
-- TOC entry 8685 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.remark IS '备注';


--
-- TOC entry 8686 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8687 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.create_time IS '创建时间';


--
-- TOC entry 8688 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.create_by IS '创建者';


--
-- TOC entry 8689 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.update_time IS '更新时间';


--
-- TOC entry 8690 (class 0 OID 0)
-- Dependencies: 584
-- Name: COLUMN post_list_info.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_list_info.update_by IS '更新者';


--
-- TOC entry 579 (class 1259 OID 16983)
-- Name: post_plan; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_plan (
    id bigint NOT NULL,
    name character varying(255 char),
    content character varying(255 char),
    start_time timestamp(0) with time zone,
    end_time timestamp(0) with time zone,
    status integer,
    remark character varying(255 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_plan OWNER TO postcheckuser;

--
-- TOC entry 8691 (class 0 OID 0)
-- Dependencies: 579
-- Name: TABLE post_plan; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_plan IS '岗检计划';


--
-- TOC entry 8692 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.id IS '主键ID';


--
-- TOC entry 8693 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.name IS '名称';


--
-- TOC entry 8694 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.content; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.content IS '内容';


--
-- TOC entry 8695 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.start_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.start_time IS '开始时间';


--
-- TOC entry 8696 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.end_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.end_time IS '结束时间';


--
-- TOC entry 8697 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.status IS '状态：1-待审核；2-审核中；3-通过；4-驳回；';


--
-- TOC entry 8698 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.remark IS '备注';


--
-- TOC entry 8699 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8700 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.create_time IS '创建时间';


--
-- TOC entry 8701 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.create_by IS '创建者';


--
-- TOC entry 8702 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.update_time IS '更新时间';


--
-- TOC entry 8703 (class 0 OID 0)
-- Dependencies: 579
-- Name: COLUMN post_plan.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan.update_by IS '更新者';


--
-- TOC entry 568 (class 1259 OID 16924)
-- Name: post_plan_info; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_plan_info (
    id bigint NOT NULL,
    post_plan_id bigint,
    checked_dept_id bigint,
    check_time timestamp(0) with time zone,
    check_workgroup_id bigint,
    check_group_id bigint,
    remark character varying(255 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_plan_info OWNER TO postcheckuser;

--
-- TOC entry 8704 (class 0 OID 0)
-- Dependencies: 568
-- Name: TABLE post_plan_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_plan_info IS '岗检计划明细表';


--
-- TOC entry 8705 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.id IS '主键ID';


--
-- TOC entry 8706 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.post_plan_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.post_plan_id IS '计划ID';


--
-- TOC entry 8707 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.checked_dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.checked_dept_id IS '被检查部门ID';


--
-- TOC entry 8708 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.check_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.check_time IS '检查时间';


--
-- TOC entry 8709 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.check_workgroup_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.check_workgroup_id IS '检查工作组ID';


--
-- TOC entry 8710 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.check_group_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.check_group_id IS '检查小组ID';


--
-- TOC entry 8711 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.remark IS '备注';


--
-- TOC entry 8712 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8713 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.create_time IS '创建时间';


--
-- TOC entry 8714 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.create_by IS '创建者';


--
-- TOC entry 8715 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.update_time IS '更新时间';


--
-- TOC entry 8716 (class 0 OID 0)
-- Dependencies: 568
-- Name: COLUMN post_plan_info.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info.update_by IS '更新者';


--
-- TOC entry 578 (class 1259 OID 16979)
-- Name: post_plan_info_user; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_plan_info_user (
    id bigint NOT NULL,
    post_plan_info_id bigint,
    checked_user_id bigint,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_plan_info_user OWNER TO postcheckuser;

--
-- TOC entry 8717 (class 0 OID 0)
-- Dependencies: 578
-- Name: TABLE post_plan_info_user; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_plan_info_user IS '计划明细检查人表';


--
-- TOC entry 8718 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.id IS '主键ID';


--
-- TOC entry 8719 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.post_plan_info_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.post_plan_info_id IS '计划明细ID';


--
-- TOC entry 8720 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.checked_user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.checked_user_id IS '检查人员ID';


--
-- TOC entry 8721 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.remark IS '备注';


--
-- TOC entry 8722 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8723 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.create_time IS '创建时间';


--
-- TOC entry 8724 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.create_by IS '创建者';


--
-- TOC entry 8725 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.update_time IS '更新时间';


--
-- TOC entry 8726 (class 0 OID 0)
-- Dependencies: 578
-- Name: COLUMN post_plan_info_user.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_plan_info_user.update_by IS '更新者';


--
-- TOC entry 577 (class 1259 OID 16975)
-- Name: post_programme; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_programme (
    id bigint NOT NULL,
    name character varying(255 char),
    submit_date timestamp(0) with time zone,
    post_programme_template_id bigint,
    status_hr integer,
    date_hr timestamp(0) with time zone,
    reason_hr character varying(255 char),
    status_icfa integer,
    date_icfa timestamp(0) with time zone,
    reason_icfa character varying(255 char),
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_programme OWNER TO postcheckuser;

--
-- TOC entry 8727 (class 0 OID 0)
-- Dependencies: 577
-- Name: TABLE post_programme; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_programme IS '岗检方案';


--
-- TOC entry 8728 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.id IS '主键ID';


--
-- TOC entry 8729 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.name IS '名称';


--
-- TOC entry 8730 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.submit_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.submit_date IS '提交日期';


--
-- TOC entry 8731 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.post_programme_template_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.post_programme_template_id IS '方案模板表ID';


--
-- TOC entry 8732 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_hr IS '人力资源审批-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8733 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.date_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.date_hr IS '人力资源审批-通过日期';


--
-- TOC entry 8734 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.reason_hr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.reason_hr IS '人力资源审批-未通过理由';


--
-- TOC entry 8735 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.status_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.status_icfa IS '内控法务部审批-状态：1-待审核；3-通过；4-驳回；';


--
-- TOC entry 8736 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.date_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.date_icfa IS '内控法务部审批-通过日期';


--
-- TOC entry 8737 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.reason_icfa; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.reason_icfa IS '内控法务部审批-未通过理由';


--
-- TOC entry 8738 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.remark IS '备注';


--
-- TOC entry 8739 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8740 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.create_time IS '创建时间';


--
-- TOC entry 8741 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.create_by IS '创建者';


--
-- TOC entry 8742 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.update_time IS '更新时间';


--
-- TOC entry 8743 (class 0 OID 0)
-- Dependencies: 577
-- Name: COLUMN post_programme.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme.update_by IS '更新者';


--
-- TOC entry 571 (class 1259 OID 16935)
-- Name: post_programme_template; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_programme_template (
    id bigint NOT NULL,
    plan_name character varying(255 char) NOT NULL,
    template_name character varying(255 char) NOT NULL,
    disk_path character varying(255 char) NOT NULL,
    status integer NOT NULL,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_programme_template OWNER TO postcheckuser;

--
-- TOC entry 8744 (class 0 OID 0)
-- Dependencies: 571
-- Name: TABLE post_programme_template; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_programme_template IS '岗检方案模板';


--
-- TOC entry 8745 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.id IS '主键ID';


--
-- TOC entry 8746 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.plan_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.plan_name IS '方案名称';


--
-- TOC entry 8747 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.template_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.template_name IS '模板名称';


--
-- TOC entry 8748 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.disk_path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.disk_path IS '模板磁盘路径';


--
-- TOC entry 8749 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.status IS '状态（1-启动；2-作废）';


--
-- TOC entry 8750 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.remark IS '备注';


--
-- TOC entry 8751 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8752 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.create_time IS '创建时间';


--
-- TOC entry 8753 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.create_by IS '创建者';


--
-- TOC entry 8754 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.update_time IS '更新时间';


--
-- TOC entry 8755 (class 0 OID 0)
-- Dependencies: 571
-- Name: COLUMN post_programme_template.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_programme_template.update_by IS '更新者';


--
-- TOC entry 592 (class 1259 OID 17087)
-- Name: post_team; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_team (
    id bigint NOT NULL,
    name character varying(255 char),
    parent_id bigint,
    status integer,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_team OWNER TO postcheckuser;

--
-- TOC entry 8756 (class 0 OID 0)
-- Dependencies: 592
-- Name: TABLE post_team; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_team IS '岗检小组';


--
-- TOC entry 8757 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.id IS '主键ID';


--
-- TOC entry 8758 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.name IS '名称';


--
-- TOC entry 8759 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.parent_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.parent_id IS '父ID（0代表根节点）';


--
-- TOC entry 8760 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.status IS '状态（1-启用；2-未启用）';


--
-- TOC entry 8761 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.remark IS '备注';


--
-- TOC entry 8762 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8763 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.create_time IS '创建时间';


--
-- TOC entry 8764 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.create_by IS '创建者';


--
-- TOC entry 8765 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.update_time IS '更新时间';


--
-- TOC entry 8766 (class 0 OID 0)
-- Dependencies: 592
-- Name: COLUMN post_team.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team.update_by IS '更新者';


--
-- TOC entry 570 (class 1259 OID 16931)
-- Name: post_team_user; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.post_team_user (
    id bigint NOT NULL,
    post_team_id character varying(255 char),
    user_id bigint,
    type integer,
    remark character varying(500 char),
    del_flag character(1 char) DEFAULT '0'::bpchar NOT NULL,
    create_time timestamp(0) with time zone NOT NULL,
    create_by varchar DEFAULT ''::varchar NOT NULL,
    update_time timestamp(0) with time zone NOT NULL,
    update_by bigint DEFAULT ''::varchar NOT NULL
);


ALTER TABLE public.post_team_user OWNER TO postcheckuser;

--
-- TOC entry 8767 (class 0 OID 0)
-- Dependencies: 570
-- Name: TABLE post_team_user; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.post_team_user IS '岗检小组成员';


--
-- TOC entry 8768 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.id IS '主键ID';


--
-- TOC entry 8769 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.post_team_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.post_team_id IS '岗检小组ID';


--
-- TOC entry 8770 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.user_id IS '用户ID';


--
-- TOC entry 8771 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.type IS '类型（1-小组成员；2-负责人）';


--
-- TOC entry 8772 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.remark IS '备注';


--
-- TOC entry 8773 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8774 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.create_time IS '创建时间';


--
-- TOC entry 8775 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.create_by IS '创建者';


--
-- TOC entry 8776 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.update_time IS '更新时间';


--
-- TOC entry 8777 (class 0 OID 0)
-- Dependencies: 570
-- Name: COLUMN post_team_user.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.post_team_user.update_by IS '更新者';


--
-- TOC entry 572 (class 1259 OID 16939)
-- Name: qrtz_blob_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_blob_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    blob_data blob
);


ALTER TABLE public.qrtz_blob_triggers OWNER TO postcheckuser;

--
-- TOC entry 8778 (class 0 OID 0)
-- Dependencies: 572
-- Name: TABLE qrtz_blob_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_blob_triggers IS 'Blob类型的触发器表';


--
-- TOC entry 8779 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.sched_name IS '调度名称';


--
-- TOC entry 8780 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 8781 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 8782 (class 0 OID 0)
-- Dependencies: 572
-- Name: COLUMN qrtz_blob_triggers.blob_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_blob_triggers.blob_data IS '存放持久化Trigger对象';


--
-- TOC entry 589 (class 1259 OID 17044)
-- Name: qrtz_calendars; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_calendars (
    sched_name character varying(120 char) NOT NULL,
    calendar_name character varying(200 char) NOT NULL,
    calendar blob NOT NULL
);


ALTER TABLE public.qrtz_calendars OWNER TO postcheckuser;

--
-- TOC entry 8783 (class 0 OID 0)
-- Dependencies: 589
-- Name: TABLE qrtz_calendars; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_calendars IS '日历信息表';


--
-- TOC entry 8784 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN qrtz_calendars.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_calendars.sched_name IS '调度名称';


--
-- TOC entry 8785 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN qrtz_calendars.calendar_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_calendars.calendar_name IS '日历名称';


--
-- TOC entry 8786 (class 0 OID 0)
-- Dependencies: 589
-- Name: COLUMN qrtz_calendars.calendar; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_calendars.calendar IS '存放持久化calendar对象';


--
-- TOC entry 574 (class 1259 OID 16950)
-- Name: qrtz_cron_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_cron_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    cron_expression character varying(200 char) NOT NULL,
    time_zone_id character varying(80 char)
);


ALTER TABLE public.qrtz_cron_triggers OWNER TO postcheckuser;

--
-- TOC entry 8787 (class 0 OID 0)
-- Dependencies: 574
-- Name: TABLE qrtz_cron_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_cron_triggers IS 'Cron类型的触发器表';


--
-- TOC entry 8788 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.sched_name IS '调度名称';


--
-- TOC entry 8789 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 8790 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 8791 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.cron_expression; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.cron_expression IS 'cron表达式';


--
-- TOC entry 8792 (class 0 OID 0)
-- Dependencies: 574
-- Name: COLUMN qrtz_cron_triggers.time_zone_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_cron_triggers.time_zone_id IS '时区';


--
-- TOC entry 573 (class 1259 OID 16945)
-- Name: qrtz_fired_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_fired_triggers (
    sched_name character varying(120 char) NOT NULL,
    entry_id character varying(95 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    instance_name character varying(200 char) NOT NULL,
    fired_time bigint NOT NULL,
    sched_time bigint NOT NULL,
    priority integer NOT NULL,
    state character varying(16 char) NOT NULL,
    job_name character varying(200 char),
    job_group character varying(200 char),
    is_nonconcurrent character varying(1 char),
    requests_recovery character varying(1 char)
);


ALTER TABLE public.qrtz_fired_triggers OWNER TO postcheckuser;

--
-- TOC entry 8793 (class 0 OID 0)
-- Dependencies: 573
-- Name: TABLE qrtz_fired_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_fired_triggers IS '已触发的触发器表';


--
-- TOC entry 8794 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.sched_name IS '调度名称';


--
-- TOC entry 8795 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.entry_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.entry_id IS '调度器实例id';


--
-- TOC entry 8796 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 8797 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 8798 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.instance_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.instance_name IS '调度器实例名';


--
-- TOC entry 8799 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.fired_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.fired_time IS '触发的时间';


--
-- TOC entry 8800 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.sched_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.sched_time IS '定时器制定的时间';


--
-- TOC entry 8801 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.priority; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.priority IS '优先级';


--
-- TOC entry 8802 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.state; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.state IS '状态';


--
-- TOC entry 8803 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.job_name IS '任务名称';


--
-- TOC entry 8804 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.job_group IS '任务组名';


--
-- TOC entry 8805 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.is_nonconcurrent; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.is_nonconcurrent IS '是否并发';


--
-- TOC entry 8806 (class 0 OID 0)
-- Dependencies: 573
-- Name: COLUMN qrtz_fired_triggers.requests_recovery; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_fired_triggers.requests_recovery IS '是否接受恢复执行';


--
-- TOC entry 585 (class 1259 OID 17022)
-- Name: qrtz_job_details; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_job_details (
    sched_name character varying(120 char) NOT NULL,
    job_name character varying(200 char) NOT NULL,
    job_group character varying(200 char) NOT NULL,
    description character varying(250 char),
    job_class_name character varying(250 char) NOT NULL,
    is_durable character varying(1 char) NOT NULL,
    is_nonconcurrent character varying(1 char) NOT NULL,
    is_update_data character varying(1 char) NOT NULL,
    requests_recovery character varying(1 char) NOT NULL,
    job_data blob
);


ALTER TABLE public.qrtz_job_details OWNER TO postcheckuser;

--
-- TOC entry 8807 (class 0 OID 0)
-- Dependencies: 585
-- Name: TABLE qrtz_job_details; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_job_details IS '任务详细信息表';


--
-- TOC entry 8808 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.sched_name IS '调度名称';


--
-- TOC entry 8809 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_name IS '任务名称';


--
-- TOC entry 8810 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_group IS '任务组名';


--
-- TOC entry 8811 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.description; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.description IS '相关介绍';


--
-- TOC entry 8812 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.job_class_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_class_name IS '执行任务类名称';


--
-- TOC entry 8813 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.is_durable; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.is_durable IS '是否持久化';


--
-- TOC entry 8814 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.is_nonconcurrent; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.is_nonconcurrent IS '是否并发';


--
-- TOC entry 8815 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.is_update_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.is_update_data IS '是否更新数据';


--
-- TOC entry 8816 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.requests_recovery; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.requests_recovery IS '是否接受恢复执行';


--
-- TOC entry 8817 (class 0 OID 0)
-- Dependencies: 585
-- Name: COLUMN qrtz_job_details.job_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_job_details.job_data IS '存放持久化job对象';


--
-- TOC entry 569 (class 1259 OID 16928)
-- Name: qrtz_locks; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_locks (
    sched_name character varying(120 char) NOT NULL,
    lock_name character varying(40 char) NOT NULL
);


ALTER TABLE public.qrtz_locks OWNER TO postcheckuser;

--
-- TOC entry 8818 (class 0 OID 0)
-- Dependencies: 569
-- Name: TABLE qrtz_locks; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_locks IS '存储的悲观锁信息表';


--
-- TOC entry 8819 (class 0 OID 0)
-- Dependencies: 569
-- Name: COLUMN qrtz_locks.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_locks.sched_name IS '调度名称';


--
-- TOC entry 8820 (class 0 OID 0)
-- Dependencies: 569
-- Name: COLUMN qrtz_locks.lock_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_locks.lock_name IS '悲观锁名称';


--
-- TOC entry 593 (class 1259 OID 17091)
-- Name: qrtz_paused_trigger_grps; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_paused_trigger_grps (
    sched_name character varying(120 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL
);


ALTER TABLE public.qrtz_paused_trigger_grps OWNER TO postcheckuser;

--
-- TOC entry 8821 (class 0 OID 0)
-- Dependencies: 593
-- Name: TABLE qrtz_paused_trigger_grps; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_paused_trigger_grps IS '暂停的触发器表';


--
-- TOC entry 8822 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN qrtz_paused_trigger_grps.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_paused_trigger_grps.sched_name IS '调度名称';


--
-- TOC entry 8823 (class 0 OID 0)
-- Dependencies: 593
-- Name: COLUMN qrtz_paused_trigger_grps.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_paused_trigger_grps.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 583 (class 1259 OID 17012)
-- Name: qrtz_scheduler_state; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_scheduler_state (
    sched_name character varying(120 char) NOT NULL,
    instance_name character varying(200 char) NOT NULL,
    last_checkin_time bigint NOT NULL,
    checkin_interval bigint NOT NULL
);


ALTER TABLE public.qrtz_scheduler_state OWNER TO postcheckuser;

--
-- TOC entry 8824 (class 0 OID 0)
-- Dependencies: 583
-- Name: TABLE qrtz_scheduler_state; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_scheduler_state IS '调度器状态表';


--
-- TOC entry 8825 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN qrtz_scheduler_state.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.sched_name IS '调度名称';


--
-- TOC entry 8826 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN qrtz_scheduler_state.instance_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.instance_name IS '实例名称';


--
-- TOC entry 8827 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN qrtz_scheduler_state.last_checkin_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.last_checkin_time IS '上次检查时间';


--
-- TOC entry 8828 (class 0 OID 0)
-- Dependencies: 583
-- Name: COLUMN qrtz_scheduler_state.checkin_interval; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_scheduler_state.checkin_interval IS '检查间隔时间';


--
-- TOC entry 600 (class 1259 OID 17144)
-- Name: qrtz_simple_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_simple_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    repeat_count bigint NOT NULL,
    repeat_interval bigint NOT NULL,
    times_triggered bigint NOT NULL
);


ALTER TABLE public.qrtz_simple_triggers OWNER TO postcheckuser;

--
-- TOC entry 8829 (class 0 OID 0)
-- Dependencies: 600
-- Name: TABLE qrtz_simple_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_simple_triggers IS '简单触发器的信息表';


--
-- TOC entry 8830 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN qrtz_simple_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.sched_name IS '调度名称';


--
-- TOC entry 8831 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN qrtz_simple_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 8832 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN qrtz_simple_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 8833 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN qrtz_simple_triggers.repeat_count; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.repeat_count IS '重复的次数统计';


--
-- TOC entry 8834 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN qrtz_simple_triggers.repeat_interval; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.repeat_interval IS '重复的间隔时间';


--
-- TOC entry 8835 (class 0 OID 0)
-- Dependencies: 600
-- Name: COLUMN qrtz_simple_triggers.times_triggered; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simple_triggers.times_triggered IS '已经触发的次数';


--
-- TOC entry 586 (class 1259 OID 17030)
-- Name: qrtz_simprop_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_simprop_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    str_prop_1 character varying(512 char),
    str_prop_2 character varying(512 char),
    str_prop_3 character varying(512 char),
    int_prop_1 integer,
    int_prop_2 integer,
    long_prop_1 bigint,
    long_prop_2 bigint,
    dec_prop_1 numeric(13,4),
    dec_prop_2 numeric(13,4),
    bool_prop_1 character varying(1 char),
    bool_prop_2 character varying(1 char)
);


ALTER TABLE public.qrtz_simprop_triggers OWNER TO postcheckuser;

--
-- TOC entry 8836 (class 0 OID 0)
-- Dependencies: 586
-- Name: TABLE qrtz_simprop_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_simprop_triggers IS '同步机制的行锁表';


--
-- TOC entry 8837 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.sched_name IS '调度名称';


--
-- TOC entry 8838 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.trigger_name IS 'qrtz_triggers表trigger_name的外键';


--
-- TOC entry 8839 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.trigger_group IS 'qrtz_triggers表trigger_group的外键';


--
-- TOC entry 8840 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.str_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.str_prop_1 IS 'String类型的trigger的第一个参数';


--
-- TOC entry 8841 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.str_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.str_prop_2 IS 'String类型的trigger的第二个参数';


--
-- TOC entry 8842 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.str_prop_3; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.str_prop_3 IS 'String类型的trigger的第三个参数';


--
-- TOC entry 8843 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.int_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.int_prop_1 IS 'int类型的trigger的第一个参数';


--
-- TOC entry 8844 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.int_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.int_prop_2 IS 'int类型的trigger的第二个参数';


--
-- TOC entry 8845 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.long_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.long_prop_1 IS 'long类型的trigger的第一个参数';


--
-- TOC entry 8846 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.long_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.long_prop_2 IS 'long类型的trigger的第二个参数';


--
-- TOC entry 8847 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.dec_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.dec_prop_1 IS 'decimal类型的trigger的第一个参数';


--
-- TOC entry 8848 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.dec_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.dec_prop_2 IS 'decimal类型的trigger的第二个参数';


--
-- TOC entry 8849 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.bool_prop_1; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.bool_prop_1 IS 'Boolean类型的trigger的第一个参数';


--
-- TOC entry 8850 (class 0 OID 0)
-- Dependencies: 586
-- Name: COLUMN qrtz_simprop_triggers.bool_prop_2; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_simprop_triggers.bool_prop_2 IS 'Boolean类型的trigger的第二个参数';


--
-- TOC entry 603 (class 1259 OID 17168)
-- Name: qrtz_triggers; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.qrtz_triggers (
    sched_name character varying(120 char) NOT NULL,
    trigger_name character varying(200 char) NOT NULL,
    trigger_group character varying(200 char) NOT NULL,
    job_name character varying(200 char) NOT NULL,
    job_group character varying(200 char) NOT NULL,
    description character varying(250 char),
    next_fire_time bigint,
    prev_fire_time bigint,
    priority integer,
    trigger_state character varying(16 char) NOT NULL,
    trigger_type character varying(8 char) NOT NULL,
    start_time bigint NOT NULL,
    end_time bigint,
    calendar_name character varying(200 char),
    misfire_instr smallint,
    job_data blob
);


ALTER TABLE public.qrtz_triggers OWNER TO postcheckuser;

--
-- TOC entry 8851 (class 0 OID 0)
-- Dependencies: 603
-- Name: TABLE qrtz_triggers; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.qrtz_triggers IS '触发器详细信息表';


--
-- TOC entry 8852 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.sched_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.sched_name IS '调度名称';


--
-- TOC entry 8853 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.trigger_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_name IS '触发器的名字';


--
-- TOC entry 8854 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.trigger_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_group IS '触发器所属组的名字';


--
-- TOC entry 8855 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.job_name IS 'qrtz_job_details表job_name的外键';


--
-- TOC entry 8856 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.job_group IS 'qrtz_job_details表job_group的外键';


--
-- TOC entry 8857 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.description; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.description IS '相关介绍';


--
-- TOC entry 8858 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.next_fire_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.next_fire_time IS '上一次触发时间（毫秒）';


--
-- TOC entry 8859 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.prev_fire_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.prev_fire_time IS '下一次触发时间（默认为-1表示不触发）';


--
-- TOC entry 8860 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.priority; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.priority IS '优先级';


--
-- TOC entry 8861 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.trigger_state; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_state IS '触发器状态';


--
-- TOC entry 8862 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.trigger_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.trigger_type IS '触发器的类型';


--
-- TOC entry 8863 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.start_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.start_time IS '开始时间';


--
-- TOC entry 8864 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.end_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.end_time IS '结束时间';


--
-- TOC entry 8865 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.calendar_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.calendar_name IS '日程表名称';


--
-- TOC entry 8866 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.misfire_instr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.misfire_instr IS '补偿执行的策略';


--
-- TOC entry 8867 (class 0 OID 0)
-- Dependencies: 603
-- Name: COLUMN qrtz_triggers.job_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.qrtz_triggers.job_data IS '存放持久化job对象';


--
-- TOC entry 576 (class 1259 OID 16962)
-- Name: sys_con; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_con (
    config_id integer NOT NULL,
    config_name character varying(100 char) DEFAULT ''::varchar,
    config_key character varying(100 char) DEFAULT ''::varchar,
    config_value character varying(500 char) DEFAULT ''::varchar,
    config_type character(1 char) DEFAULT 'N'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_con OWNER TO postcheckuser;

--
-- TOC entry 8868 (class 0 OID 0)
-- Dependencies: 576
-- Name: TABLE sys_con; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_con IS '参数配置表';


--
-- TOC entry 8869 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_id IS '参数主键';


--
-- TOC entry 8870 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_name IS '参数名称';


--
-- TOC entry 8871 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_key; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_key IS '参数键名';


--
-- TOC entry 8872 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_value; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_value IS '参数键值';


--
-- TOC entry 8873 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.config_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.config_type IS '系统内置（Y是 N否）';


--
-- TOC entry 8874 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.create_by IS '创建者';


--
-- TOC entry 8875 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.create_time IS '创建时间';


--
-- TOC entry 8876 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.update_by IS '更新者';


--
-- TOC entry 8877 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.update_time IS '更新时间';


--
-- TOC entry 8878 (class 0 OID 0)
-- Dependencies: 576
-- Name: COLUMN sys_con.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_con.remark IS '备注';


--
-- TOC entry 581 (class 1259 OID 16990)
-- Name: sys_dept; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_dept (
    dept_id bigint NOT NULL,
    parent_id bigint DEFAULT 0,
    ancestors character varying(50 char) DEFAULT ''::varchar,
    dept_name character varying(30 char) DEFAULT ''::varchar,
    order_num integer DEFAULT 0,
    leader character varying(20 char),
    phone character varying(11 char),
    email character varying(50 char),
    status character(1 char) DEFAULT '0'::bpchar,
    del_flag character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone
);


ALTER TABLE public.sys_dept OWNER TO postcheckuser;

--
-- TOC entry 8879 (class 0 OID 0)
-- Dependencies: 581
-- Name: TABLE sys_dept; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_dept IS '部门表';


--
-- TOC entry 8880 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.dept_id IS '部门id';


--
-- TOC entry 8881 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.parent_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.parent_id IS '父部门id';


--
-- TOC entry 8882 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.ancestors; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.ancestors IS '祖级列表';


--
-- TOC entry 8883 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.dept_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.dept_name IS '部门名称';


--
-- TOC entry 8884 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.order_num; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.order_num IS '显示顺序';


--
-- TOC entry 8885 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.leader; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.leader IS '负责人';


--
-- TOC entry 8886 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.phone; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.phone IS '联系电话';


--
-- TOC entry 8887 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.email; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.email IS '邮箱';


--
-- TOC entry 8888 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.status IS '部门状态（0正常 1停用）';


--
-- TOC entry 8889 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 8890 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.create_by IS '创建者';


--
-- TOC entry 8891 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.create_time IS '创建时间';


--
-- TOC entry 8892 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.update_by IS '更新者';


--
-- TOC entry 8893 (class 0 OID 0)
-- Dependencies: 581
-- Name: COLUMN sys_dept.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dept.update_time IS '更新时间';


--
-- TOC entry 604 (class 1259 OID 17180)
-- Name: sys_dict_data; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_dict_data (
    dict_code bigint NOT NULL,
    dict_sort integer DEFAULT 0,
    dict_label character varying(100 char) DEFAULT ''::varchar,
    dict_value character varying(100 char) DEFAULT ''::varchar,
    dict_type character varying(100 char) DEFAULT ''::varchar,
    css_class character varying(100 char),
    list_class character varying(100 char),
    is_default character(1 char) DEFAULT 'N'::bpchar,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_dict_data OWNER TO postcheckuser;

--
-- TOC entry 8894 (class 0 OID 0)
-- Dependencies: 604
-- Name: TABLE sys_dict_data; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_dict_data IS '字典数据表';


--
-- TOC entry 8895 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.dict_code; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_code IS '字典编码';


--
-- TOC entry 8896 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.dict_sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_sort IS '字典排序';


--
-- TOC entry 8897 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.dict_label; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_label IS '字典标签';


--
-- TOC entry 8898 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.dict_value; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_value IS '字典键值';


--
-- TOC entry 8899 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.dict_type IS '字典类型';


--
-- TOC entry 8900 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.css_class; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.css_class IS '样式属性（其他样式扩展）';


--
-- TOC entry 8901 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.list_class; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.list_class IS '表格回显样式';


--
-- TOC entry 8902 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.is_default; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.is_default IS '是否默认（Y是 N否）';


--
-- TOC entry 8903 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.status IS '状态（0正常 1停用）';


--
-- TOC entry 8904 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.create_by IS '创建者';


--
-- TOC entry 8905 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.create_time IS '创建时间';


--
-- TOC entry 8906 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.update_by IS '更新者';


--
-- TOC entry 8907 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.update_time IS '更新时间';


--
-- TOC entry 8908 (class 0 OID 0)
-- Dependencies: 604
-- Name: COLUMN sys_dict_data.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_data.remark IS '备注';


--
-- TOC entry 610 (class 1259 OID 17248)
-- Name: sys_dict_type; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_dict_type (
    dict_id bigint NOT NULL,
    dict_name character varying(100 char) DEFAULT ''::varchar,
    dict_type character varying(100 char) DEFAULT ''::varchar,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_dict_type OWNER TO postcheckuser;

--
-- TOC entry 8909 (class 0 OID 0)
-- Dependencies: 610
-- Name: TABLE sys_dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_dict_type IS '字典类型表';


--
-- TOC entry 8910 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.dict_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.dict_id IS '字典主键';


--
-- TOC entry 8911 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.dict_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.dict_name IS '字典名称';


--
-- TOC entry 8912 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.dict_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.dict_type IS '字典类型';


--
-- TOC entry 8913 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.status IS '状态（0正常 1停用）';


--
-- TOC entry 8914 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.create_by IS '创建者';


--
-- TOC entry 8915 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.create_time IS '创建时间';


--
-- TOC entry 8916 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.update_by IS '更新者';


--
-- TOC entry 8917 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.update_time IS '更新时间';


--
-- TOC entry 8918 (class 0 OID 0)
-- Dependencies: 610
-- Name: COLUMN sys_dict_type.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_dict_type.remark IS '备注';


--
-- TOC entry 602 (class 1259 OID 17156)
-- Name: sys_job; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_job (
    job_id bigint NOT NULL,
    job_name character varying(64 char) DEFAULT ''::varchar NOT NULL,
    job_group character varying(64 char) DEFAULT 'DEFAULT'::varchar NOT NULL,
    invoke_target character varying(500 char) NOT NULL,
    cron_expression character varying(255 char) DEFAULT ''::varchar,
    misfire_policy character varying(20 char) DEFAULT '3'::varchar,
    concurrent character(1 char) DEFAULT '1'::bpchar,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char) DEFAULT ''::varchar
);


ALTER TABLE public.sys_job OWNER TO postcheckuser;

--
-- TOC entry 8919 (class 0 OID 0)
-- Dependencies: 602
-- Name: TABLE sys_job; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_job IS '定时任务调度表';


--
-- TOC entry 8920 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.job_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.job_id IS '任务ID';


--
-- TOC entry 8921 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.job_name IS '任务名称';


--
-- TOC entry 8922 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.job_group IS '任务组名';


--
-- TOC entry 8923 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.invoke_target; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.invoke_target IS '调用目标字符串';


--
-- TOC entry 8924 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.cron_expression; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.cron_expression IS 'cron执行表达式';


--
-- TOC entry 8925 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.misfire_policy; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.misfire_policy IS '计划执行错误策略（1立即执行 2执行一次 3放弃执行）';


--
-- TOC entry 8926 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.concurrent; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.concurrent IS '是否并发执行（0允许 1禁止）';


--
-- TOC entry 8927 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.status IS '状态（0正常 1暂停）';


--
-- TOC entry 8928 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.create_by IS '创建者';


--
-- TOC entry 8929 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.create_time IS '创建时间';


--
-- TOC entry 8930 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.update_by IS '更新者';


--
-- TOC entry 8931 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.update_time IS '更新时间';


--
-- TOC entry 8932 (class 0 OID 0)
-- Dependencies: 602
-- Name: COLUMN sys_job.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job.remark IS '备注信息';


--
-- TOC entry 567 (class 1259 OID 16916)
-- Name: sys_job_log; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_job_log (
    job_log_id bigint NOT NULL,
    job_name character varying(64 char) NOT NULL,
    job_group character varying(64 char) NOT NULL,
    invoke_target character varying(500 char) NOT NULL,
    job_message character varying(500 char),
    status character(1 char) DEFAULT '0'::bpchar,
    exception_info character varying(2000 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone
);


ALTER TABLE public.sys_job_log OWNER TO postcheckuser;

--
-- TOC entry 8933 (class 0 OID 0)
-- Dependencies: 567
-- Name: TABLE sys_job_log; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_job_log IS '定时任务调度日志表';


--
-- TOC entry 8934 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_log_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_log_id IS '任务日志ID';


--
-- TOC entry 8935 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_name IS '任务名称';


--
-- TOC entry 8936 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_group; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_group IS '任务组名';


--
-- TOC entry 8937 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.invoke_target; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.invoke_target IS '调用目标字符串';


--
-- TOC entry 8938 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.job_message; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.job_message IS '日志信息';


--
-- TOC entry 8939 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.status IS '执行状态（0正常 1失败）';


--
-- TOC entry 8940 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.exception_info; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.exception_info IS '异常信息';


--
-- TOC entry 8941 (class 0 OID 0)
-- Dependencies: 567
-- Name: COLUMN sys_job_log.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_job_log.create_time IS '创建时间';


--
-- TOC entry 609 (class 1259 OID 17234)
-- Name: sys_logininfor; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_logininfor (
    info_id bigint NOT NULL,
    user_name character varying(50 char) DEFAULT ''::varchar,
    ipaddr character varying(128 char) DEFAULT ''::varchar,
    login_location character varying(255 char) DEFAULT ''::varchar,
    browser character varying(50 char) DEFAULT ''::varchar,
    os character varying(50 char) DEFAULT ''::varchar,
    status character(1 char) DEFAULT '0'::bpchar,
    msg character varying(255 char) DEFAULT ''::varchar,
    login_time timestamp(0) with time zone
);


ALTER TABLE public.sys_logininfor OWNER TO postcheckuser;

--
-- TOC entry 8942 (class 0 OID 0)
-- Dependencies: 609
-- Name: TABLE sys_logininfor; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_logininfor IS '系统访问记录';


--
-- TOC entry 8943 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.info_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.info_id IS '访问ID';


--
-- TOC entry 8944 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.user_name IS '用户账号';


--
-- TOC entry 8945 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.ipaddr; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.ipaddr IS '登录IP地址';


--
-- TOC entry 8946 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.login_location; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.login_location IS '登录地点';


--
-- TOC entry 8947 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.browser; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.browser IS '浏览器类型';


--
-- TOC entry 8948 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.os; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.os IS '操作系统';


--
-- TOC entry 8949 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.status IS '登录状态（0成功 1失败）';


--
-- TOC entry 8950 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.msg; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.msg IS '提示消息';


--
-- TOC entry 8951 (class 0 OID 0)
-- Dependencies: 609
-- Name: COLUMN sys_logininfor.login_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_logininfor.login_time IS '访问时间';


--
-- TOC entry 605 (class 1259 OID 17191)
-- Name: sys_menu; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_menu (
    menu_id bigint NOT NULL,
    menu_name character varying(50 char) NOT NULL,
    parent_id bigint DEFAULT 0,
    order_num integer DEFAULT 0,
    path character varying(200 char) DEFAULT ''::varchar,
    component character varying(255 char),
    query character varying(255 char),
    is_frame integer DEFAULT 1,
    is_cache integer DEFAULT 0,
    menu_type character(1 char) DEFAULT ''::bpchar,
    visible character(1 char) DEFAULT '0'::bpchar,
    status character(1 char) DEFAULT '0'::bpchar,
    perms character varying(100 char),
    icon character varying(100 char) DEFAULT '#'::varchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char) DEFAULT ''::varchar
);


ALTER TABLE public.sys_menu OWNER TO postcheckuser;

--
-- TOC entry 8952 (class 0 OID 0)
-- Dependencies: 605
-- Name: TABLE sys_menu; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_menu IS '菜单权限表';


--
-- TOC entry 8953 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.menu_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.menu_id IS '菜单ID';


--
-- TOC entry 8954 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.menu_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.menu_name IS '菜单名称';


--
-- TOC entry 8955 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.parent_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.parent_id IS '父菜单ID';


--
-- TOC entry 8956 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.order_num; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.order_num IS '显示顺序';


--
-- TOC entry 8957 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.path; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.path IS '路由地址';


--
-- TOC entry 8958 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.component; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.component IS '组件路径';


--
-- TOC entry 8959 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.query; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.query IS '路由参数';


--
-- TOC entry 8960 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.is_frame; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.is_frame IS '是否为外链（0是 1否）';


--
-- TOC entry 8961 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.is_cache; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.is_cache IS '是否缓存（0缓存 1不缓存）';


--
-- TOC entry 8962 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.menu_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.menu_type IS '菜单类型（M目录 C菜单 F按钮）';


--
-- TOC entry 8963 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.visible; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.visible IS '菜单状态（0显示 1隐藏）';


--
-- TOC entry 8964 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.status IS '菜单状态（0正常 1停用）';


--
-- TOC entry 8965 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.perms; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.perms IS '权限标识';


--
-- TOC entry 8966 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.icon; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.icon IS '菜单图标';


--
-- TOC entry 8967 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.create_by IS '创建者';


--
-- TOC entry 8968 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.create_time IS '创建时间';


--
-- TOC entry 8969 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.update_by IS '更新者';


--
-- TOC entry 8970 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.update_time IS '更新时间';


--
-- TOC entry 8971 (class 0 OID 0)
-- Dependencies: 605
-- Name: COLUMN sys_menu.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_menu.remark IS '备注';


--
-- TOC entry 596 (class 1259 OID 17113)
-- Name: sys_notice; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_notice (
    notice_id integer NOT NULL,
    notice_title character varying(50 char) NOT NULL,
    notice_type character(1 char) NOT NULL,
    notice_content blob,
    status character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(255 char)
);


ALTER TABLE public.sys_notice OWNER TO postcheckuser;

--
-- TOC entry 8972 (class 0 OID 0)
-- Dependencies: 596
-- Name: TABLE sys_notice; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_notice IS '通知公告表';


--
-- TOC entry 8973 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.notice_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_id IS '公告ID';


--
-- TOC entry 8974 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.notice_title; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_title IS '公告标题';


--
-- TOC entry 8975 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.notice_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_type IS '公告类型（1通知 2公告）';


--
-- TOC entry 8976 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.notice_content; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.notice_content IS '公告内容';


--
-- TOC entry 8977 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.status IS '公告状态（0正常 1关闭）';


--
-- TOC entry 8978 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.create_by IS '创建者';


--
-- TOC entry 8979 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.create_time IS '创建时间';


--
-- TOC entry 8980 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.update_by IS '更新者';


--
-- TOC entry 8981 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.update_time IS '更新时间';


--
-- TOC entry 8982 (class 0 OID 0)
-- Dependencies: 596
-- Name: COLUMN sys_notice.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_notice.remark IS '备注';


--
-- TOC entry 591 (class 1259 OID 17066)
-- Name: sys_oper_log; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_oper_log (
    oper_id bigint NOT NULL,
    title character varying(50 char) DEFAULT ''::varchar,
    business_type integer DEFAULT 0,
    method character varying(100 char) DEFAULT ''::varchar,
    request_method character varying(10 char) DEFAULT ''::varchar,
    operator_type integer DEFAULT 0,
    oper_name character varying(50 char) DEFAULT ''::varchar,
    dept_name character varying(50 char) DEFAULT ''::varchar,
    oper_url character varying(255 char) DEFAULT ''::varchar,
    oper_ip character varying(128 char) DEFAULT ''::varchar,
    oper_location character varying(255 char) DEFAULT ''::varchar,
    oper_param character varying(2000 char) DEFAULT ''::varchar,
    json_result character varying(2000 char) DEFAULT ''::varchar,
    status integer DEFAULT 0,
    error_msg character varying(2000 char) DEFAULT ''::varchar,
    oper_time timestamp(0) with time zone,
    cost_time bigint DEFAULT 0
);


ALTER TABLE public.sys_oper_log OWNER TO postcheckuser;

--
-- TOC entry 8983 (class 0 OID 0)
-- Dependencies: 591
-- Name: TABLE sys_oper_log; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_oper_log IS '操作日志记录';


--
-- TOC entry 8984 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_id IS '日志主键';


--
-- TOC entry 8985 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.title; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.title IS '模块标题';


--
-- TOC entry 8986 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.business_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.business_type IS '业务类型（0其它 1新增 2修改 3删除）';


--
-- TOC entry 8987 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.method; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.method IS '方法名称';


--
-- TOC entry 8988 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.request_method; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.request_method IS '请求方式';


--
-- TOC entry 8989 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.operator_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.operator_type IS '操作类别（0其它 1后台用户 2手机端用户）';


--
-- TOC entry 8990 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_name IS '操作人员';


--
-- TOC entry 8991 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.dept_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.dept_name IS '部门名称';


--
-- TOC entry 8992 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_url; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_url IS '请求URL';


--
-- TOC entry 8993 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_ip; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_ip IS '主机地址';


--
-- TOC entry 8994 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_location; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_location IS '操作地点';


--
-- TOC entry 8995 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_param; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_param IS '请求参数';


--
-- TOC entry 8996 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.json_result; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.json_result IS '返回参数';


--
-- TOC entry 8997 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.status IS '操作状态（0正常 1异常）';


--
-- TOC entry 8998 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.error_msg; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.error_msg IS '错误消息';


--
-- TOC entry 8999 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.oper_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.oper_time IS '操作时间';


--
-- TOC entry 9000 (class 0 OID 0)
-- Dependencies: 591
-- Name: COLUMN sys_oper_log.cost_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_oper_log.cost_time IS '消耗时间';


--
-- TOC entry 594 (class 1259 OID 17096)
-- Name: sys_post; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_post (
    post_id bigint NOT NULL,
    post_code character varying(64 char) NOT NULL,
    post_name character varying(50 char) NOT NULL,
    post_sort integer NOT NULL,
    status character(1 char) NOT NULL,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_post OWNER TO postcheckuser;

--
-- TOC entry 9001 (class 0 OID 0)
-- Dependencies: 594
-- Name: TABLE sys_post; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_post IS '岗位信息表';


--
-- TOC entry 9002 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_id IS '岗位ID';


--
-- TOC entry 9003 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.post_code; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_code IS '岗位编码';


--
-- TOC entry 9004 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.post_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_name IS '岗位名称';


--
-- TOC entry 9005 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.post_sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.post_sort IS '显示顺序';


--
-- TOC entry 9006 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.status IS '状态（0正常 1停用）';


--
-- TOC entry 9007 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.create_by IS '创建者';


--
-- TOC entry 9008 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.create_time IS '创建时间';


--
-- TOC entry 9009 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.update_by IS '更新者';


--
-- TOC entry 9010 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.update_time IS '更新时间';


--
-- TOC entry 9011 (class 0 OID 0)
-- Dependencies: 594
-- Name: COLUMN sys_post.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_post.remark IS '备注';


--
-- TOC entry 599 (class 1259 OID 17141)
-- Name: sys_role; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_role (
    role_id bigint NOT NULL,
    role_name character varying(30 char) NOT NULL,
    role_key character varying(100 char) NOT NULL,
    role_sort integer NOT NULL,
    data_scope character(1 char) DEFAULT '1'::bpchar,
    menu_check_strictly tinyint DEFAULT 1,
    dept_check_strictly tinyint DEFAULT 1,
    status character(1 char) NOT NULL,
    del_flag character(1 char) DEFAULT '0'::bpchar,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_role OWNER TO postcheckuser;

--
-- TOC entry 9012 (class 0 OID 0)
-- Dependencies: 599
-- Name: TABLE sys_role; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_role IS '角色信息表';


--
-- TOC entry 9013 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_id IS '角色ID';


--
-- TOC entry 9014 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.role_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_name IS '角色名称';


--
-- TOC entry 9015 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.role_key; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_key IS '角色权限字符串';


--
-- TOC entry 9016 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.role_sort; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.role_sort IS '显示顺序';


--
-- TOC entry 9017 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.data_scope; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.data_scope IS '数据范围（1：全部数据权限 2：自定数据权限 3：本部门数据权限 4：本部门及以下数据权限）';


--
-- TOC entry 9018 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.menu_check_strictly; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.menu_check_strictly IS '菜单树选择项是否关联显示';


--
-- TOC entry 9019 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.dept_check_strictly; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.dept_check_strictly IS '部门树选择项是否关联显示';


--
-- TOC entry 9020 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.status IS '角色状态（0正常 1停用）';


--
-- TOC entry 9021 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 9022 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.create_by IS '创建者';


--
-- TOC entry 9023 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.create_time IS '创建时间';


--
-- TOC entry 9024 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.update_by IS '更新者';


--
-- TOC entry 9025 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.update_time IS '更新时间';


--
-- TOC entry 9026 (class 0 OID 0)
-- Dependencies: 599
-- Name: COLUMN sys_role.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role.remark IS '备注';


--
-- TOC entry 588 (class 1259 OID 17040)
-- Name: sys_role_dept; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_role_dept (
    role_id bigint NOT NULL,
    dept_id bigint NOT NULL
);


ALTER TABLE public.sys_role_dept OWNER TO postcheckuser;

--
-- TOC entry 9027 (class 0 OID 0)
-- Dependencies: 588
-- Name: TABLE sys_role_dept; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_role_dept IS '角色和部门关联表';


--
-- TOC entry 9028 (class 0 OID 0)
-- Dependencies: 588
-- Name: COLUMN sys_role_dept.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_dept.role_id IS '角色ID';


--
-- TOC entry 9029 (class 0 OID 0)
-- Dependencies: 588
-- Name: COLUMN sys_role_dept.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_dept.dept_id IS '部门ID';


--
-- TOC entry 607 (class 1259 OID 17217)
-- Name: sys_role_menu; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_role_menu (
    role_id bigint NOT NULL,
    menu_id bigint NOT NULL
);


ALTER TABLE public.sys_role_menu OWNER TO postcheckuser;

--
-- TOC entry 9030 (class 0 OID 0)
-- Dependencies: 607
-- Name: TABLE sys_role_menu; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_role_menu IS '角色和菜单关联表';


--
-- TOC entry 9031 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN sys_role_menu.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_menu.role_id IS '角色ID';


--
-- TOC entry 9032 (class 0 OID 0)
-- Dependencies: 607
-- Name: COLUMN sys_role_menu.menu_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_role_menu.menu_id IS '菜单ID';


--
-- TOC entry 597 (class 1259 OID 17122)
-- Name: sys_user_post; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_user_post (
    user_id bigint NOT NULL,
    post_id bigint NOT NULL
);


ALTER TABLE public.sys_user_post OWNER TO postcheckuser;

--
-- TOC entry 9035 (class 0 OID 0)
-- Dependencies: 597
-- Name: TABLE sys_user_post; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_user_post IS '用户与岗位关联表';


--
-- TOC entry 9036 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_user_post.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_post.user_id IS '用户ID';


--
-- TOC entry 9037 (class 0 OID 0)
-- Dependencies: 597
-- Name: COLUMN sys_user_post.post_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_post.post_id IS '岗位ID';


--
-- TOC entry 601 (class 1259 OID 17153)
-- Name: sys_user_role; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_user_role (
    user_id bigint NOT NULL,
    role_id bigint NOT NULL
);


ALTER TABLE public.sys_user_role OWNER TO postcheckuser;

--
-- TOC entry 9038 (class 0 OID 0)
-- Dependencies: 601
-- Name: TABLE sys_user_role; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_user_role IS '用户和角色关联表';


--
-- TOC entry 9039 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_user_role.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_role.user_id IS '用户ID';


--
-- TOC entry 9040 (class 0 OID 0)
-- Dependencies: 601
-- Name: COLUMN sys_user_role.role_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_user_role.role_id IS '角色ID';


--
-- TOC entry 598 (class 1259 OID 17125)
-- Name: sys_users; Type: TABLE; Schema: public; Owner: postcheckuser
--

CREATE TABLE public.sys_users (
    user_id bigint NOT NULL,
    dept_id bigint,
    user_name character varying(30 char) NOT NULL,
    nick_name character varying(30 char) NOT NULL,
    user_type character varying(2 char) DEFAULT '00'::varchar,
    email character varying(50 char) DEFAULT ''::varchar,
    phonenumber character varying(11 char) DEFAULT ''::varchar,
    sex character(1 char) DEFAULT '0'::bpchar,
    avatar character varying(100 char) DEFAULT ''::varchar,
    password character varying(100 char) DEFAULT ''::varchar,
    status character(1 char) DEFAULT '0'::bpchar,
    del_flag character(1 char) DEFAULT '0'::bpchar,
    login_ip character varying(128 char) DEFAULT ''::varchar,
    login_date timestamp(0) with time zone,
    create_by character varying(64 char) DEFAULT ''::varchar,
    create_time timestamp(0) with time zone,
    update_by character varying(64 char) DEFAULT ''::varchar,
    update_time timestamp(0) with time zone,
    remark character varying(500 char)
);


ALTER TABLE public.sys_users OWNER TO postcheckuser;

--
-- TOC entry 9041 (class 0 OID 0)
-- Dependencies: 598
-- Name: TABLE sys_users; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON TABLE public.sys_users IS '用户信息表';


--
-- TOC entry 9042 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.user_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.user_id IS '用户ID';


--
-- TOC entry 9043 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.dept_id; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.dept_id IS '部门ID';


--
-- TOC entry 9044 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.user_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.user_name IS '用户账号';


--
-- TOC entry 9045 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.nick_name; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.nick_name IS '用户昵称';


--
-- TOC entry 9046 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.user_type; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.user_type IS '用户类型（00系统用户）';


--
-- TOC entry 9047 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.email; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.email IS '用户邮箱';


--
-- TOC entry 9048 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.phonenumber; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.phonenumber IS '手机号码';


--
-- TOC entry 9049 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.sex; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.sex IS '用户性别（0男 1女 2未知）';


--
-- TOC entry 9050 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.avatar; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.avatar IS '头像地址';


--
-- TOC entry 9051 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.password; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.password IS '密码';


--
-- TOC entry 9052 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.status; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.status IS '帐号状态（0正常 1停用）';


--
-- TOC entry 9053 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.del_flag; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.del_flag IS '删除标志（0代表存在 2代表删除）';


--
-- TOC entry 9054 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.login_ip; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.login_ip IS '最后登录IP';


--
-- TOC entry 9055 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.login_date; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.login_date IS '最后登录时间';


--
-- TOC entry 9056 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.create_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.create_by IS '创建者';


--
-- TOC entry 9057 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.create_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.create_time IS '创建时间';


--
-- TOC entry 9058 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.update_by; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.update_by IS '更新者';


--
-- TOC entry 9059 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.update_time; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.update_time IS '更新时间';


--
-- TOC entry 9060 (class 0 OID 0)
-- Dependencies: 598
-- Name: COLUMN sys_users.remark; Type: COMMENT; Schema: public; Owner: postcheckuser
--

COMMENT ON COLUMN public.sys_users.remark IS '备注';


--
-- TOC entry 8478 (class 0 OID 17051)
-- Dependencies: 590
-- Data for Name: gen_table; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.gen_table (table_id, table_name, table_comment, sub_table_name, sub_table_fk_name, class_name, tpl_category, tpl_web_type, package_name, module_name, business_name, function_name, function_author, gen_type, gen_path, options, create_by, create_time, update_by, update_time, remark) VALUES (17353168139831, 'post_plan', '岗检计划', NULL, NULL, 'PostPlan', 'crud', 'element-ui', 'com.ruoyi.postCheck', 'postPlan', 'postPlan', '岗检计划', 'csg', '1', 'C:\test\gnhz\createCode', '{"parentMenuId":"17355455216040"}', 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38', '岗检计划');


--
-- TOC entry 8496 (class 0 OID 17223)
-- Dependencies: 608
-- Data for Name: gen_table_column; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678901, 17353168139831, 'id', '主键ID', 'bigint', 'Long', 'id', '1', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 1, 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678902, 17353168139831, 'name', '名称', 'varchar', 'String', 'name', '0', '0', '1', '1', '1', '1', '1', 'LIKE', 'input', '', 2, 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678903, 17353168139831, 'content', '内容', 'varchar', 'String', 'content', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'editor', '', 3, 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678913, 17353168139831, 'start_time', '开始时间', 'timestamp with time zone', 'String', 'startTime', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 4, 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678905, 17353168139831, 'end_time', '结束时间', 'timestamp with time zone', 'String', 'endTime', '0', '0', '1', '1', '1', '1', '1', 'EQ', NULL, '', 5, 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (12345678906, 17353168139831, 'status', '状态：1-待审核；2-审核中；3-通过；4-驳回；', 'integer', 'Integer', 'status', '0', '0', '1', '1', '1', '1', '1', 'EQ', 'radio', '', 6, 'admin', '2023-12-15 06:48:30', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709879378259970, 17353168139831, 'remark', '备注', 'varchar', 'String', 'remark', '0', '0', '0', '1', '1', '1', NULL, 'EQ', 'input', '', 7, '', '2023-12-16 01:14:20', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709879596363777, 17353168139831, 'del_flag', '删除标志（0代表存在 2代表删除）', 'bpchar', 'String', 'delFlag', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 8, '', '2023-12-16 01:14:20', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709879848022017, 17353168139831, 'create_time', '创建时间', 'timestamp with time zone', 'Date', 'createTime', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', NULL, '', 9, '', '2023-12-16 01:14:20', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709880045154305, 17353168139831, 'create_by', '创建者', 'varchar', 'String', 'createBy', '0', '0', '1', '1', NULL, NULL, NULL, 'EQ', 'input', '', 10, '', '2023-12-16 01:14:20', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709880242286594, 17353168139831, 'update_time', '更新时间', 'timestamp with time zone', 'Date', 'updateTime', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', NULL, '', 11, '', '2023-12-16 01:14:20', '', '2023-12-16 01:23:38');
INSERT INTO public.gen_table_column (column_id, table_id, column_name, column_comment, column_type, java_type, java_field, is_pk, is_increment, is_required, is_insert, is_edit, is_list, is_query, query_type, html_type, dict_type, sort, create_by, create_time, update_by, update_time) VALUES (709880439418882, 17353168139831, 'update_by', '更新者', 'bigint', 'Long', 'updateBy', '0', '0', '1', '1', '1', NULL, NULL, 'EQ', 'input', '', 12, '', '2023-12-16 01:14:20', '', '2023-12-16 01:23:38');


--
-- TOC entry 8483 (class 0 OID 17101)
-- Dependencies: 595
-- Data for Name: post_checked; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8475 (class 0 OID 17034)
-- Dependencies: 587
-- Data for Name: post_checked_items; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8470 (class 0 OID 17005)
-- Dependencies: 582
-- Data for Name: post_checked_problem; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8463 (class 0 OID 16953)
-- Dependencies: 575
-- Data for Name: post_checked_report; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8468 (class 0 OID 16987)
-- Dependencies: 580
-- Data for Name: post_highlights; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8494 (class 0 OID 17210)
-- Dependencies: 606
-- Data for Name: post_list; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8472 (class 0 OID 17015)
-- Dependencies: 584
-- Data for Name: post_list_info; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8467 (class 0 OID 16983)
-- Dependencies: 579
-- Data for Name: post_plan; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.post_plan (id, name, content, start_time, end_time, status, remark, del_flag, create_time, create_by, update_time, update_by) VALUES (1, '测试岗检计划', '岗检内容', '2023-12-12 00:00:00', '2023-12-31 00:00:00', 1, '备注', '0', '2023-12-01 00:00:00', '1', '2023-12-02 00:00:00', 2);


--
-- TOC entry 8456 (class 0 OID 16924)
-- Dependencies: 568
-- Data for Name: post_plan_info; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8466 (class 0 OID 16979)
-- Dependencies: 578
-- Data for Name: post_plan_info_user; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8465 (class 0 OID 16975)
-- Dependencies: 577
-- Data for Name: post_programme; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8459 (class 0 OID 16935)
-- Dependencies: 571
-- Data for Name: post_programme_template; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8480 (class 0 OID 17087)
-- Dependencies: 592
-- Data for Name: post_team; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8458 (class 0 OID 16931)
-- Dependencies: 570
-- Data for Name: post_team_user; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8460 (class 0 OID 16939)
-- Dependencies: 572
-- Data for Name: qrtz_blob_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8477 (class 0 OID 17044)
-- Dependencies: 589
-- Data for Name: qrtz_calendars; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8462 (class 0 OID 16950)
-- Dependencies: 574
-- Data for Name: qrtz_cron_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8461 (class 0 OID 16945)
-- Dependencies: 573
-- Data for Name: qrtz_fired_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8473 (class 0 OID 17022)
-- Dependencies: 585
-- Data for Name: qrtz_job_details; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8457 (class 0 OID 16928)
-- Dependencies: 569
-- Data for Name: qrtz_locks; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8481 (class 0 OID 17091)
-- Dependencies: 593
-- Data for Name: qrtz_paused_trigger_grps; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8471 (class 0 OID 17012)
-- Dependencies: 583
-- Data for Name: qrtz_scheduler_state; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8488 (class 0 OID 17144)
-- Dependencies: 600
-- Data for Name: qrtz_simple_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8474 (class 0 OID 17030)
-- Dependencies: 586
-- Data for Name: qrtz_simprop_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8491 (class 0 OID 17168)
-- Dependencies: 603
-- Data for Name: qrtz_triggers; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8464 (class 0 OID 16962)
-- Dependencies: 576
-- Data for Name: sys_con; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (1, '主框架页-默认皮肤样式名称', 'sys.index.skinName', 'skin-blue', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '蓝色 skin-blue、绿色 skin-green、紫色 skin-purple、红色 skin-red、黄色 skin-yellow');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (2, '用户管理-账号初始密码', 'sys.user.initPassword', '123456', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '初始化密码 123456');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (3, '主框架页-侧边栏主题', 'sys.index.sideTheme', 'theme-dark', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '深色主题theme-dark，浅色主题theme-light');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (5, '账号自助-是否开启用户注册功能', 'sys.account.registerUser', 'false', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '是否开启注册用户功能（true开启，false关闭）');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (6, '用户登录-黑名单列表', 'sys.login.blackIPList', '', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '设置登录IP黑名单限制，多个匹配项以;分隔，支持匹配（*通配、网段）');
INSERT INTO public.sys_con (config_id, config_name, config_key, config_value, config_type, create_by, create_time, update_by, update_time, remark) VALUES (4, '账号自助-验证码开关', 'sys.account.captchaEnabled', 'false', 'Y', 'admin', '2023-12-11 13:16:59', '', NULL, '是否开启验证码功能（true开启，false关闭）');


--
-- TOC entry 8469 (class 0 OID 16990)
-- Dependencies: 581
-- Data for Name: sys_dept; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (101, 100, '0,100', '深圳总公司', 1, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (102, 100, '0,100', '长沙分公司', 2, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (103, 101, '0,100,101', '研发部门', 1, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (104, 101, '0,100,101', '市场部门', 2, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (105, 101, '0,100,101', '测试部门', 3, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (106, 101, '0,100,101', '财务部门', 4, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (107, 101, '0,100,101', '运维部门', 5, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (108, 102, '0,100,102', '市场部门', 1, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (109, 102, '0,100,102', '财务部门', 2, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);
INSERT INTO public.sys_dept (dept_id, parent_id, ancestors, dept_name, order_num, leader, phone, email, status, del_flag, create_by, create_time, update_by, update_time) VALUES (100, 0, '0', '外网云-public-惠州石化', 0, '若依', '15888888888', 'ry@qq.com', '0', '0', 'admin', '2023-12-11 13:16:56', '', NULL);


--
-- TOC entry 8492 (class 0 OID 17180)
-- Dependencies: 604
-- Data for Name: sys_dict_data; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (1, 1, '男', '0', 'sys_user_sex', '', '', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '性别男');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (2, 2, '女', '1', 'sys_user_sex', '', '', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '性别女');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (3, 3, '未知', '2', 'sys_user_sex', '', '', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '性别未知');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (4, 1, '显示', '0', 'sys_show_hide', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '显示菜单');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (5, 2, '隐藏', '1', 'sys_show_hide', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '隐藏菜单');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (6, 1, '正常', '0', 'sys_normal_disable', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (7, 2, '停用', '1', 'sys_normal_disable', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '停用状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (8, 1, '正常', '0', 'sys_job_status', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (9, 2, '暂停', '1', 'sys_job_status', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '停用状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (10, 1, '默认', 'DEFAULT', 'sys_job_group', '', '', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '默认分组');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (11, 2, '系统', 'SYSTEM', 'sys_job_group', '', '', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统分组');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (12, 1, '是', 'Y', 'sys_yes_no', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统默认是');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (13, 2, '否', 'N', 'sys_yes_no', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统默认否');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (14, 1, '通知', '1', 'sys_notice_type', '', 'warning', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '通知');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (15, 2, '公告', '2', 'sys_notice_type', '', 'success', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '公告');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (16, 1, '正常', '0', 'sys_notice_status', '', 'primary', 'Y', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (17, 2, '关闭', '1', 'sys_notice_status', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '关闭状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (18, 99, '其他', '0', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '其他操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (19, 1, '新增', '1', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '新增操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (20, 2, '修改', '2', 'sys_oper_type', '', 'info', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '修改操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (21, 3, '删除', '3', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '删除操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (22, 4, '授权', '4', 'sys_oper_type', '', 'primary', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '授权操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (23, 5, '导出', '5', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '导出操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (24, 6, '导入', '6', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '导入操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (25, 7, '强退', '7', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '强退操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (26, 8, '生成代码', '8', 'sys_oper_type', '', 'warning', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '生成操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (27, 9, '清空数据', '9', 'sys_oper_type', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '清空操作');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (28, 1, '成功', '0', 'sys_common_status', '', 'primary', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '正常状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (29, 2, '失败', '1', 'sys_common_status', '', 'danger', 'N', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '停用状态');
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (100, 1, '是-测试', '1', 'post_check_test_v1', NULL, 'default', 'N', '0', 'admin', '2023-12-11 14:10:22', '', NULL, NULL);
INSERT INTO public.sys_dict_data (dict_code, dict_sort, dict_label, dict_value, dict_type, css_class, list_class, is_default, status, create_by, create_time, update_by, update_time, remark) VALUES (101, 2, '否-测试', '2', 'post_check_test_v1', NULL, 'default', 'N', '0', 'admin', '2023-12-11 14:10:39', '', NULL, NULL);


--
-- TOC entry 8498 (class 0 OID 17248)
-- Dependencies: 610
-- Data for Name: sys_dict_type; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (1, '用户性别', 'sys_user_sex', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '用户性别列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (2, '菜单状态', 'sys_show_hide', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '菜单状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (3, '系统开关', 'sys_normal_disable', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统开关列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (4, '任务状态', 'sys_job_status', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '任务状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (5, '任务分组', 'sys_job_group', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '任务分组列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (6, '系统是否', 'sys_yes_no', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '系统是否列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (7, '通知类型', 'sys_notice_type', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '通知类型列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (8, '通知状态', 'sys_notice_status', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '通知状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (9, '操作类型', 'sys_oper_type', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '操作类型列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (10, '系统状态', 'sys_common_status', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '登录状态列表');
INSERT INTO public.sys_dict_type (dict_id, dict_name, dict_type, status, create_by, create_time, update_by, update_time, remark) VALUES (100, '岗检测试1', 'post_check_test_v1', '0', 'admin', '2023-12-11 14:09:50', '', NULL, '测试1');


--
-- TOC entry 8490 (class 0 OID 17156)
-- Dependencies: 602
-- Data for Name: sys_job; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_job (job_id, job_name, job_group, invoke_target, cron_expression, misfire_policy, concurrent, status, create_by, create_time, update_by, update_time, remark) VALUES (1, '系统默认（无参）', 'DEFAULT', 'ryTask.ryNoParams', '0/10 * * * * ?', '3', '1', '1', 'admin', '2023-12-11 13:16:59', '', NULL, '');
INSERT INTO public.sys_job (job_id, job_name, job_group, invoke_target, cron_expression, misfire_policy, concurrent, status, create_by, create_time, update_by, update_time, remark) VALUES (2, '系统默认（有参）', 'DEFAULT', 'ryTask.ryParams(''ry'')', '0/15 * * * * ?', '3', '1', '1', 'admin', '2023-12-11 13:16:59', '', NULL, '');
INSERT INTO public.sys_job (job_id, job_name, job_group, invoke_target, cron_expression, misfire_policy, concurrent, status, create_by, create_time, update_by, update_time, remark) VALUES (3, '系统默认（多参）', 'DEFAULT', 'ryTask.ryMultipleParams(''ry'', true, 2000L, 316.50D, 100)', '0/20 * * * * ?', '3', '1', '1', 'admin', '2023-12-11 13:16:59', '', NULL, '');


--
-- TOC entry 8455 (class 0 OID 16916)
-- Dependencies: 567
-- Data for Name: sys_job_log; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--



--
-- TOC entry 8497 (class 0 OID 17234)
-- Dependencies: 609
-- Data for Name: sys_logininfor; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (100, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-11 14:08:38');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (101, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-11 14:24:56');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (102, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-11 14:25:02');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (103, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-12 14:43:20');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1702479387267, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 06:56:27');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1702479795757, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-14 07:03:16');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1702479798165, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 07:03:18');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1734955974273003521, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-14 07:18:33');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1734956098776723458, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 07:19:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (1735200293693120514, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-14 23:29:23');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (17354791172740, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 17:57:20');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (569163985522689, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-15 23:55:09');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (569174408368129, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 23:55:11');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (640495448338434, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 20:38:38');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (642318659358722, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 20:45:50');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (650221913468929, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 21:17:17');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (650251533643778, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 21:17:24');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (654436291407874, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '退出成功', '2023-12-15 21:34:03');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (654452779216897, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 21:34:06');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (661500354977793, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 22:02:06');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (661511495049217, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 22:02:09');
INSERT INTO public.sys_logininfor (info_id, user_name, ipaddr, login_location, browser, os, status, msg, login_time) VALUES (676701624164353, 'admin', '127.0.0.1', '内网IP', 'Chrome 9', 'Windows 10', '0', '登录成功', '2023-12-15 23:02:31');


--
-- TOC entry 8493 (class 0 OID 17191)
-- Dependencies: 605
-- Data for Name: sys_menu; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1, '系统管理', 0, 1, 'system', NULL, '', 1, 0, 'M', '0', '0', '', 'system', 'admin', '2023-12-11 13:16:57', '', NULL, '系统管理目录');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (2, '系统监控', 0, 2, 'monitor', NULL, '', 1, 0, 'M', '0', '0', '', 'monitor', 'admin', '2023-12-11 13:16:57', '', NULL, '系统监控目录');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (3, '系统工具', 0, 3, 'tool', NULL, '', 1, 0, 'M', '0', '0', '', 'tool', 'admin', '2023-12-11 13:16:57', '', NULL, '系统工具目录');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (100, '用户管理', 1, 1, 'user', 'system/user/index', '', 1, 0, 'C', '0', '0', 'system:user:list', 'user', 'admin', '2023-12-11 13:16:57', '', NULL, '用户管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (101, '角色管理', 1, 2, 'role', 'system/role/index', '', 1, 0, 'C', '0', '0', 'system:role:list', 'peoples', 'admin', '2023-12-11 13:16:57', '', NULL, '角色管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (102, '菜单管理', 1, 3, 'menu', 'system/menu/index', '', 1, 0, 'C', '0', '0', 'system:menu:list', 'tree-table', 'admin', '2023-12-11 13:16:57', '', NULL, '菜单管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (103, '部门管理', 1, 4, 'dept', 'system/dept/index', '', 1, 0, 'C', '0', '0', 'system:dept:list', 'tree', 'admin', '2023-12-11 13:16:57', '', NULL, '部门管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (104, '岗位管理', 1, 5, 'post', 'system/post/index', '', 1, 0, 'C', '0', '0', 'system:post:list', 'post', 'admin', '2023-12-11 13:16:57', '', NULL, '岗位管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (105, '字典管理', 1, 6, 'dict', 'system/dict/index', '', 1, 0, 'C', '0', '0', 'system:dict:list', 'dict', 'admin', '2023-12-11 13:16:57', '', NULL, '字典管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (106, '参数设置', 1, 7, 'config', 'system/config/index', '', 1, 0, 'C', '0', '0', 'system:config:list', 'edit', 'admin', '2023-12-11 13:16:57', '', NULL, '参数设置菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (107, '通知公告', 1, 8, 'notice', 'system/notice/index', '', 1, 0, 'C', '0', '0', 'system:notice:list', 'message', 'admin', '2023-12-11 13:16:57', '', NULL, '通知公告菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (108, '日志管理', 1, 9, 'log', '', '', 1, 0, 'M', '0', '0', '', 'log', 'admin', '2023-12-11 13:16:57', '', NULL, '日志管理菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (109, '在线用户', 2, 1, 'online', 'monitor/online/index', '', 1, 0, 'C', '0', '0', 'monitor:online:list', 'online', 'admin', '2023-12-11 13:16:57', '', NULL, '在线用户菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (110, '定时任务', 2, 2, 'job', 'monitor/job/index', '', 1, 0, 'C', '0', '0', 'monitor:job:list', 'job', 'admin', '2023-12-11 13:16:57', '', NULL, '定时任务菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (112, '服务监控', 2, 4, 'server', 'monitor/server/index', '', 1, 0, 'C', '0', '0', 'monitor:server:list', 'server', 'admin', '2023-12-11 13:16:57', '', NULL, '服务监控菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (113, '缓存监控', 2, 5, 'cache', 'monitor/cache/index', '', 1, 0, 'C', '0', '0', 'monitor:cache:list', 'redis', 'admin', '2023-12-11 13:16:57', '', NULL, '缓存监控菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (114, '缓存列表', 2, 6, 'cacheList', 'monitor/cache/list', '', 1, 0, 'C', '0', '0', 'monitor:cache:list', 'redis-list', 'admin', '2023-12-11 13:16:57', '', NULL, '缓存列表菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (115, '表单构建', 3, 1, 'build', 'tool/build/index', '', 1, 0, 'C', '0', '0', 'tool:build:list', 'build', 'admin', '2023-12-11 13:16:57', '', NULL, '表单构建菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (116, '代码生成', 3, 2, 'gen', 'tool/gen/index', '', 1, 0, 'C', '0', '0', 'tool:gen:list', 'code', 'admin', '2023-12-11 13:16:57', '', NULL, '代码生成菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (500, '操作日志', 108, 1, 'operlog', 'monitor/operlog/index', '', 1, 0, 'C', '0', '0', 'monitor:operlog:list', 'form', 'admin', '2023-12-11 13:16:57', '', NULL, '操作日志菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (501, '登录日志', 108, 2, 'logininfor', 'monitor/logininfor/index', '', 1, 0, 'C', '0', '0', 'monitor:logininfor:list', 'logininfor', 'admin', '2023-12-11 13:16:57', '', NULL, '登录日志菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1000, '用户查询', 100, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:user:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1001, '用户新增', 100, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:user:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1002, '用户修改', 100, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:user:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1003, '用户删除', 100, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:user:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1004, '用户导出', 100, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:user:export', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1005, '用户导入', 100, 6, '', '', '', 1, 0, 'F', '0', '0', 'system:user:import', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1006, '重置密码', 100, 7, '', '', '', 1, 0, 'F', '0', '0', 'system:user:resetPwd', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1007, '角色查询', 101, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:role:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1008, '角色新增', 101, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:role:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1009, '角色修改', 101, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:role:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1010, '角色删除', 101, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:role:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1011, '角色导出', 101, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:role:export', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1012, '菜单查询', 102, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1013, '菜单新增', 102, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1014, '菜单修改', 102, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1015, '菜单删除', 102, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:menu:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1016, '部门查询', 103, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1017, '部门新增', 103, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1018, '部门修改', 103, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1019, '部门删除', 103, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:dept:remove', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1020, '岗位查询', 104, 1, '', '', '', 1, 0, 'F', '0', '0', 'system:post:query', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1021, '岗位新增', 104, 2, '', '', '', 1, 0, 'F', '0', '0', 'system:post:add', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1022, '岗位修改', 104, 3, '', '', '', 1, 0, 'F', '0', '0', 'system:post:edit', '#', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1023, '岗位删除', 104, 4, '', '', '', 1, 0, 'F', '0', '0', 'system:post:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1024, '岗位导出', 104, 5, '', '', '', 1, 0, 'F', '0', '0', 'system:post:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1025, '字典查询', 105, 1, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1026, '字典新增', 105, 2, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1027, '字典修改', 105, 3, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1028, '字典删除', 105, 4, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1029, '字典导出', 105, 5, '#', '', '', 1, 0, 'F', '0', '0', 'system:dict:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1030, '参数查询', 106, 1, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1031, '参数新增', 106, 2, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1032, '参数修改', 106, 3, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1033, '参数删除', 106, 4, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1034, '参数导出', 106, 5, '#', '', '', 1, 0, 'F', '0', '0', 'system:config:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1035, '公告查询', 107, 1, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1036, '公告新增', 107, 2, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1037, '公告修改', 107, 3, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1038, '公告删除', 107, 4, '#', '', '', 1, 0, 'F', '0', '0', 'system:notice:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1039, '操作查询', 500, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1040, '操作删除', 500, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1041, '日志导出', 500, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:operlog:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1042, '登录查询', 501, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1043, '登录删除', 501, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1044, '日志导出', 501, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1045, '账户解锁', 501, 4, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:logininfor:unlock', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1046, '在线查询', 109, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:online:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1047, '批量强退', 109, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:online:batchLogout', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1048, '单条强退', 109, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:online:forceLogout', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1049, '任务查询', 110, 1, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1050, '任务新增', 110, 2, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:add', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1051, '任务修改', 110, 3, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1052, '任务删除', 110, 4, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1053, '状态修改', 110, 5, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:changeStatus', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1054, '任务导出', 110, 6, '#', '', '', 1, 0, 'F', '0', '0', 'monitor:job:export', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1055, '生成查询', 116, 1, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:query', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1056, '生成修改', 116, 2, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:edit', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1057, '生成删除', 116, 3, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:remove', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1058, '导入代码', 116, 4, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:import', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1059, '预览代码', 116, 5, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:preview', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (1060, '生成代码', 116, 6, '#', '', '', 1, 0, 'F', '0', '0', 'tool:gen:code', '#', 'admin', '2023-12-11 13:16:58', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (111, '数据监控', 2, 3, 'druid', 'monitor/druid/index', '', 1, 0, 'C', '1', '1', 'monitor:druid:list', 'druid', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-14 07:02:50', '数据监控菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (117, '系统接口', 3, 3, 'swagger', 'tool/swagger/index', '', 1, 0, 'C', '1', '1', 'tool:swagger:list', 'swagger', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-14 07:03:10', '系统接口菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (4, '若依官网', 0, 4, 'http://ruoyi.vip', NULL, '', 0, 0, 'M', '1', '1', '', 'guide', 'admin', '2023-12-11 13:16:57', 'admin', '2023-12-15 21:56:44', '若依官网地址');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (17355455216040, '岗检策划', 0, 1, 'postPlan', NULL, NULL, 1, 0, 'M', '0', '0', NULL, 'star', 'admin', '2023-12-15 22:21:24', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (568950155710466, '岗检计划', 17355455216040, 1, 'postPlan', 'postPlan/postPlan/index', NULL, 1, 0, 'C', '0', '0', 'postPlan:postPlan:list', '#', 'admin', '2023-12-15 23:54:48', '', NULL, '岗检计划菜单');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (568950155710467, '岗检计划查询', 568950155710466, 1, '#', '', NULL, 1, 0, 'F', '0', '0', 'postPlan:postPlan:query', '#', 'admin', '2023-12-15 23:54:48', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (568950155710468, '岗检计划新增', 568950155710466, 2, '#', '', NULL, 1, 0, 'F', '0', '0', 'postPlan:postPlan:add', '#', 'admin', '2023-12-15 23:54:48', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (568950155710469, '岗检计划修改', 568950155710466, 3, '#', '', NULL, 1, 0, 'F', '0', '0', 'postPlan:postPlan:edit', '#', 'admin', '2023-12-15 23:54:48', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (568950155710470, '岗检计划删除', 568950155710466, 4, '#', '', NULL, 1, 0, 'F', '0', '0', 'postPlan:postPlan:remove', '#', 'admin', '2023-12-15 23:54:48', '', NULL, '');
INSERT INTO public.sys_menu (menu_id, menu_name, parent_id, order_num, path, component, query, is_frame, is_cache, menu_type, visible, status, perms, icon, create_by, create_time, update_by, update_time, remark) VALUES (568950155710471, '岗检计划导出', 568950155710466, 5, '#', '', NULL, 1, 0, 'F', '0', '0', 'postPlan:postPlan:export', '#', 'admin', '2023-12-15 23:54:48', '', NULL, '');


--
-- TOC entry 8484 (class 0 OID 17113)
-- Dependencies: 596
-- Data for Name: sys_notice; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_notice (notice_id, notice_title, notice_type, notice_content, status, create_by, create_time, update_by, update_time, remark) VALUES (1, '温馨提醒：2018-07-01 若依新版本发布啦', '2', '\346\226\260\347\211\210\346\234\254\345\206\205\345\256\271', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '管理员');
INSERT INTO public.sys_notice (notice_id, notice_title, notice_type, notice_content, status, create_by, create_time, update_by, update_time, remark) VALUES (2, '维护通知：2018-07-01 若依系统凌晨维护', '1', '\347\273\264\346\212\244\345\206\205\345\256\271', '0', 'admin', '2023-12-11 13:16:59', '', NULL, '管理员');


--
-- TOC entry 8479 (class 0 OID 17066)
-- Dependencies: 591
-- Data for Name: sys_oper_log; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (100, '字典类型', 1, 'com.ruoyi.web.controller.system.SysDictTypeController.add()', 'POST', 1, 'admin', '研发部门', '/system/dict/type', '127.0.0.1', '内网IP', '{"createBy":"admin","dictName":"岗检测试1","dictType":"post_check_test_v1","params":{},"remark":"测试1","status":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-11 14:09:50', 128);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (101, '字典数据', 1, 'com.ruoyi.web.controller.system.SysDictDataController.add()', 'POST', 1, 'admin', '研发部门', '/system/dict/data', '127.0.0.1', '内网IP', '{"createBy":"admin","default":false,"dictLabel":"是-测试","dictSort":1,"dictType":"post_check_test_v1","dictValue":"1","listClass":"default","params":{},"status":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-11 14:10:22', 86);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (102, '字典数据', 1, 'com.ruoyi.web.controller.system.SysDictDataController.add()', 'POST', 1, 'admin', '研发部门', '/system/dict/data', '127.0.0.1', '内网IP', '{"createBy":"admin","default":false,"dictLabel":"否-测试","dictSort":2,"dictType":"post_check_test_v1","dictValue":"2","listClass":"default","params":{},"status":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-11 14:10:39', 74);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (1734956191860912129, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 05:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":4,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"0","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-14 07:19:25', 45);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (1735306895750238210, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_plan"}', NULL, 1, '导入失败：
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-generator\target\classes\mapper\generator\GenTableMapper.xml]
### The error may involve com.ruoyi.generator.mapper.GenTableMapper.insertGenTable-Inline
### The error occurred while setting parameters
### SQL: insert into gen_table (     table_name,      table_comment,      class_name,                package_name,      module_name,      business_name,      function_name,      function_author,                      create_by,     create_time          )values(     ?,      ?,      ?,                ?,      ?,      ?,      ?,      ?,                      ?,       CURRENT_TIMESTAMP          )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).
; 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "table_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, post_plan, post_plan, null, null, PostPlan, crud, , com.ruoyi.system, system, plan, post_plan, ruoyi, 0, /, null, admin, 2023-12-14 22:32:59, , null, null).', '2023-12-15 06:32:59', 132);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (1735310802555670530, '代码生成', 6, 'com.ruoyi.generator.controller.GenController.importTableSave()', 'POST', 1, 'admin', '研发部门', '/tool/gen/importTable', '127.0.0.1', '内网IP', '{"tables":"post_plan"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 06:48:31', 188);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354816179600, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isInc', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:07:16', 97);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354820753195, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncr', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:09:05', 35);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354822865069, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"start_time","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isInc', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:09:55', 30);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354823648439, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:10:14', 28);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354825412480, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:10:56', 45);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354850946690, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":1735310802157211600,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":1735310802220126200,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":1735310802220126200,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":1735310802220126200,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:21:05', 261354);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354852331397, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"id","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Name","columnComment":"name","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"Content","columnComment":"content","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:21:38', 9409);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354864071925, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:21:29","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":false,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:21:29","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"0","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":false,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:21:29","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:26:18', 27);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354864995762, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:18","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:18","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:18","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:26:40', 29);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354866648780, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:40","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:40","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:26:40","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:27:19', 48);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354866747891, '代码生成', 8, 'com.ruoyi.generator.controller.GenController.genCode()', 'GET', 1, 'admin', '研发部门', '/tool/gen/genCode/post_plan', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:27:22', 146);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17354924314042, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:27:19","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:27:19","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:27:19","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 18:50:14', 47);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355193393702, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:50:14","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:50:14","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 10:50:14","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 20:37:10', 100);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355195070333, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:09","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:09","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:09","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 20:37:50', 59);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355393657750, '菜单管理', 2, 'com.ruoyi.web.controller.system.SysMenuController.edit()', 'PUT', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createTime":"2023-12-11 05:16:57","icon":"guide","isCache":"0","isFrame":"0","menuId":4,"menuName":"若依官网","menuType":"M","orderNum":4,"params":{},"parentId":0,"path":"http://ruoyi.vip","perms":"","query":"","status":"1","updateBy":"admin","visible":"1"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 21:56:44', 62);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355402883751, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-system\target\classes\mapper\system\SysMenuMapper.xml]
### The error may involve com.ruoyi.system.mapper.SysMenuMapper.insertMenu-Inline
### The error occurred while setting parameters
### SQL: insert into sys_menu(            menu_name,     order_num,     path,             is_frame,     is_cache,     menu_type,     visible,     status,         icon,         create_by,    create_time   )values(            ?,     ?,     ?,             ?,     ?,     ?,     ?,     ?,         ?,         ?,       CURRENT_TIMESTAMP   )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).
; 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:00:24, , null, ).', '2023-12-15 22:00:24', 93);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355405781847, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-system\target\classes\mapper\system\SysMenuMapper.xml]
### The error may involve com.ruoyi.system.mapper.SysMenuMapper.insertMenu-Inline
### The error occurred while setting parameters
### SQL: insert into sys_menu(            menu_name,     order_num,     path,             is_frame,     is_cache,     menu_type,     visible,     status,         icon,         create_by,    create_time   )values(            ?,     ?,     ?,             ?,     ?,     ?,     ?,     ?,         ?,         ?,       CURRENT_TIMESTAMP   )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).
; 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "menu_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 岗检策划, 0, 1, postPlan, null, null, 1, 0, M, 0, 0, null, star, admin, 2023-12-15 14:01:33, , null, ).', '2023-12-15 22:01:33', 9975);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355455736218, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"createBy":"admin","icon":"star","isCache":"0","isFrame":"1","menuId":17355455216040,"menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 22:21:24', 14106);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355456010232, '菜单管理', 1, 'com.ruoyi.web.controller.system.SysMenuController.add()', 'POST', 1, 'admin', '研发部门', '/system/menu', '127.0.0.1', '内网IP', '{"children":[],"icon":"star","isCache":"0","isFrame":"1","menuName":"岗检策划","menuType":"M","orderNum":1,"params":{},"parentId":0,"path":"postPlan","status":"0","visible":"0"}', '{"msg":"新增菜单''岗检策划''失败，菜单名称已存在","code":500}', 0, NULL, '2023-12-15 22:21:31', 4);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355465011837, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:49","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:49","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 12:37:49","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 22:25:05', 83);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (17355584373005, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 14:25:05","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 14:25:05","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-15 14:25:05","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-14 22:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-15 23:12:31', 104);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (708974885031937, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_plan', '127.0.0.1', '内网IP', '{}', NULL, 1, '
### Error updating database.  Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).
### The error may exist in file [C:\code\java\gitee\gnhz\post-check-api\ruoyi-generator\target\classes\mapper\generator\GenTableColumnMapper.xml]
### The error may involve com.ruoyi.generator.mapper.GenTableColumnMapper.insertGenTableColumn-Inline
### The error occurred while setting parameters
### SQL: insert into gen_table_column (             column_id,     table_id,      column_name,      column_comment,      column_type,      java_type,      java_field,      is_pk,      is_increment,      is_required,      is_insert,      is_edit,      is_list,           query_type,      html_type,           sort,          create_time          )values(             ?,     ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,      ?,           ?,      ?,           ?,                        CURRENT_TIMESTAMP          )
### Cause: com.kingbase8.util.KSQLException: 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).
; 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).; nested exception is com.kingbase8.util.KSQLException: 错误: 在字段 "column_id" 中空值违反了非空约束
  Detail: 失败, 行包含(null, 17353168139831, remark, remark, varchar, String, remark, 0, 0, 0, 1, 1, 1, null, EQ, input, , 7, , 2023-12-16 01:10:45, , null).', '2023-12-16 01:10:45', 762);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (709881353777154, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.synchDb()', 'GET', 1, 'admin', '研发部门', '/tool/gen/synchDb/post_plan', '127.0.0.1', '内网IP', '{}', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:14:21', 944);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (712180167913473, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:23:30', 20974);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (712206239707137, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:23:36', 698);
INSERT INTO public.sys_oper_log (oper_id, title, business_type, method, request_method, operator_type, oper_name, dept_name, oper_url, oper_ip, oper_location, oper_param, json_result, status, error_msg, oper_time, cost_time) VALUES (712218956836866, '代码生成', 2, 'com.ruoyi.generator.controller.GenController.editSave()', 'PUT', 1, 'admin', '研发部门', '/tool/gen', '127.0.0.1', '内网IP', '{"businessName":"postPlan","className":"PostPlan","columns":[{"capJavaField":"Id","columnComment":"主键ID","columnId":12345678901,"columnName":"id","columnType":"bigint","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":false,"htmlType":"input","increment":false,"insert":true,"isIncrement":"0","isInsert":"1","isPk":"1","isRequired":"1","javaField":"id","javaType":"Long","list":false,"params":{},"pk":true,"query":false,"queryType":"EQ","required":true,"sort":1,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Name","columnComment":"名称","columnId":12345678902,"columnName":"name","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"input","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"name","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"LIKE","required":true,"sort":2,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"Content","columnComment":"内容","columnId":12345678903,"columnName":"content","columnType":"varchar","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","edit":true,"htmlType":"editor","increment":false,"insert":true,"isEdit":"1","isIncrement":"0","isInsert":"1","isList":"1","isPk":"0","isQuery":"1","isRequired":"1","javaField":"content","javaType":"String","list":true,"params":{},"pk":false,"query":true,"queryType":"EQ","required":true,"sort":3,"superColumn":false,"tableId":17353168139831,"updateBy":"","updateTime":"2023-12-16 01:14:20","usableColumn":false},{"capJavaField":"StartTime","columnComment":"开始时间","columnId":12345678913,"columnName":"start_time","columnType":"timestamp with time zone","createBy":"admin","createTime":"2023-12-15 06:48:30","dictType":"","ed', '{"msg":"操作成功","code":200}', 0, NULL, '2023-12-16 01:23:39', 19931);


--
-- TOC entry 8482 (class 0 OID 17096)
-- Dependencies: 594
-- Data for Name: sys_post; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (1, 'ceo', '董事长', 1, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (2, 'se', '项目经理', 2, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (3, 'hr', '人力资源', 3, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');
INSERT INTO public.sys_post (post_id, post_code, post_name, post_sort, status, create_by, create_time, update_by, update_time, remark) VALUES (4, 'user', '普通员工', 4, '0', 'admin', '2023-12-11 13:16:57', '', NULL, '');


--
-- TOC entry 8487 (class 0 OID 17141)
-- Dependencies: 599
-- Data for Name: sys_role; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_role (role_id, role_name, role_key, role_sort, data_scope, menu_check_strictly, dept_check_strictly, status, del_flag, create_by, create_time, update_by, update_time, remark) VALUES (1, '超级管理员', 'admin', 1, '1', 1, 1, '0', '0', 'admin', '2023-12-11 13:16:57', '', NULL, '超级管理员');
INSERT INTO public.sys_role (role_id, role_name, role_key, role_sort, data_scope, menu_check_strictly, dept_check_strictly, status, del_flag, create_by, create_time, update_by, update_time, remark) VALUES (2, '普通角色', 'common', 2, '2', 1, 1, '0', '0', 'admin', '2023-12-11 13:16:57', '', NULL, '普通角色');


--
-- TOC entry 8476 (class 0 OID 17040)
-- Dependencies: 588
-- Data for Name: sys_role_dept; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_role_dept (role_id, dept_id) VALUES (2, 100);
INSERT INTO public.sys_role_dept (role_id, dept_id) VALUES (2, 101);
INSERT INTO public.sys_role_dept (role_id, dept_id) VALUES (2, 105);


--
-- TOC entry 8495 (class 0 OID 17217)
-- Dependencies: 607
-- Data for Name: sys_role_menu; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 2);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 3);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 4);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 100);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 101);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 102);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 103);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 104);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 105);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 106);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 107);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 108);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 109);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 110);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 111);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 112);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 113);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 114);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 115);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 116);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 117);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 500);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 501);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1000);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1001);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1002);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1003);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1004);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1005);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1006);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1007);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1008);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1009);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1010);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1011);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1012);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1013);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1014);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1015);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1016);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1017);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1018);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1019);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1020);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1021);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1022);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1023);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1024);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1025);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1026);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1027);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1028);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1029);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1030);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1031);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1032);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1033);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1034);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1035);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1036);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1037);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1038);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1039);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1040);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1041);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1042);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1043);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1044);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1045);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1046);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1047);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1048);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1049);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1050);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1051);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1052);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1053);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1054);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1055);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1056);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1057);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1058);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1059);
INSERT INTO public.sys_role_menu (role_id, menu_id) VALUES (2, 1060);


--
-- TOC entry 8485 (class 0 OID 17122)
-- Dependencies: 597
-- Data for Name: sys_user_post; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_user_post (user_id, post_id) VALUES (1, 1);
INSERT INTO public.sys_user_post (user_id, post_id) VALUES (2, 2);


--
-- TOC entry 8489 (class 0 OID 17153)
-- Dependencies: 601
-- Data for Name: sys_user_role; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_user_role (user_id, role_id) VALUES (1, 1);
INSERT INTO public.sys_user_role (user_id, role_id) VALUES (2, 2);


--
-- TOC entry 8486 (class 0 OID 17125)
-- Dependencies: 598
-- Data for Name: sys_users; Type: TABLE DATA; Schema: public; Owner: postcheckuser
--

INSERT INTO public.sys_users (user_id, dept_id, user_name, nick_name, user_type, email, phonenumber, sex, avatar, password, status, del_flag, login_ip, login_date, create_by, create_time, update_by, update_time, remark) VALUES (2, 105, 'ry', '若依', '00', 'ry@qq.com', '15666666666', '1', '', '$2a$10$7JB720yubVSZvUI0rEqK/.VqGOZTH.ulu33dHOiBE8ByOhJIrdAu2', '0', '0', '127.0.0.1', '2023-12-11 13:16:57', 'admin', '2023-12-11 13:16:57', '', NULL, '测试员');
INSERT INTO public.sys_users (user_id, dept_id, user_name, nick_name, user_type, email, phonenumber, sex, avatar, password, status, del_flag, login_ip, login_date, create_by, create_time, update_by, update_time, remark) VALUES (1, 103, 'admin', '若依', '00', 'ry@163.com', '15888888888', '1', '', '$2a$10$7JB720yubVSZvUI0rEqK/.VqGOZTH.ulu33dHOiBE8ByOhJIrdAu2', '0', '0', '127.0.0.1', '2023-12-15 23:02:28', 'admin', '2023-12-11 13:16:57', '', '2023-12-15 23:02:31', '管理员');


--
-- TOC entry 8012 (class 2606 OID 17269)
-- Name: qrtz_paused_trigger_grps PRIMARY_2E217F3A_17269606_29EE6398; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_paused_trigger_grps
    ADD CONSTRAINT "PRIMARY_2E217F3A_17269606_29EE6398" PRIMARY KEY (sched_name, trigger_group);


--
-- TOC entry 7991 (class 2606 OID 17175)
-- Name: post_list_info PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_list_info
    ADD CONSTRAINT "PRIMARY_2E334ECB_CF1B7FC7_C83A7C7F" PRIMARY KEY (id);


--
-- TOC entry 8022 (class 2606 OID 17273)
-- Name: sys_users PRIMARY_37A5EAD9_F5A67303_E4D89AFF; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_users
    ADD CONSTRAINT "PRIMARY_37A5EAD9_F5A67303_E4D89AFF" PRIMARY KEY (user_id);


--
-- TOC entry 7977 (class 2606 OID 17095)
-- Name: post_programme PRIMARY_3B6D5038_61CFC714_59AF6D50; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_programme
    ADD CONSTRAINT "PRIMARY_3B6D5038_61CFC714_59AF6D50" PRIMARY KEY (id);


--
-- TOC entry 7961 (class 2606 OID 16972)
-- Name: qrtz_locks PRIMARY_4122D403_EDAB840C_2AF60B02; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_locks
    ADD CONSTRAINT "PRIMARY_4122D403_EDAB840C_2AF60B02" PRIMARY KEY (lock_name, sched_name);


--
-- TOC entry 8020 (class 2606 OID 17277)
-- Name: sys_user_post PRIMARY_43097AA8_212EBDAA_2F33775D; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_user_post
    ADD CONSTRAINT "PRIMARY_43097AA8_212EBDAA_2F33775D" PRIMARY KEY (post_id, user_id);


--
-- TOC entry 7993 (class 2606 OID 17179)
-- Name: qrtz_job_details PRIMARY_43C650FB_DCEB2469_9EB58483; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_job_details
    ADD CONSTRAINT "PRIMARY_43C650FB_DCEB2469_9EB58483" PRIMARY KEY (job_group, job_name, sched_name);


--
-- TOC entry 7969 (class 2606 OID 17045)
-- Name: qrtz_fired_triggers PRIMARY_467C5086_F775F44E_FAF80C9F; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_fired_triggers
    ADD CONSTRAINT "PRIMARY_467C5086_F775F44E_FAF80C9F" PRIMARY KEY (entry_id, sched_name);


--
-- TOC entry 7989 (class 2606 OID 17177)
-- Name: qrtz_scheduler_state PRIMARY_5A1EB912_AE0CA5F9_BDAF3D78; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_scheduler_state
    ADD CONSTRAINT "PRIMARY_5A1EB912_AE0CA5F9_BDAF3D78" PRIMARY KEY (instance_name, sched_name);


--
-- TOC entry 7987 (class 2606 OID 17209)
-- Name: post_checked_problem PRIMARY_5BB25042_8B9D3461_396842BD; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_problem
    ADD CONSTRAINT "PRIMARY_5BB25042_8B9D3461_396842BD" PRIMARY KEY (checked_dept_id, checked_post_id, id);


--
-- TOC entry 8010 (class 2606 OID 17259)
-- Name: post_team PRIMARY_5C509297_2DA0CC98_7E2B4B57; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_team
    ADD CONSTRAINT "PRIMARY_5C509297_2DA0CC98_7E2B4B57" PRIMARY KEY (id);


--
-- TOC entry 8039 (class 2606 OID 17283)
-- Name: post_list PRIMARY_5CD25ED8_D5AE10F7_2330D4DD; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_list
    ADD CONSTRAINT "PRIMARY_5CD25ED8_D5AE10F7_2330D4DD" PRIMARY KEY (id);


--
-- TOC entry 8028 (class 2606 OID 17287)
-- Name: sys_user_role PRIMARY_5CF660FC_DA0A165E_F7B2E5EE; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_user_role
    ADD CONSTRAINT "PRIMARY_5CF660FC_DA0A165E_F7B2E5EE" PRIMARY KEY (role_id, user_id);


--
-- TOC entry 7957 (class 2606 OID 16961)
-- Name: sys_job_log PRIMARY_65F80228_8FCF5DFA_36EA3E8A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_job_log
    ADD CONSTRAINT "PRIMARY_65F80228_8FCF5DFA_36EA3E8A" PRIMARY KEY (job_log_id);


--
-- TOC entry 8041 (class 2606 OID 17303)
-- Name: sys_role_menu PRIMARY_6B9F418A_E70A6D3E_96DB28E6; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_role_menu
    ADD CONSTRAINT "PRIMARY_6B9F418A_E70A6D3E_96DB28E6" PRIMARY KEY (menu_id, role_id);


--
-- TOC entry 7971 (class 2606 OID 17112)
-- Name: qrtz_cron_triggers PRIMARY_6F7DA771_F8474AF3_23008EF; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_cron_triggers
    ADD CONSTRAINT "PRIMARY_6F7DA771_F8474AF3_23008EF" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 7973 (class 2606 OID 17108)
-- Name: post_checked_report PRIMARY_76F0F846_B93E0786_3CAB54F7; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_report
    ADD CONSTRAINT "PRIMARY_76F0F846_B93E0786_3CAB54F7" PRIMARY KEY (id);


--
-- TOC entry 8008 (class 2606 OID 17267)
-- Name: sys_oper_log PRIMARY_7921EFE7_5FBB2EA4_A007EEA4; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_oper_log
    ADD CONSTRAINT "PRIMARY_7921EFE7_5FBB2EA4_A007EEA4" PRIMARY KEY (oper_id);


--
-- TOC entry 7967 (class 2606 OID 17004)
-- Name: qrtz_blob_triggers PRIMARY_7E3C0400_9C121EEF_39306CE2; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_blob_triggers
    ADD CONSTRAINT "PRIMARY_7E3C0400_9C121EEF_39306CE2" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 7997 (class 2606 OID 17221)
-- Name: post_checked_items PRIMARY_7EBD25C4_9D07C4F_423FFE73; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked_items
    ADD CONSTRAINT "PRIMARY_7EBD25C4_9D07C4F_423FFE73" PRIMARY KEY (id);


--
-- TOC entry 8024 (class 2606 OID 17281)
-- Name: sys_role PRIMARY_7EFFF0FC_946AB27E_6824486D; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_role
    ADD CONSTRAINT "PRIMARY_7EFFF0FC_946AB27E_6824486D" PRIMARY KEY (role_id);


--
-- TOC entry 7985 (class 2606 OID 17257)
-- Name: sys_dept PRIMARY_817FF65E_B3CA0BCB_8150F446; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dept
    ADD CONSTRAINT "PRIMARY_817FF65E_B3CA0BCB_8150F446" PRIMARY KEY (dept_id);


--
-- TOC entry 7963 (class 2606 OID 16974)
-- Name: post_team_user PRIMARY_87E04789_A6707034_24CEE003; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_team_user
    ADD CONSTRAINT "PRIMARY_87E04789_A6707034_24CEE003" PRIMARY KEY (id);


--
-- TOC entry 8030 (class 2606 OID 17285)
-- Name: sys_job PRIMARY_91256962_5694E7E5_C1E146BE; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_job
    ADD CONSTRAINT "PRIMARY_91256962_5694E7E5_C1E146BE" PRIMARY KEY (job_group, job_id, job_name);


--
-- TOC entry 8026 (class 2606 OID 17271)
-- Name: qrtz_simple_triggers PRIMARY_9A335A95_F939BACC_D13130D; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simple_triggers
    ADD CONSTRAINT "PRIMARY_9A335A95_F939BACC_D13130D" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8047 (class 2606 OID 17296)
-- Name: sys_logininfor PRIMARY_A4D1B11F_8F01405C_230B9E0A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_logininfor
    ADD CONSTRAINT "PRIMARY_A4D1B11F_8F01405C_230B9E0A" PRIMARY KEY (info_id);


--
-- TOC entry 8051 (class 2606 OID 17300)
-- Name: sys_dict_type PRIMARY_A6E4B4D3_5E6EA297_AA3A448A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dict_type
    ADD CONSTRAINT "PRIMARY_A6E4B4D3_5E6EA297_AA3A448A" PRIMARY KEY (dict_id);


--
-- TOC entry 7981 (class 2606 OID 17110)
-- Name: post_plan PRIMARY_AE1BC363_582563EE_6E23E224; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_plan
    ADD CONSTRAINT "PRIMARY_AE1BC363_582563EE_6E23E224" PRIMARY KEY (id);


--
-- TOC entry 8043 (class 2606 OID 17294)
-- Name: gen_table_column PRIMARY_BD14958E_FC72F453_184B02D8; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.gen_table_column
    ADD CONSTRAINT "PRIMARY_BD14958E_FC72F453_184B02D8" PRIMARY KEY (column_id);


--
-- TOC entry 8016 (class 2606 OID 17261)
-- Name: post_checked PRIMARY_BDF7E303_17543270_AE60CCDC; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_checked
    ADD CONSTRAINT "PRIMARY_BDF7E303_17543270_AE60CCDC" PRIMARY KEY (id);


--
-- TOC entry 8032 (class 2606 OID 17279)
-- Name: qrtz_triggers PRIMARY_C52C5CF2_58E0B4C2_3AA840C0; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_triggers
    ADD CONSTRAINT "PRIMARY_C52C5CF2_58E0B4C2_3AA840C0" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8001 (class 2606 OID 17245)
-- Name: qrtz_calendars PRIMARY_D280BAA3_5325D179_B225191C; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_calendars
    ADD CONSTRAINT "PRIMARY_D280BAA3_5325D179_B225191C" PRIMARY KEY (calendar_name, sched_name);


--
-- TOC entry 7959 (class 2606 OID 16949)
-- Name: post_plan_info PRIMARY_D45A0920_20AEC712_42333194; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_plan_info
    ADD CONSTRAINT "PRIMARY_D45A0920_20AEC712_42333194" PRIMARY KEY (id);


--
-- TOC entry 7999 (class 2606 OID 17265)
-- Name: sys_role_dept PRIMARY_D4CC35BE_F0BFC088_E6F3DC38; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_role_dept
    ADD CONSTRAINT "PRIMARY_D4CC35BE_F0BFC088_E6F3DC38" PRIMARY KEY (dept_id, role_id);


--
-- TOC entry 8035 (class 2606 OID 17289)
-- Name: sys_dict_data PRIMARY_DFD26535_85AD8F0D_D03CC464; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dict_data
    ADD CONSTRAINT "PRIMARY_DFD26535_85AD8F0D_D03CC464" PRIMARY KEY (dict_code);


--
-- TOC entry 8003 (class 2606 OID 17247)
-- Name: gen_table PRIMARY_E2A7B70B_3AA9B50_AEC5FEA8; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.gen_table
    ADD CONSTRAINT "PRIMARY_E2A7B70B_3AA9B50_AEC5FEA8" PRIMARY KEY (table_id);


--
-- TOC entry 7965 (class 2606 OID 17029)
-- Name: post_programme_template PRIMARY_E5685837_4A4E5B51_885D79C5; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_programme_template
    ADD CONSTRAINT "PRIMARY_E5685837_4A4E5B51_885D79C5" PRIMARY KEY (id);


--
-- TOC entry 7975 (class 2606 OID 17207)
-- Name: sys_con PRIMARY_EA10AD48_8684CC6D_55402DA2; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_con
    ADD CONSTRAINT "PRIMARY_EA10AD48_8684CC6D_55402DA2" PRIMARY KEY (config_id);


--
-- TOC entry 8018 (class 2606 OID 17275)
-- Name: sys_notice PRIMARY_EFB5DD38_A077CE5A_E0DEBE34; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_notice
    ADD CONSTRAINT "PRIMARY_EFB5DD38_A077CE5A_E0DEBE34" PRIMARY KEY (notice_id);


--
-- TOC entry 7979 (class 2606 OID 17106)
-- Name: post_plan_info_user PRIMARY_F3187EA0_6D33F980_BD60B328; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_plan_info_user
    ADD CONSTRAINT "PRIMARY_F3187EA0_6D33F980_BD60B328" PRIMARY KEY (id);


--
-- TOC entry 8037 (class 2606 OID 17292)
-- Name: sys_menu PRIMARY_F5518E2A_873D814C_8464B39; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_menu
    ADD CONSTRAINT "PRIMARY_F5518E2A_873D814C_8464B39" PRIMARY KEY (menu_id);


--
-- TOC entry 8014 (class 2606 OID 17264)
-- Name: sys_post PRIMARY_F66D76A8_84150B7F_2EA0EABB; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_post
    ADD CONSTRAINT "PRIMARY_F66D76A8_84150B7F_2EA0EABB" PRIMARY KEY (post_id);


--
-- TOC entry 7995 (class 2606 OID 17231)
-- Name: qrtz_simprop_triggers PRIMARY_F8B4E6ED_ABCB7DF0_9F96A52A; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simprop_triggers
    ADD CONSTRAINT "PRIMARY_F8B4E6ED_ABCB7DF0_9F96A52A" PRIMARY KEY (sched_name, trigger_group, trigger_name);


--
-- TOC entry 8049 (class 2606 OID 17306)
-- Name: sys_dict_type dict_type_2399F8D6_80058C1A_322DFB61; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.sys_dict_type
    ADD CONSTRAINT "dict_type_2399F8D6_80058C1A_322DFB61" UNIQUE (dict_type);


--
-- TOC entry 7983 (class 2606 OID 17140)
-- Name: post_highlights post_highlights_pkey_C565D409; Type: CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.post_highlights
    ADD CONSTRAINT "post_highlights_pkey_C565D409" PRIMARY KEY (id);


--
-- TOC entry 8044 (class 1259 OID 17304)
-- Name: idx_sys_logininfor_lt_23FF0BED_E71901B0_CED0DA9E; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_logininfor_lt_23FF0BED_E71901B0_CED0DA9E ON public.sys_logininfor USING btree (login_time);


--
-- TOC entry 8045 (class 1259 OID 17307)
-- Name: idx_sys_logininfor_s_DAD31C0B_78012EE1_19B8ECF5; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_logininfor_s_DAD31C0B_78012EE1_19B8ECF5 ON public.sys_logininfor USING btree (status);


--
-- TOC entry 8004 (class 1259 OID 17290)
-- Name: idx_sys_oper_log_bt_5AA8DF25_7F5FE8A4_ED2AE1AD; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_oper_log_bt_5AA8DF25_7F5FE8A4_ED2AE1AD ON public.sys_oper_log USING btree (business_type);


--
-- TOC entry 8005 (class 1259 OID 17297)
-- Name: idx_sys_oper_log_ot_2696A8F7_FE2D1736_B58753C7; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_oper_log_ot_2696A8F7_FE2D1736_B58753C7 ON public.sys_oper_log USING btree (oper_time);


--
-- TOC entry 8006 (class 1259 OID 17301)
-- Name: idx_sys_oper_log_s_94FB440B_C5CB5BC8_411DB57C; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX idx_sys_oper_log_s_94FB440B_C5CB5BC8_411DB57C ON public.sys_oper_log USING btree (status);


--
-- TOC entry 8033 (class 1259 OID 17298)
-- Name: sched_name_CFEFF700_DF8C3C86_A6A9A0F6; Type: INDEX; Schema: public; Owner: postcheckuser
--

CREATE INDEX sched_name_CFEFF700_DF8C3C86_A6A9A0F6 ON public.qrtz_triggers USING btree (sched_name, job_name, job_group);


--
-- TOC entry 8052 (class 2606 OID 17313)
-- Name: qrtz_blob_triggers qrtz_blob_triggers_ibfk_1_602016CE_BF4EF810_4A74C7; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_blob_triggers
    ADD CONSTRAINT "qrtz_blob_triggers_ibfk_1_602016CE_BF4EF810_4A74C7" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8053 (class 2606 OID 17318)
-- Name: qrtz_cron_triggers qrtz_cron_triggers_ibfk_1_DCC7CA6E_24F7DA4F_2DFE1CCC; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_cron_triggers
    ADD CONSTRAINT "qrtz_cron_triggers_ibfk_1_DCC7CA6E_24F7DA4F_2DFE1CCC" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8055 (class 2606 OID 17328)
-- Name: qrtz_simple_triggers qrtz_simple_triggers_ibfk_1_BA07CD2E_59F29895_2447A99D; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simple_triggers
    ADD CONSTRAINT "qrtz_simple_triggers_ibfk_1_BA07CD2E_59F29895_2447A99D" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8054 (class 2606 OID 17323)
-- Name: qrtz_simprop_triggers qrtz_simprop_triggers_ibfk_1_FCECB7C0_8EDC5C80_4506780B; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_simprop_triggers
    ADD CONSTRAINT "qrtz_simprop_triggers_ibfk_1_FCECB7C0_8EDC5C80_4506780B" FOREIGN KEY (sched_name, trigger_name, trigger_group) REFERENCES public.qrtz_triggers(sched_name, trigger_name, trigger_group);


--
-- TOC entry 8056 (class 2606 OID 17308)
-- Name: qrtz_triggers qrtz_triggers_ibfk_1_2DEC48B4_582C285F_ED72A16F; Type: FK CONSTRAINT; Schema: public; Owner: postcheckuser
--

ALTER TABLE ONLY public.qrtz_triggers
    ADD CONSTRAINT "qrtz_triggers_ibfk_1_2DEC48B4_582C285F_ED72A16F" FOREIGN KEY (sched_name, job_name, job_group) REFERENCES public.qrtz_job_details(sched_name, job_name, job_group);


--
-- TOC entry 8505 (class 0 OID 0)
-- Dependencies: 3335
-- Name: FUNCTION sys_stat_statements_reset(userid oid, dbid oid, queryid bigint); Type: ACL; Schema: public; Owner: postcheckuser
--

REVOKE ALL ON FUNCTION public.sys_stat_statements_reset(userid oid, dbid oid, queryid bigint) FROM system;
GRANT IF NOT EXISTS ALL ON FUNCTION public.sys_stat_statements_reset(userid oid, dbid oid, queryid bigint) TO postcheckuser;


--
-- TOC entry 9033 (class 0 OID 0)
-- Dependencies: 550
-- Name: TABLE sys_stat_statements_all; Type: ACL; Schema: public; Owner: postcheckuser
--

REVOKE ALL ON TABLE public.sys_stat_statements_all FROM system;
REVOKE SELECT ON TABLE public.sys_stat_statements_all FROM PUBLIC;
GRANT IF NOT EXISTS ALL ON TABLE public.sys_stat_statements_all TO postcheckuser;
GRANT IF NOT EXISTS SELECT ON TABLE public.sys_stat_statements_all TO PUBLIC;


--
-- TOC entry 9034 (class 0 OID 0)
-- Dependencies: 551
-- Name: TABLE sys_stat_statements; Type: ACL; Schema: public; Owner: postcheckuser
--

REVOKE ALL ON TABLE public.sys_stat_statements FROM system;
REVOKE SELECT ON TABLE public.sys_stat_statements FROM PUBLIC;
GRANT IF NOT EXISTS ALL ON TABLE public.sys_stat_statements TO postcheckuser;
GRANT IF NOT EXISTS SELECT ON TABLE public.sys_stat_statements TO PUBLIC;


-- Completed on 2023-12-16 15:48:54

--
-- Kingbase database dump complete
--
